	SUBROUTINE LMTBND(IPNT,IPAN,IENW)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix,calculates eigenvalies and eigenvectors and   *
*  prepares wave functions                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR,NOVR     !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS           !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                 !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT                 !!! from readini
	USE COM_LMTIND  ,ONLY: LMTIND                            !!! from lmtpar
	USE COM_LMTMAT  ,ONLY: HMAT,OMAT                         !!! from lmtmat
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                          !!! from tetra
      USE COM_SCRINP  ,ONLY: ALPHA                             !!! from alpcon
      USE COM_ENERGY  ,ONLY: EARR,EARW                         !!! from bands
      USE COM_STRCON  ,ONLY: SSCON,SDCON                       !!! from strgnt
      USE COM_MASHDEP ,ONLY: LENCMP                            !!! from readini
	USE COM_LMTOUT  ,ONLY: ICCHI,ICOPT                       !!! from readini
	USE COM_CHANNELS,ONLY: IUWFK,IUPSI,IUHAM                 !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: E(:)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APJ(:,:,:)
	COMPLEX*16 CONV
	LOGICAL LOG
	SAVE NERR
	CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(E(NDIMMEM*NSPINMEM))
	ALLOCATE(APH(LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(APS(LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(APJ(LIMT1MEM,NATOMMEM,NKAPMEM))
	NDIM=NBNDT(IPAN)*NSPIN
C HERMITIANNESS OF THE MATRICES
	DO IDIM1=1,NDIM
	DO IDIM=1,IDIM1
      TH=ABS(HMAT(IDIM1,IDIM)-CONJG(HMAT(IDIM,IDIM1)))
      IF(TH.GE.1.D-05)WRITE(IUT,*)'HMAT-->',IDIM1,IDIM,TH
      TO=ABS(OMAT(IDIM1,IDIM)-CONJG(OMAT(IDIM,IDIM1)))
      IF(TO.GE.1.D-05)WRITE(IUT,*)'OMAT-->',IDIM1,IDIM,TO
	ENDDO
	ENDDO
C HAMILTONIAN STORAGE
	IF(IDMF.EQ.2.AND.IPAN.EQ.1)THEN
	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=IUPDN+NSPIN*(IORBS-1)+NSPIN*NORBS*(IPNT-1)+NSHIFT
      WRITE(IUHAM,REC=IREC)
     &((HMAT(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1)),
     &((OMAT(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1))
	ENDDO
	ENDDO
	ENDIF
C GENERALIZED EIGENVALUE PROBLEM
	IF(IPNT.EQ.1)NERR=0
      CALL EIGEN1C(NDIM,HMAT,OMAT,E,NSPIN,NORBS,IERR)
	IF(IERR.EQ.1)NERR=NERR+1
	IF((IPNT.EQ.NPNT(IPAN).OR.IPNT.EQ.NPNW(IPAN)).AND.NERR.NE.0)THEN
	WRITE(IUT,*)'Warning from <LMTBND>:'
	WRITE(IUT,*)'There were ',NERR,' errors in Cholesky decomposition'
	ENDIF
C EIGENVALUES
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(IPAN)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EARR(IBAND,IPNT,IPAN)=E(IBAND)
      IF(IENW.EQ.1)EARW(IBAND,IPNT,IPAN)=E(IBAND)
	IF(NPNT(IPAN).EQ.NPNW(IPAN))
     &EARW(IBAND,IPNT,IPAN)=EARR(IBAND,IPNT,IPAN)
      ENDDO
      ENDDO
	IF(IENW.EQ.1)GOTO1000
C WAVE FUNCTIONS EXPANSION COEFFICIENTS APH AND APJ 
	DO 400 IORBS=1,NORBS        !!! over spinor components
	DO 300 IBNDS=1,NSPIN        !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO 200 IBNDT=1,NBNDF(IPAN)  !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO 100 IKAP=1,NKAP(IPAN)    !!! over energies
C SET APH
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
	IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)
	APH(LM,IATOM,IKAP)=(0.D0,0.D0)
	APS(LM,IATOM,IKAP)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	APH(LM,IATOM,IKAP)=OMAT(IDIM,IBAND)
	APS(LM,IATOM,IKAP)=OMAT(IDIM,IBAND)
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
C SET APJ
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)          !!! over l
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	CONV=(0.D0,0.D0)
	DO IATOM2=1,NATOM            !!! over iatom2
	ISORT2=IS(IATOM2)
	DO L2=0,ILSB(ISORT2)         !!! over l2
	IF(.NOT.LTPAN(L2,IATOM2,IKAP,IPAN))CYCLE
	DO M2=-L2,L2                !!! over m2
	L2M2=L2*(L2+1)+M2+1
	IDIM2=LMTIND(L2M2,IATOM2,IKAP,ISPIN,IPAN)
	CONV=CONV+SSCON(LM,IATOM,L2M2,IATOM2,IKAP)*
     &OMAT(IDIM2,IBAND)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
	APJ(LM,IATOM,IKAP)=CONV
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
C SET APS (if screened LMTO, these represent bare coefficients)
	IF(LMTO.NE.1)THEN
      DO IATOM=1,NATOM            !!! over iatom
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
      IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)
      APS(LM,IATOM,IKAP)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
      DO IATOM2=1,NATOM           !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)        !!! over l2
      IF(.NOT.LTPAN(L2,IATOM2,IKAP,IPAN))CYCLE
      DO M2=-L2,L2                !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=LMTIND(L2M2,IATOM2,IKAP,ISPIN,IPAN)
      IF(IDIM.EQ.IDIM2)ONE=1.D0
      IF(IDIM.NE.IDIM2)ONE=0.D0
	APS(LM,IATOM,IKAP)=APS(LM,IATOM,IKAP)+(DCMPLX(ONE,0.D0)+
     &ALPHA(L,ISORT,IKAP,IPAN)*SSCON(LM,IATOM,L2M2,IATOM2,IKAP))*
     &APH(L2M2,IATOM2,IKAP)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
	ENDIF
	IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN-1)*(NORBS-1)
	WRITE(UNIT=IUWFK,REC=IREC)
     &((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	IF((LIFT.GT.2.OR.ICCHI.GT.0.OR.ICOPT.GT.0).
     &AND.IBNDT.GE.NBNDE(IPAN))THEN !!! only for panel #1
	IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
	WRITE(UNIT=IUPSI,REC=IREC)
     &((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ENDIF
 100  CONTINUE                    !!! over energies
 200  CONTINUE                    !!! over bands
 300  CONTINUE                    !!! over spin subbands
 400  CONTINUE                    !!! over spinor components
C MEMORY DEALLOCATIONS
1000  SIZE_MAT=2.D0*DBLE(SIZE(HMAT)*LENCMP)/1024.D0**2
      DEALLOCATE(HMAT,OMAT)
      CURMEM=CURMEM-SIZE_MAT
	DEALLOCATE(APH,APS,APJ,E)
	END
