	SUBROUTINE STRGNT(IPNT,IPAN,IENW,ILBO)
*******************************************************
* The calculation of the structure constants.         *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,IS,ILST,ILSB  !!! from readini
      USE COM_LATPAR  ,ONLY : PAR,ORTH,OMEGAC                 !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP,EKAP,EK,EDGE          !!! from readini
      USE COM_SPHERE  ,ONLY : SMT,SWZ                         !!! from readini
      USE COM_KMESH   ,ONLY : NPNT,PNT                        !!! from makettr
      USE COM_WMESH   ,ONLY : NPNW,PNW                        !!! from makettr
      USE COM_VECGEN  ,ONLY : LIMDT                           !!! from vecgen
      USE COM_LMSTRS  ,ONLY : IDELP                           !!! from vecgen
      USE COM_STRCON  ,ONLY : SSCON,SDCON                     !!! from strgnt
      USE COM_GAUNT   ,ONLY : C,GGNT                          !!! from gdata
      USE COM_LMTOUT  ,ONLY : ICCON,CONFILE                   !!! from readini
      USE COM_CHANNELS,ONLY : IUCON                           !!! from readini
      USE COM_MASHDEP ,ONLY : LENCMP                          !!! from readini
	USE COM_UNIT    ,ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: SIGMA(:)
      COMPLEX*16, ALLOCATABLE :: SIGMD(:)
	COMPLEX*16 KAPPA,KAPPADOT,KAP
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS FOR STRUCTURE CONSTANTS
	IF(ILBO.EQ.0)ALLOCATE(SSCON(LIMT1MEM,NATOMMEM,LIMBMEM,
     &NATOMMEM,NKAPMEM),STAT=IALLOC)
	IF(ILBO.EQ.1)ALLOCATE(SSCON(LIMTMEM,NATOMMEM,LIMB1MEM,
     &NATOMMEM,NKAPMEM),STAT=IALLOC)
	IF(IALLOC.EQ.1)CALL STRGNT_MESG01
	SIZE_SSCON=DBLE(SIZE(SSCON)*LENCMP)/1024.D0**2
	IF(ILBO.EQ.0)ALLOCATE(SDCON(LIMB1MEM,NATOMMEM,LIMBMEM,
     &NATOMMEM,NKAPMEM),STAT=IALLOC)
	IF(ILBO.EQ.1)ALLOCATE(SDCON(LIMBMEM,NATOMMEM,LIMB1MEM,
     &NATOMMEM,NKAPMEM),STAT=IALLOC)
	SIZE_SDCON=DBLE(SIZE(SDCON)*LENCMP)/1024.D0**2
	IF(IALLOC.EQ.1)CALL STRGNT_MESG02
	CURMEM=CURMEM+SIZE_SSCON+SIZE_SDCON
	IF(TOTMEM.LT.CURMEM)TXTMEM='<STRGNT> Subroutine'
	IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
      LTLMEM=(LMAXTMEM+1+LMAXBMEM+1)**2
      LDLMEM=(LMAXBMEM+1+LMAXBMEM+1)**2
      ALLOCATE(SIGMA(LTLMEM))
      ALLOCATE(SIGMD(LDLMEM))
C CALCULATE SHIFT FOR THIS PANEL
	IF(ICCON.NE.0.AND.IENW.EQ.0)THEN ! sigma was calculated at the begining
	NSHIFT=1+NKAP(IPAN)*LIMDT*(IPNT-1)
	DO JPAN=1,IPAN-1
	NSHIFT=NSHIFT+NPNT(JPAN)*NKAP(JPAN)*LIMDT
      ENDDO
	ELSEIF(ICCON.EQ.0.OR.IENW.EQ.1)THEN ! no preliminary calculation of sigma
	NSHIFT=0
	ENDIF
C SET LOOPING LIMITS
	IF(ILBO.EQ.0)ILB=0
	IF(ILBO.EQ.0)ILT=1
	IF(ILBO.EQ.1)ILB=1
	IF(ILBO.EQ.1)ILT=0
C RESTORE FULL S AND S_DOT -MATRICES FOR DIFF.ENERGIES
	DO IKAP=1,NKAP(IPAN)           !!! over diff.energies
	KAP=SQRT(EK(IKAP,IPAN))
	DO JATOM=1,NATOM               !!! over jatom
	JSORT=IS(JATOM)
	DO IATOM=1,NATOM               !!! over iatom
	ISORT=IS(IATOM)
	ITAU=IDELP(IATOM,JATOM)
	IREC=ITAU+LIMDT*(IKAP-1)+NSHIFT
	READ(IUCON,REC=IREC)LIM2,LID2,(SIGMA(LM),LM=1,LIM2),
     &(SIGMD(LM),LM=1,LID2)
	DO L =0,ILSB(JSORT)+ILB        !!! over l
	DO L1=0,ILST(ISORT)+ILT        !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILT+ILSB(ISORT))LOG=.TRUE.
	SOS=(SMT(ISORT)/SWZ)**(L1+0.5)*(SMT(JSORT)/SWZ)**(L+0.5)
	QSOSQ=SQRT(SMT(ISORT)/2.D0/PAR)*SOS*SQRT(SMT(JSORT)/2.D0/PAR)
	SQSOSQS=SWZ/PAR*QSOSQ*SWZ/PAR
	DO M =-L,L                     !!! over m
	LM=L*(L+1)+M+1
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SSCON(L1M1,IATOM,LM,JATOM,IKAP)=(0.0,0.0)
	IF(LOG)
     &SDCON(L1M1,IATOM,LM,JATOM,IKAP)=(0.0,0.0)
	DO L2=ABS(L-L1),L+L1,2         !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN          !!! over m2
	KAPPA=(1.D0,0.D0)              !!! energies are in units 1/a^2)
	IF(L+L1-L2.NE.0)KAPPA=(SWZ/PAR*KAP)**(L+L1-L2)
	KAPPADOT=(0.D0,0.D0)
	IF(L+L1-L2.NE.0.AND.ABS(EK(IKAP,IPAN)).NE.0.D0)THEN
	KAPPADOT=(L+L1-L2)*0.5D0*(SWZ/PAR*KAP)**(L+L1-L2-2)
	ELSEIF(L+L1-L2.EQ.2.AND.ABS(EK(IKAP,IPAN)).EQ.0.D0)THEN
	KAPPADOT=(1.D0,0.D0)
	ENDIF
	SSCON(L1M1,IATOM,LM,JATOM,IKAP)=
     &SSCON(L1M1,IATOM,LM,JATOM,IKAP)+
     &C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMA(L2M2)*QSOSQ*
     &KAPPA
	IF(LOG)
     &SDCON(L1M1,IATOM,LM,JATOM,IKAP)=
     &SDCON(L1M1,IATOM,LM,JATOM,IKAP)+
     &C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMD(L2M2)*
     &SQSOSQS*KAPPA+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &SIGMA(L2M2)*SQSOSQS*KAPPADOT
	ENDIF                          !!! over m2
      ENDDO                          !!! over l2
      ENDDO                          !!! over m1
      ENDDO                          !!! over m
      ENDDO                          !!! over l1
      ENDDO                          !!! over l
      ENDDO                          !!! over iatom
      ENDDO                          !!! over jatom
      ENDDO                          !!! over diff.energies
C MEMORY DEALLOCATIONS
      DEALLOCATE(SIGMA)
      DEALLOCATE(SIGMD)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE STRGNT_MESG01
	LSIZE=LIMT1MEM*NATOMMEM*LIMBMEM*NATOMMEM*NKAPMEM
	WRITE(IUT,*)'Terminated in <STRGNT>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array SSCON of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
	END SUBROUTINE STRGNT_MESG01
	SUBROUTINE STRGNT_MESG02
	LSIZE=LIMB1MEM*NATOMMEM*LIMBMEM*NATOMMEM*NKAPMEM
	WRITE(IUT,*)'Terminated in <STRGNT>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array SDCON of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
	END SUBROUTINE STRGNT_MESG02
	END



	SUBROUTINE STRSUM(IPNT,IPAN,IENW)
*******************************************************
*   Calculate lattice sums if it was not done before. *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,IS,ILST,ILSB  !!! from readini
      USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                 !!! from readini
      USE COM_KAPPAR,  ONLY : NPAN,NKAP,EKAP,EK,EDGE          !!! from readini
      USE COM_SPHERE,  ONLY : SMT,SWZ                         !!! from readini
      USE COM_INPTTR,  ONLY : NDIV,NDIC,SH                    !!! from readini
      USE COM_KMESH,   ONLY : NPNT,PNT                        !!! from makettr
      USE COM_WMESH,   ONLY : NPNW,PNW                        !!! from makettr
      USE COM_LMTOUT,  ONLY : ICCON,CONFILE,ICSCR,SCRFILE     !!! from readini
      USE COM_VECGEN,  ONLY : LIMDT                           !!! from vecgen
      USE COM_LMSTRS,  ONLY : NR2,ILS2,ILD2,LIMLPL2,LIMLDL2   !!! from vecgen
      USE COM_CHANNELS,ONLY : IUCON                           !!! from readini
      USE COM_MASHDEP, ONLY : NVAL,LENCMP                     !!! from readini
	USE COM_UNIT    ,ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: SIGMA(:,:,:)
      COMPLEX*16, ALLOCATABLE :: SIGMD(:,:,:)
	LOGICAL FIRST,LAST,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C FILE OPERATIONS
	IF(IPNT.EQ.1.AND.IPAN.EQ.1.AND.IENW.EQ.0)THEN
	IF(ICCON.EQ.0)
     &OPEN(UNIT=IUCON,FILE=SCRFILE(IUCON),STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NR2)
	IF(ICCON.NE.0)
     &OPEN(UNIT=IUCON,FILE=CONFILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NR2)
	ELSEIF(IPNT.EQ.1.AND.IPAN.EQ.1.AND.IENW.EQ.1)THEN
	OPEN(UNIT=IUCON,FILE=SCRFILE(IUCON),STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NR2)
	ENDIF
C RETURN KEYS
	IF(ICCON.NE.0.AND.IENW.EQ.0)RETURN
C MEMORY ALLOCATIONS
      LTLMEM=(LMAXTMEM+1+LMAXBMEM+1)**2
      LDLMEM=(LMAXBMEM+1+LMAXBMEM+1)**2
      ALLOCATE(SIGMA(LTLMEM,LIMDTMEM,NKAPMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL STRSUM_MESG01('SIGMA',
     &LTLMEM*LIMDTMEM*NKAPMEM*LENCMP)
      SIZE_SIGMA=DBLE(SIZE(SIGMA)*LENCMP)/1024.D0**2
      ALLOCATE(SIGMD(LDLMEM,LIMDTMEM,NKAPMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL STRSUM_MESG01('SIGMD',
     &LDLMEM*LIMDTMEM*NKAPMEM*LENCMP)
      SIZE_SIGMD=DBLE(SIZE(SIGMD)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_SIGMA+SIZE_SIGMD
      IF(TOTMEM.LT.CURMEM)TXTMEM='<STRSUM> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	IF(IPNT.EQ.1)FIRST=.TRUE.
	IF(IPNT.NE.1)FIRST=.FALSE. 
	IF(IPNT.NE.NPNT(IPAN).AND.IENW.EQ.0)LAST=.FALSE.
	IF(IPNT.EQ.NPNT(IPAN).AND.IENW.EQ.0)LAST=.TRUE. 
	IF(IPNT.NE.NPNW(IPAN).AND.IENW.EQ.1)LAST=.FALSE.
	IF(IPNT.EQ.NPNW(IPAN).AND.IENW.EQ.1)LAST=.TRUE. 
      IF(IENW.EQ.0)THEN
      XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
      ELSE
      XK=PNW(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNW(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNW(3,IPNT,IPAN)+SH(3,IPAN)
      ENDIF
C CALCULATE LATTICE SUMS IF IT WAS NOT DONE BEFORE
	IF(IPAN.EQ.1.OR.(DREAL(EKAP(1,IPAN)).GE.EDGE.AND.IPAN.NE.1))
     &CALL DSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &LAST,LTLMEM,LDLMEM,NKAPMEM,SIGMA,SIGMD)
	IF(IPAN.NE.1.AND.DREAL(EKAP(1,IPAN)).LT.EDGE)
     &CALL HSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &LAST,LTLMEM,LDLMEM,NKAPMEM,SIGMA,SIGMD)
	IREC=0
	DO 20 IKAP=1,NKAP(IPAN)
	DO 10 ITAU=1,LIMDT
	IREC=IREC+1
	WRITE(IUCON,REC=IREC)LIMLPL2(ITAU),LIMLDL2(ITAU),
     &(SIGMA(LM,ITAU,IKAP),LM=1,LIMLPL2(ITAU)),
     &(SIGMD(LM,ITAU,IKAP),LM=1,LIMLDL2(ITAU))
  10  CONTINUE
  20  CONTINUE
C MEMORY DEALLOCATIONS
      DEALLOCATE(SIGMA)
      DEALLOCATE(SIGMD)
      CURMEM=CURMEM-SIZE_SIGMA-SIZE_SIGMD
      CONTAINS
C ERROR HANDLINGS
      SUBROUTINE STRSUM_MESG01(CHARV,LSIZE)
      CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <STRSUM>:'
      WRITE(IUT,*)'Memory allocation problem detected by'
      WRITE(IUT,*)'the system. Array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE STRSUM_MESG01
	END SUBROUTINE STRSUM
