	SUBROUTINE FTBBND(IPNT,IENW)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix,calculates eigenvalies and eigenvectors and   *
*  prepares wave functions                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,IDMF              !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                         !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS               !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                       !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                             !!! from lmtmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC               !!! from readini
      USE COM_ENERGY  ,ONLY: EARR,EARW                             !!! from bands
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                          !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                              !!! from tetra
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
	USE COM_CHANNELS,ONLY: IUPSI,IUDOS,IUHAM                     !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: E(:)
      LOGICAL LOG
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(E(NDIMMEM*NSPINMEM))
C HERMITIANNESS OF THE MATRICES
	DO IDIM1=1,NTBAS*NSPIN
	DO IDIM=1,IDIM1
      TH=ABS(HMAT(IDIM1,IDIM)-CONJG(HMAT(IDIM,IDIM1)))
C     IF(TH.GE.1.D-05)WRITE(IUT,*)'HMAT-->',IDIM1,IDIM,TH
      TO=ABS(OMAT(IDIM1,IDIM)-CONJG(OMAT(IDIM,IDIM1)))
C     IF(TO.GE.1.D-05)WRITE(IUT,*)'OMAT-->',IDIM1,IDIM,TO
	ENDDO
	ENDDO
C HAMILTONIAN STORAGE
	IF(IDMF.EQ.2)THEN
	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=IUPDN+NSPIN*(IORBS-1)+NSPIN*NORBS*(IPNT-1)+NSHIFT
      WRITE(IUHAM,REC=IREC)
     &((HMAT(IDIM1+NTBAS*(ISPIN1-1),IDIM+NTBAS*(ISPIN-1)),
     &IDIM1=1,NTBAS),IDIM=1,NTBAS),
     &((OMAT(IDIM1+NTBAS*(ISPIN1-1),IDIM+NTBAS*(ISPIN-1)),
     &IDIM1=1,NTBAS),IDIM=1,NTBAS)
	ENDDO
	ENDDO
	ENDIF
C GENERALIZED EIGENVALUE PROBLEM
      CALL EIGEN1C(NTBAS*NSPIN,HMAT,OMAT,E,NSPIN,NORBS,IERR)
C EIGENVALUES
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NTBAS
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EARR(IBAND,IPNT,1)=E(IBAND)
      IF(IENW.EQ.1)EARW(IBAND,IPNT,1)=E(IBAND)
      IF(NPNT(1).EQ.NPNW(1))
     &EARW(IBAND,IPNT,1)=EARR(IBAND,IPNT,1)
      ENDDO
      ENDDO
C WAVE COEFFICIENTS
	IF(IENW.EQ.1)GOTO1000
	DO IORBS=1,NORBS            !!! over spinor components
      DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=NBNDE(1),NBNDF(1)  !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IREC=1+IBNDT-NBNDE(1)+(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      WRITE(IUPSI,REC=IREC)
     &(OMAT(IDIM+NTBAS*(ISPIN-1),IBAND),IDIM=1,NTBAS)
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
	ENDDO                       !!! over spinor components
C MEMORY DEALLOCATIONS
 1000 DEALLOCATE(E)
	IF(IENW.EQ.1)THEN
	SIZE_MAT=2.D0*DBLE(SIZE(OMAT)*LENCMP)/1024.D0**2
	DEALLOCATE(HMAT,OMAT)
      CURMEM=CURMEM-SIZE_MAT
	ENDIF
	END
