	SUBROUTINE FTBFAT(IPNT,IENW)
**********************************************************
* Program calculates tlm-characters of wave functions    *
* to plot fat bands.                                     *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                        !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_LMTMAT  ,ONLY: OMAT                              !!! from lmtmat
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
	USE COM_ENERGY  ,ONLY: EARR                              !!! from energy
	USE COM_CHANNELS,ONLY: IUDOS                             !!! from readini
	USE COM_LMTOUT  ,ONLY: ICFAT,ICDOS                       !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TLMM(:,:,:,:,:)
	LOGICAL LOG
      CALL ABORTNOW()
C RETURN KEYS
	IF(ICFAT.EQ.0.AND.ICDOS.EQ.0)RETURN
	IF(IENW.EQ.1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(TLMM(LIMB2MEM,NATOMMEM,NORBSMEM,NBNDT(1),NSPINMEM))
C START CODE
      DO 2000 IBNDS=1,NSPIN            !!! over spin subbands
      DO 1000 IBNDT=1,NBNDF(1)         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET NORMALIZATION
	ANORM=0.D0
	DO IORBS=1,NORBS                 !!! over spinors   
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)               !!! over l
	DO M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	IDIM=INBAS(LM,IATOM)+NTBAS*(ISPIN-1)
	IF(LTBAS(L,IATOM).AND.LTBAS(L,IATOM))
     &ANORM=ANORM+CONJG(OMAT(IDIM,IBAND))*OMAT(IDIM,IBAND)
      ENDDO                            !!! over m
      ENDDO                            !!! over l
      ENDDO                            !!! over atoms
      ENDDO                            !!! over spinors
	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
C SET TLM-CHARACTER IN SPHERICAL HARMONIC REPRESENTATION
	DO IORBS=1,NORBS                 !!! over spinors   
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,MIN(ILSB(ISORT),3)        !!! over l
	DO M1=-L,L                       !!! over m1
	LM1=L*(L+1)+M1+1
	IDIM1=INBAS(LM1,IATOM)+NTBAS*(ISPIN-1)
	DO M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	IDIM=INBAS(LM,IATOM)+NTBAS*(ISPIN-1)
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
	TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=(0.D0,0.D0)
	IF(LTBAS(L,IATOM))
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)+
     &CONJG(OMAT(IDIM1,IBAND))*OMAT(IDIM,IBAND)
 	TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)/ANORM
	ENDDO                            !!! over m
	ENDDO                            !!! over m1
      ENDDO                            !!! over l
      ENDDO                            !!! over atoms
      ENDDO                            !!! over spinors
C  SAVE TLM-CHARACTERS IN FILE
1000	CONTINUE                         !!! over bands
2000	CONTINUE                         !!! over spin subbands
      DO IORBS=1,NORBS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      WRITE(IUDOS)(((TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS),
     &LM1M=LMS,LME),IBNDT=1,NBNDT(1)),IBNDS=1,NSPIN)
      ENDDO
      ENDDO
      ENDDO
	IF(IPNT.EQ.NPNT(1))CLOSE(IUDOS)
C MEMORY DEALLOCATIONS
	DEALLOCATE(TLMM)
	END
