	SUBROUTINE RHOHUB
***********************************************************
*  Computes occupation numbers from the TOS-matrices.     *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,ILSV,LRTV
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SUMPAR  ,ONLY: OHH,OJH,OHJ,OJJ                  !!! from ovrpar
      USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ
      USE COM_HUBCOM  ,ONLY: DHUB                             !!! from readhub
      USE COM_CHANNELS,ONLY: IUTOS                            !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_MASHDEP ,ONLY: LENREL,LENCMP                    !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	COMPLEX*16 SUM
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(IDMF.NE.1)GOTO6000
	DO 5000 IORBS=1,NORBS                       !!! over iorbs
	DO 4000 IUPDN=1,NSPIN                       !!! over spins
	DO 3000 IPAN=1,1                            !!! over panels
C SET OCCUPATION NUMBERS TO ZERO
	DO IATOM=1,NATOM                            !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                          !!! over l
      DO M1=-L,L                                  !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                   !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DHUB(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO                                       !!! over m1
      ENDDO                                       !!! over m
      ENDDO                                       !!! over l
      ENDDO                                       !!! over atoms
	DO 2000 IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO 2000 IKAP=1,NKAP(IPAN)                   !!! over energies
	DO 1000 IATOM=1,NATOM                       !!! over atoms
	ISORT=IS(IATOM)
C READ TOS-MATRICES
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C COMPUTE OCCUPATION NUMBERS
	DO L=0,ILSB(ISORT)                          !!! over l
      DO M1=-L,L                                  !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                   !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
	SUM=(0.D0,0.D0)
      IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
      SUM=SUM+ATOSHH(LM1,LM,IATOM)*
     &OHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      SUM=SUM-ATOSHJ(LM1,LM,IATOM)*
     &OHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      SUM=SUM-ATOSJH(LM1,LM,IATOM)*
     &OJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      ENDIF
      SUM=SUM+ATOSJJ(LM1,LM,IATOM)*
     &OJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
	DHUB(IU,IATOM,IUPDN,IORBS)=DHUB(IU,IATOM,IUPDN,IORBS)+SUM
	ENDDO                                       !!! over m1
      ENDDO                                       !!! over m
      ENDDO                                       !!! over l
1000  CONTINUE                                    !!! over atoms
2000  CONTINUE                                    !!! over energies
3000  CONTINUE                                    !!! over panels
4000  CONTINUE                                    !!! over spins
5000  CONTINUE                                    !!! over iorbs
6000  CLOSE(UNIT=IUTOS,STATUS='DELETE')
C MEMORY DEALLOCATIONS
      SIZE_ATOSHH=DBLE(SIZE(ATOSHH)*LENCMP)/1024.D0**2
      SIZE_ATOSJH=DBLE(SIZE(ATOSJH)*LENCMP)/1024.D0**2
      SIZE_ATOSHJ=DBLE(SIZE(ATOSHJ)*LENCMP)/1024.D0**2
      SIZE_ATOSJJ=DBLE(SIZE(ATOSJJ)*LENCMP)/1024.D0**2
      DEALLOCATE(ATOSHH)
      DEALLOCATE(ATOSJJ)
      DEALLOCATE(ATOSHJ)
      DEALLOCATE(ATOSJH)
      CURMEM=CURMEM-SIZE_ATOSHH-SIZE_ATOSJH-SIZE_ATOSHJ-
     &SIZE_ATOSJJ
	END
