	SUBROUTINE BLOWMTS(WR,RMT,A,B,C,TAU,NATOM)
*********************************************************
*  Blows MT-spheres until they touch.                   *
*********************************************************
        use com_unit
	implicit real*8 (a-h,o-z)
	integer, allocatable :: isat(:)
	integer, allocatable :: flag(:)
	real*8, allocatable :: site(:,:)
	real*8, allocatable :: tauc(:,:)
	dimension a(3),b(3),c(3),tau(3,natom)
     &     ,wr(natom),rmt(natom)
c memory allocations for scratch arrays
	allocate(isat(8*natom),stat=ialloc)
	allocate(flag(natom),stat=ialloc)
	allocate(site(3,8*natom),stat=ialloc)
	allocate(tauc(3,natom),stat=ialloc)
c generate all sites in 8 cell:
	do 10 i=1,natom
	call sitegen_redc(a,b,c,tau(1,i),tauc(1,i),1)
  10  continue
	ns=0
	do 60 i=0,1
	do 50 j=0,1
	do 40 k=0,1
	do 30 iat=1,natom
	ns=ns+1
	isat(ns)=iat
	do 20 l=1,3
	site(l,ns)=tauc(l,iat)-i*a(l)-j*b(l)-k*c(l)
  20  continue
  30  continue
  40  continue
  50  continue
  60  continue
c basis set:
	do 70 i=1,natom
	call sitegen_redc(a,b,c,tau(1,i),tauc(1,i),0)
  70  continue
	do 110 iat=1,natom
	do 100 i=1,ns
	rw=(site(1,i)-tauc(1,iat))**2+
     &   (site(2,i)-tauc(2,iat))**2+
     &   (site(3,i)-tauc(3,iat))**2
	if(rw.lt.1.d-08) then
	do 80 k=1,3
	site(k,i)=site(k,iat)
  80  continue
	do 90 k=1,3
	site(k,iat)=tauc(k,iat)
  90  continue
	goto 110
	endif
 100  continue
 110  continue
c start up:
	do 120 i=1,natom
	rmt(i)=0.
	flag(i)=0
 120  continue
c blowing coefficient:
	idog=0
 125  al0=1.d10
	idog=idog+1
	if (idog.gt.100)call blowmts_mesg01
	do 140 i=1,natom
	if(flag(i).eq.1) goto 140
	do 130 j=1,ns
	if(i.eq.j) goto 130
	dij=sqrt((site(1,i)-site(1,j))**2+(site(2,i)-site(2,j))**2+
     &         (site(3,i)-site(3,j))**2)
	al=(dij-rmt(isat(j))*flag(isat(j)))/
     &(wr(i)+wr(isat(j))*(1-flag(isat(j))))
	al0=min(al0,al)
 130  continue
 140  continue
c blowing:
	do 150 i=1,natom
	if(flag(i).eq.0) rmt(i)=wr(i)*al0
 150  continue
c flag set:
	do 170 i=1,natom
	do 160 j=1,ns
	if(i.eq.j) goto 160
	dij=sqrt((site(1,i)-site(1,j))**2+(site(2,i)-site(2,j))**2+
     &         (site(3,i)-site(3,j))**2)
	g=abs(dij-rmt(i)-rmt(isat(j)))
	if(g.le.1.d-08) then
	flag(i)=1
	goto 170
	endif
 160  continue
 170  continue
c check:        
	ncheck=0
	do 180 i=1,natom
	ncheck=ncheck+flag(i)
 180  continue
	if(ncheck.lt.natom) goto 125
c memory deallocations
	deallocate(isat,stat=ialloc)
	deallocate(flag,stat=ialloc)
	deallocate(site,stat=ialloc)
	deallocate(tauc,stat=ialloc)
	return
c error handlings
	contains
	subroutine blowmts_mesg01
	write(iut,*)'Terminated in <BLOWMTS>:'
	write(iut,*)'Infinite looping detected in the subroutine.'
	write(iut,*)'Passed parameters are'
	write(iut,*)'Natom = ',natom
	write(iut,*)'Wr(iatom) =',wr
	write(iut,*)'A(i) =',a
	write(iut,*)'B(i) =',b
	write(iut,*)'C(i) =',c
	write(iut,*)'Tau(i,iatom) = ',tau
	call fullstop(' ')
	end subroutine blowmts_mesg01
	end subroutine blowmts
