	SUBROUTINE INIT
*************************************************************
*    Control module <INIT> for reading all the input data   *
*************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_LMTINP ,ONLY: CTRFILE,LOGFILE
     &                     ,PROJECT,INPINFO,RUNMODE,TRACINP !!! from init
      USE COM_UNIT   ,ONLY: IUT,IUR,IUN,IUI                 !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER ST*8,FN*8,PROGN*8
      LOGICAL EXIST,EXIT,TRACER,TRAC
      DATA ST/'started'/,FN/'finished'/
C LOG FILE
	IF(LOGFILE.NE.'terminal')THEN
	INQUIRE(FILE=LOGFILE,EXIST=EXIST)
	IF(EXIST)THEN
	OPEN(UNIT=IUT,FILE=LOGFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUT,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUT,FILE=LOGFILE,STATUS='NEW',FORM='FORMATTED')
	ENDIF
C CONTROL FILE
	IF(CTRFILE.NE.'terminal')THEN
	INQUIRE(FILE=CTRFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL INIT_MESG01
	OPEN(UNIT=IUR,FILE=CTRFILE,STATUS='OLD',FORM='FORMATTED')
	ENDIF
C START CODE
	CALL PHEAD(IUT)        !!! prints title
      CALL CHANN             !!! channel description
C GET PROJECT TITLE
	IF(IUI.EQ.IUR)WRITE(IUT,1010,ADVANCE='NO')
	READ(UNIT=IUR,FMT='(A)')PROJECT
1010  FORMAT(1X,'PROJECT? ')
	CALL RMBLANK(PROJECT,130)
	IF(PROJECT(1:1).EQ.' ')CALL INIT_MESG02
C GET INPUT INFORMATION
	IF(IUI.EQ.IUR)WRITE(IUT,1020,ADVANCE='NO')
	READ(UNIT=IUR,FMT='(A)')INPINFO
1020  FORMAT(1X,'INPINFO? ')
C GET RUNNING MODE
	IF(IUI.EQ.IUR)WRITE(IUT,1030,ADVANCE='NO')
	READ(UNIT=IUR,FMT='(A)')RUNMODE
1030  FORMAT(1X,'RUNMODE? ')
C RECOGNIZE CONTROL INFORMATION
	CALL CTRLINF
C READ CONTROL DATA
	CALL READINI           !!! read INIFILE
	CALL READSTR           !!! read STRFILE
	CALL NMTFILE           !!! file storage
C TEST DATA
	CALL TESTINP           !!! test input data
	CALL READINI_SHOW      !!! print INIFILE
	CALL READSTR_SHOW      !!! print STRFILE
C MAKE POINT GROUP
	progn='MakeGRP '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
	CALL MAKEGRP           !!! find point group
	CALL MAKEGNT           !!! find Gaunt coefficients
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C FIND SYMMETRY OF CHARGE DENSITY
	progn='MakeSYM '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKESYM           !!! find symmetry of RHO
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C FIND MT-SPHERES
	progn='MakeSMT '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKESMT           !!! find MT-spheres
	CALL MAKERAD           !!! make radial mesh
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE FAST FOURIER TRANSFORM
	progn='MakeFFT '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKEFFT           !!! make FFTs
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE PLANE WAVES
	progn='MakePLW '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKEPLW           !!! make PLWs
      CALL MAKEPLW_DPLW      !!! make PLWs
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE SCF FILE
      progn='MakeSCF '
      if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKESCF           !!! make input density
      CALL READSCF           !!! read scffile
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
      endif
C MAKE PSEUDOHANKELS
	progn='MakeHAN '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKEHAN           !!! make pseudoHankels
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE PSEUDOLMTOS
	progn='MakeTEI '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
 	CALL MAKETEI           !!! make pseudoLMTOs
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE CLUSTER SITES
	progn='MakeENV '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKEENV           !!! make enviroment vectors
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE K-MESH
	progn='MakeTTR '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL MAKETTR           !!! make tetrahedron grid
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C READ HUBBARD INTERACTION MATRIX
	progn='ReadHUB '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL READHUB           !!! read Hubbard interactions
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C READ HOPPING INTEGRALS
	progn='ReadHOP '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL READHOP           !!! read hoppings
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C READ Q-POINTS
	progn='ReadPNT '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL READPNT           !!! read 
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C INITIALIZATION COMPLETED. UPGRADE INPUT FILES
	progn='MakeUPG '
	if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL READINI_UPGR      !!! upgrade INIFILE
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1120  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
	CONTAINS
C ERROR HANDLINGS
	SUBROUTINE INIT_MESG01
	WRITE(IUT,*)'Terminated in <INIT>:'
	WRITE(IUT,*)'Control file not found.'
	WRITE(IUT,*)'Set to <<terminal>> for terminal input.'
	CALL FULLSTOP(' ')
      END SUBROUTINE INIT_MESG01
	SUBROUTINE INIT_MESG02
	WRITE(IUT,*)'Terminated in <INIT>:'
	WRITE(IUT,*)'Project string is blank.'
	WRITE(IUT,*)'It should contain project title and its location'
	CALL FULLSTOP(' ')
      END SUBROUTINE INIT_MESG02
      END SUBROUTINE INIT
