	SUBROUTINE READINI           
************************************************************
*  <READINI> controls reading atomic data from INIFILE.    *
************************************************************
      USE COM_LMTINP ,ONLY: PROJECT,INPINFO,INIFILE,TRACINP !!! from init
	USE COM_EXTENS ,ONLY: EXTNINI,LENEXTN                 !!! from setup
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER STRING*150,INF*130
	CHARACTER*150, ALLOCATABLE :: INIDATA(:)
	LOGICAL EXIST,MODIFIED,PRESENT
	DATA PI/3.141592653589793D0/
C CHECK INPINFO
	INF=INPINFO
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNINI,LENEXTN)
	IF(.NOT.PRESENT)CALL READINI_MESG00
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNINI,60,NBE)
	INIFILE=PROJECT(:NBP)//'.'//EXTNINI(:NBE)
	INQUIRE(FILE=INIFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL READINI_MESG01
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(INIFILE,NLEN)
	ALLOCATE(INIDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=1,FILE=INIFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(1,FMT='(A150)')INIDATA(ILEN)
	ENDDO
	CLOSE(1)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=INIDATA(1)
	CALL CONVLOW(STRING,150)
	CALL RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL READINI_MESG02
C SET UP TRACER: TRUE or FALSE
	TRACINP=.FALSE.
	IF(MODERN.EQ.2)THEN
	STRING=INIDATA(1)
	CALL CONVLOW(STRING,150)
	CALL RMBLANK(STRING,150)
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+9).EQ.'trace=true')TRACINP=.TRUE.
	ENDDO
	ENDIF
C ********************************
C START READING THE DATA
C SELECT: heading
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=head',13,'<section=',9,'ok',2)
	CALL READINI_HEAD(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C SELECT: main control parameters
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=ctrl',13,'<section=',9,'ok',2)
	CALL READINI_CTRL(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C SELECT: exchange & correlation
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=exch',13,'<section=',9,'ok',2)
	CALL READINI_EXCH(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C SELECT: iterative procedure limits
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=iter',13,'<section=',9,'ok',2)
	CALL READINI_ITER(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C SELECT: main data
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=main',13,'<section=',9,'ok',2)
	CALL READINI_MAIN(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C SELECT: atomic data
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=sort',13,'<section=',9,'<section=sort',13)
	CALL READINI_SORT(INIDATA(ISEC),NSEC,MSEC,MODERN)
	CALL READINI_CONF!!! select atomic configuration
C ********************************
C SELECT: LMTO basis set
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=sort',13,'<section=',9,'<section=sort',13)
	CALL READINI_LMTO(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C SELECT: FFT grids
	CALL READINI_SECT(INIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=ffts',13,'<section=',9,'ok',2)
	CALL READINI_FFTS(INIDATA(ISEC),NSEC,MSEC,MODERN)
C ********************************
C INIFILE HAS BEEN READ, OVERWRITE IT
	IF(MODIFIED)CALL READINI_OVWR(INIFILE,INIDATA,NLEN)
C MEMORY DEALLOCATIONS
	DEALLOCATE(INIDATA)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG00
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'INIFILE identificator << '//EXTNINI(1:LENEXTN)//' >>'
	WRITE(IUT,*)'is not found in INPINFO string.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG00
	SUBROUTINE READINI_MESG01
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Input data file INIFILE ',INIFILE
	WRITE(IUT,*)'cannot be found. Check for its existence'
	WRITE(IUT,*)'and/or correct path.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG01
	SUBROUTINE READINI_MESG02
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Input data file INIFILE ',INIFILE
	WRITE(IUT,*)'is not recoginized. Check its format.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG02
C *****************************************************************
	END SUBROUTINE READINI




	SUBROUTINE READINI_HEAD(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
*  Reads HEADINI                                                  *
*******************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LABELS  ,ONLY: HEADINI
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C Set section title
	DO IPOS=1,150
	IF(INIDATA(1)(IPOS:IPOS).EQ.'>')EXIT
	ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC.NE.0)INIDATA(1)(JPOS:JPOS)=' '
	ENDDO 
	IF(IPOS.LE.50)THEN
	HELP='! PROJECT HEAD:                        '
	IF(MSEC.NE.0)INIDATA(1)(IPOS+1:IPOS+40)=HELP
	ENDIF
C Allocate temporary file
	ALLOCATE(INICOPY(NSEC))
	DO ISEC=1,MSEC
	INICOPY(ISEC)=INIDATA(ISEC)
	ENDDO
C Set HEADINI
	HEADINI='Compound'
	HELP='! Compound title                       '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'title',5,IN,1,0,RE,1,0,CM,1,0,HEADINI,64,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
        CALL REMCOMM(HEADINI,64)
	CALL RMBLANK(HEADINI,64)
C **************************************
	CALL READINI_ERRR(INIDATA(1),INICOPY(1),NSEC,MSEC,'CTRL')
	DEALLOCATE(INICOPY)
C END PROCESSING CONTROLS
	END SUBROUTINE READINI_HEAD






	SUBROUTINE READINI_CTRL(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
*  Reads CONTROL parameters.                                      *
*    LIFT=1 - strmsh ; =2 + bands ; =3 + self-consistence         *
*    LMTO=1 - original (bare) LMTO; =2 - screened TB-LMTO         *
*        =3 - screened TB-LMTO with real-space screening          *
*    IASA=1 - without =2 - with plane wave expansions             *
*    LRWF=0 - froze Phi, 1/2 - adjust Phi.                        *
*    NPFR=0 - without =1 with atomic force calculations           *
*******************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL,  ONLY : LIFT,LMTO,IASA,LRWF,NPFR,NOVR  !!! from readini
	USE COM_UNIT     ,ONLY : IUN,IUT,IUR                    !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40,TCTRL*10
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C Set section title
	DO IPOS=1,150
	IF(INIDATA(1)(IPOS:IPOS).EQ.'>')EXIT
	ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC.NE.0)INIDATA(1)(JPOS:JPOS)=' '
	ENDDO 
	IF(IPOS.LE.50)THEN
	HELP='! CONTROL PARAMETERS:                  '
	IF(MSEC.NE.0)INIDATA(1)(IPOS+1:IPOS+40)=HELP
	ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC))
	DO ISEC=1,MSEC
	INICOPY(ISEC)=INIDATA(ISEC)
	ENDDO
C Process LIFT
	TCTRL='SCF       '
	HELP='! set: Struc  / Bands / SCF            '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'lift',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
        CALL CONVLOW(TCTRL,10)
        CALL RMBLANK(TCTRL,10)
	LIFT=0
      IF(TCTRL(1:5).EQ.'struc')LIFT=1
      IF(TCTRL(1:5).EQ.'bands')LIFT=2
      IF(TCTRL(1:3).EQ.'scf'  )LIFT=3
      IF(DEF.OR.NTH.OR.ASK    )LIFT=3
	IF(LIFT.EQ.0)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line LIFT'
	CALL FULLSTOP(' ')
	ENDIF
C Process LMTO
	TCTRL='Bare      '
	HELP='! set: Bare / Screened / Rspace          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'lmto',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	LMTO=0
      IF(TCTRL(1:4).EQ.'bare'    )LMTO=1
      IF(TCTRL(1:8).EQ.'screened')LMTO=2
      IF(TCTRL(1:6).EQ.'rspace'  )LMTO=3     
      IF(DEF.OR.NTH.OR.ASK       )LMTO=1
	IF(LMTO.EQ.0)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line LMTO'
	CALL FULLSTOP(' ')
	ENDIF
C Process IASA
	TCTRL='PLW       '
	HELP='! set: FTB/ ASA / PLW                  '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'fulpot',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	IASA=-1
      IF(TCTRL(1:3).EQ.'ftb')IASA=0
      IF(TCTRL(1:3).EQ.'asa')IASA=1
      IF(TCTRL(1:3).EQ.'plw')IASA=2
      IF(DEF.OR.NTH.OR.ASK  )IASA=2
	IF(IASA.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line FULPOT'
	CALL FULLSTOP(' ')
	ENDIF
C Process LRWF
	TCTRL='RelaxP    '
	HELP='! set: Relax / RelaxP / Froze          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'radpot',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	LRWF=-1
      IF(TCTRL(1:5).EQ.'relax' )LRWF=2
      IF(TCTRL(1:6).EQ.'relaxp')LRWF=1
      IF(TCTRL(1:5).EQ.'froze' )LRWF=0
	IF(LRWF.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line RADPOT'
	CALL FULLSTOP(' ')
	ENDIF
C Process NPFR
	TCTRL='none      '
	HELP='! set: none / fast / full              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'frcpul',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	NPFR=-1
      IF(TCTRL(1:4).EQ.'none')NPFR=0
      IF(TCTRL(1:4).EQ.'full')NPFR=1
      IF(TCTRL(1:4).EQ.'fast')NPFR=2
      IF(DEF.OR.NTH.OR.ASK   )NPFR=0
	IF(NPFR.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line FRCPUL'
	CALL FULLSTOP(' ')
	ENDIF
C Donot Process NOVR
	NOVR=0
	HELP='! controls calculating overlap matrix  '
	LHLP=40
C **************************************
	CALL READINI_ERRR(INIDATA(1),INICOPY(1),NSEC,MSEC,'CTRL')
	DEALLOCATE(INICOPY)
C END PROCESSING CONTROLS
	END SUBROUTINE READINI_CTRL




	SUBROUTINE READINI_EXCH(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
* Reads exchange-correlation code.                                *
* IEXC =1 Barth-Hedin,2:Gun-Lun,3:Mor-Jan-Will,4:Vosko-Wilk,Nuss. *
*       5:Perdew-Wang 1991, 6:Gaspar-Kohn-Sham                    *
* for IEXC +10  generalized gradient corrections after Perdew 1991*
* are included, IEXC +20 gives GGA96.                             *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART,   ONLY : NGGAMEM
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL,  ONLY : IEXC                         !!! from readini
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40,TCTRL*10
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C Set section title
      DO IPOS=1,150
      IF(INIDATA(1)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC.NE.0)INIDATA(1)(JPOS:JPOS)=' '
	ENDDO 
      IF(IPOS.LE.50)THEN
      HELP='! EXCHANGE-CORRELATION:                '
      IF(MSEC.NE.0)INIDATA(1)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC))
	DO ISEC=1,MSEC
	INICOPY(ISEC)=INIDATA(ISEC)
	ENDDO
C Process ILDA
	TCTRL='Vosko     '
	HELP='! set: none/Barth/Gunn/etc.            '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'lda',3,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	ILDA=-1
      IF(TCTRL(1:4).EQ.'none'   )ILDA=0
      IF(TCTRL(1:5).EQ.'barth'  )ILDA=1
      IF(TCTRL(1:4).EQ.'gunn'   )ILDA=2
      IF(TCTRL(1:7).EQ.'moruzzi')ILDA=3
      IF(TCTRL(1:5).EQ.'vosko'  )ILDA=4
      IF(TCTRL(1:6).EQ.'perdew' )ILDA=5
      IF(TCTRL(1:6).EQ.'gaspar' )ILDA=6
      IF(DEF.OR.NTH.OR.ASK      )ILDA=4
	IF(ILDA.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line LDA'
	CALL FULLSTOP(' ')
	ENDIF
C Process IGGA
	TCTRL='none      '
	HELP='! set: none/91/96                      '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'gga',3,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	IGGA=-1
      IF(TCTRL(1:4).EQ.'none')IGGA=0
      IF(TCTRL(1:2).EQ.'91'  )IGGA=1
      IF(TCTRL(1:2).EQ.'96'  )IGGA=2
      IF(DEF.OR.NTH.OR.ASK   )IGGA=0
	IF(IGGA.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line GGA'
	CALL FULLSTOP(' ')
	ENDIF
C **************************************
	CALL READINI_ERRR(INIDATA(1),INICOPY(1),NSEC,MSEC,'EXCH')
	DEALLOCATE(INICOPY)
C END PROCESSING EXCHANGE-CORRELATION
	IEXC=ILDA+IGGA*10
      ILDA=MOD(IEXC,10)    !!! LDA key
      IGGA=(IEXC-ILDA)/10  !!! GGA key
	IF(IGGA.NE.0.AND.ILDA.EQ.0)
     &CALL FULLSTOP('<READINI>: Set correct LDA key in INIFILE')
C SET MEMORY LIMITS
	IF(IGGA.EQ.0)NGGAMEM=1
	IF(IGGA.GT.0)NGGAMEM=3
	END SUBROUTINE READINI_EXCH




	SUBROUTINE READINI_ITER(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
* Reads iterative procedure limits and accuracy parameters        *
*  NITER1 - Max.number of iterations                              *
*  ADMIX1 - Charge Density Admixture                              *
*  ADMSPN - Magnetization  Admixture                              *
*  EPSTOT - Total energy accuracy (Ry)                            *
*  LBROY  - switch on Broyden mixing for Lbroy=0,1,... components *
*  IBROY  - switch on Broyden mixing after N=IBROY iterations     *
*  NBROY  - updates   Broyden mixing after NBroy iterations       *
*  ADMIXB - Initial Broyden Jakobian                              *
*  ADMIXH - Mixing for high-l components of the density if        *
*           low-l components (.le.lbroy) are mixed with Broyden   *
*******************************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_SCFLOOP ,ONLY : NITER1,EPSTOT,EPSRHO,EPSMAG
	USE COM_MIXRHO1 ,ONLY : KEY,KSP,ADMIX1,ADMIN,ADMAX,ADMOPT,
     &                                  ADMSPN,ASMIN,ASMAX
	USE COM_MIXBROY ,ONLY : NBROY,LBROY,IBROY,ADMIXB,ADMIXH
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C Set section title
      DO IPOS=1,150
      IF(INIDATA(1)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC.NE.0)INIDATA(1)(JPOS:JPOS)=' '
	ENDDO 
      IF(IPOS.LE.50)THEN
      HELP='! ITERATIVE PROCEDURES:                '
      IF(MSEC.NE.0)INIDATA(1)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC))
	DO ISEC=1,MSEC
	INICOPY(ISEC)=INIDATA(ISEC)
	ENDDO
C Process NITER1
	NITER1=15
	HELP='! # of iterations in SCF loop          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'niter1',6,NITER1,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ADMIX1
	ADMIX1=0.1D0
	HELP='! initial mixing for density           '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'admix1',6,IN,1,0,ADMIX1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ADMSPN
	ADMSPN=0.3D0
	HELP='! initial mixing for magnetization     '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'adspin',6,IN,1,0,ADMSPN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process EPSTOT
	EPSTOT=1.D-07
	HELP='! total energy accuracy                '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'epstot',6,IN,0,0,EPSTOT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process EPSRHO
	EPSRHO=1.D-07
	HELP='! charge density accuracy              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'epsrho',6,IN,0,0,EPSRHO,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process EPSMAG
	EPSMAG=1.D-07
	HELP='! magnetization accuracy               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'epsmag',6,IN,0,0,EPSMAG,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process LBROY
	LBROY=1
	HELP='! Broyden mixing for low l.le.lbroy    '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'lbroy',5,LBROY,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process NBROY
	NBROY=15
	HELP='! Broyden updated  after Nbroy iters   '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'nbroy',5,NBROY,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process IBROY
	IBROY=0
	HELP='! Broyden switched after Ibroy iters   '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'ibroy',5,IBROY,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ADMIXB
	ADMIXB=0.3D0
	HELP='! Broyden mixing parameter             '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'admixb',6,IN,1,0,ADMIXB,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ADMIXH
	ADMIXH=0.3D0
	HELP='! Mixing for high l>lbroy              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'admixh',6,IN,1,0,ADMIXH,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
	CALL READINI_ERRR(INIDATA(1),INICOPY(1),NSEC,MSEC,'ITER')
	DEALLOCATE(INICOPY)
C Specify settings for linear mixing
      ADMIN=MAX(0.D0,ADMIX1/2.D0)
      ADMAX=MIN(1.D0,ADMIX1*2.D0)
      ASMIN=ADMSPN
      ASMAX=ADMSPN
      KEY=0    ! 1 makes ADMIX1=1.D0 for iter=1
      KSP=0    ! 1 makes ADMSPN=1.D0 for iter=1
C Set memory control parameter
	NTERMEM=NBROY
C END PROCESSING ITERATIVE PROCEDURE LIMITS
	END SUBROUTINE READINI_ITER




	SUBROUTINE READINI_MAIN(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
*  Reads main atomic data:                                        *
*   NATOM - number of atoms in unit-cell                          *
*   NSORT - number of different types of atoms                    *
*   NSPIN - number of spins                                       *
*   NORBS - 1/2 which switches off/on spin-orbit coupling         *
*   PAR   - lattice parameter, equillibrium volume ratio          *
*   OVRMAX - maximum allowed overlap for atomic spheres.          *
*   CLSMAX - cluster size for TB-calculation.                     *
*   IS(IATOM) - points to sort # for each atom.                   *
*   NKAP,EKAP  - # of tails for wave functions and their energies *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL ,ONLY : LMTO,IASA
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS
     &                       ,IS,NHSORT
	USE COM_KAPPAR  ,ONLY : NKAP,EKAP
	USE COM_SPHERE  ,ONLY : OVRMAX,CLSMAX
	USE COM_LATPAR  ,ONLY : PAR,PAR0,VV0
	USE COM_UNIT    ,ONLY : IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C Set section title
      DO IPOS=1,150
      IF(INIDATA(1)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC.NE.0)INIDATA(1)(JPOS:JPOS)=' '
	ENDDO 
      IF(IPOS.LE.50)THEN
      HELP='! MAIN ATOMIC DATA:                    '
      IF(MSEC.NE.0)INIDATA(1)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC))
	DO ISEC=1,MSEC
	INICOPY(ISEC)=INIDATA(ISEC)
	ENDDO
C Process NATOM 
	NATOM=0
	HELP='! # of atoms in the unit cell          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'natom',5,NATOM,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	IF(.NOT.VAL)CALL READINI_MESG01
C Process NSORT
	NSORT=NATOM
	HELP='! # of sorts in the unit cell          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'nsort',5,NSORT,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process NSPIN
	NSPIN=1
	HELP='! # of spins                           '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'nspin',5,NSPIN,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process NORBS
	NORBS=1
	HELP='! 1-without/2 -with spin orbit coupling'
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'norbs',5,NORBS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process PAR0
	PAR0=0.D0
	HELP='! lattice parameter in a.u.            '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'par0',4,IN,1,0,PAR0,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	IF(.NOT.VAL)CALL READINI_MESG02
C Process VV0 
	VV0=1.D0
	HELP='! volume compression                   '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'vv0',3,IN,1,0,VV0,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process OVRMAX
	OVRMAX=1.22D0
	HELP='! Maximum allowed overlap for ASA      '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'ovrl',4,IN,1,0,OVRMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process CLSMAX
	IF(LMTO.EQ.1)CLSMAX=0.1D0 !!! no cluster will be generated
	IF(LMTO.GT.1)CLSMAX=0.0D0 !!! will be found automatically
	HELP='! Cluster size in TB calculations      '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'rcls',4,IN,1,0,CLSMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Atom-to-sort pointers
      ALLOCATE(IS(NATOM))
	DO IATOM=1,NATOM
	IS(IATOM)=0
	ENDDO
	HELP='! atom-to-sort pointer array           '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'is(:)',5,IS,NATOM,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	IF(.NOT.VAL)CALL READINI_MESG03
C # of tail energies
	ALLOCATE(NKAP(1))
	IF(IASA.EQ.0)NKAP(1)=1
	IF(IASA.EQ.1)NKAP(1)=1
	IF(IASA.EQ.2)NKAP(1)=2
	HELP='! # of tail energies                   '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'nkap',4,NKAP,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Complex tail energies
	ALLOCATE(EKAP(NKAP(1),1))
	IF(NKAP(1).GT.0)EKAP(1,1)=(-0.1D0,0.D0)
	IF(NKAP(1).GT.1)EKAP(2,1)=(-1.0D0,0.D0)
	IF(NKAP(1).GT.2)EKAP(3,1)=(-2.5D0,0.D0)
	IF(NKAP(1).GT.3.AND.DEF)CALL READINI_MESG04
	HELP=' '
	LHLP=1
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'ek(:)',5,IN,1,0,RE,1,0,EKAP(1,1),NKAP(1),1,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
	CALL READINI_ERRR(INIDATA(1),INICOPY(1),NSEC,MSEC,'MAIN')
	DEALLOCATE(INICOPY)
C END PROCESSING MAIN ATOMIC DATA
C **************************************
C Set lattice parameter according to V/V0 
	PAR=PAR0*VV0**0.333333333333333333D0
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
      NATOMMEM=NATOM
      NSORTMEM=NSORT
      NSPINMEM=NSPIN
      NORBSMEM=NORBS
      IF(NSPIN.EQ.1.AND.NORBS.EQ.2)CALL READINI_MESG05
C ARRAYS DERIVED FROM INPUT 
C nhsort(isort) shows # of atoms for each sort
      ALLOCATE(NHSORT(NSORTMEM))
      DO ISORT=1,NSORT
      NHSORT(ISORT)=0
      DO IATOM=1,NATOM
      IF(IS(IATOM).EQ.ISORT)NHSORT(ISORT)=NHSORT(ISORT)+1
      ENDDO
      ENDDO
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG01
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'# of atoms NATOM cannot be found in'
	WRITE(IUT,*)'INIFILE. Specify correct # of atoms.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG01
	SUBROUTINE READINI_MESG02
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Lattice parameter PAR0 cannot be found in'
	WRITE(IUT,*)'INIFILE. Specifiy correct lattice parameter.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG02
	SUBROUTINE READINI_MESG03
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Atom-to-sort pointer array IS(:) cannot be found'
	WRITE(IUT,*)'INIFILE. Specifiy correct IS(:).'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG03
	SUBROUTINE READINI_MESG04
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Default tail energies are avaiable only for'   
	WRITE(IUT,*)'NKAP.LE.3. Specify EKAP(:) manually in INIFILE.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG04
	SUBROUTINE READINI_MESG05
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Spin-orbit coupling can be switched on'
	WRITE(IUT,*)'only in spin-polarized case.'
	WRITE(IUT,*)'Set NSPIN=2 in INIFILE.'                          
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG05
C *****************************************************************
	END SUBROUTINE READINI_MAIN




	SUBROUTINE READINI_SORT(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
*  Reads data specific for every atom.                            *
*   ILST(ISORT) - lmax for trial function expansion               *
*   ILSB(ISORT) - lmax for basis set                              *
*   ILSV(ISORT) - lmax for the potential and charge density       *
*   ZNUC(ISORT) - nuclear charge                                  *
*   ZCOR(ISORT) - number of core electrons                        *
*   LRTV(ISORT) - =0 - non =1 - semirelativistic version          *
*   ICOR(ISORT) - core renormalisation key                        *
*   AXMAG(ISORT) - magnetization axis array                       *
*   ISPL(ISORT) - = 1 - permanent splitting (magnetic field)      *
*   SPLIT(ISORT) - splitting in case spin-polarisation            *
*   AMAS(ISORT) - nuclear mass of the element                     *
*   SMTS(ISORT)  - non-overlapping mt-sphere radius               *
*   SROU(ISORT)  - cicumscribed sphere radius                     *
*   SASA(ISORT)  - atomic sphere radius                           *
*   RLOC(ISORT)  - nearest neighbors sphere                       *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS
     &                       ,ILST,ILSB,ILSV,LRTV
	USE COM_KAPPAR  ,ONLY : NKAP
      USE COM_SPHERE  ,ONLY : SMT,SMTS,SROU,SASA,ZNUC,ZVAL
     &                       ,ZSEM,ZCOR,AMAS,CLSMAX,OVRMAX
	USE COM_LATPAR  ,ONLY : PAR,PAR0,VV0
	USE COM_SCRINP  ,ONLY : RLOC
	USE COM_CORELEC ,ONLY : ICOR
	USE COM_MAGDAT  ,ONLY : AXMAG,BEXT,ISPL,SPLIT
	USE COM_LABELS  ,ONLY : TXTAT,TXTEL,ELEMENT,NAMELMTO
	USE COM_UNIT    ,ONLY : IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40
     &    ,FILE*130,TCTRL*10,RAXIS*40,STRARR(80)*1
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
	CHARACTER*150, ALLOCATABLE :: INIATOM(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF,EXIST
      DATA PI/3.141592653589793D0/
C ******************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
C Labels
      ALLOCATE(TXTEL(NSORTMEM))
      ALLOCATE(TXTAT(NSORTMEM))
C Different Lmax'es
      ALLOCATE(ILSB(NSORTMEM))
      ALLOCATE(ILST(NSORTMEM))
      ALLOCATE(ILSV(NSORTMEM))
C Charges/Masses
      ALLOCATE(ZNUC(NSORTMEM))
      ALLOCATE(ZVAL(NSORTMEM))
      ALLOCATE(ZSEM(NSORTMEM))
      ALLOCATE(ZCOR(NSORTMEM))
      ALLOCATE(AMAS(NSORTMEM))
C Spheres
      ALLOCATE(SMT (NSORTMEM))
      ALLOCATE(SMTS(NSORTMEM))
      ALLOCATE(SROU(NSORTMEM))
      ALLOCATE(SASA(NSORTMEM))
      ALLOCATE(RLOC(NSORTMEM))
C Controls cores/relativistics/spin splitting
      ALLOCATE(LRTV(NSORTMEM))
      ALLOCATE(ICOR(NSORTMEM))
      ALLOCATE(ISPL(NSORTMEM))
      ALLOCATE(SPLIT(NSORTMEM))
      ALLOCATE(BEXT(NSORTMEM))
	ALLOCATE(AXMAG(3,NSORTMEM))
C ******************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
	ILOC=1
	DO 2000 ISORT=1,NSORT
C Locate Section for given SORT
	CALL READINI_SECT(INIDATA(ILOC),NSEC-ILOC+1,ISEC1,NSEC1,MSEC1,
     &      '<section=sort',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(INIDATA(ILOC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC1.NE.0)INIDATA(ILOC)(JPOS:JPOS)=' '
	ENDDO 
      IF(IPOS.LE.50)THEN
      HELP='! SORT DATA:                           '
      IF(MSEC1.NE.0)INIDATA(ILOC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC1))
	DO ISEC=1,MSEC1
	INICOPY(ISEC)=INIDATA(ILOC+ISEC-1)
	ENDDO
C Process Znuc
	ZNUC(ISORT)=-1.D0
	HELP='! nuclear charge                       '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'znuc',4,IN,1,0,ZNUC(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	IF(ABS(ZNUC(ISORT)+1.D0).LE.1.D-10)CALL READINI_MESG01
C Nuclear charge found, try to find DEFAULT DATA FILE
	NUCZ=NINT(ZNUC(ISORT))
      CALL FIND_LBLANK(NAMELMTO,130,NBL)
	FILE=NAMELMTO(1:NBL)//ELEMENT(NUCZ)
	INQUIRE(FILE=FILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL READINI_MESG02
	CALL FILE_LENGHT(FILE,NLEN1)
	ALLOCATE(INIATOM(NLEN1))
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN1=1,NLEN1
      READ(1,FMT='(A150)')INIATOM(ILEN1)
      ENDDO
      CLOSE(1)
C Process Txtat
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'name',4,IN,1,0,RE,1,0,CM,1,0,TXTAT(ISORT),10,1,' ',1,
     &  DEF,ASK,VAL,NTH,.FALSE.)
	HELP='! atom label                           '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'name',4,IN,1,0,RE,1,0,CM,1,0,TXTAT(ISORT),10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	CALL RMBLANK(TXTAT(ISORT),10)
	TXTEL(ISORT)='for '//TXTAT(ISORT)(1:6)
C Process Zval
	ZVAL(ISORT)=0.D0
	HELP='! # of valence electrons               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'zval',4,IN,1,0,ZVAL(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process Zsem
	ZSEM(ISORT)=0.D0
	HELP='! # of semicore electrons              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'zsem',4,IN,1,0,ZSEM(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process Zcor
	ZCOR(ISORT)=0.D0
	HELP='! # of deepcore electrons              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'zcor',4,IN,1,0,ZCOR(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process Lrtv
	IF(ZNUC(ISORT)+1.D-05.LT.21.D0)TCTRL='none      '
	IF(ZNUC(ISORT)+1.D-05.GE.21.D0)TCTRL='semi      '
	HELP='! controls relativistic: none/semi     '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'lrtv',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	LRTV(ISORT)=-1
      IF(TCTRL(1:4).EQ.'none')LRTV(ISORT)=0
      IF(TCTRL(1:4).EQ.'semi')LRTV(ISORT)=1
      IF(DEF.OR.NTH.OR.ASK   )THEN
	IF(ZNUC(ISORT)+1.D-05.LT.21.D0)LRTV(ISORT)=0
	IF(ZNUC(ISORT)+1.D-05.GE.21.D0)LRTV(ISORT)=1
	ENDIF
	IF(LRTV(ISORT).EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line LRTV '
	CALL FULLSTOP(' ')
	ENDIF
C Process Icor
	TCTRL='soft      '
	HELP='! soft core key: frozen/soft           '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'icor',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	ICOR(ISORT)=-1
      IF(TCTRL(1:4).EQ.'soft'  )ICOR(ISORT)=1
      IF(TCTRL(1:6).EQ.'frozen')ICOR(ISORT)=0
      IF(DEF.OR.NTH.OR.ASK     )ICOR(ISORT)=1
	IF(ICOR(ISORT).EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line ICOR '
	CALL FULLSTOP(' ')
	ENDIF
C Process AXMAG
	AXMAG(1,ISORT)=0.D0
	AXMAG(2,ISORT)=0.D0
	AXMAG(3,ISORT)=1.D0
      DO I=1,40
      RAXIS(I:I)=' '
      ENDDO
	HELP='! local magnetization axis             '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'axmag',5,IN,1,0,RE,1,0,CM,1,0,RAXIS,40,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	IF(VAL)THEN
      CALL CONVLOW(RAXIS,40)
      CALL RMBLANK(RAXIS,40)
	DO I=1,40
	STRARR(I)=RAXIS(I:I)
	ENDDO
	DO I=41,80
	STRARR(I)=' '
	ENDDO
      CALL COMPVEC(STRARR,AXMAG(1,ISORT),3)
	ABA=SQRT(AXMAG(1,ISORT)**2+AXMAG(2,ISORT)**2+AXMAG(3,ISORT)**2)
	IF(ABA.LE.1.D-05)CALL READINI_MESG03
	AXMAG(1,ISORT)=AXMAG(1,ISORT)/ABA
	AXMAG(2,ISORT)=AXMAG(2,ISORT)/ABA
	AXMAG(3,ISORT)=AXMAG(3,ISORT)/ABA
	ENDIF
	IF(NORBS.EQ.1.AND.ABS(AXMAG(1,ISORT)).NE.0.D0
     &             .AND.ABS(AXMAG(2,ISORT)).NE.0.D0
     &             .AND.ABS(AXMAG(3,ISORT)).NE.1.D0)
     &CALL READINI_MESG04
C Process BEXT
	BEXT(ISORT)=+0.0D0
	HELP='! External magnetic field              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'bext',4,IN,1,0,BEXT(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process Ispl
	TCTRL='none      '
	HELP='! splitting key: none/always/kickup    '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'ispl',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	ISPL(ISORT)=-1
      IF(TCTRL(1:4).EQ.'none'  )ISPL(ISORT)=0
      IF(TCTRL(1:6).EQ.'always')ISPL(ISORT)=1
      IF(TCTRL(1:6).EQ.'kickup')ISPL(ISORT)=2
      IF(DEF.OR.NTH.OR.ASK     )ISPL(ISORT)=0
	IF(ISPL(ISORT).EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line ISPL '
	CALL FULLSTOP(' ')
	ENDIF
C Process SPLIT
	IF(NSPIN.EQ.1)SPLIT(ISORT)=+0.0D0
	IF(NSPIN.EQ.2)SPLIT(ISORT)=-0.4D0
	HELP='! initial splitting                    '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'split',5,IN,1,0,SPLIT(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process AMAS
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'amas',4,IN,1,0,AMAS(ISORT),1,1,CM,1,0,' ',1,0,' ',1,
     &  DEF,ASK,VAL,NTH,.FALSE.)
	HELP='! atomic mass as in periodic table     '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'amas',4,IN,1,0,AMAS(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process SMTS
      SMTS(ISORT)=0.D0
      HELP='! non-overlapping MT-sphere            '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'smts',4,IN,1,0,SMTS(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process SROU
	SROU(ISORT)=0.D0
	HELP='! circumscribed sphere                 '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'srou',4,IN,1,0,SROU(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process SASA
        SASA(ISORT)=0.D0
	HELP='! atomic sphere                        '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'sasa',4,IN,1,0,SASA(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process RLOC
	RLOC(ISORT)=CLSMAX
	HELP='! nearest neighbors sphere             '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'rloc',4,IN,1,0,RLOC(ISORT),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ILSV
	ILSV(ISORT)=6
	HELP='! lmax for the potential               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'lmaxv',5,ILSV(ISORT),1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ILST
	ILST(ISORT)=ILSV(ISORT)
	HELP='! lmax for the wave functions          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'lmaxt',5,ILST(ISORT),1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process ILSB
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'lmaxb',5,ILSB(ISORT),1,1,RE,1,0,CM,1,0,' ',1,0,' ',1,
     &  DEF,ASK,VAL,NTH,.FALSE.)
	HELP='! lmax for the basis set               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'lmaxb',5,ILSB(ISORT),1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
	CALL READINI_ERRR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,'SORT')
	DEALLOCATE(INICOPY)
	DEALLOCATE(INIATOM)
	ILOC=ILOC+MSEC1
2000	CONTINUE
C END PROCESSING ATOMIC DATA
C **************************************
C SCALE SPHERES ACCORDING TO VOLUME COMPRESSION
	DO ISORT=1,NSORT
      SMTS(ISORT)=SMTS(ISORT)*PAR/PAR0
	SASA(ISORT)=SASA(ISORT)*PAR/PAR0
	SROU(ISORT)=SROU(ISORT)*PAR/PAR0
	ENDDO
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG01
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Nuclear charge ZNUC cannot be found in'
 	WRITE(IUT,*)'INIFILE. Specify correct ZNUC for ISORT=',ISORT
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG01
	SUBROUTINE READINI_MESG02
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Default LMTO data file ',FILE 
	WRITE(IUT,*)'cannot be found. Check whether the file'
	WRITE(IUT,*)'exists and the path is specified correctly'
	WRITE(IUT,*)'in <SETUP> subroutine.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG02
	SUBROUTINE READINI_MESG03
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Local magnetization axis array'
	WRITE(IUT,*)'not recognized or set to 0.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG03
	SUBROUTINE READINI_MESG04
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Local magnetization axis array'
	WRITE(IUT,*)'can only be 0,0,1 if NORBS=1. '
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG04
C *****************************************************************
	END SUBROUTINE READINI_SORT





	SUBROUTINE READINI_CONF
*******************************************************************
* Reads atomic configuration from atomic data files.              *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS
	USE COM_SPHERE  ,ONLY : ZNUC
	USE COM_LABELS  ,ONLY : ELEMENT,NAMELMTO
	USE COM_CORELEC ,ONLY : NLEVT,NLEVC,LNUM,ELEV,ZLEV
     &                         ,LEVN,LEVL,LEVJ,LEVC
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER STRING*150,HELP*40,SNOT*10,TNOT*2
     &    ,FILE*130
	CHARACTER*150, ALLOCATABLE :: INIATOM(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF,CASE,EXIST
      DATA PI/3.141592653589793D0/
C ******************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(NLEVT(NSORTMEM))
	ALLOCATE(NLEVC(NSORTMEM))
	ALLOCATE(LNUM(36,NSORTMEM))
	ALLOCATE(ELEV(36,NSORTMEM))
	ALLOCATE(ZLEV(36,NSORTMEM))
	ALLOCATE(LEVC(36,NSORTMEM))
	ALLOCATE(LEVN(36,NSORTMEM))
	ALLOCATE(LEVL(36,NSORTMEM))
	ALLOCATE(LEVJ(36,NSORTMEM))
C START LOOPING OVER SORTS
	DO 1000 ISORT=1,NSORT
C Nuclear charge is known, try to find DEFAULT DATA FILE
      NUCZ=NINT(ZNUC(ISORT))
      CALL FIND_LBLANK(NAMELMTO,130,NBL)
      FILE=NAMELMTO(1:NBL)//ELEMENT(NUCZ)
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL READINI_MESG01
      CALL FILE_LENGHT(FILE,NLEN1)
      ALLOCATE(INIATOM(NLEN1))
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN1=1,NLEN1
      READ(1,FMT='(A150)')INIATOM(ILEN1)
      ENDDO
      CLOSE(1)
C Locate subsection=CONF
	CALL READINI_SECT(INIATOM(1),NLEN1,ISEC1,
     &  NSEC1,MSEC1,'<subsection=conf',16,'<subsection=',12,'ok',2)
C Read level information
	ILEV=1
	DO ISEC=ISEC1+2,ISEC1+NSEC1-1
	DO IPOS=1,9
	INIATOM(ISEC)(IPOS:IPOS)=' '
	ENDDO
	DO IPOS=1,150
	IF(INIATOM(ISEC)(IPOS:IPOS).EQ.'/')
     &     INIATOM(ISEC)(IPOS:IPOS)=' '
      ENDDO
	READ(INIATOM(ISEC),*,ERR=10,END=10)
     &  NQ,LQ,J1Q,J2Q,NE,ENER
	LNUM(ILEV,ISORT)=100*NQ+10*LQ+J1Q
	ZLEV(ILEV,ISORT)=DBLE(NE)  ! # of electrons
	ELEV(ILEV,ISORT)=ENER      ! energies
	LEVC(ILEV,ISORT)=1         ! initialize core levels
	LEVN(ILEV,ISORT)=NQ        ! main quantum number
	LEVL(ILEV,ISORT)=LQ        ! orbital quantum number
	LEVJ(ILEV,ISORT)=J1Q       ! total moment
	ILEV=ILEV+1
	ENDDO
  10	NLEVT(ISORT)=ILEV-1
	DEALLOCATE(INIATOM)
1000	CONTINUE
C END PROCESSING CONFIGURATION DATA
C **************************************
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG01
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Default LMTO data file ',FILE 
	WRITE(IUT,*)'cannot be found. Check whether the file'
	WRITE(IUT,*)'exists and the path is specified correctly'
	WRITE(IUT,*)'in <SETUP> subroutine.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG01
C *****************************************************************
	END SUBROUTINE READINI_CONF


	SUBROUTINE READINI_LMTO(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
* Reads LMTO basis set information.                               *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS
     &                       ,ILST,ILSB,ILSV
	USE COM_SPHERE  ,ONLY : ZNUC,ZVAL,ZSEM,ZCOR
	USE COM_KAPPAR  ,ONLY : NPAN,NKAP,EKAP,EK
	USE COM_LATPAR  ,ONLY : PAR,PAR0,VV0
	USE COM_PANPAR  ,ONLY : LTPAN,LSPAN,IATS,ISTS
	USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC
	USE COM_INPPAR  ,ONLY : ENY,DNY,TNY,DHLOG,MNY,LNY
     &                       ,NODES,ITS,NCLS
	USE COM_SEMICOR ,ONLY : NSEM,NDS,LBS,ESEM
	USE COM_CORELEC ,ONLY : NLEVT,NLEVC,LNUM,ELEV,ZLEV
     &                       ,LEVC,LEVN,LEVL,LEVJ,ICOR
	USE COM_LABELS  ,ONLY : ELEMENT,NAMELMTO,TXTEL,TXTAT
	USE COM_LMTIND  ,ONLY : LMTIND
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: IWK(:,:)
      INTEGER, ALLOCATABLE :: ITM(:,:)
	COMPLEX*16, ALLOCATABLE :: ETMP(:)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40,SNOT*10
     &    ,FILE*130,TNOT*2
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
	CHARACTER*150, ALLOCATABLE :: INIATOM(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF,CASE,EXIST
      DATA PI/3.141592653589793D0/
C ******************************************
C FIRST, DO SEMICORE STATES
C ******************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(NSEM(NSORTMEM))
	ALLOCATE(ESEM(36,NSORTMEM))
	ALLOCATE(NDS(36,NSORTMEM))
	ALLOCATE(LBS(36,NSORTMEM))
	ALLOCATE(IWK(36,NSORTMEM))
C ******************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
	ILOC=1
	DO 2000 ISORT=1,NSORT                !!! over sorts
C Locate Section for given SORT
	CALL READINI_SECT(INIDATA(ILOC),NSEC-ILOC+1,ISEC1,
     &  NSEC1,MSEC1,'<section=sort',13,'<section=',9,'ok',2)
C Locate subsection SEMI
	CALL READINI_SECT(INIDATA(ILOC),NSEC1,ISEC2,
     &  NSEC2,MSEC2,'<subsection=semi',16,'<',1,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(INIDATA(ISEC2+ILOC-1)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
	DO JPOS=IPOS+1,150
	IF(MSEC2.NE.0)INIDATA(ISEC2+ILOC-1)(JPOS:JPOS)=' '
	ENDDO 
      IF(IPOS.LE.50)THEN
      HELP='! Semicore states:                     '
      IF(MSEC2.NE.0)INIDATA(ISEC2+ILOC-1)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC2))
	DO ISEC=1,MSEC2
	INICOPY(ISEC)=INIDATA(ISEC2+ISEC-1+ILOC-1)
	ENDDO
C Nuclear charge is known, try to find DEFAULT DATA FILE
      NUCZ=NINT(ZNUC(ISORT))
      CALL FIND_LBLANK(NAMELMTO,130,NBL)
      FILE=NAMELMTO(1:NBL)//ELEMENT(NUCZ)
      INQUIRE(FILE=FILE,EXIST=EXIST)
      CALL FILE_LENGHT(FILE,NLEN1)
      ALLOCATE(INIATOM(NLEN1))
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN1=1,NLEN1
      READ(1,FMT='(A150)')INIATOM(ILEN1)
      ENDDO
      CLOSE(1)
C PROCESS DEFAULTS FIRST
C Default Nsem
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),
     &  NLEN1,NLEN1,'nsem',4,NSEM(ISORT),1,1,RE,1,0,CM,1,0,
     &  ' ',1,0,' ',1,DEF,ASK,VAL,NTH,.FALSE.)
C Default States
	DO ISEM=1,NSEM(ISORT)
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),
     &  NLEN1,NLEN1,'lsem',4,IN,1,0,RE,1,0,CM,1,0,SNOT,10,1,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.FALSE.)
        CALL GET_SPDF(SNOT,10,MQN,LQN)
	NDS(ISEM,ISORT)=MQN-LQN-1
	LBS(ISEM,ISORT)=LQN
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),
     &  NLEN1,NLEN1,'esem',4,IN,1,0,RE,1,0,ESEM(ISEM,ISORT),1,1,
     &  ' ',1,0,' ',1,DEF,ASK,VAL,NTH,.FALSE.)
	ENDDO
C CHECK INIDATA NOW
C Process Nsem
	HELP='! # of semicore states                 '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'nsem',4,NSEM(ISORT),1,1,RE,1,0,CM,1,0,
     &  ' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.FALSE.)
	IF(ASK)CALL READINI_MESG08
	IF(.NOT.NTH)THEN
	DO ISEM=1,NSEM(ISORT)
C Process Lsem
	HELP='! n,l, energy                          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'lsem',4,IN,1,0,RE,1,0,CM,1,0,SNOT,10,1,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
	IF(NTH)CALL READINI_MESG09
        CALL GET_SPDF(SNOT,10,MQN,LQN)
	NDS(ISEM,ISORT)=MQN-LQN-1
	LBS(ISEM,ISORT)=LQN
C Process Esem
	HELP='! n,l, energy                          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'esem',4,IN,1,0,RE,1,0,ESEM(ISEM,ISORT),1,1,
     &  ' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
	ENDDO
	ENDIF
C **************************************
	CALL READINI_ERRR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'SEMI')
	DEALLOCATE(INIATOM)
	DEALLOCATE(INICOPY)
	ILOC=ILOC+MSEC1
2000	CONTINUE                         !!! over sorts
C END PROCESSING ATOMIC DATA
C **************************************
C REDEFINE LmaxB
	DO ISORT=1,NSORT
      DO ISEM=1,NSEM(ISORT)
	ILSB(ISORT)=MAX(ILSB(ISORT),LBS(ISEM,ISORT))
	ENDDO
	ENDDO
C SET # of semicore electrons
      DO ISORT=1,NSORT
	ZSEMT=0.D0
	DO ISEM=1,NSEM(ISORT)
      DO ILEV=1,NLEVT(ISORT)
      IF(LEVN(ILEV,ISORT).EQ.NDS(ISEM,ISORT)+LBS(ISEM,ISORT)+1.AND.
     &   LEVL(ILEV,ISORT).EQ.LBS(ISEM,ISORT))THEN
      ZSEMT=ZSEMT+ZLEV(ILEV,ISORT)
	LEVC(ILEV,ISORT)=2
	ENDIF
        ENDDO
	ENDDO
	IF(ABS(ZSEM(ISORT)-ZSEMT).GT.1.D-10.AND.
     &   ABS(ZSEM(ISORT)).GT.1.D-10)CALL READINI_MESG01
	ZSEM(ISORT)=ZSEMT
      ENDDO
C DEFINE variables which control the memory
      LMAXTMEM=0
      LMAXBMEM=0
      LMAXVMEM=0
      LMAXCMEM=0
      DO ISORT=1,NSORT
      LMAXTMEM=MAX(LMAXTMEM,ILST(ISORT))
      LMAXBMEM=MAX(LMAXBMEM,ILSB(ISORT))
      LMAXVMEM=MAX(LMAXVMEM,ILSV(ISORT))
      LMAXCMEM=MAX(LMAXCMEM,ILSV(ISORT),ILST(ISORT),ILSB(ISORT))
      ENDDO
      LIMTMEM =(LMAXTMEM+1)**2
      LIMBMEM =(LMAXBMEM+1)**2
      LIMVMEM =(LMAXVMEM+1)**2
      LIMCMEM =(LMAXCMEM+1)**2
      LIMT1MEM=(LMAXTMEM+2)**2
      LIMB1MEM=(LMAXBMEM+2)**2
      LIMV1MEM=(LMAXVMEM+2)**2
      LIMC1MEM=(LMAXCMEM+2)**2
      LIMT2MEM=(LMAXTMEM+1)*(2*LMAXTMEM+1)*(2*LMAXTMEM+3)/3
      LIMB2MEM=(LMAXBMEM+1)*(2*LMAXBMEM+1)*(2*LMAXBMEM+3)/3
      LIMV2MEM=(LMAXVMEM+1)*(2*LMAXVMEM+1)*(2*LMAXVMEM+3)/3
      LIMC2MEM=(LMAXCMEM+1)*(2*LMAXCMEM+1)*(2*LMAXCMEM+3)/3
      NWIGMEM =(LMAXCMEM+1)*(2*LMAXCMEM+1)*(2*LMAXCMEM+3)/3
C DEFINE total # of panels
      IPAN=1
	DO ISORT=1,NSORT
      DO ISEM=1,NSEM(ISORT)
	IWK(ISEM,ISORT)=0
	ENDDO
	ENDDO
	DO ISORT=1,NSORT
      DO ISEM=1,NSEM(ISORT)
	IF(IWK(ISEM,ISORT).EQ.0)THEN
	IWK(ISEM,ISORT)=IPAN
	IPAN=IPAN+1
	DO JSORT=1,NSORT
	DO JSEM=1,NSEM(JSORT)
	IF(ABS(ESEM(ISEM,ISORT)-ESEM(JSEM,JSORT)).LE.1.D-10)
     &IWK(JSEM,JSORT)=IPAN
	ENDDO
	ENDDO
	ENDIF 
	ENDDO
	ENDDO
      NPAN=IPAN
	NPANMEM=NPAN           ! # of panels
	NKAPMEM=NKAP(1)        ! max.# of kappas
C DEFINE TAIL ENERGIES
	ALLOCATE(ETMP(NKAPMEM))
	DO IKAP=1,NKAPMEM
	ETMP(IKAP)=EKAP(IKAP,1)
	ENDDO
	DEALLOCATE(NKAP)
	DEALLOCATE(EKAP)
	ALLOCATE(NKAP(NPANMEM))
	NKAP(1)=NKAPMEM
	DO IPAN=2,NPAN
	NKAP(IPAN)=1
	ENDDO
	ALLOCATE(EKAP(NKAPMEM,NPANMEM))
	ALLOCATE(EK(NKAPMEM,NPANMEM))
	DO IKAP=1,NKAP(1)
	EKAP(IKAP,1)=ETMP(IKAP)
	ENDDO
	DO IPAN=2,NPAN
	DO ISORT=1,NSORT 
	DO ISEM=1,NSEM(ISORT)
	IF(IWK(ISEM,ISORT).EQ.IPAN)
     &EKAP(1,IPAN)=ESEM(ISEM,ISORT)
	ENDDO
	ENDDO
	ENDDO
C Scale tail energies
	DO IPAN=1,NPAN
	DO IKAP=1,NKAP(IPAN)
	EKAP(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR0**2/PAR**2
	EK(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR*PAR
	ENDDO
	ENDDO
      DO ISORT=1,NSORT
      DO ISEM=1,NSEM(ISORT)
      ESEM(ISEM,ISORT)=ESEM(ISEM,ISORT)*PAR0**2/PAR**2
      ENDDO
      ENDDO
C ******************************************
C SECOND, DO VALENCE STATES
C ******************************************
C Nodes/Basis pointers/Enu's/Dnu's stored in COM_INPPAR
	ALLOCATE(NODES(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(ITS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(MNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(ENY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,
     &NSPINMEM))
	ALLOCATE(DNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,
     &NSPINMEM))
	ALLOCATE(TNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,
     &NSPINMEM))
	ALLOCATE(DHLOG(0:LMAXBMEM,NSORTMEM,NKAPMEM,NPANMEM,
     &NSPINMEM))
C ******************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
	ILOC=1
	DO 4000 ISORT=1,NSORT              !!! over sorts
C Locate Section for given SORT
	CALL READINI_SECT(INIDATA(ILOC),NSEC-ILOC+1,ISEC1,
     &  NSEC1,MSEC1,'<section=sort',13,'<section=',9,'ok',2)
C Locate subsection LMTO
	CALL READINI_SECT(INIDATA(ILOC),NSEC1,ISEC2,
     &  NSEC2,MSEC2,'<subsection=lmto',16,'<',1,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(INIDATA(ISEC2+ILOC-1)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC2.NE.0)INIDATA(ISEC2+ILOC-1)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! Valence states:                      '
      IF(MSEC2.NE.0)INIDATA(ISEC2+ILOC-1)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC2))
	DO ISEC=1,MSEC2
	INICOPY(ISEC)=INIDATA(ISEC2+ISEC-1+ILOC-1)
	ENDDO
C Nuclear charge is known, try to find DEFAULT DATA FILE
      NUCZ=NINT(ZNUC(ISORT))
      CALL FIND_LBLANK(NAMELMTO,130,NBL)
      FILE=NAMELMTO(1:NBL)//ELEMENT(NUCZ)
      INQUIRE(FILE=FILE,EXIST=EXIST)
      CALL FILE_LENGHT(FILE,NLEN1)
      ALLOCATE(INIATOM(NLEN1))
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN1=1,NLEN1
      READ(1,FMT='(A150)')INIATOM(ILEN1)
      ENDDO
      CLOSE(1)
C Process Nodes
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'mqn(:)',6,NODES(0,ISORT,1,1),MIN(ILSB(ISORT)+1,5),1,
     &  RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.FALSE.)
	DO IKAP=1,NKAP(1)                 !!! over ikap
	DO L=0,MIN(ILSB(ISORT),4)
	NODES(L,ISORT,IKAP,1)=NODES(L,ISORT,1,1)
	ENDDO
	HELP='! main quantum numbers                 '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'mqn(:)',6,NODES(0,ISORT,IKAP,1),ILSB(ISORT)+1,1,
     &  RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
	ENDDO                             !!! over ikap
C Process Basis
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'bas(:)',6,ITS(0,ISORT,1,1),MIN(ILSB(ISORT)+1,5),1,
     &  RE,1,0,CM,1,0,' ',1,0,' ',1,DEF,ASK,VAL,NTH,.FALSE.)
	DO IKAP=1,NKAP(1)                 !!! over ikap
	DO L=0,MIN(ILSB(ISORT),4)
	ITS(L,ISORT,IKAP,1)=ITS(L,ISORT,1,1)
	ENDDO
	HELP='! LMTO basis set                       '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'bas(:)',6,ITS(0,ISORT,IKAP,1),ILSB(ISORT)+1,1,
     &  RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
	ENDDO                             !!! over ikap
C Process Mnu
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'mnu(:)',6,MNY(0,ISORT,1,1),MIN(ILSB(ISORT)+1,5),1,
     &  RE,1,0,CM,1,0,' ',1,0,' ',1,DEF,ASK,VAL,NTH,.FALSE.)
	DO IKAP=1,NKAP(1)                 !!! over ikap
	DO L=0,MIN(ILSB(ISORT),4)
	MNY(L,ISORT,IKAP,1)=MNY(L,ISORT,1,1)
	ENDDO
	HELP='! choice of Enu(s)                     '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'mnu(:)',6,MNY(0,ISORT,IKAP,1),ILSB(ISORT)+1,1,
     &  RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
	ENDDO                             !!! over ikap
C Process Enu
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'enu(:)',6,IN,1,0,ENY(0,ISORT,1,1,1),
     &  MIN(ILSB(ISORT)+1,5),1,CM,1,0,' ',1,0,HELP,LHLP,DEF,
     &  ASK,VAL,NTH,.FALSE.)
	DO IKAP=1,NKAP(1)                 !!! over ikap
	DO L=0,MIN(ILSB(ISORT),4)
	ENY(L,ISORT,IKAP,1,1)=ENY(L,ISORT,1,1,1)
	ENDDO
	HELP=' '
	LHLP=1
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'enu(:)',6,IN,1,0,ENY(0,ISORT,IKAP,1,1),
     &  ILSB(ISORT)+1,1,CM,1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,
     &  NTH,.TRUE.)
	ENDDO                             !!! over ikap
C Process Dnu
	CALL READINI_CHAR(INIATOM(1),INIATOM(1),NLEN1,NLEN1,
     &  'dnu(:)',6,IN,1,0,DNY(0,ISORT,1,1,1),
     &  MIN(ILSB(ISORT)+1,5),1,CM,1,0,' ',1,0,' ',1,DEF,ASK,
     &  VAL,NTH,.FALSE.)
	DO IKAP=1,NKAP(1)                 !!! over ikap
	DO L=0,MIN(ILSB(ISORT),4)
	DNY(L,ISORT,IKAP,1,1)=DNY(L,ISORT,1,1,1)
	ENDDO
	HELP=' '
	LHLP=1 
	CALL READINI_CHAR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &  NSEC2,MSEC2,'dnu(:)',6,IN,1,0,DNY(0,ISORT,IKAP,1,1),
     &  ILSB(ISORT)+1,1,CM,1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,
     &  NTH,.TRUE.)
	ENDDO                             !!! over ikap
C Set arrays
	DO IKAP=1,NKAP(1)                 !!! over ikap
	ENYUP=0.D0
	DO L=0,ILSB(ISORT)
	NODES(L,ISORT,IKAP,1)=NODES(L,ISORT,IKAP,1)-L-1
	ENY(L,ISORT,IKAP,1,NSPIN)=ENY(L,ISORT,IKAP,1,1)
	DNY(L,ISORT,IKAP,1,NSPIN)=DNY(L,ISORT,IKAP,1,1)
	ENYUP=ENYUP+ENY(L,ISORT,IKAP,1,1)*
     &DBLE(2*L+1)/DBLE(ILSB(ISORT)+1)**2
	ENDDO
	DO L=ILSB(ISORT)+1,ILST(ISORT)
	NODES(L,ISORT,IKAP,1)=0
	ENY(L,ISORT,IKAP,1,1)=ENYUP
	ENY(L,ISORT,IKAP,1,NSPIN)=ENYUP
	DNY(L,ISORT,IKAP,1,1)=DBLE(-L-1)
	DNY(L,ISORT,IKAP,1,NSPIN)=DBLE(-L-1)
	ENDDO
	ENDDO                             !!! over ikap
C **************************************
	CALL READINI_ERRR(INIDATA(ISEC2+ILOC-1),INICOPY(1),
     &NSEC2,MSEC2,'LMTO')
	DEALLOCATE(INICOPY)
	DEALLOCATE(INIATOM)
	ILOC=ILOC+MSEC1
4000	CONTINUE                          !!! over sorts
C END PROCESSING ATOMIC DATA
C ***************************************
C DEFINE # of valence electrons
      ALLOCATE(ITM(0:LMAXBMEM,NKAPMEM))
      ISTOP=0
      DO ISORT=1,NSORT                !!! over sorts
C Initialize indicator
      DO IKAP=1,NKAP(1)
      DO L=0,ILSB(ISORT)
      ITM(L,IKAP)=0
      ENDDO
      ENDDO
      ZVALT=0.D0
      DO IKAP=1,NKAP(1)
      DO L=0,ILSB(ISORT)
      IF(ITM(L,IKAP).EQ.0)THEN
C Check atomic states
      DO ILEV=1,NLEVT(ISORT)
	DO JKAP=1,NKAP(1)
      IF(LEVL(ILEV,ISORT).EQ. L.AND.LEVN(ILEV,ISORT).EQ.
     &NODES(L,ISORT,IKAP,1)+L+1.AND.LEVN(ILEV,ISORT).EQ.
     &NODES(L,ISORT,JKAP,1)+L+1.AND.ITS(L,ISORT,IKAP,1).EQ.1.AND.
     &ITS(L,ISORT,JKAP,1).EQ.1)ITM(L,JKAP)=1
	ENDDO
      IF(LEVL(ILEV,ISORT).EQ.L.AND.LEVN(ILEV,ISORT).EQ.
     &NODES(L,ISORT,IKAP,1)+L+1.AND.ITS(L,ISORT,IKAP,1).EQ.1)THEN
	ZVALT=ZVALT+ZLEV(ILEV,ISORT)
	LEVC(ILEV,ISORT)=3
	ENDIF
      ENDDO
C Check with semicore states
      DO ISEM=1,NSEM(ISORT)
      IF(LBS(ISEM,ISORT).EQ.L.AND.NDS(ISEM,ISORT).EQ.
     &NODES(L,ISORT,IKAP,1).AND.ITS(L,ISORT,IKAP,1).EQ.1)THEN
      CALL SET_SPDF(TNOT,2,NODES(L,ISORT,IKAP,1)+L+1,L)
	CALL READINI_MESG02
      ENDIF
      ENDDO
C
	ENDIF
	ENDDO
	ENDDO
C Check for virtual crystal
	ZEXTR=ZNUC(ISORT)-DBLE(NINT(ZNUC(ISORT)))
	ZVALT=ZVALT+ZEXTR
	IF(ABS(ZVAL(ISORT)-ZVALT).GT.1.D-10.AND.
     &   ABS(ZVAL(ISORT)).GT.1.D-10)CALL READINI_MESG03
	ZVAL(ISORT)=ZVALT
C Set deep core charge now:
      ZCORT=ZNUC(ISORT)-ZVAL(ISORT)-ZSEM(ISORT)
	IF(ABS(ZCOR(ISORT)-ZCORT).GT.1.D-10.AND.
     &   ABS(ZCOR(ISORT)).GT.1.D-10)CALL READINI_MESG04
	ZCOR(ISORT)=ZCORT
	IF(ABS(ZCOR(ISORT)).LE.1.D-10.AND.ICOR(ISORT).EQ.1)
     &ICOR(ISORT)=0
      ENDDO                                   !!! over sorts
      IF(ISTOP.EQ.1)CALL FULLSTOP(' ')
C DEFINE # of deep core levels according to ZCOR
	DO ISORT=1,NSORT
	ILEVC=0
      CHARGE=0.D0
      DO ILEV=1,NLEVT(ISORT)
	IF(LEVC(ILEV,ISORT).EQ.1)THEN
      CHARGE=CHARGE+ZLEV(ILEV,ISORT)
	IF(ABS(CHARGE-ZCOR(ISORT)).LE.1.D-10)ILEVC=ILEV
	ENDIF
 	ENDDO
	IF(ABS(CHARGE-ZCOR(ISORT)).GT.1.D-10)
     &CALL READINI_MESG06
	NLEVC(ISORT)=ILEVC
	ENDDO
C CHECK CORE STATES
	DO ISORT=1,NSORT
	DO ILEV=1,NLEVT(ISORT)
	DO JLEV=1,NLEVT(ISORT)
	IF(LEVC(ILEV,ISORT).GT.LEVC(JLEV,ISORT).AND.
     &   ELEV(ILEV,ISORT).LT.ELEV(JLEV,ISORT))
     &   CALL READINI_MESG07
	ENDDO
	ENDDO
	ENDDO
C DEFINE Logical basis pointers; stored in COM_PANPAR
	ALLOCATE(LTPAN(0:LMAXTMEM+1,NATOMMEM,NKAPMEM,NPANMEM))
	ALLOCATE(LSPAN(0:LMAXTMEM+1,NSORTMEM,NKAPMEM,NPANMEM))
      ALLOCATE(LMTIND(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,NPANMEM))
	ALLOCATE(IATS(NATOMMEM,NPANMEM))
	ALLOCATE(ISTS(NSORTMEM,NPANMEM))
C # of bands; stored in COM_NBANDS
	ALLOCATE(NBNDF(NPANMEM))
	ALLOCATE(NBNDE(NPANMEM))
	ALLOCATE(NBNDT(NPANMEM))
	ALLOCATE(NBNDC(NPANMEM))
C Process main panel
	NBND=0
	DO IATOM=1,NATOM                       !!! over atoms
	ISORT=IS(IATOM)
	I=0
	DO IKAP=1,NKAP(1)
	DO L=0,ILSB(ISORT)
	LTPAN(L,IATOM,IKAP,1)=.FALSE.
	LSPAN(L,ISORT,IKAP,1)=.FALSE.
	IF(ITS(L,ISORT,IKAP,1).EQ.1)THEN
	LTPAN(L,IATOM,IKAP,1)=.TRUE.
	LSPAN(L,ISORT,IKAP,1)=.TRUE.
	I=I+1
	NBND=NBND+2*L+1
	ENDIF
	ENDDO
	DO L=ILSB(ISORT)+1,LMAXTMEM
	LTPAN(L,IATOM,IKAP,1)=.FALSE.
	LSPAN(L,ISORT,IKAP,1)=.FALSE.
	MNY(L,ISORT,IKAP,1)=0
	ENDDO
	LTPAN(LMAXTMEM+1,IATOM,IKAP,1)=.FALSE.
	LSPAN(LMAXTMEM+1,ISORT,IKAP,1)=.FALSE.
	ENDDO
	IATS(IATOM,1)=0
	ISTS(ISORT,1)=0
	IF(I.NE.0)IATS(IATOM,1)=IATOM
	IF(I.NE.0)ISTS(ISORT,1)=ISORT
	ENDDO                                 !!! over atoms
	NBNDT(1)=NBND
	NDIMMEM=NBNDT(1)       ! Max.dimension of the hamiltonian.
C Process semicore panels 
	DO IPAN=2,NPAN                        !!! over panels
	NBND=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IATS(IATOM,IPAN)=0
	ISTS(ISORT,IPAN)=0
	DO L=0,ILST(ISORT)
	LSPAN(L,ISORT,1,IPAN)=.FALSE.
	LTPAN(L,IATOM,1,IPAN)=.FALSE.
	MNY(L,ISORT,1,IPAN)=0
      ENY(L,ISORT,1,IPAN,1)=0.D0
      ENY(L,ISORT,1,IPAN,NSPIN)=0.D0
	ENDDO
	LTPAN(ILST(ISORT)+1,IATOM,1,IPAN)=.FALSE.
	LSPAN(ILST(ISORT)+1,ISORT,1,IPAN)=.FALSE.
	DO ISEM=1,NSEM(ISORT)
	IF(ABS(ESEM(ISEM,ISORT)-EKAP(1,IPAN)).LE.1.D-10)THEN
	L=LBS(ISEM,ISORT)
	IATS(IATOM,IPAN)=IATOM
	ISTS(ISORT,IPAN)=ISORT
	NBND=NBND+2*L+1
	LTPAN(L,IATOM,1,IPAN)=.TRUE.
	LSPAN(L,ISORT,1,IPAN)=.TRUE.
	MNY(L,ISORT,1,IPAN)=2
	NODES(L,ISORT,1,IPAN)=NDS(ISEM,ISORT)
      ENY(L,ISORT,1,IPAN,1)=EKAP(1,IPAN)
      ENY(L,ISORT,1,IPAN,NSPIN)=EKAP(1,IPAN)
	ENDIF
	ENDDO
	ENDDO
	NBNDF(IPAN)=NBND
	NBNDT(IPAN)=NBND
	NBNDE(IPAN)=NBND+1
	NBNDC(IPAN)=0
	ENDDO                                    !!! over panels
C Sort multiple kappa basis over different classes
	ALLOCATE(LNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(NCLS(0:LMAXTMEM,NSORTMEM,NPANMEM))
      DO IPAN=1,NPAN
      DO ISORT=1,NSORT
      DO L=0,ILST(ISORT)
      DO IKAP=1,NKAP(IPAN)
      LNY(L,ISORT,IKAP,IPAN)=0
      ENDDO
      ICLS=0
      DO IKAP=1,NKAP(IPAN)
      IF(LNY(L,ISORT,IKAP,IPAN).EQ.0)THEN
      ICLS=ICLS+1
      DO JKAP=1,NKAP(IPAN)
      CASE=MNY(L,ISORT,IKAP,IPAN).EQ.0.AND.
     &     MNY(L,ISORT,JKAP,IPAN).EQ.0.AND.
     &     ENY(L,ISORT,IKAP,IPAN,1).EQ.
     &     ENY(L,ISORT,JKAP,IPAN,1).AND.
     &     ENY(L,ISORT,IKAP,IPAN,NSPIN).EQ.
     &     ENY(L,ISORT,JKAP,IPAN,NSPIN)
      IF(.NOT.CASE)CASE=
     &     MNY(L,ISORT,IKAP,IPAN).EQ.1.AND.
     &     MNY(L,ISORT,JKAP,IPAN).EQ.1.AND.
     &     DNY(L,ISORT,IKAP,IPAN,1).EQ.
     &     DNY(L,ISORT,JKAP,IPAN,1).AND.
     &     DNY(L,ISORT,IKAP,IPAN,NSPIN).EQ.
     &     DNY(L,ISORT,JKAP,IPAN,NSPIN).AND.
     &     NODES(L,ISORT,IKAP,IPAN).EQ.
     &     NODES(L,ISORT,JKAP,IPAN)
      IF(.NOT.CASE)CASE=
     &     MNY(L,ISORT,IKAP,IPAN).EQ.2.AND.
     &     MNY(L,ISORT,JKAP,IPAN).EQ.2.AND.
     &     NODES(L,ISORT,IKAP,IPAN).EQ.
     &     NODES(L,ISORT,JKAP,IPAN)
      IF(.NOT.CASE)CASE=
     &     MNY(L,ISORT,IKAP,IPAN).EQ.3.AND.
     &     MNY(L,ISORT,JKAP,IPAN).EQ.3.AND.
     &     NODES(L,ISORT,IKAP,IPAN).EQ.
     &     NODES(L,ISORT,JKAP,IPAN)
      IF(CASE)LNY(L,ISORT,JKAP,IPAN)=ICLS
      ENDDO
      ENDIF
      ENDDO
      NCLS(L,ISORT,IPAN)=ICLS
      ENDDO
      ENDDO
      ENDDO
C Set complex index
	DO IPAN=1,NPAN
	IDIM=0
	DO ISPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)
	DO IATOM=1,NATOM
	DO L=0,ILSB(IS(IATOM))
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)=IDIM
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
C RELEASE MEMORY ALLOCATED BY SCRATCH ARRAYS
	DEALLOCATE(ETMP)
	DEALLOCATE(IWK)
      DEALLOCATE(ITM)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG01
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'# of semicore electrons ZSEM calculated'
	WRITE(IUT,*)'for ISORT=',TXTAT(ISORT),' is equal to ',ZSEMT
	WRITE(IUT,*)'does not coincide with ZSEM = ',ZSEM(ISORT)
	WRITE(IUT,*)'read from INIFILE. Check for correctness.'
	WRITE(IUT,*)'See also default LMTO data file located in' 
	WRITE(IUT,*)'the directory ',NAMELMTO
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG01

	SUBROUTINE READINI_MESG02
      WRITE(IUT,*)'<READINI>: Error in LMTO basis set ------------>'
      WRITE(IUT,*)TNOT,
     &'-state appears in BOTH valence and semicore panel;'
      WRITE(IUT,*)
     &'If semicore panel is constructed automatically, manual '
      WRITE(IUT,*)
     &'resetting is required in INIFILE.The program will stop.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG02

	SUBROUTINE READINI_MESG03
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'# of valence electrons ZVAL calculated'
	WRITE(IUT,*)'for ISORT=',TXTAT(ISORT),' is equal to ',ZVALT
	WRITE(IUT,*)'does not coincide with ZVAL = ',ZVAL(ISORT)
	WRITE(IUT,*)'read from INIFILE. Check for correctness.'
	WRITE(IUT,*)'See also default LMTO data file located in' 
	WRITE(IUT,*)'the directory ',NAMELMTO
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG03

	SUBROUTINE READINI_MESG04
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'# of core electrons ZCOR calculated'
	WRITE(IUT,*)'for ISORT=',TXTAT(ISORT),' is equal to ',ZCORT
	WRITE(IUT,*)'does not coincide with ZCOR = ',ZCOR(ISORT)
	WRITE(IUT,*)'read from INIFILE. Check for correctness.'
	WRITE(IUT,*)'See also default LMTO data file located in' 
	WRITE(IUT,*)'the directory ',NAMELMTO
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG04

	SUBROUTINE READINI_MESG05
	WRITE(IUT,*)'No errors'
	END SUBROUTINE READINI_MESG05

	SUBROUTINE READINI_MESG06
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Error during control estimate of core charge'
	WRITE(IUT,*)'for ISORT =',TXTAT(ISORT)
	WRITE(IUT,*)'Value ZCOR =',ZCOR(ISORT)
	WRITE(IUT,*)'Control value CHARGE =',CHARGE
	WRITE(IUT,*)'Check # of valence/semicore/deepcore '
	WRITE(IUT,*)'electrons in INIFILE.'
	WRITE(IUT,*)'See also default LMTO data file located in' 
	WRITE(IUT,*)'the directory ',NAMELMTO
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG06

	SUBROUTINE READINI_MESG07
	CHARACTER PRM(3)*8
	PRM(1)='deepcore'
	PRM(2)='semicore'
	PRM(3)='valence '
	WRITE(IUT,*)'Warning from <READINI>:',TXTAT(ISORT)
	CALL SET_SPDF(TNOT,2,LEVN(ILEV,ISORT),LEVL(ILEV,ISORT))
	WRITE(IUT,106)TNOT,ELEV(ILEV,ISORT),PRM(LEVC(ILEV,ISORT))
  106	FORMAT(1X,A2,'-atomic level, E=',G12.5, 'is treated as ',A10)
	WRITE(IUT,*)'while --->'
	CALL SET_SPDF(TNOT,2,LEVN(JLEV,ISORT),LEVL(JLEV,ISORT))
	WRITE(IUT,106)TNOT,ELEV(JLEV,ISORT),PRM(LEVC(JLEV,ISORT))
	WRITE(IUT,*)'The correct way to sort the levels is such that'
	WRITE(IUT,*)'    E(deepcore) < E (semicore) < E (valence)'
	WRITE(IUT,*)'Check selection of semicore and (or) valence states'
	END SUBROUTINE READINI_MESG07

	SUBROUTINE READINI_MESG08
	WRITE(IUT,*)'Terminated in <READINI>:',TXTAT(ISORT)
	WRITE(IUT,*)'You cannot <ask for> a # of semicore states.'
	WRITE(IUT,*)'Either specify exact # <nsem> or comment this line.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG08

	SUBROUTINE READINI_MESG09
	WRITE(IUT,*)'Terminated in <READINI>:',TXTAT(ISORT)
	WRITE(IUT,*)'Necessary information about semicore state'
	WRITE(IUT,*)'cannot be found. Check for a valid format'
	WRITE(IUT,*)'of INIFILE.' 
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG09

C *****************************************************************
	END SUBROUTINE READINI_LMTO









	SUBROUTINE READINI_FFTS(INIDATA,NSEC,MSEC,MODERN)
*******************************************************************
*  Reads different FFT grids.                                     *
*   NFF - number of fully filled bands                            *
*   NEF - number of bands at EF                                   *
*   NDIV(1..3) - divisions along G1,G2,G3 of the BZ               *
*   NDIVDIR - divsions for high-symmetry lines                    *
*   NDC - divisions along G1 for semicore panels                  *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS
     &                       ,NHSORT
	USE COM_SPHERE  ,ONLY : ZNUC,ZVAL,ZSEM,ZCOR
	USE COM_KAPPAR  ,ONLY : NPAN,NKAP
	USE COM_LATPAR  ,ONLY : PAR,PAR0,VV0
	USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDC,NBNDT,POLUS
     &                       ,MBNDF,MBNDE,MBNDC,WINDOW
	USE COM_INPTTR  ,ONLY : KEYTTR,NDIV,NDIC,NDIW,SH
     &                       ,TFERMI,GBROAD
	USE COM_FFTMESH ,ONLY : NFFTG
	USE COM_FERMI   ,ONLY : EF
	USE COM_ACCURG  ,ONLY : EPSR,EPSG
	USE COM_TEILORG ,ONLY : KEYT,BZM
	USE COM_LMTOUT  ,ONLY : ICBND
	USE COM_UNIT    ,ONLY : IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER INIDATA(NSEC)*150,STRING*150,HELP*40,TCTRL*10
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C Set section title
      DO IPOS=1,150
      IF(INIDATA(1)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)INIDATA(1)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! FFT GRIDS:                           '
      IF(MSEC.NE.0)INIDATA(1)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file 
	ALLOCATE(INICOPY(NSEC))
	DO ISEC=1,MSEC
	INICOPY(ISEC)=INIDATA(ISEC)
	ENDDO
C Process NFF
	NFF=-1
	HELP='! # fully filled bands                 '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'nfull',5,NFF,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process NEF
	NEF=MIN(5,NBNDT(1))
	HELP='! # of bands crossing Ef               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'natef',5,NEF,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process POLUS
	POLUS=0.1D0
	HELP='! Linear response broadending          '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'broad',5,IN,1,0,POLUS,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process Efermi
	EF=0.0D0
	HELP='! Approximate Fermi energy (Ry)        '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'efermi',6,IN,1,0,EF,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process Temperature
	TFERMI=0.0D0
	HELP='! Temperature (Ry)                     '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'temp',4,IN,1,0,TFERMI,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process KEYTTR
	TCTRL='Ttrs     '
	HELP='! Sttr/Ttrs/Gaus                       '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'bzint',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TCTRL,10)
      CALL RMBLANK(TCTRL,10)
	KEYTTR=-1
	IF(TCTRL(1:4).EQ.'sttr')KEYTTR=0
	IF(TCTRL(1:4).EQ.'ttrs')KEYTTR=1
	IF(TCTRL(1:4).EQ.'gaus')KEYTTR=2
C Process Gbroad
	GBROAD=0.015D0
	HELP='! Gaussian Broadening (Ry)             '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'gausbr',6,IN,1,0,GBROAD,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	IF(KEYTTR.EQ.2.AND.TFERMI.NE.0.D0)CALL READINI_MESG04
C Process NDIV
	NDIV(1)=0
	NDIV(2)=0
	NDIV(3)=0
	HELP='! Tetrahedron mesh                     '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'ndiv(:)',7,NDIV,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process NDIW
      NDW=NDIV(1)
      HELP='! Tetrahedron mesh for weights         '
      LHLP=40
      CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'ndiw(:)',7,NDW,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process NDC
	NDC=NDIV(1)
	HELP='! Tetrahedron mesh for semicore        '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'ndic(:)',7,NDC,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process NFFTG
	NFFTG(1)=0
	NFFTG(2)=0
	NFFTG(3)=0
	HELP='! FFT mesh                             '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'nfft(:)',7,NFFTG,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process WINDOW
	WINDOW=0.5D0
	HELP='! Linear response window               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'window',6,IN,1,0,WINDOW,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process EPSR
	EPSR=0.02D0
	HELP='! PseudoHankel accuracy                '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'epsr',4,IN,1,0,EPSR,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process EPSG
	EPSG=0.04D0
	HELP='! PseudoHankel accuracy                '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'epsg',4,IN,1,0,EPSG,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process BZM
	BZM=0.D0      
	HELP='! Radius                               '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'bzm',3,IN,1,0,BZM,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Process KEYT
	TCTRL='On        '
	HELP='! Teilor key: On/Off                   '
	LHLP=40
	CALL READINI_CHAR(INIDATA(1),INICOPY(1),NSEC,MSEC,
     &  'keyt',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	CALL CONVLOW(TCTRL,10)
	CALL RMBLANK(TCTRL,10)
	KEYT=-1
	IF(TCTRL(1:2).EQ.'on' )KEYT=1
	IF(TCTRL(1:3).EQ.'off')KEYT=0
        IF(DEF.OR.NTH.OR.ASK  )KEYT=1
	IF(KEYT.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Syntax error in control line KEYT'
	CALL FULLSTOP(' ')
	ENDIF
C **************************************
	CALL READINI_ERRR(INIDATA(1),INICOPY(1),NSEC,MSEC,'FFTS')
	DEALLOCATE(INICOPY)
C SET DIVISIONS FOR SEMICORE PANELS OR FOR INTEGRATION WEIGHTS
      IF(NDIV(1).NE.0)THEN
	DN2=DBLE(NDIV(2))/DBLE(NDIV(1))
      DN3=DBLE(NDIV(3))/DBLE(NDIV(1))
      NDIC(1)=NDC
      NDIC(2)=ANINT(DBLE(NDC)*DN2)
      NDIC(3)=ANINT(DBLE(NDC)*DN3)
	IF(NDIC(1).EQ.0)NDIC(1)=1
	IF(NDIC(2).EQ.0)NDIC(2)=1
	IF(NDIC(3).EQ.0)NDIC(3)=1
      NDIW(1)=NDW
      NDIW(2)=ANINT(DBLE(NDW)*DN2)
      NDIW(3)=ANINT(DBLE(NDW)*DN3)
	ENDIF
	CALL READINI_MESG01 ! check grids
C CHECK WHETHER THE NUMBER OF VALENCE BANDS IS CORRECT
      ZVALTOT=0.D0
      DO ISORT=1,NSORT              !!! define total valence charge
      ZVALTOT=ZVALTOT+(ZNUC(ISORT)-ZCOR(ISORT))*
     &DBLE(NHSORT(ISORT)) 
      ENDDO
      DO IPAN=2,NPAN                !!! define semicore charge
      ZVALTOT=ZVALTOT-2.D0*DBLE(NBNDT(IPAN))
      ENDDO
      IF(NFF.GT.-1)THEN ! check it
      NBNDF(1)=NFF+NEF
      NBNDE(1)=NFF+1
      NBNDC(1)=NBNDF(1)-NBNDE(1)+1
      IF(2.D0*NBNDF(1).LT.ZVALTOT)CALL READINI_MESG02
      IF(2.D0*NBNDF(1).LT.ZVALTOT)NFF=-1
      ENDIF
      IF(NFF.EQ.-1)THEN ! set automatically
      IF(MOD(ZVALTOT,2.D0).LT.1.D-10)NVL=ZVALTOT/2.D0
      IF(MOD(ZVALTOT,2.D0).GE.1.D-10)NVL=ZVALTOT/2.D0+1
      IF(MOD(DBLE(NEF),2.D0).LT.1.D-10)NFF=NVL-NEF/2
      IF(MOD(DBLE(NEF),2.D0).GT.1.D-10)NFF=NVL-NEF/2-1
      IF(NFF.LT.0)NFF=0
      NBNDF(1)=NFF+NEF
      NBNDE(1)=NFF+1
      NBNDC(1)=NBNDF(1)-NBNDE(1)+1
      ENDIF
C INITIALIZE # OF BANDS WHICH WILL BE DETERMINED DURING ITERATIONS
	MBNDF=-1
	MBNDE=-1
	MBNDC=-1
C SET BZ-SHIFT FOR METALLIC CASE
	ALLOCATE(SH(3,NPANMEM))
      DO IPAN=1,NPAN
      DO I=1,3
      SH(I,IPAN)=0.D0
      ENDDO
      ENDDO
      IF(NBNDF(1)-NBNDE(1)+1.NE.0.AND.ICBND.EQ.0)THEN
      SH(1,1)=0.D0!1.D-07
      SH(2,1)=0.D0!2.D-07
      SH(3,1)=0.D0!3.D-07
      ENDIF
C END PROCESSING FFT INFORMATION
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG01
      IF(MOD(NFFTG(1),2).NE.0.OR. 
     &   MOD(NFFTG(2),2).NE.0.OR.
     &   MOD(NFFTG(3),2).NE.0)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Fast Fourier transform grid NFFTG = ',NFFTG
	WRITE(IUT,*)'read from INIFILE is not even. All divisions'
	WRITE(IUT,*)'of NFFTG must be even numbers. Correct INIFILE.'
	CALL FULLSTOP(' ')
	ENDIF
	END SUBROUTINE READINI_MESG01
	SUBROUTINE READINI_MESG02
	WRITE(IUT,*)'Warning from <READINI>:'
      WRITE(IUT,*)'The number of  filled bands for  the main  valence'
      WRITE(IUT,*)'panel calculated from the valence charge is larger'
      WRITE(IUT,*)'than the value read from INIFILE. Standard correc-'
      WRITE(IUT,*)'tion will be made.  In the following,  check input'
      WRITE(IUT,*)'values NFF and NEF in the INIFILE.'
	END SUBROUTINE READINI_MESG02
	SUBROUTINE READINI_MESG03
	WRITE(IUT,*)'Warning from <READINI>:'
	WRITE(IUT,*)'Linear response window is smaller than the maximum'
	WRITE(IUT,*)'frequency chosen. Not all interband transitions'
	WRITE(IUT,*)'will be treated!!!'
	END SUBROUTINE READINI_MESG03
	SUBROUTINE READINI_MESG04
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'Finite temperature calculation cannot be done'
	WRITE(IUT,*)'with gaussian broadening technique.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG04
C **************************************************************
	END SUBROUTINE READINI_FFTS






      SUBROUTINE READINI_UPGR
************************************************************
*  Upgrades INIFILE by storing MT-spheres and other data   *
*  which have been determined during initialzation.        *
************************************************************
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS
      USE COM_SPHERE  ,ONLY : SMT,SMTS,SROU,SASA,ZNUC,ZVAL
     &                       ,ZSEM,ZCOR
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW
      USE COM_FFTMESH ,ONLY: NFFTG
      USE COM_LMTINP  ,ONLY: INIFILE
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER NUPG(3)
	CHARACTER*150, ALLOCATABLE :: INIDATA(:)
	CHARACTER*150, ALLOCATABLE :: INICOPY(:)
      CHARACTER STRING*150,HELP*40
      LOGICAL DEF,ASK,VAL,NTH,MDF
	DATA PI/3.141592653589793D0/
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(INIFILE,NLEN)
	ALLOCATE(INIDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=1,FILE=INIFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(1,FMT='(A150)')INIDATA(ILEN)
	ENDDO
	CLOSE(1)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=INIDATA(1)
	CALL CONVLOW(STRING,150)
	CALL RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+12).EQ.'input=classic')MODERN=1
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.0)MODERN=1
      IF(MODERN.EQ.1)GOTO2000 ! no upgration possible
C ********************************
C UPGRADE MUFFIN-TIN SPHERES NOW
      CALL READINI_SECT(INIDATA(1),NLEN,ISEC0,NSEC,MSEC,
     &  '<section=sort',13,'<section=',9,'<section=sort',13)
      ILOC=ISEC0
      DO 1000 ISORT=1,NSORT
C Locate Section for given SORT
	CALL READINI_SECT(INIDATA(ILOC),NSEC-ILOC+ISEC0,ISEC1,
     &  NSEC1,MSEC1,'<section=sort',13,'<section=',9,'ok',2)
	ALLOCATE(INICOPY(NSEC1))
	DO ISEC=1,MSEC1
	INICOPY(ISEC)=INIDATA(ILOC+ISEC-1)
	ENDDO
C Upgrade Zval
	HELP='! # of valence electrons               '
      ZVAL1=ZVAL(ISORT)
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'zval',4,IN,1,0,ZVAL1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade Zsem
        ZSEM1=ZSEM(ISORT)
	HELP='! # of semicore electrons              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'zsem',4,IN,1,0,ZSEM1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade Zcor
        ZCOR1=ZCOR(ISORT)
	HELP='! # of deepcore electrons              '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'zcor',4,IN,1,0,ZCOR1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade SMTS
      SMTS1=SMTS(ISORT)
      HELP='! non-overlapping MT-sphere            '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'smts',4,IN,1,0,SMTS1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade SROU
        SROU1=SROU(ISORT)
	HELP='! circumscribed sphere                 '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'srou',4,IN,1,0,SROU1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade SASA
      SASA1=SASA(ISORT)
      HELP='! classic atomic sphere                '
	LHLP=40
	CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC1,MSEC1,
     &  'sasa',4,IN,1,0,SASA1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	DEALLOCATE(INICOPY)
	ILOC=ILOC+MSEC1
1000  CONTINUE
C END UPGRATING ATOMIC DATA
C **************************************
C UPGRADE: FFT grids
      CALL READINI_SECT(INIDATA(1),NLEN,ISEC0,NSEC,MSEC,
     &  '<section=ffts',13,'<section=',9,'ok',2)
	ALLOCATE(INICOPY(NSEC))
      ILOC=ISEC0
	DO ISEC=1,MSEC
      INICOPY(ISEC)=INIDATA(ISEC+ILOC-1)
	ENDDO
C Upgrade NDIV
      NUPG(1)=NDIV(1)
      NUPG(2)=NDIV(2)
      NUPG(3)=NDIV(3)
	HELP='! Tetrahedron mesh                     '
	LHLP=40
      CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC,MSEC,
     &  'ndiv(:)',7,NUPG,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade NDIC
      NUPG(1)=NDIC(1)
	HELP='! Tetrahedron mesh for semicore panels '
	LHLP=40
      CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC,MSEC,
     &  'ndic(:)',7,NUPG(1),1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
C Upgrade NFFTG
      NUPG(1)=NFFTG(1)
      NUPG(2)=NFFTG(2)
      NUPG(3)=NFFTG(3)
	HELP='! FFT mesh                             '
	LHLP=40
      CALL READINI_CHAR(INIDATA(ILOC),INICOPY(1),NSEC,MSEC,
     &  'nfft(:)',7,NFFTG,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.)
	DEALLOCATE(INICOPY)
C ********************************
C INIFILE HAS BEEN UPGRATED, STORE IT
      CALL READINI_OVWR(INIFILE,INIDATA,NLEN)
C MEMORY DEALLOCATIONS
2000  DEALLOCATE(INIDATA)
      END SUBROUTINE READINI_UPGR




	SUBROUTINE READINI_SECT(INIDATA,NLEN,ISEC,NSEC,MSEC,
     &             SLABL,NL,SNEXT,NN,SNOTS,NT)
**************************************************************
*  Selects section in the INIDATA                            *
**************************************************************
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER SLABL*(*),SNEXT*(*),SNOTS*(*)
     &    ,STRING*150,INIDATA(NLEN)*150
	ISEC=0
	DO ILEN=1,NLEN
	STRING=INIDATA(ILEN)
	CALL CONVLOW(STRING,150)
	DO IPOS=1,150-NL
	IF(STRING(IPOS:IPOS+NL-1).EQ.SLABL)ISEC=ILEN
	IF(ISEC.NE.0)EXIT
	ENDDO
	IF(ISEC.NE.0)EXIT
	ENDDO
	NSEC=0
	DO ILEN=ISEC+1,NLEN
	STRING=INIDATA(ILEN)
	CALL CONVLOW(STRING,150)
	DO IPOS=1,150-MAX(NL,NN,NT)
	IF(STRING(IPOS:IPOS+NN-1).EQ.SNEXT.AND.
     &     STRING(IPOS:IPOS+NT-1).NE.SNOTS)NSEC=ILEN-ISEC
	IF(NSEC.NE.0)EXIT
	ENDDO
	IF(NSEC.NE.0)EXIT
	ENDDO
	MSEC=NSEC
	IF(ISEC.EQ.0)NSEC=1  !!! no section present
	IF(ISEC.EQ.0)MSEC=0  
	IF(ISEC.EQ.0)ISEC=1
	IF(ISEC.NE.0.AND.NSEC.EQ.0)MSEC=NLEN-ISEC+1 !!! end of file reached
	IF(ISEC.NE.0.AND.NSEC.EQ.0)NSEC=NLEN-ISEC+1
	END SUBROUTINE READINI_SECT 



	SUBROUTINE READINI_CHAR(INIDATA,INICOPY,NSEC,MSEC,
     &  CLOC,NLOC,INTARR,NINT,KINT,RELARR,NREL,KREL,
     &  CMPARR,NCMP,KCMP,CHRARR,NCHR,KCHR,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,MDF)
************************************************************
*  Locates CHAR in character string, returns value,        *
*  modifies if necessary.                                  *
************************************************************
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
C PASSED PARAMETERS
	INTEGER INTARR(NINT)
	DIMENSION RELARR(NREL)
	COMPLEX*16 CMPARR(NCMP)
	CHARACTER CHRARR*(*),HELP*(*),CLOC*(*)
     &    ,INIDATA(NSEC)*150,INICOPY(NSEC)*150
C LOCAL VARIBLES
	CHARACTER STRING*150,STRINC*150,CHARVAL*150
	LOGICAL DEF,ASK,VAL,NTH,MDF
C START CODE:
      DEF=.FALSE. ! default value processed
      VAL=.FALSE. ! actual value processed
      ASK=.FALSE. ! question asterik
      NTH=.TRUE.  ! no keywork found
    	ICONT=0     ! # of continuation lines processed
	IF(MSEC.EQ.0)THEN
C String of zero lenght case
	IXCOORD=0
	IYCOORD=0
	ENDIF
	DO ISEC=1,MSEC
	CALL REMCOMM(INICOPY(ISEC),150)
	ENDDO
C Locate CHAR now:
	IXCOORD=0
	IYCOORD=0
	DO ISEC=1,MSEC
	STRING=INICOPY(ISEC)
	CALL CONVLOW(STRING,150)
	DO IPOS=1,150-NLOC
	IF(STRING(IPOS:IPOS+NLOC-1).EQ.CLOC)THEN
C Character found, locate '='
	STRING=INICOPY(ISEC)
	CALL REMCOMM(STRING,150)
	DO LPOS=IPOS+NLOC,150
	IF(STRING(LPOS:LPOS).EQ.'=')EXIT
	ENDDO
	IF(LPOS.EQ.150+1)CALL READINI_MESG01
	IXCOORD=LPOS+1
	IYCOORD=ISEC
	DO LPOS=IPOS,IXCOORD-1
	STRING(LPOS:LPOS)=' '
	ENDDO
C Reset INICOPY
	INICOPY(ISEC)=STRING
      LOTHER=150
	DO LPOS=IXCOORD,150
	IF(STRING(LPOS:LPOS).EQ.';')THEN
C Erase other data from the STRING
	DO KPOS=LPOS,150
	STRING(KPOS:KPOS)=' '
	ENDDO
	LOTHER=LPOS
	EXIT
	ENDIF
	ENDDO
C Erase data to be read
	DO KPOS=IXCOORD,LOTHER
	INICOPY(ISEC)(KPOS:KPOS)=' '
	ENDDO
C Check for DEFAULT/ASK MARK
	DO LPOS=IXCOORD,150
	IF(STRING(LPOS:LPOS).EQ.'#')THEN
	DEF=.TRUE.
	NTH=.FALSE.
	IDEF=LPOS
	EXIT
	ELSEIF(STRING(LPOS:LPOS).EQ.'?')THEN
	ASK=.TRUE.
	NTH=.FALSE.
	IASK=LPOS
	EXIT
	EXIT
	ENDIF
	ENDDO
C READ VALUE:
	IF(.NOT.DEF.AND..NOT.ASK)THEN
	VAL=.TRUE.
	NTH=.FALSE.
C INTEGER ARRAY
	IF(KINT.NE.0)THEN
	DO ITRL=1,NINT
	ITRL1=ITRL
	READ(STRING(IXCOORD:150),*,ERR=110,END=110)
     &(INTARR(I),I=1,ITRL)
	ENDDO
	GOTO200  !!! EXIT
C Processing continuation lines
 110	ITRL=ITRL1
    	ICONT=ICONT+1
	IF(NINT.EQ.1)CALL READINI_MESG02
	IF(ICONT.GT.100000)CALL READINI_MESG05
	DO ITRL1=ITRL,NINT
      READ(INIDATA(IYCOORD+ICONT),*,ERR=110,END=110)
     &(INTARR(I),I=ITRL,ITRL1)
	ENDDO
C REAL ARRAY
	ELSEIF(KREL.NE.0)THEN
	DO ITRL=1,NREL
	ITRL1=ITRL
	READ(STRING(IXCOORD:150),*,ERR=120,END=120)
     &(RELARR(I),I=1,ITRL)
	ENDDO
	GOTO200  !!! EXIT
C Processing continuation lines
 120	ITRL=ITRL1
    	ICONT=ICONT+1
	IF(NREL.EQ.1)CALL READINI_MESG03
	IF(ICONT.GT.100000)CALL READINI_MESG05
	DO ITRL1=ITRL,NREL
      READ(INIDATA(IYCOORD+ICONT),*,ERR=120,END=120)
     &(RELARR(I),I=ITRL,ITRL1)
	ENDDO
C COMPLEX ARRAY
	ELSEIF(KCMP.NE.0)THEN
      DO ITRL=1,NCMP
      ITRL1=ITRL
      READ(STRING(IXCOORD:150),*,ERR=130,END=130)
     &(CMPARR(I),I=1,ITRL)
      ENDDO
      GOTO200  !!! EXIT
C Processing continuation lines
 130  ITRL=ITRL1
      ICONT=ICONT+1
	IF(NCMP.EQ.1)CALL READINI_MESG04
      IF(ICONT.GT.100000)CALL READINI_MESG05
      DO ITRL1=ITRL,NCMP
      READ(INIDATA(IYCOORD+ICONT),*,ERR=130,END=130)
     &(CMPARR(I),I=ITRL,ITRL1)
      ENDDO
	ELSEIF(KCHR.NE.0)THEN
	IF(IXCOORD+NCHR-1.GT.150)CALL READINI_MESG06
	READ(STRING(IXCOORD:IXCOORD+NCHR-1),FMT='(A)')CHRARR
	ENDIF
	DO ID=1,ICONT
	DO LPOS=1,150
      INICOPY(IYCOORD+ID)(LPOS:LPOS)=' '
	ENDDO
	ENDDO
 200	CONTINUE
	ENDIF
	EXIT
	ENDIF
	ENDDO
	IF(IXCOORD.NE.0)EXIT
	ENDDO
C If nothing else to do, get out from here.
C	IF(.NOT.ASK)RETURN  ! do not make formatting (commented now!)
	IF(.NOT.MDF)RETURN  ! do not modify if not necessary
	IF(NTH)RETURN       ! return if no keyword found
	IF(DEF)RETURN       ! return if default is found
	IF(ICONT.GT.0)RETURN! do not format lines with continuations 
C NOW TRY TO MODIFY:
	DO LPOS=1,150 
	STRING(LPOS:LPOS)=' '
	STRINC(LPOS:LPOS)=' '
	ENDDO
	DO LPOS=1,IXCOORD-1
	STRING(LPOS:LPOS)=INIDATA(IYCOORD)(LPOS:LPOS)
	STRINC(LPOS:LPOS)=INICOPY(IYCOORD)(LPOS:LPOS)
	ENDDO
	ISHIFT=0
	IF(KINT.NE.0)N=NINT
	IF(KREL.NE.0)N=NREL
	IF(KCMP.NE.0)N=NCMP
	IF(KCHR.NE.0)N=1   
	DO I=1,N
	IF(KINT.NE.0)CALL INT_TO_CHAR(INTARR(I),CHARVAL,150,LENC) 
	IF(KREL.NE.0)CALL REL_TO_CHAR(RELARR(I),CHARVAL,150,LENC) 
	IF(KCMP.NE.0)CALL CMP_TO_CHAR(CMPARR(I),CHARVAL,150,LENC) 
	IF(KCHR.NE.0)CALL FIND_LBLANK(CHRARR,NCHR,NCHR1)
	IF(KCHR.NE.0)LENC=NCHR1
	IF(KCHR.NE.0)CHARVAL(1:NCHR1)=CHRARR(1:NCHR1)
	IF(IXCOORD+ISHIFT+LENC-1.GT.150)CALL READINI_MESG07
	STRING(IXCOORD+ISHIFT:IXCOORD+ISHIFT+LENC-1)=CHARVAL(1:LENC)
	ISHIFT=ISHIFT+LENC+1
	ENDDO
C Line is modified, try to put the rest
	LNEXT=150+1
	DO LPOS=IXCOORD,150
	IF(INIDATA(IYCOORD)(LPOS:LPOS).EQ.';')LNEXT=LPOS
	IF(INIDATA(IYCOORD)(LPOS:LPOS).EQ.';')EXIT
	ENDDO
	IPOS=IXCOORD+ISHIFT
	DO LPOS=LNEXT,150
	IPOS=IPOS+1
	IF(IPOS.GT.150)EXIT ! truncated
	STRING(IPOS:IPOS)=INIDATA(IYCOORD)(LPOS:LPOS)
	STRINC(IPOS:IPOS)=INICOPY(IYCOORD)(LPOS:LPOS)
	ENDDO
C Add help
	CALL REMCOMM(STRING,150)
	DO IBL=150,1,-1
	IF(STRING(IBL:IBL).NE.' ')EXIT
	ENDDO
	IPOS=IBL+1
	DO LPOS=1,LHLP
	IPOS=IPOS+1
	IF(IPOS.GT.150)EXIT ! truncated
	STRING(IPOS:IPOS)=HELP(LPOS:LPOS)
	ENDDO
C Seems that's all, may return
	INIDATA(IYCOORD)=STRING
	INICOPY(IYCOORD)=STRINC
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE READINI_MESG01
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Compilation error in the line:'
	WRITE(IUT,*) STRING
	WRITE(IUT,*)'of input FILE. An input token does not'
	WRITE(IUT,*)'follow the correct format. No sign =!'
	WRITE(IUT,*)'Correct input FILE.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG01
	SUBROUTINE READINI_MESG02
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Compilation error in the line:'
	WRITE(IUT,*) STRING
	WRITE(IUT,*)'of input FILE or near it. Integer value '
	WRITE(IUT,*)'cannot be read. Check for correct format.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG02
	SUBROUTINE READINI_MESG03
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Compilation error in the line:'
	WRITE(IUT,*)STRING
	WRITE(IUT,*)'of input FILE or near it. Real value '
	WRITE(IUT,*)'cannot be read. Check for correct format.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG03
	SUBROUTINE READINI_MESG04
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Compilation error in the line:'
	WRITE(IUT,*)STRING
	WRITE(IUT,*)'of input FILE or near it. Complex value '
	WRITE(IUT,*)'cannot be read. Check for correct format.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG04
	SUBROUTINE READINI_MESG05
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Infinite looping detected in subroutine'
	WRITE(IUT,*)'<READINI_CHAR> when compiling continuation'
	WRITE(IUT,*)'lines in input FILE. Check for correct format.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG05
	SUBROUTINE READINI_MESG06
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Subscript out of bounds detected.'
	WRITE(IUT,*)'Character string to be read by this subroutine'
	WRITE(IUT,*)'has a lenght=',NCHR
	WRITE(IUT,*)'which exceeds maximum allowed value=',
     &  150+1-IXCOORD
	WRITE(IUT,*)'Most probable reason: too long record'
	WRITE(IUT,*)'in one of the main input files.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG06
	SUBROUTINE READINI_MESG07
	WRITE(IUT,*)'Terminated in <READINI_CHAR>:'
	WRITE(IUT,*)'Subscript out of bounds detected.'
	WRITE(IUT,*)'Modification of character string by'
	WRITE(IUT,*)'concatenating another string of the lenght='
	WRITE(IUT,*)LENC,' exceeds maximum allowed value.'
	WRITE(IUT,*)'Most probable reason: too long record'
	WRITE(IUT,*)'in one of the main input files.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READINI_MESG07
C *****************************************************************
	END SUBROUTINE READINI_CHAR	




	SUBROUTINE READINI_ERRR(INIDATA,INICOPY,NSEC,MSEC,SECT)
*******************************************************************
*  Traces INICOPY text field for errors.                          *
*******************************************************************
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER SECT*(*),INICOPY(NSEC)*150,INIDATA(NSEC)*150
	ICTRL=0
	ISTOP=0
	DO ISEC=1,MSEC
	IERR=0
	DO IPOS=1,150
C Check for errors
	IF(INICOPY(ISEC)(IPOS:IPOS).NE.' ')IERR=1
	IF(INICOPY(ISEC)(IPOS:IPOS).EQ.'<')IERR=0
	IF(INICOPY(ISEC)(IPOS:IPOS).EQ.'<')ICTRL=ICTRL+1
	IF(INICOPY(ISEC)(IPOS:IPOS).EQ.'<')EXIT
	ENDDO
	IF(ICTRL.GT.1)EXIT
	IF(IERR.EQ.1)THEN
	ISTOP=1
      WRITE(IUT,*)'======================================'
      WRITE(IUT,*)'<READINI>: Syntax error in input FILE:'
	WRITE(IUT,*)'<SECTION='//SECT//'>'
	WRITE(IUT,*)'The following line has error(s):'
	WRITE(IUT,*)INIDATA(ISEC)
	WRITE(IUT,*)INICOPY(ISEC)
	ENDIF
	ENDDO
	IF(ISTOP.EQ.1)CALL FULLSTOP(' ')
	END SUBROUTINE READINI_ERRR




	SUBROUTINE READINI_OVWR(INIFILE,INIDATA,NLEN)
************************************************************
*  Overwrites INIFILE.                                     *
************************************************************
	USE COM_UNIT   ,ONLY: IUN,IUT,IUR                     !!! from setup
	CHARACTER INIFILE*130, INIDATA(NLEN)*150
C TRY TO REFORMAT
	LCOM=0
	IDAT=0
	DO ILEN=1,NLEN                        !!! over ilen
	IF(INIDATA(ILEN)(1:1).NE.'C'.AND.
     &     INIDATA(ILEN)(1:1).NE.'c'.AND.
     &     INIDATA(ILEN)(1:1).NE.'*'.AND.
     &     INIDATA(ILEN)(1:1).NE.'!')THEN
	DO IPOS=1,150                         !!! over ipos
	IF(INIDATA(ILEN)(IPOS:IPOS).EQ.'!')THEN
C Estimate comment lenght
	DO JPOS=150,IPOS,-1
	IF(INIDATA(ILEN)(JPOS:JPOS).NE.' ')EXIT
	ENDDO
	LCOM=MAX(LCOM,JPOS-IPOS+1)
C Estimate record lenght
	DO JPOS=IPOS-1,1,-1
	IF(INIDATA(ILEN)(JPOS:JPOS).NE.' ')EXIT
	ENDDO
	IDAT=MAX(IDAT,JPOS)
	EXIT
	ENDIF
	ENDDO                                 !!! over ipos
	ENDIF
	ENDDO                                 !!! over ilen
C FORMATTING IS POSSIBLE
	IF(IDAT+10+LCOM.LE.150-1)THEN
C Comments start from position 
	ICOM=IDAT+10
	DO ILEN=1,NLEN                        !!! over ilen
	IF(INIDATA(ILEN)(1:1).NE.'C'.AND.
     &     INIDATA(ILEN)(1:1).NE.'c'.AND.
     &     INIDATA(ILEN)(1:1).NE.'*'.AND.
     &     INIDATA(ILEN)(1:1).NE.'!')THEN
	DO IPOS=1,150                         !!! over ipos
	IF(INIDATA(ILEN)(IPOS:IPOS).EQ.'!')THEN
	LSHF=ICOM-IPOS
C Strat shifting comments
	IF(LSHF.GT.0)THEN
	DO JPOS=150,IPOS,-1
	IF(JPOS+LSHF.LE.150)THEN
	INIDATA(ILEN)(JPOS+LSHF:JPOS+LSHF)=INIDATA(ILEN)(JPOS:JPOS)
	INIDATA(ILEN)(JPOS:JPOS)=' '
	ENDIF
	ENDDO
	ELSEIF(LSHF.LT.0)THEN
	DO JPOS=IPOS,150,+1
	IF(JPOS+LSHF.GE.1)THEN
	INIDATA(ILEN)(JPOS+LSHF:JPOS+LSHF)=INIDATA(ILEN)(JPOS:JPOS)
	INIDATA(ILEN)(JPOS:JPOS)=' '
	ENDIF
	ENDDO
	ENDIF
C End shifting comments
	EXIT
	ENDIF
	ENDDO                                 !!! over ipos
	ENDIF
	ENDDO                                 !!! over ilen
C  DELETE OLD FILE
      OPEN(UNIT=1,FILE=INIFILE,STATUS='OLD',FORM='FORMATTED')
      CLOSE(UNIT=1,STATUS='DELETE')
      OPEN(UNIT=1,FILE=INIFILE,STATUS='NEW',FORM='FORMATTED')
      DO ILEN=1,NLEN
      DO IPOS=150,1,-1
      IF(INIDATA(ILEN)(IPOS:IPOS).NE.' ')EXIT
      ENDDO
	IF(IPOS.EQ.0)IPOS=1
      WRITE(1,FMT='(A)')INIDATA(ILEN)(1:IPOS)
      ENDDO
      ENDIF
	CLOSE(UNIT=1,STATUS='KEEP')
C  Now I got really tied to write this shit... 08 July 1998, SS
	END SUBROUTINE READINI_OVWR










	SUBROUTINE READINI_SHOW
**********************************************************
*  Print input/output data information.                  *
**********************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL,ONLY: LIFT,LMTO,IASA,LRWF,NPFR,IEXC,NOVR   !!! from readini
	USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS,ILST,ILSB    !!! from readini
     &                     ,ILSV,IS,LRTV
	USE COM_LATPAR ,ONLY: PAR,PAR0,VV0                         !!! from readini
	USE COM_SPHERE ,ONLY: ZNUC,ZVAL,ZSEM,ZCOR,SMTS,SROU,SASA,AMAS! from readini
     &                     ,OVRMAX,CLSMAX
	USE COM_KAPPAR ,ONLY: NPAN,NKAP,EKAP                       !!! from readini
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,POLUS,WINDOW       !!! from readini
	USE COM_INPPAR ,ONLY: ENY,DNY,MNY,ITS,NODES                !!! from readini
	USE COM_INPTTR ,ONLY: KEYTTR,NDIV,NDIC,NDIW,SH
     &                     ,TFERMI,GBROAD
      USE COM_FFTMESH,ONLY: NFFTG                                !!! from readini
	USE COM_ACCURG ,ONLY: EPSR,EPSG                            !!! from readini
	USE COM_TEILORG,ONLY: BZM,KEYT                             !!! from readini
	USE COM_SEMICOR,ONLY: NSEM,NDS,LBS,ESEM                    !!! from readini
	USE COM_CORELEC,ONLY: ICOR                                 !!! from readini
	USE COM_SCFLOOP,ONLY: NITER1,EPSTOT,EPSRHO,EPSMAG          !!! from readini
	USE COM_MAGDAT ,ONLY: AXMAG,BEXT,ISPL,SPLIT                !!! from readini
	USE COM_FERMI  ,ONLY: EF                                   !!! from readini
	USE COM_MIXRHO1,ONLY: KEY,KSP,ADMIX1,ADMIN,ADMAX,ADMOPT    !!! from readini
     &                               ,ADMSPN,ASMIN,ASMAX
	USE COM_MIXBROY,ONLY: NBROY,LBROY,IBROY,ADMIXB,ADMIXH      !!! from readini
      USE COM_LABELS ,ONLY: TXTAT,TXTEL,TXTSP,HEADINI            !!! from readini
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                          !!! from setup
      USE COM_LMTINP
      USE COM_LMTOUT
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER HELP*40,RCHAR*8,TDPS*8,CCHAR*19,TCPS*19,SNOT*2
     &    ,TARR(0:4)*1,TCTRL*10,FKEY*1
C PRINT HEAD
	IF(IUN.NE.IUT)CALL PHEAD(IUN)
      WRITE(IUN,1000)
1000  FORMAT(/' <<<--- INIFILE READ --->>>'/)
C PRINT FILE CONTROL
	CALL FIND_LBLANK(INIFILE,130,NBL)
	IF(TRACINP)     WRITE(IUN,1001)
	IF(.NOT.TRACINP)WRITE(IUN,1002)
	WRITE(IUN,1003)
1001	FORMAT(1X,'<FILE=INIFILE,INPUT=MODERN,TRACE=TRUE>')
1002	FORMAT(1X,'<FILE=INIFILE,INPUT=MODERN,TRACE=FALSE>')
1003  FORMAT('****************************************************')
C PRINT TITLE
	WRITE(IUN,1010)
      WRITE(IUN,1011)HEADINI
1010	FORMAT(1X,'<SECTION=HEAD>              ! PROJECT HEAD:')
1011  FORMAT(1X,'title =',A64)
C PRINT CONTROL PARAMETERS
	WRITE(IUN,1030)
1030  FORMAT(1X,'<SECTION=CTRL>              ! CONTROL PARAMETERS:')
	HELP='! set: Struc  / Bands / SCF             '
	IF(LIFT.EQ.1)TCTRL='Struc     '
	IF(LIFT.EQ.2)TCTRL='Bands     '
	IF(LIFT.EQ.3)TCTRL='SCF       '
	WRITE(IUN,1040)TCTRL,HELP
1040  FORMAT(1X,'Lift  =',A10,11X,A40)
	HELP='! set: Bare / Screened / Rspace         '
	IF(LMTO.EQ.1)TCTRL='Bare      '
	IF(LMTO.EQ.2)TCTRL='Screened  '
	IF(LMTO.EQ.3)TCTRL='Rspace    '
	WRITE(IUN,1050)TCTRL,HELP 
1050  FORMAT(1X,'Lmto  =',A10,11X,A40)
	HELP='! set: ASA / PLW                        '
	IF(IASA.EQ.0)TCTRL='FTB       '
	IF(IASA.EQ.1)TCTRL='ASA       '
	IF(IASA.EQ.2)TCTRL='PLW       '
	WRITE(IUN,1060)TCTRL,HELP 
1060  FORMAT(1X,'FulPot=',A10,11X,A40)
	HELP='! set: Relax / RelaxP / Froze           '
	IF(LRWF.EQ.0)TCTRL='froze     '
	IF(LRWF.EQ.1)TCTRL='RelaxP    '
	IF(LRWF.EQ.2)TCTRL='Relax     '
	WRITE(IUN,1070)TCTRL,HELP 
1070  FORMAT(1X,'RadPot=',A10,11X,A40)
	HELP='! set: none / fast / full               '
	IF(NPFR.EQ.0)TCTRL='none      '
	IF(NPFR.EQ.1)TCTRL='full      '
	IF(NPFR.EQ.2)TCTRL='fast      '
	WRITE(IUN,1080)TCTRL,HELP 
1080  FORMAT(1X,'FrcPul=',A10,11X,A40)
C  EXCHANGE-CORRELATION
	WRITE(IUN,1200)
1200  FORMAT(1X,'<SECTION=EXCH>              ! EXCHANGE CORRELATION:')
	HELP='! set: none/Barth/Gunn/etc.             '
      ILDA=MOD(IEXC,10)    !!! LDA key
	IF(ILDA.EQ.0)TCTRL='none      '
	IF(ILDA.EQ.1)TCTRL='Barth     '
	IF(ILDA.EQ.2)TCTRL='Gunn      '
	IF(ILDA.EQ.3)TCTRL='Moruzzi   '
	IF(ILDA.EQ.4)TCTRL='Vosko     '
	IF(ILDA.EQ.5)TCTRL='Perdew    '
	IF(ILDA.EQ.6)TCTRL='Gaspar    '
	WRITE(IUN,1210)TCTRL,HELP
1210	FORMAT(1X,'LDA   =',A10,11X,A40)
	HELP='! set: none/91/96                       '
      IGGA=(IEXC-ILDA)/10  !!! GGA key
	IF(IGGA.EQ.0)TCTRL='none      '
	IF(IGGA.EQ.1)TCTRL='91        '
	IF(IGGA.EQ.2)TCTRL='96        '
	WRITE(IUN,1211)TCTRL,HELP
1211	FORMAT(1X,'GGA   =',A10,11X,A40)
C  ITERATIVE PROCEDURE LIMITS AND ACCURACY
	WRITE(IUN,1310)
1310  FORMAT(1X,'<SECTION=ITER>              ! ITERATIVE PROCEDURES:')
	HELP='! # of iterations in SCF loop          '
	WRITE(IUN,1320)NITER1,HELP
1320  FORMAT(1X,'Niter1=',I3,18X,A40)
	HELP='! initial mixing for density           '
	RCHAR=TDPS(ADMIX1,1.D-05)
	WRITE(IUN,1330)RCHAR,HELP
1330  FORMAT(1X,'Admix1=',A8,13X,A40)
	HELP='! initial mixing for magnetization     '
	RCHAR=TDPS(ADMSPN,1.D-05)
	WRITE(IUN,1340)RCHAR,HELP
1340  FORMAT(1X,'Adspin=',A8,13X,A40)
	HELP='! total energy accuracy                '
	RCHAR=TDPS(EPSTOT,1.D-15)
	WRITE(IUN,1350)RCHAR,HELP
1350  FORMAT(1X,'Epstot=',A8,13X,A40)
	HELP='! charge density accuracy              '
	RCHAR=TDPS(EPSRHO,1.D-15)
	WRITE(IUN,1360)RCHAR,HELP
1360  FORMAT(1X,'Epsrho=',A8,13X,A40)
	HELP='! magnetization accuracy               '
	RCHAR=TDPS(EPSMAG,1.D-15)
	WRITE(IUN,1370)RCHAR,HELP
1370  FORMAT(1X,'Epsmag=',A8,13X,A40)
	HELP='! Broyden mixing for low l.le.lbroy    '
	WRITE(IUN,1380)LBROY,HELP
1380  FORMAT(1X,'Lbroy =',I2,19X,A40)
	HELP='! Broyden updated  after Nbroy iters   '
	WRITE(IUN,1385)NBROY,HELP
1385  FORMAT(1X,'Nbroy =',I2,19X,A40)
	HELP='! Broyden switched after Ibroy iters   '
	WRITE(IUN,1390)IBROY,HELP
1390  FORMAT(1X,'Ibroy =',I2,19X,A40)
	HELP='! Broyden mixing parameter             '
	RCHAR=TDPS(ADMIXB,1.D-15)
	WRITE(IUN,1400)RCHAR,HELP
1400  FORMAT(1X,'AdmixB=',A8,13X,A40)
	HELP='! Mixing for high l>lbroy              '
	RCHAR=TDPS(ADMIXH,1.D-15)
	WRITE(IUN,1410)RCHAR,HELP
1410  FORMAT(1X,'AdmixH=',A8,13X,A40)
C  ATOMIC DATA
	WRITE(IUN,1510)
1510  FORMAT(1X,'<SECTION=MAIN>              ! MAIN ATOMIC DATA: ')
	HELP='! # of atoms in the unit cell          '
	WRITE(IUN,1520)NATOM,HELP
1520  FORMAT(1X,'Natom =',I3,18X,A40)
	HELP='! # of sorts in the unit cell          '
	WRITE(IUN,1530)NSORT,HELP
1530  FORMAT(1X,'Nsort =',I3,18X,A40)
	HELP='! # of spins                           '
	WRITE(IUN,1540)NSPIN,HELP
1540  FORMAT(1X,'Nspin =',I3,18X,A40)
	HELP='! 1-without/2 -with spin orbit coupling'
	WRITE(IUN,1550)NORBS,HELP
1550  FORMAT(1X,'Norbs =',I3,18X,A40)
	HELP='! lattice parameter in a.u.            '
	RCHAR=TDPS(PAR0,1.D-15)
	WRITE(IUN,1560)RCHAR,HELP
1560  FORMAT(1X,'Par0  =',A8,13X,A40)
	HELP='! volume compression                   '
	RCHAR=TDPS(VV0,1.D-15)
	WRITE(IUN,1570)RCHAR,HELP
1570  FORMAT(1X,'VV0   =',A8,13X,A40)
	HELP='! Maximum allowed overlap for ASA      '
	RCHAR=TDPS(OVRMAX,1.D-15)
	WRITE(IUN,1580)RCHAR,HELP
1580  FORMAT(1X,'Ovrl  =',A8,13X,A40)
	HELP='! Cluster size in TB calculation       '
	RCHAR=TDPS(CLSMAX,1.D-15)
	WRITE(IUN,1585)RCHAR,HELP
1585  FORMAT(1X,'Rcls  =',A8,13X,A40)
	HELP='! atom-to-sort pointer array           '
	WRITE(IUN,1590)(IS(IATOM),IATOM=1,MIN(NATOM,15))
1590	FORMAT(1X,'Is(:) =',15(I3,1X))
	IF(NATOM.GT.15)THEN
	WRITE(IUN,1600)(IS(IATOM),IATOM=16,NATOM)
1600	FORMAT(1X,15(I3,1X))
	ENDIF
	HELP='! # of tail energies                   '
	WRITE(IUN,1610)NKAP(1),HELP
1610  FORMAT(1X,'Nkap  =',I1,20X,A40)
	HELP='! tail energies (Ry)                   '
	CCHAR=TCPS(EKAP(1,1),1.D-07)
	WRITE(IUN,1620)CCHAR,HELP
1620	FORMAT(1X,'Ek(:) =',A19,2X,A40)
	DO IKAP=2,NKAP(1)
	CCHAR=TCPS(EKAP(IKAP,1),1.D-07)
	WRITE(IUN,1630)CCHAR
1630	FORMAT(1X,'       ',A19)
	ENDDO
C SORT DATA
	DO ISORT=1,NSORT                    !!! over kappas
	WRITE(IUN,1700)
1700	FORMAT(1X,'<SECTION=SORT>              ! SORT DATA:')
	CALL FIND_LBLANK(TXTAT(ISORT),10,NBL)
	HELP='! atom label                           '
	WRITE(IUN,1710)TXTAT(ISORT),HELP
1710	FORMAT(1X,'Name  = ',A10,10X,A40)
	HELP='! nuclear charge                       '
	RCHAR=TDPS(ZNUC(ISORT),1.D-05)
	WRITE(IUN,1720)RCHAR,HELP
1720  FORMAT(1X,'Znuc  =',A8,13X,A40)
	HELP='! # of valence electrons               '
	RCHAR=TDPS(ZVAL(ISORT),1.D-05)
	WRITE(IUN,1730)RCHAR,HELP
1730  FORMAT(1X,'Zval  =',A8,13X,A40)
	HELP='! # of semicore electrons              '
	RCHAR=TDPS(ZSEM(ISORT),1.D-05)
	WRITE(IUN,1740)RCHAR,HELP
1740  FORMAT(1X,'Zsem  =',A8,13X,A40)
	HELP='! # of deepcore electrons              '
	RCHAR=TDPS(ZCOR(ISORT),1.D-05)
	WRITE(IUN,1750)RCHAR,HELP
1750  FORMAT(1X,'Zcor  =',A8,13X,A40)
	HELP='! atomic mass as in periodic table     '
	RCHAR=TDPS(AMAS(ISORT),1.D-05)
	WRITE(IUN,1760)RCHAR,HELP
1760  FORMAT(1X,'Amas  =',A8,13X,A40)
	IF(ABS(SMTS(ISORT)).GT.1.D-10)THEN
	HELP='! non-overlapping MT-sphere            '
	RCHAR=TDPS(SMTS(ISORT),1.D-05)
	WRITE(IUN,1770)RCHAR,HELP
1770  FORMAT(1X,'Smts  =',A8,13X,A40)
	ELSEIF(ABS(SMTS(ISORT)).LE.1.D-10)THEN
	HELP='! MT-sphere will be determined later   '
	WRITE(IUN,1771)HELP
1771  FORMAT(1X,'Smts  = ?',19X,A40)
	ENDIF
	HELP='! circumscribed sphere                 '
	RCHAR=TDPS(SROU(ISORT),1.D-05)
	WRITE(IUN,1780)RCHAR,HELP
1780  FORMAT(1X,'Srou  =',A8,13X,A40)
	IF(ABS(SASA(ISORT)).GT.1.D-10)THEN
	HELP='! classic atomic sphere (space filling)'
	RCHAR=TDPS(SASA(ISORT),1.D-05)
	WRITE(IUN,1790)RCHAR,HELP
1790  FORMAT(1X,'Sasa  =',A8,13X,A40)
	ELSEIF(ABS(SASA(ISORT)).LE.1.D-10)THEN
	HELP='! ASA sphere will be determined later  '
	WRITE(IUN,1791)HELP
1791  FORMAT(1X,'Sasa  = ?',19X,A40)
	ENDIF
	HELP='! nearest neighbors sphere             '
	RCHAR=TDPS(SASA(ISORT),1.D-05)
	WRITE(IUN,1800)RCHAR,HELP
1800  FORMAT(1X,'Rloc  =',A8,13X,A40)
	HELP='! lmax for the potential               '
	WRITE(IUN,1810)ILSV(ISORT),HELP
1810  FORMAT(1X,'LmaxV =',I2,19X,A40)
	HELP='! lmax for the wave functions          '
	WRITE(IUN,1820)ILST(ISORT),HELP
1820  FORMAT(1X,'LmaxT =',I2,19X,A40)
	HELP='! lmax for the basis set               '
	WRITE(IUN,1830)ILSB(ISORT),HELP
1830  FORMAT(1X,'LmaxB =',I2,19X,A40)
	HELP='! controls relativistic: none/semi     '
	IF(LRTV(ISORT).EQ.0)TCTRL='none      '
	IF(LRTV(ISORT).EQ.1)TCTRL='semi      '
	WRITE(IUN,1840)TCTRL,HELP
1840  FORMAT(1X,'Lrtv  =',A10,11X,A40)
	HELP='! soft core key: frozen/soft           '
	IF(ICOR(ISORT).EQ.0)TCTRL='frozen     '
	IF(ICOR(ISORT).EQ.1)TCTRL='soft       '
	WRITE(IUN,1850)TCTRL,HELP
1850  FORMAT(1X,'Icor  =',A10,11X,A40)
	HELP='! local magnetization axis             '
	WRITE(IUN,1855)(AXMAG(I,ISORT),I=1,3),HELP
1855	FORMAT(1X,'AxMag =',F6.2,1X,F6.2,1X,F6.2,1X,A40)
	HELP='! External magnetic field (Ry)         '
	RCHAR=TDPS(BEXT(ISORT),1.D-08)
	WRITE(IUN,1860)RCHAR,HELP
1860  FORMAT(1X,'Bext  =',A8,13X,A40)
	HELP='! splitting key: none/always/kickup    '
	IF(ISPL(ISORT).EQ.0)TCTRL='none       '
	IF(ISPL(ISORT).EQ.1)TCTRL='always     '
	IF(ISPL(ISORT).EQ.2)TCTRL='kickup     '
	WRITE(IUN,1865)TCTRL,HELP
1865  FORMAT(1X,'Ispl  =',A10,11X,A40)
	HELP='! initial spin splitting (Ry)          '
	RCHAR=TDPS(SPLIT(ISORT),1.D-05)
	WRITE(IUN,1870)RCHAR,HELP
1870  FORMAT(1X,'Split =',A8,13X,A40)
C LMTO DATA
	WRITE(IUN,1900)
1900	FORMAT(1X,'<Subsection=LMTO>           ! Valence states:')
	DO IKAP=1,NKAP(1)                  !!! over kappas
      CCHAR=TCPS(EKAP(IKAP,1),1.D-07)
	WRITE(IUN,1910)CCHAR
1910	FORMAT(1X,'!!!!!!  s p d f g  states for Ekap=',A19)
	HELP='! main quantum numbers                 '
	DO L=0,4
	TARR(L)='*'
	ENDDO
	DO L=0,MIN(5,ILSB(ISORT))
	WRITE(TARR(L),FMT='(I1)')NODES(L,ISORT,IKAP,1)+L+1
	ENDDO
	WRITE(IUN,1920)(TARR(L),L=0,4),HELP
1920	FORMAT(1X,'Mqn(:)=',5(1X,A1),11X,A40)
	HELP='! LMTO basis set                       '
	DO L=0,4
	TARR(L)='0'
	ENDDO
	DO L=0,MIN(5,ILSB(ISORT))
	WRITE(TARR(L),FMT='(I1)')ITS(L,ISORT,IKAP,1)
	ENDDO
 	WRITE(IUN,1930)(TARR(L),L=0,4),HELP
1930	FORMAT(1X,'Bas(:)=',5(1X,A1),11X,A40)
	HELP='! choice of Enu(s)                     '
	DO L=0,4
	TARR(L)='0'
	ENDDO
	DO L=0,MIN(5,ILSB(ISORT))
	WRITE(TARR(L),FMT='(I1)')MNY(L,ISORT,IKAP,1)
	ENDDO
 	WRITE(IUN,1940)(TARR(L),L=0,4),HELP
1940	FORMAT(1X,'Mnu(:)=',5(1X,A1),11X,A40)
	WRITE(IUN,1950)(ENY(L,ISORT,IKAP,1,1),L=0,ILSB(ISORT))
1950	FORMAT(1X,'Enu(:)=',5(1X,G12.5))
	WRITE(IUN,1960)(DNY(L,ISORT,IKAP,1,1),L=0,ILSB(ISORT))
1960	FORMAT(1X,'Dnu(:)=',5(1X,G12.5))
	ENDDO                              !!! over kappas
C SEMICORE DATA
	WRITE(IUN,1970)
1970	FORMAT(1X,'<Subsection=SEMI>           ! Semicore states:')
	HELP='! # of semicore states                 '
	WRITE(IUN,1980)NSEM(ISORT),HELP
1980	FORMAT(1X,'Nsem  =',I2,19X,A40)
	DO ISEM=1,NSEM(ISORT)              !!! over isem
	HELP='! n,l, energy                          '
	CALL SET_SPDF(SNOT,2,NDS(ISEM,ISORT)+LBS(ISEM,ISORT)+1,
     &LBS(ISEM,ISORT))
	CCHAR=TCPS(ESEM(ISEM,ISORT),1.D-07)
	WRITE(IUN,1990)SNOT,CCHAR
1990	FORMAT(1X,'Lsem   =',A2,' ; Esem =',A19)
	ENDDO                              !!! over isem
	ENDDO                              !!! over sorts
C  FFT GRIDS
	WRITE(IUN,2200)
2200  FORMAT(1X,'<SECTION=FFTS>              ! FFT GRIDS:') 
	HELP='! # fully filled bands                 '
	WRITE(IUN,2210)NBNDE(1)-1,HELP
2210  FORMAT(1X,'Nfull =',I3,18X,A40)
	HELP='! # of bands crossing Ef               '
	WRITE(IUN,2220)NBNDF(1)-NBNDE(1)+1,HELP
2220  FORMAT(1X,'NatEF =',I3,18X,A40)
	HELP='! Tetrahedra vs Gaussians scheme       '
	IF(KEYTTR.EQ.0)
     &WRITE(IUN,2221)HELP
	IF(KEYTTR.EQ.1)
     &WRITE(IUN,2222)HELP
	IF(KEYTTR.EQ.2)
     &WRITE(IUN,2223)HELP
2221  FORMAT(1X,'BZint = Sttr   ',13X,A40)
2222  FORMAT(1X,'BZint = TTRs   ',13X,A40)
2223  FORMAT(1X,'BZint = Gaus   ',13X,A40)
	HELP='! Gaussian broadending (Ry)            '
	RCHAR=TDPS(GBROAD,1.D-05)
	WRITE(IUN,2225)RCHAR,HELP
2225  FORMAT(1X,'Broad =',A8,13X,A40)
	HELP='! Linear response broadending (Ry)     '
	RCHAR=TDPS(POLUS,1.D-05)
	WRITE(IUN,2230)RCHAR,HELP
2230  FORMAT(1X,'GausBr=',A8,13X,A40)
	HELP='! Approximate Fermi energy (Ry)        '
      RCHAR=TDPS(EF,1.D-05)
      WRITE(IUN,2235)RCHAR,HELP
2235  FORMAT(1X,'EFermi=',A8,13X,A40)
	HELP='! Temperature (Ry)                     '
      RCHAR=TDPS(TFERMI,1.D-08)
      WRITE(IUN,2237)RCHAR,HELP
2237  FORMAT(1X,'Temp  =',A8,13X,A40)
	HELP='! Tetrahedron mesh                     '
	WRITE(IUN,2240)NDIV,HELP
2240  FORMAT(1X,'Ndiv(:)=',3(I3,1X),8X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUN,2245)NDIW,HELP
2245  FORMAT(1X,'Ndiw(:)=',3(I3,1X),8X,A40)
	HELP='! Tetrahedron mesh for semicore        '
	WRITE(IUN,2250)NDIC,HELP
2250  FORMAT(1X,'Ndic(:)=',3(I3,1X),8X,A40)
	IF(NFFTG(1).NE.0)THEN
	HELP='! FFT mesh                             '
	WRITE(IUN,2260)NFFTG,HELP
2260  FORMAT(1X,'Nfft(:)=',3(I3,1X),8X,A40)
	ELSE
	HELP='! FFT mesh will be determined below    '
	WRITE(IUN,2261)HELP
2261  FORMAT(1X,'Nfft(:)= ?',18X,A40)
	ENDIF
	HELP='! Linear response window               '
	RCHAR=TDPS(WINDOW,1.D-05)
	WRITE(IUN,2268)RCHAR,HELP
2268	FORMAT(1X,'Window =',A8,12X,A40)
	HELP='! PseudoHankel accuracy                '
	RCHAR=TDPS(EPSR,1.D-05)
	WRITE(IUN,2275)RCHAR,HELP
2275  FORMAT(1X,'EpsR  =',A8,13X,A40)
	HELP='! PseudoHankel accuracy                '
	RCHAR=TDPS(EPSG,1.D-05)
	WRITE(IUN,2280)RCHAR,HELP
2280  FORMAT(1X,'EpsG  =',A8,13X,A40)
	IF(ABS(BZM).GT.1.D-10)THEN
	HELP='! BZ radius                            '
	RCHAR=TDPS(BZM,1.D-05)
	ELSEIF(ABS(BZM).LT.1.D-10)THEN
	HELP='! BZ radius will be automatically found'
	RCHAR=' ?      '
	ENDIF
	WRITE(IUN,2290)RCHAR,HELP
2290  FORMAT(1X,'BZM   =',A8,13X,A40)
	HELP='! Teilor key: On/Off                   '
	IF(KEYT.EQ.0)TCTRL='Off       '
	IF(KEYT.EQ.1)TCTRL='On        '
	WRITE(IUN,2295)TCTRL,HELP
2295  FORMAT(1X,'KeyT  =',A10,11X,A40)
	END
