	SUBROUTINE READPNT
************************************************************
*   Reads q-points from the file                           *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                        !!! from setup
      USE COM_LMTMEM                                        !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN              !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW,NDIVDIR         !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,AKBAS,RKBAS          !!! from readstr
      USE COM_LMTINP  ,ONLY: PROJECT,INPINFO,RUNMODE        !!! from init
     &                      ,ICPNT,PNTFILE                  !!! from readini
      USE COM_EXTENS  ,ONLY: LENEXTN,EXTNPNT                !!! from setup
      USE COM_TETRGEN ,ONLY: NPOINTS,POINTS,WEIGHS,IREFPQS
     &                      ,IREFGQS,ITTRCUT                !!! from makettr
      USE COM_QMESH   ,ONLY: NQPNT,QPNT,NQDIV               !!! from readpnt
      USE COM_MASHDEP ,ONLY: LENINT,LENREL                  !!! from setup
	USE COM_CHANNELS,ONLY: IUAIN                          !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	INTEGER, ALLOCATABLE :: ISG(:,:)
      CHARACTER*150, ALLOCATABLE :: PNTDATA(:)
      CHARACTER*150, ALLOCATABLE :: PNTCOPY(:)
	CHARACTER INF*130,HELP*40,STRING*150
      LOGICAL EXIST,MODIFIED,PRESENT,DEF,ASK,VAL,NTH,MDF
C *****************************
C CHECK INPINFO
      INF=INPINFO
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNPNT,LENEXTN)
      IF(.NOT.PRESENT)GOTO1000
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNPNT,60,NBE)
      PNTFILE=PROJECT(:NBP)//'.'//EXTNPNT(:NBE)
      INQUIRE(FILE=PNTFILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL READPNT_MESG01
C ********************************
C UNDERSTAND THE LENGHT OF PNTFILE
      CALL FILE_LENGHT(PNTFILE,NLEN)
      ALLOCATE(PNTDATA(NLEN))
C ********************************
C READ PNTFILE TO INTERNAL FILE
      OPEN(UNIT=1,FILE=PNTFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(1,FMT='(A150)')PNTDATA(ILEN)
      ENDDO
      CLOSE(1)
C READ Q-VECTOR FROM PNTFILE
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
      STRING=PNTDATA(1)
      CALL CONVLOW(STRING,150)
      MODERN=0
      DO IPOS=1,80
      IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
      IF(MODERN.NE.0)EXIT
      ENDDO
      IF(MODERN.NE.2)CALL READPNT_MESG02
      IF(MODERN.EQ.2)MODIFIED=.TRUE.
C ********************************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C LOCATE SECTION CONTROL
      CALL READINI_SECT(PNTDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(PNTDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)PNTDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL DATA:                        '
      IF(MSEC.NE.0)PNTDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(PNTCOPY(NSEC))
      DO ILIN=1,MSEC
      PNTCOPY(ILIN)=PNTDATA(ILIN+ISEC-1)
      ENDDO
C Set NQDIV
      HELP='! BZ divisions for q-mesh              '
	LHLP=40
      NQDIV(1)=NDIV(1)
      NQDIV(2)=NDIV(2)
      NQDIV(3)=NDIV(3)
      CALL READINI_CHAR(PNTDATA(ISEC),PNTCOPY(1),NSEC,MSEC,
     &'nqdiv(:)',8,NQDIV,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Set NQPNT
      HELP='! # of q-points avaiable               '
	LHLP=40
      NQPNT=0
      CALL READINI_CHAR(PNTDATA(ISEC),PNTCOPY(1),NSEC,MSEC,
     &'nqpnt',5,NQPNT,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
C     CALL READINI_ERRR(PNTDATA(ISEC),PNTCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(PNTCOPY)
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(QPNT(3,NQPNT))
      SIZE_QPNT=DBLE(SIZE(QPNT)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_QPNT
C ********************************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
C LOCATE SECTION CONTROL
      CALL READINI_SECT(PNTDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=qpnt',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(PNTDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)PNTDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! Q-POINT LIST:                        '
      IF(MSEC.NE.0)PNTDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(PNTCOPY(NSEC))
      DO ILIN=1,MSEC
      PNTCOPY(ILIN)=PNTDATA(ILIN+ISEC-1)
      ENDDO
	DO IQPNT=1,NQPNT
C Set IQPNT
      HELP='! q-point number                       '
      LHLP=40
	IQ=0
      CALL READINI_CHAR(PNTDATA(ISEC),PNTCOPY(1),NSEC,MSEC,
     &'iqpnt',5,IQ,1,1,RE,1,0,CM,1,0,' ',1,0,' ',0,
     &DEF,ASK,VAL,NTH,.FALSE.)
C Set QPNT
      HELP='! q-point coordinates                  '
	LHLP=40
      QPNT(1,IQPNT)=0.D0
      QPNT(2,IQPNT)=0.D0
      QPNT(3,IQPNT)=0.D0
      CALL READINI_CHAR(PNTDATA(ISEC),PNTCOPY(1),NSEC,MSEC,
     &'qpnt(:)',7,IN,1,0,QPNT(1,IQPNT),3,1,CM,1,0,' ',1,0,' ',0,
     &DEF,ASK,VAL,NTH,.FALSE.)
	QPNT(1,IQPNT)=QPNT(1,IQPNT)
	QPNT(2,IQPNT)=QPNT(2,IQPNT)/ORTH(2)
	QPNT(3,IQPNT)=QPNT(3,IQPNT)/ORTH(3)
	ENDDO
C **************************************
C     CALL READINI_ERRR(PNTDATA(ISEC),PNTCOPY(1),NSEC,MSEC,'CTRL')
C APPLY FORMATTING
      CALL READINI_OVWR(PNTFILE,PNTDATA,NLEN)
      DEALLOCATE(PNTDATA,PNTCOPY)
	RETURN
C GENERATE AUTOMATICALLY
1000	CONTINUE
C **************************************
C CHECK RUNMODE
      INF=RUNMODE
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNPNT,LENEXTN)
      IF(.NOT.PRESENT)RETURN
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNPNT,60,NBE)
      PNTFILE=PROJECT(:NBP)//'.'//EXTNPNT(:NBE)
      INQUIRE(FILE=PNTFILE,EXIST=EXIST)
      IF(EXIST)CALL READPNT_MESG03
C START STORING
	NQDIV(1)=NDIV(1)
	NQDIV(2)=NDIV(2)
	NQDIV(3)=NDIV(3)
      CALL MAKETTR_TETR(NQDIV,RBAS,GBAS,AKBAS(1,1,1),RKBAS(1,1,1))
      NQPNT=NPOINTS
      ALLOCATE(QPNT(3,NQPNT))
      SIZE_QPNT=DBLE(SIZE(QPNT)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_QPNT
	OPEN(UNIT=IUAIN,FILE=PNTFILE,STATUS='NEW',FORM='FORMATTED')
C  STORE HEAD
	WRITE(IUAIN,1010)
	WRITE(IUAIN,1020)
	WRITE(IUAIN,1030)
1010  FORMAT('<FILE=PNTFILE,INPUT=MODERN>')
1020  FORMAT('**************************************************')
1030  FORMAT('<SECTION=CTRL>', ' ! CONTROL DATA')
      WRITE(IUAIN,1040)(NQDIV(I),I=1,3)
      WRITE(IUAIN,1050)NQPNT
1040	FORMAT(1X,'Nqdiv(:)=',3(I2,1X),' ! BZ-divisions for q-mesh')
1050	FORMAT(1X,'Nqpnt   =',I4,1X   ,' ! # of q-points          ')
      WRITE(IUAIN,1060)
1060  FORMAT('<SECTION=QPNT>', ' ! Q-POINT LIST')
C Set points/weights
	ALLOCATE(ISG(NOPRMEM,NOPRMEM))
      DO IQPNT=1,NQPNT
	WRITE(IUAIN,1065)
1065	FORMAT('***** Q-point data')
      QPNT(1,IQPNT)=POINTS(1,IQPNT)
      QPNT(2,IQPNT)=POINTS(2,IQPNT)
      QPNT(3,IQPNT)=POINTS(3,IQPNT)
	CALL SYMQVEC(QPNT(1,IQPNT),QPNT(2,IQPNT),QPNT(3,IQPNT),
     &NGEQ,NSGQ,ISG,RKBAS(1,1,1))
	WRITE(IUAIN,1070)IQPNT
1070	FORMAT(1X,'iQpnt   =',I4)
	WRITE(IUAIN,1080)
     &QPNT(1,IQPNT),QPNT(2,IQPNT)*ORTH(2),QPNT(3,IQPNT)*ORTH(3)
1080	FORMAT(1X,'Qpnt(:) =',1X,G21.14,1X,G21.14,1X,G21.14)
	WRITE(IUAIN,1090)WEIGHS(IQPNT)/2.D0,NGEQ,NSGQ
1090	FORMAT(1X,'Qwgt    =',1X,G14.7,' ; nGeq = ',I2,
     &' ; nSgq = ',I2)
      ENDDO
      DEALLOCATE(ISG)
	CLOSE(UNIT=IUAIN)
C ********************************
C UNDERSTAND THE LENGHT OF STRFILE
      CALL FILE_LENGHT(PNTFILE,NLEN)
      ALLOCATE(PNTDATA(NLEN))
C ********************************
C READ PNTFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=PNTFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(IUAIN,FMT='(A150)')PNTDATA(ILEN)
      ENDDO
      CLOSE(IUAIN)
C APPLY FORMATTING
      CALL READINI_OVWR(PNTFILE,PNTDATA,NLEN)
      DEALLOCATE(PNTDATA)
C MEMORY DEALLOCATIONS
      DEALLOCATE(POINTS,WEIGHS,IREFPQS,IREFGQS)

	CONTAINS

	SUBROUTINE READPNT_MESG01
	WRITE(IUT,*)'Terminated in <ReadPNT>::'
	WRITE(IUT,*)'Q-points file PNTFILE ',PNTFILE
	WRITE(IUT,*)'cannot be found!'
	CALL FULLSTOP(' ')
	END SUBROUTINE READPNT_MESG01
      SUBROUTINE READPNT_MESG02
      WRITE(IUT,*)'Terminated in <READPNT>:'
      WRITE(IUT,*)'Q-points file PNTFILE is not recoginized.'
      WRITE(IUT,*)'Check its format.'
      CALL FULLSTOP(' ')
      END SUBROUTINE READPNT_MESG02
      SUBROUTINE READPNT_MESG03
      WRITE(IUT,*)'Terminated in <READPNT>:'
      WRITE(IUT,*)'Q-points file PNTFILE already exist!'
      CALL FULLSTOP(' ')
      END SUBROUTINE READPNT_MESG03
	END SUBROUTINE READPNT




      SUBROUTINE SYMQVEC(QX,QY,QZ,NGEQ,NSGQ,ISG,RK)
************************************************************
*  Calculates point group for given vector q=(qx,qy,qz)    *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV    !!! from groups
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                   !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER ISG(NOPRMEM,NOPRMEM)
	INTEGER, ALLOCATABLE :: KQG(:,:)
	REAL*8 RK(3,3)
C START CODE
	ALLOCATE(KQG(3,NOPRMEM))
C ROTATE Q-VECTOR BY RECIPROCAL SYMMETRY OPERATIONS
      DO 10 IR=1,NGROUP                               !!! over group
      IG=IKOV(IR)
      CALL ROTATE(QX,QY,QZ,Q1,Q2,Q3,U(2,IG),1)
      X1=Q1*RK(1,1)+Q2*RK(2,1)+Q3*RK(3,1)
      X2=Q1*RK(1,2)+Q2*RK(2,2)+Q3*RK(3,2)
      X3=Q1*RK(1,3)+Q2*RK(2,3)+Q3*RK(3,3)
      J1=ANINT(X1)
      J2=ANINT(X2)
      J3=ANINT(X3)
C  CHECK WHETHER THE Q-VECTOR IS ON THE GRID
      IF(ABS(X1-J1).GE.1.D-03.OR.ABS(X2-J2).GE.1.D-03.OR.ABS(X3-J3).
     &GE.1.D-03)
     &CALL FULLSTOP('<SYMQVEC>: Q-COORDINATES ARE NOT INTEGER')
      KQG(1,IR)=J1
      KQG(2,IR)=J2
      KQG(3,IR)=J3
  10  CONTINUE                                       !!! over group
C  DEFINE # OF ELEMENTS IN Q-STAR
      NSGQ=0
      NGEQ=0
      DO 60 IR=1,NGROUP
      NEC=1
      DO 30 ISGQ=1,NSGQ
      DO 20 IGEQ=1,NGEQ
      IF(ISG(IGEQ,ISGQ).EQ.IR)NEC=0
  20  CONTINUE
  30  CONTINUE
      IF(NEC.EQ.1)THEN
      NSGQ=NSGQ+1
      NGEQ=0
      DO 50 IR1=IR,NGROUP                            !!! over group
      NEQ=0
      DO 40 I=1,3
      IF(KQG(I,IR).EQ.KQG(I,IR1))NEQ=NEQ+1
  40  CONTINUE
      IF(NEQ.EQ.3)THEN
      NGEQ=NGEQ+1
      ISG(NGEQ,NSGQ)=IR1
      ENDIF
  50  CONTINUE                                       !!! over group
      ENDIF
  60  CONTINUE
	DEALLOCATE(KQG)
      END
