	FUNCTION TCP(C,EPS)
************************************************************
*  Converts complex number to character string of the type *
*  C=( 0.1234567,-0.7654321)                               *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 C,C0,CNUM0P
	CHARACTER TCP*23,TDP*10,TREAL*10,TIMAG*10,SIGNR*1,SIGNI*1
	C0=CNUM0P(C,EPS)
	DRC=DREAL(C0)
	DIC=DIMAG(C0)
	TREAL=TDP(ABS(DRC),EPS)
	TIMAG=TDP(ABS(DIC),EPS)
	IF(DRC.LT.0.D0)SIGNR='-'
	IF(DRC.GE.0.D0)SIGNR=' '
	IF(DIC.LT.0.D0)SIGNI='-'
	IF(DIC.GE.0.D0)SIGNI=' '
	TREAL(1:1)=SIGNR
	TIMAG(1:1)=SIGNI
C ANSWER
	TCP='('//TREAL//','//TIMAG//')'
	END

	FUNCTION TCW(C,EPS)
************************************************************
*  Converts complex number to character string of the type *
*  C=( 0.1234567-i0.7654321)                               *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 C,C0,CNUM0P
	CHARACTER TCW*23,TDP*10,TREAL*10,TIMAG*10,SIGNR*1,SIGNI*1
	C0=CNUM0P(C,EPS)
	DRC=DREAL(C0)
	DIC=DIMAG(C0)
	TREAL=TDP(ABS(DRC),EPS)
	TIMAG=TDP(ABS(DIC),EPS)
	IF(DRC.LT.0.D0)SIGNR='-'
	IF(DRC.GE.0.D0)SIGNR=' '
	IF(DIC.LT.0.D0)SIGNI='-'
	IF(DIC.GE.0.D0)SIGNI='+'
	TREAL(1:1)=SIGNR
	TIMAG(1:1)='i'
C ANSWER
	TCW='('//TREAL//SIGNI//TIMAG//')'
	END

	FUNCTION TCPS(C,EPS)
************************************************************
*  Converts complex number to character string of the type *
*  C=( 0.12345,-0.76543)                                   *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 C,C0,CNUM0P
	CHARACTER TCPS*19,TDP*8,TREAL*8,TIMAG*8,SIGNR*1,SIGNI*1
	C0=CNUM0P(C,EPS)
	DRC=DREAL(C0)
	DIC=DIMAG(C0)
	TREAL=TDP(ABS(DRC),EPS)
	TIMAG=TDP(ABS(DIC),EPS)
	IF(DRC.LT.0.D0)SIGNR='-'
	IF(DRC.GE.0.D0)SIGNR=' '
	IF(DIC.LT.0.D0)SIGNI='-'
	IF(DIC.GE.0.D0)SIGNI=' '
	TREAL(1:1)=SIGNR
	TIMAG(1:1)=SIGNI
C ANSWER
	TCPS='('//TREAL//','//TIMAG//')'
	END



	FUNCTION TDP(D,EPS)
************************************************************
*  Converts real*8  number to character string of the type *
*  D=+0.1234567 for E-07<D<E+07 and D=1.230E-XX otherwise. *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TDP*10,RS*10,SIGN*1
	D0=DNUM0P(D,EPS)
	AD=ABS(D0)
C  GET SIGN
	IF(D0.LT.0.D0)SIGN='-'
	IF(D0.GE.0.D0)SIGN=' '
C  GET VALUE FORMATTED
	    IF(AD.EQ.0.D+00)THEN
	RS=' 0.0000000'
	ELSEIF(AD.LT.1.D-07)THEN
	WRITE(RS,FMT='(G10.2)')AD
	ELSEIF(AD.LE.9.9999999D0)THEN
	WRITE(RS,FMT='(F10.7)')AD
	ELSEIF(AD.LE.99.999999D0)THEN
	WRITE(RS,FMT='(F10.6)')AD
	ELSEIF(AD.LE.999.99999D0)THEN
	WRITE(RS,FMT='(F10.5)')AD
	ELSEIF(AD.LE.9999.9999D0)THEN
	WRITE(RS,FMT='(F10.4)')AD
	ELSEIF(AD.LE.99999.999D0)THEN
	WRITE(RS,FMT='(F10.3)')AD
	ELSEIF(AD.LE.999999.99D0)THEN
	WRITE(RS,FMT='(F10.2)')AD
	ELSEIF(AD.LE.9999999.9D0)THEN
	WRITE(RS,FMT='(F10.1)')AD
	ELSE
	WRITE(RS,FMT='(G10.2)')AD
	ENDIF
C  CHECK ERROR
 	IF(RS(1:1).NE.' ')THEN
	WRITE(RS,FMT='(G10.2)')D0
	RETURN
 	ENDIF
C  SET ZERO
	IF(RS(2:2).EQ.' '.AND.RS(3:3).EQ.'.')RS(2:2)='0'
	IF(RS(2:2).EQ.' '.AND.RS(3:3).EQ.' '.AND.RS(4:4).EQ.'.')
     &  RS(3:3)='0'
C  SET SIGN
	IF(RS(2:2).NE.' ')RS(1:1)=SIGN
	IF(RS(2:2).EQ.' ')RS(2:2)=SIGN
C  SET ANSWER
	TDP=RS
	END
	

	FUNCTION TDPS(D,EPS)
************************************************************
*  Converts real*8  number to character string of the type *
*  D=+0.12345   for E-05<D<E+05 and D=+1.2E-XX otherwise.  *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TDPS*8,RS*8,SIGN*1
	D0=DNUM0P(D,EPS)
	AD=ABS(D0)
C  GET SIGN
	IF(D0.LT.0.D0)SIGN='-'
	IF(D0.GE.0.D0)SIGN=' '
C  GET VALUE FORMATTED
	IF(AD.EQ.0.D+00)THEN
	RS=' 0.00000'
	ELSEIF(AD.LT.1.D-05)THEN
	WRITE(RS,FMT='(G8.1)')AD
	ELSEIF(AD.LE.9.99999D0)THEN
	WRITE(RS,FMT='(F8.5)')AD
	ELSEIF(AD.LE.99.9999D0)THEN
	WRITE(RS,FMT='(F8.4)')AD
	ELSEIF(AD.LE.999.999D0)THEN
	WRITE(RS,FMT='(F8.3)')AD
	ELSEIF(AD.LE.9999.99D0)THEN
	WRITE(RS,FMT='(F8.2)')AD
	ELSEIF(AD.LE.99999.9D0)THEN
	WRITE(RS,FMT='(F8.1)')AD
	ELSE
	WRITE(RS,FMT='(G8.1)')AD
	ENDIF
C  CHECK ERROR
 	IF(RS(1:1).NE.' ')THEN
	WRITE(RS,FMT='(G8.1)')D0
	RETURN
 	ENDIF
C  SET ZERO
	IF(RS(2:2).EQ.' '.AND.RS(3:3).EQ.'.')RS(2:2)='0'
	IF(RS(2:2).EQ.' '.AND.RS(3:3).EQ.' '.AND.RS(4:4).EQ.'.')
     &  RS(3:3)='0'
C  SET SIGN
	IF(RS(2:2).NE.' ')RS(1:1)=SIGN
	IF(RS(2:2).EQ.' ')RS(2:2)=SIGN
C  SET ANSWER
	TDPS=RS
	END


        FUNCTION CNUM0P(C,EPS)
********************************************************
*  Sets Re(C),Im(C) to zero if Re(C),Im(C)<eps         *
********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        COMPLEX*16 C,CNUM0P
        DRC=DREAL(C)
        DMC=DIMAG(C)
        IF(ABS(DRC).LE.EPS)DRC=0.D0
        IF(ABS(DMC).LE.EPS)DMC=0.D0
        CNUM0P=DCMPLX(DRC,DMC)
        RETURN
        END



        FUNCTION DNUM0P(D,EPS)
********************************************************
*  Sets D to zero if D<eps                             *
********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        IF(ABS(D).LE.EPS)D=0.D0
        DNUM0P=D
        RETURN
        END




	SUBROUTINE DBLVALUE(DVAL,CVAL,LEN)
*******************************************************
*  Returns string with double precisioned value       *
*******************************************************
C  uncomment next line, use RISC or CRAY to generate the data
C     IMPLICIT REAL*16 (A-H,O-Z)
      IMPLICIT REAL*8  (A-H,O-Z)
	CHARACTER*60 CVAL
	LOGICAL MADE
	DO I=1,60
	CVAL(I:I)=' '
	ENDDO
	WRITE(CVAL,FMT='(G21.14)')DVAL
C  Make double precision
	MADE=.FALSE.
	DO I=1,60
	IF(CVAL(I:I).EQ.'e'.OR.CVAL(I:I).EQ.'E')THEN
	CVAL(I:I)='D'
	MADE=.TRUE.
	ENDIF
	ENDDO
	IF(.NOT.MADE)THEN
	DO I=60,1,-1
	IF(CVAL(I:I).NE.' ')EXIT
	ENDDO
	IF(I+4.LE.60)CVAL(I+1:I+4)='D+00'
	ENDIF
	DO I=60,1,-1
	IF(CVAL(I:I).NE.' ')EXIT
	ENDDO
	LEN=I
	END




	SUBROUTINE CONVLOW(TEXT,LENGHT)
*****************************************************
*  Converts upper case letters to lower case.       *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TEXT*(*),LET(26,2)*1
	LET(1 ,1)='A'
	LET(2 ,1)='B'
	LET(3 ,1)='C'
	LET(4 ,1)='D'
	LET(5 ,1)='E'
	LET(6 ,1)='F'
	LET(7 ,1)='G'
	LET(8 ,1)='H'
	LET(9 ,1)='I'
	LET(10,1)='K'
	LET(11,1)='J'
	LET(12,1)='L'
	LET(13,1)='M'
	LET(14,1)='N'
	LET(15,1)='O'
	LET(16,1)='P'
	LET(17,1)='Q'
	LET(18,1)='R'
	LET(19,1)='S'
	LET(20,1)='T'
	LET(21,1)='U'
	LET(22,1)='V'
	LET(23,1)='W'
	LET(24,1)='X'
	LET(25,1)='Y'
	LET(26,1)='Z'
	LET(1 ,2)='a'
	LET(2 ,2)='b'
	LET(3 ,2)='c'
	LET(4 ,2)='d'
	LET(5 ,2)='e'
	LET(6 ,2)='f'
	LET(7 ,2)='g'
	LET(8 ,2)='h'
	LET(9 ,2)='i'
	LET(10,2)='k'
	LET(11,2)='j'
	LET(12,2)='l'
	LET(13,2)='m'
	LET(14,2)='n'
	LET(15,2)='o'
	LET(16,2)='p'
	LET(17,2)='q'
	LET(18,2)='r'
	LET(19,2)='s'
	LET(20,2)='t'
	LET(21,2)='u'
	LET(22,2)='v'
	LET(23,2)='w'
	LET(24,2)='x'
	LET(25,2)='y'
	LET(26,2)='z'
	DO I=1,LENGHT
	DO J=1,26
	IF(TEXT(I:I).EQ.LET(J,1))TEXT(I:I)=LET(J,2)
    	ENDDO
	ENDDO
	END


        SUBROUTINE RMBLANK(TEXT,LENGHT)
*****************************************************
*  Removes blanck records in the file TEXT.         *
*****************************************************
	  IMPLICIT REAL*8 (A-H,O-Z)
        CHARACTER TEXT*(*),LBLANCK*1
        LBLANCK=' '
C  REMOVE BLANKS
        NEWL=LENGHT
        DO 40 I=1,LENGHT
        NBLANCK=0
        DO 10 J=I,NEWL
        IF(TEXT(J:J).EQ.LBLANCK)THEN
        NBLANCK=NBLANCK+1
        ELSE
        GOTO20
        ENDIF
  10    CONTINUE
  20    DO 30 J=I+NBLANCK,NEWL
        TEXT(J-NBLANCK:J-NBLANCK)=TEXT(J:J)
  30    CONTINUE
        NEWL=NEWL-NBLANCK
  40    CONTINUE
        DO 50 I=NEWL+1,LENGHT
        TEXT(I:I)=LBLANCK
  50    CONTINUE
        END

	SUBROUTINE FIND_LBLANK(TEXT,LENGHT,NBL)
*****************************************************
*  Finds last blanck in the file TEXT               *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER TEXT*(*),LBLANCK*1
	NBL=0
	DO I=LENGHT,1,-1
	IF(TEXT(I:I).NE.' ')NBL=I
	IF(TEXT(I:I).NE.' ')EXIT
	ENDDO
	END


	SUBROUTINE SHIFT_ST(TEXT,LENGHT)
*****************************************************
*  Shifts text to the begining of file.             *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	END


	SUBROUTINE FIND_FBLANK(TEXT,LENGHT,NBL)
*****************************************************
*  Finds first blanck in the file TEXT              *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER TEXT*(*),LBLANCK*1
	NBL=1
	DO I=1,LENGHT
	IF(TEXT(I:I).NE.' ')NBL=I
	IF(TEXT(I:I).NE.' ')EXIT
	ENDDO
	END
	


	SUBROUTINE REMCOMM(TEXT,LENGHT)
******************************************************
*   Remove comments records in the file TEXT.        *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TEXT*(*),COMM*1
	ICOM=0
	IF(TEXT(1:1).EQ.'c'.OR.TEXT(1:1).EQ.'C'.OR.
     &     TEXT(1:1).EQ.'*'.OR.TEXT(1:1).EQ.'!')THEN
	ICOM=1   !!! whole line is a comment
	ELSE
	DO I=1,LENGHT
	IF(TEXT(I:I).EQ.'!')EXIT !!! part of it
	ENDDO
	ICOM=I
	ENDIF
	DO J=ICOM,LENGHT
	TEXT(J:J)=' '
	ENDDO
	END


      SUBROUTINE SUBSTR_IN_STR(PRESENT,STR,LSTR,SUB,LSUB)
********************************************************
*  Looks for a SubString in String.                    *
********************************************************
      CHARACTER*(*) STR,SUB
      LOGICAL PRESENT
      PRESENT=.FALSE.
      DO IPOS=1,LSTR-LSUB+1
      IF(STR(IPOS:IPOS+LSUB-1).EQ.SUB)PRESENT=.TRUE.
      IF(STR(IPOS:IPOS+LSUB-1).EQ.SUB)
     &  STR(IPOS:IPOS+LSUB-1)='   '
      IF(PRESENT)EXIT
      ENDDO
	END




	SUBROUTINE INT_TO_CHAR(INT,CHAR,NLEN,LVAL)
********************************************************
*  Writes integer value to a character string.         *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER CHAR*(*)
	LVAL=0
	DO L=1,NLEN
	CHAR(L:L)=' '
	ENDDO
	IF(INT.GE.0)IMINUS=0
	IF(INT.LT.0)IMINUS=1
	IF(INT.LT.0)CHAR(1:1)='-'
	IF(INT.GE.0)IVAL=+INT
	IF(INT.LT.0)IVAL=-INT
	IF(IVAL.GE.0.AND.IVAL.LT.10)THEN
	LVAL=IMINUS+1
	WRITE(CHAR(1+IMINUS:1+IMINUS),FMT='(I1)')IVAL
	ELSEIF(IVAL.LT.99)THEN
	LVAL=IMINUS+2
	WRITE(CHAR(1+IMINUS:2+IMINUS),FMT='(I2)')IVAL
	ELSEIF(IVAL.LT.999)THEN
	LVAL=IMINUS+3
	WRITE(CHAR(1+IMINUS:3+IMINUS),FMT='(I3)')IVAL
	ELSEIF(IVAL.LT.9999)THEN
	LVAL=IMINUS+4
	WRITE(CHAR(1+IMINUS:4+IMINUS),FMT='(I4)')IVAL
	ELSEIF(IVAL.LT.99999)THEN
	LVAL=IMINUS+5
	WRITE(CHAR(1+IMINUS:5+IMINUS),FMT='(I5)')IVAL
	ELSEIF(IVAL.LT.999999)THEN
	LVAL=IMINUS+6
	WRITE(CHAR(1+IMINUS:6+IMINUS),FMT='(I6)')IVAL
	ELSEIF(IVAL.LT.9999999)THEN
	LVAL=IMINUS+7
	WRITE(CHAR(1+IMINUS:7+IMINUS),FMT='(I7)')IVAL
	ELSEIF(IVAL.LT.99999999)THEN
	LVAL=IMINUS+8
	WRITE(CHAR(1+IMINUS:8+IMINUS),FMT='(I8)')IVAL
	ELSE
	CALL FULLSTOP('<INT_TO_CHAR>: INT VALUE IS TOO BIG>')
	ENDIF
	END




	SUBROUTINE REL_TO_CHAR(REL,CHAR,NLEN,LVAL)
********************************************************
*  Writes integer value to a character string.         *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER CHAR*(*), TDPS*8
	DO L=1,NLEN
	CHAR(L:L)=' '
	ENDDO
	LVAL=8
	IF(NLEN.LT.8)CALL REL_TO_CHAR_MESG1
	CHAR(1:8)=TDPS(REL,1.D-14)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE REL_TO_CHAR_MESG1
	PRINT*,'Terminated in <REL_TO_CHAR>:'
	PRINT*,'Character lenght ',NLEN,' passed to this subroutine'
	PRINT*,'is too small. Minimum allowed value is 8'
	CALL FULLSTOP(' ')
	END SUBROUTINE REL_TO_CHAR_MESG1
	END



	SUBROUTINE CMP_TO_CHAR(CMP,CHAR,NLEN,LVAL)
********************************************************
*  Writes integer value to a character string.         *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER CHAR*(*), TCPS*19
	COMPLEX*16 CMP
	DO L=1,NLEN
	CHAR(L:L)=' '
	ENDDO
	LVAL=19
	IF(NLEN.LT.19)CALL CMP_TO_CHAR_MESG1
	CHAR(1:19)=TCPS(CMP,1.D-05)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE CMP_TO_CHAR_MESG1
	PRINT*,'Terminated in <CMP_TO_CHAR>:'
	PRINT*,'Character lenght ',NLEN,' passed to this subroutine'
	PRINT*,'is too small. Minimum allowed value is 19'
	CALL FULLSTOP(' ')
	END SUBROUTINE CMP_TO_CHAR_MESG1
	END


	SUBROUTINE FILE_LENGHT(FILE,NLEN)
********************************************************
*  Computes # of records in the formatted FILE.        *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*150, ALLOCATABLE :: FILEDATA(:)
	CHARACTER FILE*(*),STRING*1
	LOGICAL EXIST
	INQUIRE(FILE=FILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FILE_LENGHT_MESG1
      ILEN=0
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
  10  ILEN=ILEN+1
      READ(1,FMT='(A1)',END=20,ERR=20)STRING
      GOTO10
  20  CONTINUE
      CLOSE(UNIT=1)
      NLEN=ILEN-1
	ALLOCATE(FILEDATA(NLEN))
C READ FILE TO INTERNAL FILE
	OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	DO IPOS=1,150
	FILEDATA(ILEN)(IPOS:IPOS)=' '
	ENDDO 
	READ(1,FMT='(A150)')FILEDATA(ILEN)
	ENDDO
	CLOSE(1)
C CHECK FOR BLANK LINES AT THE END OF FILE
	NBLANK=0
      DO ILEN=NLEN,1,-1
	INONBLANK=0
      DO IPOS=1,150
	IF(FILEDATA(ILEN)(IPOS:IPOS).NE.' ')INONBLANK=1
	ENDDO
	IF(INONBLANK.EQ.0)NBLANK=NBLANK+1
	IF(INONBLANK.NE.0)EXIT
	ENDDO
	NLEN=NLEN-NBLANK
	DEALLOCATE(FILEDATA)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE FILE_LENGHT_MESG1
	PRINT*,'Terminated in <FILE_LENGHT>:'
	PRINT*,'Error during file openning:',FILE
	PRINT*,'cannot be found.'
	CALL FULLSTOP(' ')
	END SUBROUTINE FILE_LENGHT_MESG1
*******************************************************
	END




	SUBROUTINE GET_SPDF(SNOT,LENGHT,MQN,LQN)
************************************************************
* Gets main quantum number and orbital quantum number.     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER SNOT*(*)
	CALL CONVLOW(SNOT,LENGHT)
      IPOS=0
      DO LPOS=1,LENGHT
      IF(SNOT(LPOS:LPOS).EQ.'s')LQN=0
      IF(SNOT(LPOS:LPOS).EQ.'p')LQN=1
      IF(SNOT(LPOS:LPOS).EQ.'d')LQN=2
      IF(SNOT(LPOS:LPOS).EQ.'f')LQN=3
      IF(SNOT(LPOS:LPOS).EQ.'g')LQN=4
      IF(SNOT(LPOS:LPOS).EQ.'s')IPOS=LPOS
      IF(SNOT(LPOS:LPOS).EQ.'p')IPOS=LPOS
      IF(SNOT(LPOS:LPOS).EQ.'d')IPOS=LPOS
      IF(SNOT(LPOS:LPOS).EQ.'f')IPOS=LPOS
      IF(SNOT(LPOS:LPOS).EQ.'g')IPOS=LPOS
      ENDDO
C     IF(IPOS.EQ.0)WRITE(IUT,*)'ERROR IN <GET_SPDF>'
      SNOT(IPOS:IPOS)=' '
      READ(SNOT,*)MQN
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE GET_SPDF_MESG1
	PRINT*,'Terminated in <GET_SPDF>:',SNOT
	PRINT*,'The subroutine fails to convert orbital quantum'
	PRINT*,'number s,p,d,f to an integer value. Check format'
	PRINT*,'in input files.'
	CALL FULLSTOP(' ')
	END SUBROUTINE GET_SPDF_MESG1
*******************************************************
	END SUBROUTINE GET_SPDF



      SUBROUTINE SET_SPDF(TNOT,LEN,N,L)
*******************************************************
*  Writes N,L into the TNOT file.                     *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER TNOT*(*),SL(0:5)*1
      DATA SL/'s','p','d','f','g','h'/
      DO ILEN=1,LEN
      TNOT(ILEN:ILEN)=' '
      ENDDO
      IF(N.GE.0.AND.N.LE.9)WRITE(TNOT(1:1),FMT='(I1)')N
      IF(N.LT.0.OR .N.GT.9)CALL SET_SPDF_MESG1
      IF(L.GE.0.AND.L.LE.5)TNOT(2:2)=SL(L)
      IF(L.LT.0.OR .L.GT.5)CALL SET_SPDF_MESG2
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE SET_SPDF_MESG1
	PRINT*,'Terminated in <SET_SPDF>:'
	PRINT*,'The subroutine tries to write an INTEGER N=',N
	PRINT*,'which does not fit to the allowed format.'
	PRINT*,'This internal error can be caused by memory'
	PRINT*,'allocation or similar.'
	CALL FULLSTOP(' ')
	END SUBROUTINE SET_SPDF_MESG1
	SUBROUTINE SET_SPDF_MESG2
	PRINT*,'Terminated in <SET_SPDF>:'
	PRINT*,'The subroutine tries to write an INTEGER L=',L
	PRINT*,'which does not fit to the allowed format.'
	PRINT*,'This internal error can be caused by memory'
	PRINT*,'allocation or similar.'
	CALL FULLSTOP(' ')
	END SUBROUTINE SET_SPDF_MESG2
*******************************************************
      END SUBROUTINE SET_SPDF




	SUBROUTINE GET_STATE(TXTH,NB,IATOM,ISPIN,NM,L,M,ICUBC)
*********************************************************************
*  Reads state from the character string                            *
*********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TXTH*(*),SNOT*10,TCUBC(-3:3,0:3,2)*10
     &     ,TW1*10,TW2*10
	LOGICAL FIRST
	SAVE TCUBC,FIRST
	DATA FIRST/.TRUE./
	IF(FIRST)CALL INTCUBC(TCUBC)
	FIRST=.FALSE.
C SEARCH FOR IATOM
	IATOM=-1
	IPOS=1
	DO IB=IPOS,NB
	IF(TXTH(IB:IB).EQ.'@')THEN
	DO IB1=IB+1,NB
	IF(TXTH(IB1:IB1).EQ.'-'.OR.TXTH(IB1:IB1).EQ.':')EXIT
	ENDDO
	READ(TXTH(IB+1:IB1-1),*)IATOM
	DO IB0=IPOS,IB1-1
	TXTH(IB0:IB0)=' '
	ENDDO
	EXIT
	ENDIF
	ENDDO
	IF(IB.EQ.NB+1.OR.IATOM.EQ.-1)
     &  CALL FULLSTOP('<GET_STATE>:: CANNOT FIND DATA <IATOM>')
	IPOS=IB1
C SEARCH FOR ISPIN
	ISPIN=-1
	DO IB=IPOS,NB
	IF(TXTH(IB:IB).EQ.'-')THEN
	DO IB1=IB+1,NB
	IF(TXTH(IB1:IB1).EQ.':')EXIT
	ENDDO
	IF(TXTH(IB+1:IB1-1).EQ.'up')ISPIN=1
	IF(TXTH(IB+1:IB1-1).EQ.'dn')ISPIN=2
	DO IB0=IPOS,IB1-1
	TXTH(IB0:IB0)=' '
	ENDDO
	EXIT
	ELSEIF(TXTH(IB:IB).EQ.':')THEN
	ISPIN=0
	IB1=IB
	EXIT
	ENDIF 
	ENDDO
	IF(IB.EQ.NB+1.OR.ISPIN.EQ.-1)
     &  CALL FULLSTOP('<GET_STATE> CANNOT FIND DATA <ISPIN>')
	IPOS=IB1
C SEARCH FOR ORBITAL
	NM=-1
      L=-1
      DO IB=IPOS,NB
      IF(TXTH(IB-1:IB).EQ.'::')THEN
	LENGHT=0
      DO IB1=IB+1,IB+3
      IF(TXTH(IB1:IB1).EQ.'{')EXIT
	LENGHT=LENGHT+1
	SNOT(LENGHT:LENGHT)=TXTH(IB1:IB1)
      ENDDO
	CALL GET_SPDF(SNOT,LENGHT,NM,L)
      DO IB0=IPOS,IB1-1
      TXTH(IB0:IB0)=' '
      ENDDO
      EXIT
      ENDIF
	ENDDO
      IPOS=IB1
C SEARCH FOR ORBITAL, SITE <TO>
      M=-100
      DO IB=IPOS,NB
      IF(TXTH(IB:IB).EQ.'{')THEN
      DO IB1=IB+1,NB
      IF(TXTH(IB1:IB1).EQ.'}')EXIT
      ENDDO
      DO I1=1,10
      TW1(I1:I1)=' '
      TW2(I1:I1)=' '
      ENDDO
      DO I1=1,IB1-IB-1
      TW1(I1:I1)=TXTH(IB+I1:IB+I1)
      ENDDO
      CALL RMBLANK(TW1,10)
      DO MV=-L,L
      TW2=TCUBC(MV,L,ICUBC)
      CALL RMBLANK(TW2,10)
      IF(TW1.EQ.TW2)EXIT
      ENDDO
      M=MV
      DO IB0=IPOS,IB1
      TXTH(IB0:IB0)=' '
      ENDDO
	EXIT
	ENDIF
	ENDDO
	END



	SUBROUTINE SET_STATE(TXTH,NB,TXTAT,IATOM,ISPIN,NM,L,M,ICUBC)
*********************************************************************
*  Writes state to the character string                             *
*********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER TXTH*(*),TCUBC(-3:3,0:3,2)*10
     &  ,TW1*10,TW2*10,TXTAT*10
	LOGICAL FIRST
	SAVE TCUBC,FIRST
	DATA FIRST/.TRUE./
	IF(FIRST)CALL INTCUBC(TCUBC)
	FIRST=.FALSE.
	DO IB=1,NB
	TXTH(IB:IB)=' '
	ENDDO
C SET IATOM
      IPOINT=0
      CALL FIND_LBLANK(TXTAT,10,NBL)
      DO IB=1,NBL
      TXTH(IPOINT+IB:IPOINT+IB)=TXTAT(IB:IB)
      ENDDO
      IPOINT=IPOINT+NBL+1
      TXTH(IPOINT:IPOINT)='@'
      IPOINT=IPOINT+1
      IF(IATOM.LE.9)THEN
      WRITE(TXTH(IPOINT:IPOINT+1),FMT='(I1)')IATOM
      ELSEIF(IATOM.LE.99.AND.IATOM.GT.9)THEN
      WRITE(TXTH(IPOINT:IPOINT+2),FMT='(I2)')IATOM
      ELSEIF(IATOM.LE.999.AND.IATOM.GT.99)THEN
      WRITE(TXTH(IPOINT:IPOINT+3),FMT='(I3)')IATOM
      ELSE
      CALL FULLSTOP('<SET_STATE> # ATOMS>999 NOT ALLOWED HERE')
      ENDIF
      IF(IATOM.LE.999)ID=3
      IF(IATOM.LE.99 )ID=2
      IF(IATOM.LE.9  )ID=1
      IPOINT=IPOINT+ID
C SET SPIN
      IF(ISPIN.EQ.1)THEN
      TXTH(IPOINT:IPOINT+2)='-up'
      IPOINT=IPOINT+3
      ELSEIF(ISPIN.EQ.2)THEN
      TXTH(IPOINT:IPOINT+2)='-dn'
      IPOINT=IPOINT+3
      ENDIF
C SET ORBITAL
      TXTH(IPOINT:IPOINT+1)='::'
      IPOINT=IPOINT+2
      WRITE(TXTH(IPOINT:IPOINT),FMT='(I1)')NM
      IPOINT=IPOINT+1
      IF(L.EQ.0)TXTH(IPOINT:IPOINT)='s'
      IF(L.EQ.1)TXTH(IPOINT:IPOINT)='p'
      IF(L.EQ.2)TXTH(IPOINT:IPOINT)='d'
      IF(L.EQ.3)TXTH(IPOINT:IPOINT)='f'
	IF(M.EQ.-100)RETURN
      IPOINT=IPOINT+1
      JPOINT=IPOINT
      TXTH(IPOINT:IPOINT)='{'
      TW2=TCUBC(M,L,ICUBC)
      CALL RMBLANK(TW2,10)
      DO IB=1,10
      IF(TW2(IB:IB).EQ.' ')EXIT
      TXTH(IPOINT+IB:IPOINT+IB)=TW2(IB:IB)
      ENDDO
      IPOINT=IPOINT+IB
      TXTH(IPOINT:IPOINT)='}'
      IPOINT=JPOINT+10
	END





      LOGICAL FUNCTION TRACER(PROGN,TRAC,IUT,IUR,IUI)
*********************************************************
*  Asks for processing the subroutine call.             *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER PROGN*(*),YES*1
      LOGICAL TRAC
	CALL ABORTNOW()
      TRACER=.TRUE.
      IF(.NOT.TRAC)RETURN
1000  IF(IUR.EQ.IUI)WRITE(IUT,1100)PROGN
      READ(IUR,FMT='(A1)')YES
1100  FORMAT(1X,'Proceed with CALL to subroutite ',A,' ? [y/n/s]:',$)
      IF(YES.EQ.'y'.OR.YES.EQ.'Y'.OR.YES.EQ.' ')THEN
      TRACER=.TRUE.
      ELSEIF(YES.EQ.'n'.OR.YES.EQ.'N')THEN
      TRACER=.FALSE.
      IF(IUR.EQ.IUI)WRITE(IUT,1130)
      ELSEIF(YES.EQ.'s'.OR.YES.EQ.'S')THEN
      TRACER=.FALSE.
      CALL FULLSTOP('Program stopped.')
      ELSE
      IF(IUR.EQ.IUI)WRITE(IUT,1110)YES
      IF(IUR.EQ.IUI)WRITE(IUT,1120)
1110  FORMAT(1X,'Input symbol ',A1,' not recognized.')
1120  FORMAT(1X,'Please specify either [Y]es, [N]o, or [S]top.')
1130	FORMAT(1X,'Avoiding this call may throw an exception.')
      GOTO 1000
      ENDIF
      END





	SUBROUTINE GET_DATES(MONTHES,DAYS)
***********************************************
* Sets days and monthes.                      *
***********************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER DAYS(7)*9,MONTHES(12)*9
	DAYS(1)='Monday   '
	DAYS(2)='Tuesday  '
	DAYS(3)='Wednesday'
	DAYS(4)='Thursday '
	DAYS(5)='Friday   '
	DAYS(6)='Saturday '
	DAYS(7)='Sunday   '
	MONTHES( 1)='January  '
	MONTHES( 2)='February '
	MONTHES( 3)='March    '
	MONTHES( 4)='April    '
	MONTHES( 5)='May      '
	MONTHES( 6)='June     '
	MONTHES( 7)='July     '
	MONTHES( 8)='August   '
	MONTHES( 9)='September'
	MONTHES(10)='October  '
	MONTHES(11)='November '
	MONTHES(12)='December '
	END SUBROUTINE GET_DATES
