C 	CALL FERMISUB
C  	END
	
	SUBROUTINE FERMISUB
*******************************************************
*  Generates coefficients for expansion of f(E-mu)    *
*  Note that REAL*16 must be used to get proper data! *
*******************************************************
C  uncomment next line, use RISC or CRAY to generate the data
C  	IMPLICIT REAL*16 (A-H,O-Z) 
	IMPLICIT REAL*8  (A-H,O-Z)
	PARAMETER (NM=50)! this will work fine only if real*16 accuracy is used
	PARAMETER (LM=4) ! LM first images will be generated
	DIMENSION FACT(0:NM),ALPHA(NM,0:LM,NM),COEF(0:LM,NM)
	CHARACTER*60 CVAL
	DO N=1,NM
	DO L=0,LM
	DO I=1,NM
	ALPHA(I,L,N)=0.D0
	COEF(L,N)=0.D0
	ENDDO
	ENDDO
	ENDDO
C Compute coefficients Alpha_n_i[l]
	DO 3000 N=1,NM
	DO 2000 L=0,LM
	FACT(0)=1.D0
	DO I=1,N
	FACT(I)=DBLE(I)*FACT(I-1)
	ENDDO
	DO 1000 I=1,N
	SUM=0.D0
	SUT=0.D0
	DO K=I,N
	DK=DBLE(K)
	DI=DBLE(I)
	SUM=SUM+FACT(N)/FACT(I)*(-1)**I*
     &  (-1)**K/FACT(N-K)/FACT(K-I)/DK**L
	IF(L.EQ.0.AND.I.NE.N)SUT=0.D0
	IF(L.EQ.0.AND.I.EQ.N)SUT=1.D0
	IF(L.EQ.1)SUT=1.D0/DI
	IF(L.EQ.2)SUT=SUT+1.D0/DI/DK
	ENDDO
	IF(L.LE.2.AND.ABS(SUM-SUT).GT.1.D-14)THEN
      PRINT*,'Accuracy is lost,i,n,l=',I,N,L
	PRINT*,SUM
	PRINT*,SUT
	ENDIF
	IF(L.LE.2)SUM=SUT
	ALPHA(I,L,N)=SUM
 1000	CONTINUE
	SUM=0.D0
	SUT=0.D0
	DO K=1,N
	DK=DBLE(K)
	SUM=SUM+FACT(N)/FACT(K)/FACT(N-K)*(-1)**K/DK**L
	IF(L.EQ.0)SUT=-1.D0
	IF(L.EQ.1)SUT=SUT-1.D0/DK
	ENDDO
	IF(L.LE.1.AND.ABS(SUM-SUT).GT.1.D-12)THEN
      PRINT*,'Accuracy is lost,n,l=',N,L
	PRINT*,SUM
	PRINT*,SUT
	ENDIF
	IF(L.LE.1)SUM=SUT
	COEF(L,N)=SUM
 2000	CONTINUE
 3000	CONTINUE
C Store data now
	WRITE(1,FMT='(15(6X,A/))')
     &  'SUBROUTINE FERMICOF(ALPHA,COEF)',
     &  'IMPLICIT REAL*8 (A-H,O-Z)',
     &  'PARAMETER (NM=50)',
     &  'PARAMETER (LM=4)',
     &  'DIMENSION ALPHA(NM,0:LM,NM),COEF(0:LM,NM)',
     &  'DO N=1,NM',
     &  'DO L=0,LM',
     &  'DO I=1,NM',
     &  'ALPHA(I,L,N)=0.D0',
     &  'ENDDO',
     &  'COEF(L,N)=0.D0',
     &  'ENDDO',
     &  'ENDDO'
	DO N=1,NM
	DO L=0,LM
	WRITE(1,FMT='(A1,1X,A2,I2,1X,A2,I2,A)')
     &  'C','l=',L,'n=',N,' ; Alpha :'
	DO I=1,N
	CALL DBLVALUE(ALPHA(I,L,N),CVAL,LEN)
	WRITE(1,FMT='(6X,A,I2,A1,I1,A1,I2,A,A)')
     &  'ALPHA(',I,',',L,',',N,')=',CVAL(1:LEN)
	ENDDO
	WRITE(1,FMT='(A1,1X,A2,I2,1X,A2,I2,A)')
     &  'C','l=',L,'n=',N,' ; Coef  :'
	CALL DBLVALUE(COEF(L,N),CVAL,LEN)
	WRITE(1,FMT='(6X,A,I1,A1,I2,A,G21.14)')
     &  'COEF (   ',L,',',N,')=',CVAL(1:LEN)
	ENDDO
	ENDDO
	WRITE(1,FMT='(6X,A)')'END'
	CLOSE(1)
	END




      SUBROUTINE FERMICOF(ALPHA,COEF)
*******************************************************
*  Returns coefficients generated by FERMISUB         *
*******************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NM=50)
      PARAMETER (LM=4)
      DIMENSION ALPHA(NM,0:LM,NM),COEF(0:LM,NM)
      DO N=1,NM
      DO L=0,LM
      DO I=1,NM
      ALPHA(I,L,N)=0.D0
      ENDDO
      COEF(L,N)=0.D0
      ENDDO
      ENDDO
C l= 0 n= 1 ; Alpha :
      ALPHA( 1,0, 1)=  1.0000000000000D+00
C l= 0 n= 1 ; Coef  :
      COEF (   0, 1)= -1.0000000000000D+00
C l= 1 n= 1 ; Alpha :
      ALPHA( 1,1, 1)=  1.0000000000000D+00
C l= 1 n= 1 ; Coef  :
      COEF (   1, 1)= -1.0000000000000D+00
C l= 2 n= 1 ; Alpha :
      ALPHA( 1,2, 1)=  1.0000000000000D+00
C l= 2 n= 1 ; Coef  :
      COEF (   2, 1)= -1.0000000000000D+00
C l= 3 n= 1 ; Alpha :
      ALPHA( 1,3, 1)=  1.0000000000000D+00
C l= 3 n= 1 ; Coef  :
      COEF (   3, 1)= -1.0000000000000D+00
C l= 4 n= 1 ; Alpha :
      ALPHA( 1,4, 1)=  1.0000000000000D+00
C l= 4 n= 1 ; Coef  :
      COEF (   4, 1)= -1.0000000000000D+00
C l= 0 n= 2 ; Alpha :
      ALPHA( 1,0, 2)=  0.0000000000000D+00
      ALPHA( 2,0, 2)=  1.0000000000000D+00
C l= 0 n= 2 ; Coef  :
      COEF (   0, 2)= -1.0000000000000D+00
C l= 1 n= 2 ; Alpha :
      ALPHA( 1,1, 2)=  1.0000000000000D+00
      ALPHA( 2,1, 2)= 0.50000000000000D+00
C l= 1 n= 2 ; Coef  :
      COEF (   1, 2)= -1.5000000000000D+00
C l= 2 n= 2 ; Alpha :
      ALPHA( 1,2, 2)=  1.5000000000000D+00
      ALPHA( 2,2, 2)= 0.25000000000000D+00
C l= 2 n= 2 ; Coef  :
      COEF (   2, 2)= -1.7500000000000D+00
C l= 3 n= 2 ; Alpha :
      ALPHA( 1,3, 2)=  1.7500000000000D+00
      ALPHA( 2,3, 2)= 0.12500000000000D+00
C l= 3 n= 2 ; Coef  :
      COEF (   3, 2)= -1.8750000000000D+00
C l= 4 n= 2 ; Alpha :
      ALPHA( 1,4, 2)=  1.8750000000000D+00
      ALPHA( 2,4, 2)= 0.62500000000000D-01
C l= 4 n= 2 ; Coef  :
      COEF (   4, 2)= -1.9375000000000D+00
C l= 0 n= 3 ; Alpha :
      ALPHA( 1,0, 3)=  0.0000000000000D+00
      ALPHA( 2,0, 3)=  0.0000000000000D+00
      ALPHA( 3,0, 3)=  1.0000000000000D+00
C l= 0 n= 3 ; Coef  :
      COEF (   0, 3)= -1.0000000000000D+00
C l= 1 n= 3 ; Alpha :
      ALPHA( 1,1, 3)=  1.0000000000000D+00
      ALPHA( 2,1, 3)= 0.50000000000000D+00
      ALPHA( 3,1, 3)= 0.33333333333333D+00
C l= 1 n= 3 ; Coef  :
      COEF (   1, 3)= -1.8333333333333D+00
C l= 2 n= 3 ; Alpha :
      ALPHA( 1,2, 3)=  1.8333333333333D+00
      ALPHA( 2,2, 3)= 0.41666666666667D+00
      ALPHA( 3,2, 3)= 0.11111111111111D+00
C l= 2 n= 3 ; Coef  :
      COEF (   2, 3)= -2.3611111111111D+00
C l= 3 n= 3 ; Alpha :
      ALPHA( 1,3, 3)=  2.3611111111111D+00
      ALPHA( 2,3, 3)= 0.26388888888889D+00
      ALPHA( 3,3, 3)= 0.37037037037037D-01
C l= 3 n= 3 ; Coef  :
      COEF (   3, 3)= -2.6620370370370D+00
C l= 4 n= 3 ; Alpha :
      ALPHA( 1,4, 3)=  2.6620370370370D+00
      ALPHA( 2,4, 3)= 0.15046296296296D+00
      ALPHA( 3,4, 3)= 0.12345679012346D-01
C l= 4 n= 3 ; Coef  :
      COEF (   4, 3)= -2.8248456790123D+00
C l= 0 n= 4 ; Alpha :
      ALPHA( 1,0, 4)=  0.0000000000000D+00
      ALPHA( 2,0, 4)=  0.0000000000000D+00
      ALPHA( 3,0, 4)=  0.0000000000000D+00
      ALPHA( 4,0, 4)=  1.0000000000000D+00
C l= 0 n= 4 ; Coef  :
      COEF (   0, 4)= -1.0000000000000D+00
C l= 1 n= 4 ; Alpha :
      ALPHA( 1,1, 4)=  1.0000000000000D+00
      ALPHA( 2,1, 4)= 0.50000000000000D+00
      ALPHA( 3,1, 4)= 0.33333333333333D+00
      ALPHA( 4,1, 4)= 0.25000000000000D+00
C l= 1 n= 4 ; Coef  :
      COEF (   1, 4)= -2.0833333333333D+00
C l= 2 n= 4 ; Alpha :
      ALPHA( 1,2, 4)=  2.0833333333333D+00
      ALPHA( 2,2, 4)= 0.54166666666667D+00
      ALPHA( 3,2, 4)= 0.19444444444444D+00
      ALPHA( 4,2, 4)= 0.62500000000000D-01
C l= 2 n= 4 ; Coef  :
      COEF (   2, 4)= -2.8819444444444D+00
C l= 3 n= 4 ; Alpha :
      ALPHA( 1,3, 4)=  2.8819444444444D+00
      ALPHA( 2,3, 4)= 0.39930555555556D+00
      ALPHA( 3,3, 4)= 0.85648148148148D-01
      ALPHA( 4,3, 4)= 0.15625000000000D-01
C l= 3 n= 4 ; Coef  :
      COEF (   3, 4)= -3.3825231481481D+00
C l= 4 n= 4 ; Alpha :
      ALPHA( 1,4, 4)=  3.3825231481481D+00
      ALPHA( 2,4, 4)= 0.25028935185185D+00
      ALPHA( 3,4, 4)= 0.33757716049383D-01
      ALPHA( 4,4, 4)= 0.39062500000000D-02
C l= 4 n= 4 ; Coef  :
      COEF (   4, 4)= -3.6704764660494D+00
C l= 0 n= 5 ; Alpha :
      ALPHA( 1,0, 5)=  0.0000000000000D+00
      ALPHA( 2,0, 5)=  0.0000000000000D+00
      ALPHA( 3,0, 5)=  0.0000000000000D+00
      ALPHA( 4,0, 5)=  0.0000000000000D+00
      ALPHA( 5,0, 5)=  1.0000000000000D+00
C l= 0 n= 5 ; Coef  :
      COEF (   0, 5)= -1.0000000000000D+00
C l= 1 n= 5 ; Alpha :
      ALPHA( 1,1, 5)=  1.0000000000000D+00
      ALPHA( 2,1, 5)= 0.50000000000000D+00
      ALPHA( 3,1, 5)= 0.33333333333333D+00
      ALPHA( 4,1, 5)= 0.25000000000000D+00
      ALPHA( 5,1, 5)= 0.20000000000000D+00
C l= 1 n= 5 ; Coef  :
      COEF (   1, 5)= -2.2833333333333D+00
C l= 2 n= 5 ; Alpha :
      ALPHA( 1,2, 5)=  2.2833333333333D+00
      ALPHA( 2,2, 5)= 0.64166666666667D+00
      ALPHA( 3,2, 5)= 0.26111111111111D+00
      ALPHA( 4,2, 5)= 0.11250000000000D+00
      ALPHA( 5,2, 5)= 0.40000000000000D-01
C l= 2 n= 5 ; Coef  :
      COEF (   2, 5)= -3.3386111111111D+00
C l= 3 n= 5 ; Alpha :
      ALPHA( 1,3, 5)=  3.3386111111111D+00
      ALPHA( 2,3, 5)= 0.52763888888889D+00
      ALPHA( 3,3, 5)= 0.13787037037037D+00
      ALPHA( 4,3, 5)= 0.38125000000000D-01
      ALPHA( 5,3, 5)= 0.80000000000000D-02
C l= 3 n= 5 ; Coef  :
      COEF (   3, 5)= -4.0502453703704D+00
C l= 4 n= 5 ; Alpha :
      ALPHA( 1,4, 5)=  4.0502453703704D+00
      ALPHA( 2,4, 5)= 0.35581712962963D+00
      ALPHA( 3,4, 5)= 0.61331790123457D-01
      ALPHA( 4,4, 5)= 0.11531250000000D-01
      ALPHA( 5,4, 5)= 0.16000000000000D-02
C l= 4 n= 5 ; Coef  :
      COEF (   4, 5)= -4.4805255401235D+00
C l= 0 n= 6 ; Alpha :
      ALPHA( 1,0, 6)=  0.0000000000000D+00
      ALPHA( 2,0, 6)=  0.0000000000000D+00
      ALPHA( 3,0, 6)=  0.0000000000000D+00
      ALPHA( 4,0, 6)=  0.0000000000000D+00
      ALPHA( 5,0, 6)=  0.0000000000000D+00
      ALPHA( 6,0, 6)=  1.0000000000000D+00
C l= 0 n= 6 ; Coef  :
      COEF (   0, 6)= -1.0000000000000D+00
C l= 1 n= 6 ; Alpha :
      ALPHA( 1,1, 6)=  1.0000000000000D+00
      ALPHA( 2,1, 6)= 0.50000000000000D+00
      ALPHA( 3,1, 6)= 0.33333333333333D+00
      ALPHA( 4,1, 6)= 0.25000000000000D+00
      ALPHA( 5,1, 6)= 0.20000000000000D+00
      ALPHA( 6,1, 6)= 0.16666666666667D+00
C l= 1 n= 6 ; Coef  :
      COEF (   1, 6)= -2.4500000000000D+00
C l= 2 n= 6 ; Alpha :
      ALPHA( 1,2, 6)=  2.4500000000000D+00
      ALPHA( 2,2, 6)= 0.72500000000000D+00
      ALPHA( 3,2, 6)= 0.31666666666667D+00
      ALPHA( 4,2, 6)= 0.15416666666667D+00
      ALPHA( 5,2, 6)= 0.73333333333333D-01
      ALPHA( 6,2, 6)= 0.27777777777778D-01
C l= 2 n= 6 ; Coef  :
      COEF (   2, 6)= -3.7469444444444D+00
C l= 3 n= 6 ; Alpha :
      ALPHA( 1,3, 6)=  3.7469444444444D+00
      ALPHA( 2,3, 6)= 0.64847222222222D+00
      ALPHA( 3,3, 6)= 0.19064814814815D+00
      ALPHA( 4,3, 6)= 0.63819444444444D-01
      ALPHA( 5,3, 6)= 0.20222222222222D-01
      ALPHA( 6,3, 6)= 0.46296296296296D-02
C l= 3 n= 6 ; Coef  :
      COEF (   3, 6)= -4.6747361111111D+00
C l= 4 n= 6 ; Alpha :
      ALPHA( 1,4, 6)=  4.6747361111111D+00
      ALPHA( 2,4, 6)= 0.46389583333333D+00
      ALPHA( 3,4, 6)= 0.93106481481481D-01
      ALPHA( 4,4, 6)= 0.22167824074074D-01
      ALPHA( 5,4, 6)= 0.49703703703704D-02
      ALPHA( 6,4, 6)= 0.77160493827160D-03
C l= 4 n= 6 ; Coef  :
      COEF (   4, 6)= -5.2596482253086D+00
C l= 0 n= 7 ; Alpha :
      ALPHA( 1,0, 7)=  0.0000000000000D+00
      ALPHA( 2,0, 7)=  0.0000000000000D+00
      ALPHA( 3,0, 7)=  0.0000000000000D+00
      ALPHA( 4,0, 7)=  0.0000000000000D+00
      ALPHA( 5,0, 7)=  0.0000000000000D+00
      ALPHA( 6,0, 7)=  0.0000000000000D+00
      ALPHA( 7,0, 7)=  1.0000000000000D+00
C l= 0 n= 7 ; Coef  :
      COEF (   0, 7)= -1.0000000000000D+00
C l= 1 n= 7 ; Alpha :
      ALPHA( 1,1, 7)=  1.0000000000000D+00
      ALPHA( 2,1, 7)= 0.50000000000000D+00
      ALPHA( 3,1, 7)= 0.33333333333333D+00
      ALPHA( 4,1, 7)= 0.25000000000000D+00
      ALPHA( 5,1, 7)= 0.20000000000000D+00
      ALPHA( 6,1, 7)= 0.16666666666667D+00
      ALPHA( 7,1, 7)= 0.14285714285714D+00
C l= 1 n= 7 ; Coef  :
      COEF (   1, 7)= -2.5928571428571D+00
C l= 2 n= 7 ; Alpha :
      ALPHA( 1,2, 7)=  2.5928571428571D+00
      ALPHA( 2,2, 7)= 0.79642857142857D+00
      ALPHA( 3,2, 7)= 0.36428571428571D+00
      ALPHA( 4,2, 7)= 0.18988095238095D+00
      ALPHA( 5,2, 7)= 0.10190476190476D+00
      ALPHA( 6,2, 7)= 0.51587301587302D-01
      ALPHA( 7,2, 7)= 0.20408163265306D-01
C l= 2 n= 7 ; Coef  :
      COEF (   2, 7)= -4.1173526077098D+00
C l= 3 n= 7 ; Alpha :
      ALPHA( 1,3, 7)=  4.1173526077098D+00
      ALPHA( 2,3, 7)= 0.76224773242630D+00
      ALPHA( 3,3, 7)= 0.24268896447468D+00
      ALPHA( 4,3, 7)= 0.90945294784580D-01
      ALPHA( 5,3, 7)= 0.34780045351474D-01
      ALPHA( 6,3, 7)= 0.11999244142101D-01
      ALPHA( 7,3, 7)= 0.29154518950437D-02
C l= 3 n= 7 ; Coef  :
      COEF (   3, 7)= -5.2629293407839D+00
C l= 4 n= 7 ; Alpha :
      ALPHA( 1,4, 7)=  5.2629293407839D+00
      ALPHA( 2,4, 7)= 0.57278836653709D+00
      ALPHA( 3,4, 7)= 0.12777633354929D+00
      ALPHA( 4,4, 7)= 0.35160009043300D-01
      ALPHA( 5,4, 7)= 0.99389482777238D-02
      ALPHA( 6,4, 7)= 0.24857826728575D-02
      ALPHA( 7,4, 7)= 0.41649312786339D-03
C l= 4 n= 7 ; Coef  :
      COEF (   4, 7)= -6.0114952739921D+00
C l= 0 n= 8 ; Alpha :
      ALPHA( 1,0, 8)=  0.0000000000000D+00
      ALPHA( 2,0, 8)=  0.0000000000000D+00
      ALPHA( 3,0, 8)=  0.0000000000000D+00
      ALPHA( 4,0, 8)=  0.0000000000000D+00
      ALPHA( 5,0, 8)=  0.0000000000000D+00
      ALPHA( 6,0, 8)=  0.0000000000000D+00
      ALPHA( 7,0, 8)=  0.0000000000000D+00
      ALPHA( 8,0, 8)=  1.0000000000000D+00
C l= 0 n= 8 ; Coef  :
      COEF (   0, 8)= -1.0000000000000D+00
C l= 1 n= 8 ; Alpha :
      ALPHA( 1,1, 8)=  1.0000000000000D+00
      ALPHA( 2,1, 8)= 0.50000000000000D+00
      ALPHA( 3,1, 8)= 0.33333333333333D+00
      ALPHA( 4,1, 8)= 0.25000000000000D+00
      ALPHA( 5,1, 8)= 0.20000000000000D+00
      ALPHA( 6,1, 8)= 0.16666666666667D+00
      ALPHA( 7,1, 8)= 0.14285714285714D+00
      ALPHA( 8,1, 8)= 0.12500000000000D+00
C l= 1 n= 8 ; Coef  :
      COEF (   1, 8)= -2.7178571428571D+00
C l= 2 n= 8 ; Alpha :
      ALPHA( 1,2, 8)=  2.7178571428571D+00
      ALPHA( 2,2, 8)= 0.85892857142857D+00
      ALPHA( 3,2, 8)= 0.40595238095238D+00
      ALPHA( 4,2, 8)= 0.22113095238095D+00
      ALPHA( 5,2, 8)= 0.12690476190476D+00
      ALPHA( 6,2, 8)= 0.72420634920635D-01
      ALPHA( 7,2, 8)= 0.38265306122449D-01
      ALPHA( 8,2, 8)= 0.15625000000000D-01
C l= 2 n= 8 ; Coef  :
      COEF (   2, 8)= -4.4570847505669D+00
C l= 3 n= 8 ; Alpha :
      ALPHA( 1,3, 8)=  4.4570847505669D+00
      ALPHA( 2,3, 8)= 0.86961380385488D+00
      ALPHA( 3,3, 8)= 0.29343301209373D+00
      ALPHA( 4,3, 8)= 0.11858666383220D+00
      ALPHA( 5,3, 8)= 0.50643140589569D-01
      ALPHA( 6,3, 8)= 0.21051823507181D-01
      ALPHA( 7,3, 8)= 0.76986151603499D-02
      ALPHA( 8,3, 8)= 0.19531250000000D-02
C l= 3 n= 8 ; Coef  :
      COEF (   3, 8)= -5.8200649346048D+00
C l= 4 n= 8 ; Alpha :
      ALPHA( 1,4, 8)=  5.8200649346048D+00
      ALPHA( 2,4, 8)= 0.68149009201895D+00
      ALPHA( 3,4, 8)= 0.16445546006101D+00
      ALPHA( 4,4, 8)= 0.49983342022325D-01
      ALPHA( 5,4, 8)= 0.16269340851420D-01
      ALPHA( 6,4, 8)= 0.51172606112551D-02
      ALPHA( 7,4, 8)= 0.13788200229071D-02
      ALPHA( 8,4, 8)= 0.24414062500000D-03
C l= 4 n= 8 ; Coef  :
      COEF (   4, 8)= -6.7390033908177D+00
C l= 0 n= 9 ; Alpha :
      ALPHA( 1,0, 9)=  0.0000000000000D+00
      ALPHA( 2,0, 9)=  0.0000000000000D+00
      ALPHA( 3,0, 9)=  0.0000000000000D+00
      ALPHA( 4,0, 9)=  0.0000000000000D+00
      ALPHA( 5,0, 9)=  0.0000000000000D+00
      ALPHA( 6,0, 9)=  0.0000000000000D+00
      ALPHA( 7,0, 9)=  0.0000000000000D+00
      ALPHA( 8,0, 9)=  0.0000000000000D+00
      ALPHA( 9,0, 9)=  1.0000000000000D+00
C l= 0 n= 9 ; Coef  :
      COEF (   0, 9)= -1.0000000000000D+00
C l= 1 n= 9 ; Alpha :
      ALPHA( 1,1, 9)=  1.0000000000000D+00
      ALPHA( 2,1, 9)= 0.50000000000000D+00
      ALPHA( 3,1, 9)= 0.33333333333333D+00
      ALPHA( 4,1, 9)= 0.25000000000000D+00
      ALPHA( 5,1, 9)= 0.20000000000000D+00
      ALPHA( 6,1, 9)= 0.16666666666667D+00
      ALPHA( 7,1, 9)= 0.14285714285714D+00
      ALPHA( 8,1, 9)= 0.12500000000000D+00
      ALPHA( 9,1, 9)= 0.11111111111111D+00
C l= 1 n= 9 ; Coef  :
      COEF (   1, 9)= -2.8289682539683D+00
C l= 2 n= 9 ; Alpha :
      ALPHA( 1,2, 9)=  2.8289682539683D+00
      ALPHA( 2,2, 9)= 0.91448412698413D+00
      ALPHA( 3,2, 9)= 0.44298941798942D+00
      ALPHA( 4,2, 9)= 0.24890873015873D+00
      ALPHA( 5,2, 9)= 0.14912698412698D+00
      ALPHA( 6,2, 9)= 0.90939153439153D-01
      ALPHA( 7,2, 9)= 0.54138321995465D-01
      ALPHA( 8,2, 9)= 0.29513888888889D-01
      ALPHA( 9,2, 9)= 0.12345679012346D-01
C l= 2 n= 9 ; Coef  :
      COEF (   2, 9)= -4.7714145565634D+00
C l= 3 n= 9 ; Alpha :
      ALPHA( 1,3, 9)=  4.7714145565634D+00
      ALPHA( 2,3, 9)= 0.97122315129756D+00
      ALPHA( 3,3, 9)= 0.34265405853700D+00
      ALPHA( 4,3, 9)= 0.14624318940539D+00
      ALPHA( 5,3, 9)= 0.67212805492567D-01
      ALPHA( 6,3, 9)= 0.31156173889309D-01
      ALPHA( 7,3, 9)= 0.13713984270957D-01
      ALPHA( 8,3, 9)= 0.52324459876543D-02
      ALPHA( 9,3, 9)= 0.13717421124829D-02
C l= 3 n= 9 ; Coef  :
      COEF (   3, 9)= -6.3502221075563D+00
C l= 4 n= 9 ; Alpha :
      ALPHA( 1,4, 9)=  6.3502221075563D+00
      ALPHA( 2,4, 9)= 0.78940377549646D+00
      ALPHA( 3,4, 9)= 0.20252813323179D+00
      ALPHA( 4,4, 9)= 0.66232585289591D-01
      ALPHA( 5,4, 9)= 0.23737430350594D-01
      ALPHA( 6,4, 9)= 0.85790577100672D-02
      ALPHA( 7,4, 9)= 0.29025960530135D-02
      ALPHA( 8,4, 9)= 0.82552351251715D-03
      ALPHA( 9,4, 9)= 0.15241579027587D-03
C l= 4 n= 9 ; Coef  :
      COEF (   4, 9)= -7.4445836249906D+00
C l= 0 n=10 ; Alpha :
      ALPHA( 1,0,10)=  0.0000000000000D+00
      ALPHA( 2,0,10)=  0.0000000000000D+00
      ALPHA( 3,0,10)=  0.0000000000000D+00
      ALPHA( 4,0,10)=  0.0000000000000D+00
      ALPHA( 5,0,10)=  0.0000000000000D+00
      ALPHA( 6,0,10)=  0.0000000000000D+00
      ALPHA( 7,0,10)=  0.0000000000000D+00
      ALPHA( 8,0,10)=  0.0000000000000D+00
      ALPHA( 9,0,10)=  0.0000000000000D+00
      ALPHA(10,0,10)=  1.0000000000000D+00
C l= 0 n=10 ; Coef  :
      COEF (   0,10)= -1.0000000000000D+00
C l= 1 n=10 ; Alpha :
      ALPHA( 1,1,10)=  1.0000000000000D+00
      ALPHA( 2,1,10)= 0.50000000000000D+00
      ALPHA( 3,1,10)= 0.33333333333333D+00
      ALPHA( 4,1,10)= 0.25000000000000D+00
      ALPHA( 5,1,10)= 0.20000000000000D+00
      ALPHA( 6,1,10)= 0.16666666666667D+00
      ALPHA( 7,1,10)= 0.14285714285714D+00
      ALPHA( 8,1,10)= 0.12500000000000D+00
      ALPHA( 9,1,10)= 0.11111111111111D+00
      ALPHA(10,1,10)= 0.10000000000000D+00
C l= 1 n=10 ; Coef  :
      COEF (   1,10)= -2.9289682539683D+00
C l= 2 n=10 ; Alpha :
      ALPHA( 1,2,10)=  2.9289682539683D+00
      ALPHA( 2,2,10)= 0.96448412698413D+00
      ALPHA( 3,2,10)= 0.47632275132275D+00
      ALPHA( 4,2,10)= 0.27390873015873D+00
      ALPHA( 5,2,10)= 0.16912698412698D+00
      ALPHA( 6,2,10)= 0.10760582010582D+00
      ALPHA( 7,2,10)= 0.68424036281179D-01
      ALPHA( 8,2,10)= 0.42013888888889D-01
      ALPHA( 9,2,10)= 0.23456790123457D-01
      ALPHA(10,2,10)= 0.10000000000000D-01
C l= 2 n=10 ; Coef  :
      COEF (   2,10)= -5.0643113819602D+00
C l= 3 n=10 ; Alpha :
      ALPHA( 1,3,10)=  5.0643113819602D+00
      ALPHA( 2,3,10)=  1.0676715639960D+00
      ALPHA( 3,3,10)= 0.39028633366927D+00
      ALPHA( 4,3,10)= 0.17363406242126D+00
      ALPHA( 5,3,10)= 0.84125503905266D-01
      ALPHA( 6,3,10)= 0.41916755899891D-01
      ALPHA( 7,3,10)= 0.20556387899075D-01
      ALPHA( 8,3,10)= 0.94338348765432D-02
      ALPHA( 9,3,10)= 0.37174211248285D-02
      ALPHA(10,3,10)= 0.10000000000000D-02
C l= 3 n=10 ; Coef  :
      COEF (   3,10)= -6.8566532457523D+00
C l= 4 n=10 ; Alpha :
      ALPHA( 1,4,10)=  6.8566532457523D+00
      ALPHA( 2,4,10)= 0.89617093189605D+00
      ALPHA( 3,4,10)= 0.24155676659871D+00
      ALPHA( 4,4,10)= 0.83595991531717D-01
      ALPHA( 5,4,10)= 0.32149980741121D-01
      ALPHA( 6,4,10)= 0.12770733300056D-01
      ALPHA( 7,4,10)= 0.49582348429210D-02
      ALPHA( 8,4,10)= 0.17689070001715D-02
      ALPHA( 9,4,10)= 0.52415790275873D-03
      ALPHA(10,4,10)= 0.10000000000000D-03
C l= 4 n=10 ; Coef  :
      COEF (   4,10)= -8.1302489495658D+00
C l= 0 n=11 ; Alpha :
      ALPHA( 1,0,11)=  0.0000000000000D+00
      ALPHA( 2,0,11)=  0.0000000000000D+00
      ALPHA( 3,0,11)=  0.0000000000000D+00
      ALPHA( 4,0,11)=  0.0000000000000D+00
      ALPHA( 5,0,11)=  0.0000000000000D+00
      ALPHA( 6,0,11)=  0.0000000000000D+00
      ALPHA( 7,0,11)=  0.0000000000000D+00
      ALPHA( 8,0,11)=  0.0000000000000D+00
      ALPHA( 9,0,11)=  0.0000000000000D+00
      ALPHA(10,0,11)=  0.0000000000000D+00
      ALPHA(11,0,11)=  1.0000000000000D+00
C l= 0 n=11 ; Coef  :
      COEF (   0,11)= -1.0000000000000D+00
C l= 1 n=11 ; Alpha :
      ALPHA( 1,1,11)=  1.0000000000000D+00
      ALPHA( 2,1,11)= 0.50000000000000D+00
      ALPHA( 3,1,11)= 0.33333333333333D+00
      ALPHA( 4,1,11)= 0.25000000000000D+00
      ALPHA( 5,1,11)= 0.20000000000000D+00
      ALPHA( 6,1,11)= 0.16666666666667D+00
      ALPHA( 7,1,11)= 0.14285714285714D+00
      ALPHA( 8,1,11)= 0.12500000000000D+00
      ALPHA( 9,1,11)= 0.11111111111111D+00
      ALPHA(10,1,11)= 0.10000000000000D+00
      ALPHA(11,1,11)= 0.90909090909091D-01
C l= 1 n=11 ; Coef  :
      COEF (   1,11)= -3.0198773448773D+00
C l= 2 n=11 ; Alpha :
      ALPHA( 1,2,11)=  3.0198773448773D+00
      ALPHA( 2,2,11)=  1.0099386724387D+00
      ALPHA( 3,2,11)= 0.50662578162578D+00
      ALPHA( 4,2,11)= 0.29663600288600D+00
      ALPHA( 5,2,11)= 0.18730880230880D+00
      ALPHA( 6,2,11)= 0.12275733525734D+00
      ALPHA( 7,2,11)= 0.81411049268192D-01
      ALPHA( 8,2,11)= 0.53377525252525D-01
      ALPHA( 9,2,11)= 0.33557800224467D-01
      ALPHA(10,2,11)= 0.19090909090909D-01
      ALPHA(11,2,11)= 0.82644628099174D-02
C l= 2 n=11 ; Coef  :
      COEF (   2,11)= -5.3388456860400D+00
C l= 3 n=11 ; Alpha :
      ALPHA( 1,3,11)=  5.3388456860400D+00
      ALPHA( 2,3,11)=  1.1594841705813D+00
      ALPHA( 3,3,11)= 0.43634322290798D+00
      ALPHA( 4,3,11)= 0.20060097177454D+00
      ALPHA( 5,3,11)= 0.10115357684243D+00
      ALPHA( 6,3,11)= 0.53076513650558D-01
      ALPHA( 7,3,11)= 0.27957392378002D-01
      ALPHA( 8,3,11)= 0.14286337172227D-01
      ALPHA( 9,3,11)= 0.67681302361437D-02
      ALPHA(10,3,11)= 0.27355371900826D-02
      ALPHA(11,3,11)= 0.75131480090158D-03
C l= 3 n=11 ; Coef  :
      COEF (   3,11)= -7.3420028535741D+00
C l= 4 n=11 ; Alpha :
      ALPHA( 1,4,11)=  7.3420028535741D+00
      ALPHA( 2,4,11)=  1.0015785837671D+00
      ALPHA( 3,4,11)= 0.28122433231762D+00
      ALPHA( 4,4,11)= 0.10183244351122D+00
      ALPHA( 5,4,11)= 0.41345760454069D-01
      ALPHA( 6,4,11)= 0.17595870904652D-01
      ALPHA( 7,4,11)= 0.74998159681938D-02
      ALPHA( 8,4,11)= 0.30676649249194D-02
      ALPHA( 9,4,11)= 0.11394424696809D-02
      ALPHA(10,4,11)= 0.34868519909842D-03
      ALPHA(11,4,11)= 0.68301345536507D-04
C l= 4 n=11 ; Coef  :
      COEF (   4,11)= -8.7977037544362D+00
C l= 0 n=12 ; Alpha :
      ALPHA( 1,0,12)=  0.0000000000000D+00
      ALPHA( 2,0,12)=  0.0000000000000D+00
      ALPHA( 3,0,12)=  0.0000000000000D+00
      ALPHA( 4,0,12)=  0.0000000000000D+00
      ALPHA( 5,0,12)=  0.0000000000000D+00
      ALPHA( 6,0,12)=  0.0000000000000D+00
      ALPHA( 7,0,12)=  0.0000000000000D+00
      ALPHA( 8,0,12)=  0.0000000000000D+00
      ALPHA( 9,0,12)=  0.0000000000000D+00
      ALPHA(10,0,12)=  0.0000000000000D+00
      ALPHA(11,0,12)=  0.0000000000000D+00
      ALPHA(12,0,12)=  1.0000000000000D+00
C l= 0 n=12 ; Coef  :
      COEF (   0,12)= -1.0000000000000D+00
C l= 1 n=12 ; Alpha :
      ALPHA( 1,1,12)=  1.0000000000000D+00
      ALPHA( 2,1,12)= 0.50000000000000D+00
      ALPHA( 3,1,12)= 0.33333333333333D+00
      ALPHA( 4,1,12)= 0.25000000000000D+00
      ALPHA( 5,1,12)= 0.20000000000000D+00
      ALPHA( 6,1,12)= 0.16666666666667D+00
      ALPHA( 7,1,12)= 0.14285714285714D+00
      ALPHA( 8,1,12)= 0.12500000000000D+00
      ALPHA( 9,1,12)= 0.11111111111111D+00
      ALPHA(10,1,12)= 0.10000000000000D+00
      ALPHA(11,1,12)= 0.90909090909091D-01
      ALPHA(12,1,12)= 0.83333333333333D-01
C l= 1 n=12 ; Coef  :
      COEF (   1,12)= -3.1032106782107D+00
C l= 2 n=12 ; Alpha :
      ALPHA( 1,2,12)=  3.1032106782107D+00
      ALPHA( 2,2,12)=  1.0516053391053D+00
      ALPHA( 3,2,12)= 0.53440355940356D+00
      ALPHA( 4,2,12)= 0.31746933621934D+00
      ALPHA( 5,2,12)= 0.20397546897547D+00
      ALPHA( 6,2,12)= 0.13664622414622D+00
      ALPHA( 7,2,12)= 0.93315811172954D-01
      ALPHA( 8,2,12)= 0.63794191919192D-01
      ALPHA( 9,2,12)= 0.42817059483726D-01
      ALPHA(10,2,12)= 0.27424242424242D-01
      ALPHA(11,2,12)= 0.15840220385675D-01
      ALPHA(12,2,12)= 0.69444444444444D-02
C l= 2 n=12 ; Coef  :
      COEF (   2,12)= -5.5974465758908D+00
C l= 3 n=12 ; Alpha :
      ALPHA( 1,3,12)=  5.5974465758908D+00
      ALPHA( 2,3,12)=  1.2471179488401D+00
      ALPHA( 3,3,12)= 0.48087685285827D+00
      ALPHA( 4,3,12)= 0.22705674979282D+00
      ALPHA( 5,3,12)= 0.11815153259039D+00
      ALPHA( 6,3,12)= 0.64463698996076D-01
      ALPHA( 7,3,12)= 0.35733709975748D-01
      ALPHA( 8,3,12)= 0.19602519832160D-01
      ALPHA( 9,3,12)= 0.10336218526454D-01
      ALPHA(10,3,12)= 0.50208907254362D-02
      ALPHA(11,3,12)= 0.20713331663745D-02
      ALPHA(12,3,12)= 0.57870370370370D-03
C l= 3 n=12 ; Coef  :
      COEF (   3,12)= -7.8084567348983D+00
C l= 4 n=12 ; Alpha :
      ALPHA( 1,4,12)=  7.8084567348983D+00
      ALPHA( 2,4,12)=  1.1055050795038D+00
      ALPHA( 3,4,12)= 0.32129740338914D+00
      ALPHA( 4,4,12)= 0.12075383932729D+00
      ALPHA( 5,4,12)= 0.51191721503268D-01
      ALPHA( 6,4,12)= 0.22967845820992D-01
      ALPHA( 7,4,12)= 0.10477625132839D-01
      ALPHA( 8,4,12)= 0.47012082442661D-02
      ALPHA( 9,4,12)= 0.20007940135521D-02
      ALPHA(10,4,12)= 0.76709275955144D-03
      ALPHA(11,4,12)= 0.24091244273438D-03
      ALPHA(12,4,12)= 0.48225308641975D-04
C l= 4 n=12 ; Coef  :
      COEF (   4,12)= -9.4484084823444D+00
C l= 0 n=13 ; Alpha :
      ALPHA( 1,0,13)=  0.0000000000000D+00
      ALPHA( 2,0,13)=  0.0000000000000D+00
      ALPHA( 3,0,13)=  0.0000000000000D+00
      ALPHA( 4,0,13)=  0.0000000000000D+00
      ALPHA( 5,0,13)=  0.0000000000000D+00
      ALPHA( 6,0,13)=  0.0000000000000D+00
      ALPHA( 7,0,13)=  0.0000000000000D+00
      ALPHA( 8,0,13)=  0.0000000000000D+00
      ALPHA( 9,0,13)=  0.0000000000000D+00
      ALPHA(10,0,13)=  0.0000000000000D+00
      ALPHA(11,0,13)=  0.0000000000000D+00
      ALPHA(12,0,13)=  0.0000000000000D+00
      ALPHA(13,0,13)=  1.0000000000000D+00
C l= 0 n=13 ; Coef  :
      COEF (   0,13)= -1.0000000000000D+00
C l= 1 n=13 ; Alpha :
      ALPHA( 1,1,13)=  1.0000000000000D+00
      ALPHA( 2,1,13)= 0.50000000000000D+00
      ALPHA( 3,1,13)= 0.33333333333333D+00
      ALPHA( 4,1,13)= 0.25000000000000D+00
      ALPHA( 5,1,13)= 0.20000000000000D+00
      ALPHA( 6,1,13)= 0.16666666666667D+00
      ALPHA( 7,1,13)= 0.14285714285714D+00
      ALPHA( 8,1,13)= 0.12500000000000D+00
      ALPHA( 9,1,13)= 0.11111111111111D+00
      ALPHA(10,1,13)= 0.10000000000000D+00
      ALPHA(11,1,13)= 0.90909090909091D-01
      ALPHA(12,1,13)= 0.83333333333333D-01
      ALPHA(13,1,13)= 0.76923076923077D-01
C l= 1 n=13 ; Coef  :
      COEF (   1,13)= -3.1801337551338D+00
C l= 2 n=13 ; Alpha :
      ALPHA( 1,2,13)=  3.1801337551338D+00
      ALPHA( 2,2,13)=  1.0900668775669D+00
      ALPHA( 3,2,13)= 0.56004458504459D+00
      ALPHA( 4,2,13)= 0.33670010545011D+00
      ALPHA( 5,2,13)= 0.21936008436008D+00
      ALPHA( 6,2,13)= 0.14946673696674D+00
      ALPHA( 7,2,13)= 0.10430482216197D+00
      ALPHA( 8,2,13)= 0.73409576534577D-01
      ALPHA( 9,2,13)= 0.51364068030735D-01
      ALPHA(10,2,13)= 0.35116550116550D-01
      ALPHA(11,2,13)= 0.22833227378682D-01
      ALPHA(12,2,13)= 0.13354700854701D-01
      ALPHA(13,2,13)= 0.59171597633136D-02
C l= 2 n=13 ; Coef  :
      COEF (   2,13)= -5.8420722493627D+00
C l= 3 n=13 ; Alpha :
      ALPHA( 1,3,13)=  5.8420722493627D+00
      ALPHA( 2,3,13)=  1.3309692471145D+00
      ALPHA( 3,3,13)= 0.52395720555401D+00
      ALPHA( 4,3,13)= 0.25295675790436D+00
      ALPHA( 5,3,13)= 0.13502538523347D+00
      ALPHA( 6,3,13)= 0.75961140301210D-01
      ALPHA( 7,3,13)= 0.43757157834360D-01
      ALPHA( 8,3,13)= 0.25249410334820D-01
      ALPHA( 9,3,13)= 0.14287300682665D-01
      ALPHA(10,3,13)= 0.77221638113247D-02
      ALPHA(11,3,13)= 0.38277352724269D-02
      ALPHA(12,3,13)= 0.16059883848345D-02
      ALPHA(13,3,13)= 0.45516613563951D-03
C l= 3 n=13 ; Coef  :
      COEF (   3,13)= -8.2578469079262D+00
C l= 4 n=13 ; Alpha :
      ALPHA( 1,4,13)=  8.2578469079262D+00
      ALPHA( 2,4,13)=  1.2078873292818D+00
      ALPHA( 3,4,13)= 0.36160180381637D+00
      ALPHA( 4,4,13)= 0.14021205147378D+00
      ALPHA( 5,4,13)= 0.61578289598150D-01
      ALPHA( 6,4,13)= 0.28811010459547D-01
      ALPHA( 7,4,13)= 0.13843560350867D-01
      ALPHA( 8,4,13)= 0.66434705777137D-02
      ALPHA( 9,4,13)= 0.30998171429878D-02
      ALPHA(10,4,13)= 0.13611053604226D-02
      ALPHA(11,4,13)= 0.53535361753645D-03
      ALPHA(12,4,13)= 0.17176287670617D-03
      ALPHA(13,4,13)= 0.35012779664578D-04
C l= 4 n=13 ; Coef  :
      COEF (   4,13)= -10.083627475262D+00
C l= 0 n=14 ; Alpha :
      ALPHA( 1,0,14)=  0.0000000000000D+00
      ALPHA( 2,0,14)=  0.0000000000000D+00
      ALPHA( 3,0,14)=  0.0000000000000D+00
      ALPHA( 4,0,14)=  0.0000000000000D+00
      ALPHA( 5,0,14)=  0.0000000000000D+00
      ALPHA( 6,0,14)=  0.0000000000000D+00
      ALPHA( 7,0,14)=  0.0000000000000D+00
      ALPHA( 8,0,14)=  0.0000000000000D+00
      ALPHA( 9,0,14)=  0.0000000000000D+00
      ALPHA(10,0,14)=  0.0000000000000D+00
      ALPHA(11,0,14)=  0.0000000000000D+00
      ALPHA(12,0,14)=  0.0000000000000D+00
      ALPHA(13,0,14)=  0.0000000000000D+00
      ALPHA(14,0,14)=  1.0000000000000D+00
C l= 0 n=14 ; Coef  :
      COEF (   0,14)= -1.0000000000000D+00
C l= 1 n=14 ; Alpha :
      ALPHA( 1,1,14)=  1.0000000000000D+00
      ALPHA( 2,1,14)= 0.50000000000000D+00
      ALPHA( 3,1,14)= 0.33333333333333D+00
      ALPHA( 4,1,14)= 0.25000000000000D+00
      ALPHA( 5,1,14)= 0.20000000000000D+00
      ALPHA( 6,1,14)= 0.16666666666667D+00
      ALPHA( 7,1,14)= 0.14285714285714D+00
      ALPHA( 8,1,14)= 0.12500000000000D+00
      ALPHA( 9,1,14)= 0.11111111111111D+00
      ALPHA(10,1,14)= 0.10000000000000D+00
      ALPHA(11,1,14)= 0.90909090909091D-01
      ALPHA(12,1,14)= 0.83333333333333D-01
      ALPHA(13,1,14)= 0.76923076923077D-01
      ALPHA(14,1,14)= 0.71428571428571D-01
C l= 1 n=14 ; Coef  :
      COEF (   1,14)= -3.2515623265623D+00
C l= 2 n=14 ; Alpha :
      ALPHA( 1,2,14)=  3.2515623265623D+00
      ALPHA( 2,2,14)=  1.1257811632812D+00
      ALPHA( 3,2,14)= 0.58385410885411D+00
      ALPHA( 4,2,14)= 0.35455724830725D+00
      ALPHA( 5,2,14)= 0.23364579864580D+00
      ALPHA( 6,2,14)= 0.16137149887150D+00
      ALPHA( 7,2,14)= 0.11450890379462D+00
      ALPHA( 8,2,14)= 0.82338147963148D-01
      ALPHA( 9,2,14)= 0.59300575967243D-01
      ALPHA(10,2,14)= 0.42259407259407D-01
      ALPHA(11,2,14)= 0.29326733872188D-01
      ALPHA(12,2,14)= 0.19307081807082D-01
      ALPHA(13,2,14)= 0.11411665257819D-01
      ALPHA(14,2,14)= 0.51020408163265D-02
C l= 2 n=14 ; Coef  :
      COEF (   2,14)= -6.0743267012600D+00
C l= 3 n=14 ; Alpha :
      ALPHA( 1,3,14)=  6.0743267012600D+00
      ALPHA( 2,3,14)=  1.4113821873488D+00
      ALPHA( 3,3,14)= 0.56566107047216D+00
      ALPHA( 4,3,14)= 0.27828227564059D+00
      ALPHA( 5,3,14)= 0.15171437085103D+00
      ALPHA( 6,3,14)= 0.87487675934888D-01
      ALPHA( 7,3,14)= 0.51936365248262D-01
      ALPHA( 8,3,14)= 0.31130706617902D-01
      ALPHA( 9,3,14)= 0.18523056108896D-01
      ALPHA(10,3,14)= 0.10740692901282D-01
      ALPHA(11,3,14)= 0.59225019775833D-02
      ALPHA(12,3,14)= 0.29850656567690D-02
      ALPHA(13,3,14)= 0.12702850826266D-02
      ALPHA(14,3,14)= 0.36443148688047D-03
C l= 3 n=14 ; Coef  :
      COEF (   3,14)= -8.6917273865877D+00
C l= 4 n=14 ; Alpha :
      ALPHA( 1,4,14)=  8.6917273865877D+00
      ALPHA( 2,4,14)=  1.3087003426638D+00
      ALPHA( 3,4,14)= 0.40200616599296D+00
      ALPHA( 4,4,14)= 0.16008935687668D+00
      ALPHA( 5,4,14)= 0.72415030373223D-01
      ALPHA( 6,4,14)= 0.35060130169182D-01
      ALPHA( 7,4,14)= 0.17553300725743D-01
      ALPHA( 8,4,14)= 0.88670924789924D-02
      ALPHA( 9,4,14)= 0.44228925793375D-02
      ALPHA(10,4,14)= 0.21282977105142D-02
      ALPHA(11,4,14)= 0.95838947307812D-03
      ALPHA(12,4,14)= 0.38498185218967D-03
      ALPHA(13,4,14)= 0.12574742842362D-03
      ALPHA(14,4,14)= 0.26030820491462D-04
C l= 4 n=14 ; Coef  :
      COEF (   4,14)= -10.704465145732D+00
C l= 0 n=15 ; Alpha :
      ALPHA( 1,0,15)=  0.0000000000000D+00
      ALPHA( 2,0,15)=  0.0000000000000D+00
      ALPHA( 3,0,15)=  0.0000000000000D+00
      ALPHA( 4,0,15)=  0.0000000000000D+00
      ALPHA( 5,0,15)=  0.0000000000000D+00
      ALPHA( 6,0,15)=  0.0000000000000D+00
      ALPHA( 7,0,15)=  0.0000000000000D+00
      ALPHA( 8,0,15)=  0.0000000000000D+00
      ALPHA( 9,0,15)=  0.0000000000000D+00
      ALPHA(10,0,15)=  0.0000000000000D+00
      ALPHA(11,0,15)=  0.0000000000000D+00
      ALPHA(12,0,15)=  0.0000000000000D+00
      ALPHA(13,0,15)=  0.0000000000000D+00
      ALPHA(14,0,15)=  0.0000000000000D+00
      ALPHA(15,0,15)=  1.0000000000000D+00
C l= 0 n=15 ; Coef  :
      COEF (   0,15)= -1.0000000000000D+00
C l= 1 n=15 ; Alpha :
      ALPHA( 1,1,15)=  1.0000000000000D+00
      ALPHA( 2,1,15)= 0.50000000000000D+00
      ALPHA( 3,1,15)= 0.33333333333333D+00
      ALPHA( 4,1,15)= 0.25000000000000D+00
      ALPHA( 5,1,15)= 0.20000000000000D+00
      ALPHA( 6,1,15)= 0.16666666666667D+00
      ALPHA( 7,1,15)= 0.14285714285714D+00
      ALPHA( 8,1,15)= 0.12500000000000D+00
      ALPHA( 9,1,15)= 0.11111111111111D+00
      ALPHA(10,1,15)= 0.10000000000000D+00
      ALPHA(11,1,15)= 0.90909090909091D-01
      ALPHA(12,1,15)= 0.83333333333333D-01
      ALPHA(13,1,15)= 0.76923076923077D-01
      ALPHA(14,1,15)= 0.71428571428571D-01
      ALPHA(15,1,15)= 0.66666666666667D-01
C l= 1 n=15 ; Coef  :
      COEF (   1,15)= -3.3182289932290D+00
C l= 2 n=15 ; Alpha :
      ALPHA( 1,2,15)=  3.3182289932290D+00
      ALPHA( 2,2,15)=  1.1591144966145D+00
      ALPHA( 3,2,15)= 0.60607633107633D+00
      ALPHA( 4,2,15)= 0.37122391497391D+00
      ALPHA( 5,2,15)= 0.24697913197913D+00
      ALPHA( 6,2,15)= 0.17248260998261D+00
      ALPHA( 7,2,15)= 0.12403271331843D+00
      ALPHA( 8,2,15)= 0.90671481296481D-01
      ALPHA( 9,2,15)= 0.66707983374650D-01
      ALPHA(10,2,15)= 0.48926073926074D-01
      ALPHA(11,2,15)= 0.35387339932794D-01
      ALPHA(12,2,15)= 0.24862637362637D-01
      ALPHA(13,2,15)= 0.16539870386024D-01
      ALPHA(14,2,15)= 0.98639455782313D-02
      ALPHA(15,2,15)= 0.44444444444444D-02
C l= 2 n=15 ; Coef  :
      COEF (   2,15)= -6.2955419674752D+00
C l= 3 n=15 ; Alpha :
      ALPHA( 1,3,15)=  6.2955419674752D+00
      ALPHA( 2,3,15)=  1.4886564871231D+00
      ALPHA( 3,3,15)= 0.60606615921058D+00
      ALPHA( 4,3,15)= 0.30303053663886D+00
      ALPHA( 5,3,15)= 0.16817964631630D+00
      ALPHA( 6,3,15)= 0.98986516600396D-01
      ALPHA( 7,3,15)= 0.60205212802824D-01
      ALPHA( 8,3,15)= 0.37175472037667D-01
      ALPHA( 9,3,15)= 0.22970255000540D-01
      ALPHA(10,3,15)= 0.14002431163021D-01
      ALPHA(11,3,15)= 0.82816579731029D-02
      ALPHA(12,3,15)= 0.46425748142781D-02
      ALPHA(13,3,15)= 0.23729431083615D-02
      ALPHA(14,3,15)= 0.10220278587626D-02
      ALPHA(15,3,15)= 0.29629629629630D-03
C l= 3 n=15 ; Coef  :
      COEF (   3,15)= -9.1114301844194D+00
C l= 4 n=15 ; Alpha :
      ALPHA( 1,4,15)=  9.1114301844194D+00
      ALPHA( 2,4,15)=  1.4079441084721D+00
      ALPHA( 3,4,15)= 0.44241057660700D+00
      ALPHA( 4,4,15)= 0.18029139265260D+00
      ALPHA( 5,4,15)= 0.83627006794310D-01
      ALPHA( 6,4,15)= 0.41659231275875D-01
      ALPHA( 7,4,15)= 0.21566981579265D-01
      ALPHA( 8,4,15)= 0.11345457281504D-01
      ALPHA( 9,4,15)= 0.59542429127068D-02
      ALPHA(10,4,15)= 0.30617931213822D-02
      ALPHA(11,4,15)= 0.15105000046183D-02
      ALPHA(12,4,15)= 0.69448683980821D-03
      ALPHA(13,4,15)= 0.28394363564772D-03
      ALPHA(14,4,15)= 0.94166011075632D-04
      ALPHA(15,4,15)= 0.19753086419753D-04
C l= 4 n=15 ; Coef  :
      COEF (   4,15)= -11.311893824694D+00
C l= 0 n=16 ; Alpha :
      ALPHA( 1,0,16)=  0.0000000000000D+00
      ALPHA( 2,0,16)=  0.0000000000000D+00
      ALPHA( 3,0,16)=  0.0000000000000D+00
      ALPHA( 4,0,16)=  0.0000000000000D+00
      ALPHA( 5,0,16)=  0.0000000000000D+00
      ALPHA( 6,0,16)=  0.0000000000000D+00
      ALPHA( 7,0,16)=  0.0000000000000D+00
      ALPHA( 8,0,16)=  0.0000000000000D+00
      ALPHA( 9,0,16)=  0.0000000000000D+00
      ALPHA(10,0,16)=  0.0000000000000D+00
      ALPHA(11,0,16)=  0.0000000000000D+00
      ALPHA(12,0,16)=  0.0000000000000D+00
      ALPHA(13,0,16)=  0.0000000000000D+00
      ALPHA(14,0,16)=  0.0000000000000D+00
      ALPHA(15,0,16)=  0.0000000000000D+00
      ALPHA(16,0,16)=  1.0000000000000D+00
C l= 0 n=16 ; Coef  :
      COEF (   0,16)= -1.0000000000000D+00
C l= 1 n=16 ; Alpha :
      ALPHA( 1,1,16)=  1.0000000000000D+00
      ALPHA( 2,1,16)= 0.50000000000000D+00
      ALPHA( 3,1,16)= 0.33333333333333D+00
      ALPHA( 4,1,16)= 0.25000000000000D+00
      ALPHA( 5,1,16)= 0.20000000000000D+00
      ALPHA( 6,1,16)= 0.16666666666667D+00
      ALPHA( 7,1,16)= 0.14285714285714D+00
      ALPHA( 8,1,16)= 0.12500000000000D+00
      ALPHA( 9,1,16)= 0.11111111111111D+00
      ALPHA(10,1,16)= 0.10000000000000D+00
      ALPHA(11,1,16)= 0.90909090909091D-01
      ALPHA(12,1,16)= 0.83333333333333D-01
      ALPHA(13,1,16)= 0.76923076923077D-01
      ALPHA(14,1,16)= 0.71428571428571D-01
      ALPHA(15,1,16)= 0.66666666666667D-01
      ALPHA(16,1,16)= 0.62500000000000D-01
C l= 1 n=16 ; Coef  :
      COEF (   1,16)= -3.3807289932290D+00
C l= 2 n=16 ; Alpha :
      ALPHA( 1,2,16)=  3.3807289932290D+00
      ALPHA( 2,2,16)=  1.1903644966145D+00
      ALPHA( 3,2,16)= 0.62690966440966D+00
      ALPHA( 4,2,16)= 0.38684891497391D+00
      ALPHA( 5,2,16)= 0.25947913197913D+00
      ALPHA( 6,2,16)= 0.18289927664928D+00
      ALPHA( 7,2,16)= 0.13296128474700D+00
      ALPHA( 8,2,16)= 0.98483981296481D-01
      ALPHA( 9,2,16)= 0.73652427819094D-01
      ALPHA(10,2,16)= 0.55176073926074D-01
      ALPHA(11,2,16)= 0.41069158114613D-01
      ALPHA(12,2,16)= 0.30070970695971D-01
      ALPHA(13,2,16)= 0.21347562693717D-01
      ALPHA(14,2,16)= 0.14328231292517D-01
      ALPHA(15,2,16)= 0.86111111111111D-02
      ALPHA(16,2,16)= 0.39062500000000D-02
C l= 2 n=16 ; Coef  :
      COEF (   2,16)= -6.5068375295521D+00
C l= 3 n=16 ; Alpha :
      ALPHA( 1,3,16)=  6.5068375295521D+00
      ALPHA( 2,3,16)=  1.5630542681615D+00
      ALPHA( 3,3,16)= 0.64524801323619D+00
      ALPHA( 4,3,16)= 0.32720859382473D+00
      ALPHA( 5,3,16)= 0.18439709206500D+00
      ALPHA( 6,3,16)= 0.11041772139098D+00
      ALPHA( 7,3,16)= 0.68515293099511D-01
      ALPHA( 8,3,16)= 0.43330720868697D-01
      ALPHA( 9,3,16)= 0.27573531739233D-01
      ALPHA(10,3,16)= 0.17450935783400D-01
      ALPHA(11,3,16)= 0.10848480355266D-01
      ALPHA(12,3,16)= 0.65220104827763D-02
      ALPHA(13,3,16)= 0.37071657767188D-02
      ALPHA(14,3,16)= 0.19175423145449D-02
      ALPHA(15,3,16)= 0.83449074074074D-03
      ALPHA(16,3,16)= 0.24414062500000D-03
C l= 3 n=16 ; Coef  :
      COEF (   3,16)= -9.5181075300164D+00
C l= 4 n=16 ; Alpha :
      ALPHA( 1,4,16)=  9.5181075300164D+00
      ALPHA( 2,4,16)=  1.5056350002322D+00
      ALPHA( 3,4,16)= 0.48273857743426D+00
      ALPHA( 4,4,16)= 0.20074192976665D+00
      ALPHA( 5,4,16)= 0.95151825048372D-01
      ALPHA( 6,4,16)= 0.48560338862811D-01
      ALPHA( 7,4,16)= 0.25849187397984D-01
      ALPHA( 8,4,16)= 0.14053627335797D-01
      ALPHA( 9,4,16)= 0.76775886464089D-02
      ALPHA(10,4,16)= 0.41524766078447D-02
      ALPHA(11,4,16)= 0.21885300268224D-02
      ALPHA(12,4,16)= 0.11021124949817D-02
      ALPHA(13,4,16)= 0.51564149669265D-03
      ALPHA(14,4,16)= 0.21401240573469D-03
      ALPHA(15,4,16)= 0.71908757716049D-04
      ALPHA(16,4,16)= 0.15258789062500D-04
C l= 4 n=16 ; Coef  :
      COEF (   4,16)= -11.906775545320D+00
C l= 0 n=17 ; Alpha :
      ALPHA( 1,0,17)=  0.0000000000000D+00
      ALPHA( 2,0,17)=  0.0000000000000D+00
      ALPHA( 3,0,17)=  0.0000000000000D+00
      ALPHA( 4,0,17)=  0.0000000000000D+00
      ALPHA( 5,0,17)=  0.0000000000000D+00
      ALPHA( 6,0,17)=  0.0000000000000D+00
      ALPHA( 7,0,17)=  0.0000000000000D+00
      ALPHA( 8,0,17)=  0.0000000000000D+00
      ALPHA( 9,0,17)=  0.0000000000000D+00
      ALPHA(10,0,17)=  0.0000000000000D+00
      ALPHA(11,0,17)=  0.0000000000000D+00
      ALPHA(12,0,17)=  0.0000000000000D+00
      ALPHA(13,0,17)=  0.0000000000000D+00
      ALPHA(14,0,17)=  0.0000000000000D+00
      ALPHA(15,0,17)=  0.0000000000000D+00
      ALPHA(16,0,17)=  0.0000000000000D+00
      ALPHA(17,0,17)=  1.0000000000000D+00
C l= 0 n=17 ; Coef  :
      COEF (   0,17)= -1.0000000000000D+00
C l= 1 n=17 ; Alpha :
      ALPHA( 1,1,17)=  1.0000000000000D+00
      ALPHA( 2,1,17)= 0.50000000000000D+00
      ALPHA( 3,1,17)= 0.33333333333333D+00
      ALPHA( 4,1,17)= 0.25000000000000D+00
      ALPHA( 5,1,17)= 0.20000000000000D+00
      ALPHA( 6,1,17)= 0.16666666666667D+00
      ALPHA( 7,1,17)= 0.14285714285714D+00
      ALPHA( 8,1,17)= 0.12500000000000D+00
      ALPHA( 9,1,17)= 0.11111111111111D+00
      ALPHA(10,1,17)= 0.10000000000000D+00
      ALPHA(11,1,17)= 0.90909090909091D-01
      ALPHA(12,1,17)= 0.83333333333333D-01
      ALPHA(13,1,17)= 0.76923076923077D-01
      ALPHA(14,1,17)= 0.71428571428571D-01
      ALPHA(15,1,17)= 0.66666666666667D-01
      ALPHA(16,1,17)= 0.62500000000000D-01
      ALPHA(17,1,17)= 0.58823529411765D-01
C l= 1 n=17 ; Coef  :
      COEF (   1,17)= -3.4395525226408D+00
C l= 2 n=17 ; Alpha :
      ALPHA( 1,2,17)=  3.4395525226408D+00
      ALPHA( 2,2,17)=  1.2197762613204D+00
      ALPHA( 3,2,17)= 0.64651750754692D+00
      ALPHA( 4,2,17)= 0.40155479732686D+00
      ALPHA( 5,2,17)= 0.27124383786148D+00
      ALPHA( 6,2,17)= 0.19270319821790D+00
      ALPHA( 7,2,17)= 0.14136464609154D+00
      ALPHA( 8,2,17)= 0.10583692247295D+00
      ALPHA( 9,2,17)= 0.80188375531513D-01
      ALPHA(10,2,17)= 0.61058426867250D-01
      ALPHA(11,2,17)= 0.46416751697500D-01
      ALPHA(12,2,17)= 0.34972931480284D-01
      ALPHA(13,2,17)= 0.25872449571545D-01
      ALPHA(14,2,17)= 0.18529911964786D-01
      ALPHA(15,2,17)= 0.12532679738562D-01
      ALPHA(16,2,17)= 0.75827205882353D-02
      ALPHA(17,2,17)= 0.34602076124567D-02
C l= 2 n=17 ; Coef  :
      COEF (   2,17)= -6.7091641485309D+00
C l= 3 n=17 ; Alpha :
      ALPHA( 1,3,17)=  6.7091641485309D+00
      ALPHA( 2,3,17)=  1.6348058129451D+00
      ALPHA( 3,3,17)= 0.68327845485660D+00
      ALPHA( 4,3,17)= 0.35082946425572D+00
      ALPHA( 5,3,17)= 0.20035261193920D+00
      ALPHA( 6,3,17)= 0.12175320363909D+00
      ALPHA( 7,3,17)= 0.76830860516660D-01
      ALPHA( 8,3,17)= 0.49556422190636D-01
      ALPHA( 9,3,17)= 0.32290495005793D-01
      ALPHA(10,3,17)= 0.21042607952062D-01
      ALPHA(11,3,17)= 0.13578877513943D-01
      ALPHA(12,3,17)= 0.85792417463224D-02
      ALPHA(13,3,17)= 0.52290745750450D-02
      ALPHA(14,3,17)= 0.30075371360029D-02
      ALPHA(15,3,17)= 0.15717071959503D-02
      ALPHA(16,3,17)= 0.69018301254325D-03
      ALPHA(17,3,17)= 0.20354162426216D-03
C l= 3 n=17 ; Coef  :
      COEF (   3,17)= -9.9127642446358D+00
C l= 4 n=17 ; Alpha :
      ALPHA( 1,4,17)=  9.9127642446358D+00
      ALPHA( 2,4,17)=  1.6018000480525D+00
      ALPHA( 3,4,17)= 0.52293142771994D+00
      ALPHA( 4,4,17)= 0.22137895707581D+00
      ALPHA( 5,4,17)= 0.10693727280950D+00
      ALPHA( 6,4,17)= 0.55722292018051D-01
      ALPHA( 7,4,17)= 0.30368649781317D-01
      ALPHA( 8,4,17)= 0.16968710994070D-01
      ALPHA( 9,4,17)= 0.95770295291026D-02
      ALPHA(10,4,17)= 0.53902770756131D-02
      ALPHA(11,4,17)= 0.29872875276426D-02
      ALPHA(12,4,17)= 0.16067737741772D-02
      ALPHA(13,4,17)= 0.82323411875412D-03
      ALPHA(14,4,17)= 0.39092635491133D-03
      ALPHA(15,4,17)= 0.16436212218371D-03
      ALPHA(16,4,17)= 0.55857789800338D-04
      ALPHA(17,4,17)= 0.11973036721304D-04
C l= 4 n=17 ; Coef  :
      COEF (   4,17)= -12.489879324416D+00
C l= 0 n=18 ; Alpha :
      ALPHA( 1,0,18)=  0.0000000000000D+00
      ALPHA( 2,0,18)=  0.0000000000000D+00
      ALPHA( 3,0,18)=  0.0000000000000D+00
      ALPHA( 4,0,18)=  0.0000000000000D+00
      ALPHA( 5,0,18)=  0.0000000000000D+00
      ALPHA( 6,0,18)=  0.0000000000000D+00
      ALPHA( 7,0,18)=  0.0000000000000D+00
      ALPHA( 8,0,18)=  0.0000000000000D+00
      ALPHA( 9,0,18)=  0.0000000000000D+00
      ALPHA(10,0,18)=  0.0000000000000D+00
      ALPHA(11,0,18)=  0.0000000000000D+00
      ALPHA(12,0,18)=  0.0000000000000D+00
      ALPHA(13,0,18)=  0.0000000000000D+00
      ALPHA(14,0,18)=  0.0000000000000D+00
      ALPHA(15,0,18)=  0.0000000000000D+00
      ALPHA(16,0,18)=  0.0000000000000D+00
      ALPHA(17,0,18)=  0.0000000000000D+00
      ALPHA(18,0,18)=  1.0000000000000D+00
C l= 0 n=18 ; Coef  :
      COEF (   0,18)= -1.0000000000000D+00
C l= 1 n=18 ; Alpha :
      ALPHA( 1,1,18)=  1.0000000000000D+00
      ALPHA( 2,1,18)= 0.50000000000000D+00
      ALPHA( 3,1,18)= 0.33333333333333D+00
      ALPHA( 4,1,18)= 0.25000000000000D+00
      ALPHA( 5,1,18)= 0.20000000000000D+00
      ALPHA( 6,1,18)= 0.16666666666667D+00
      ALPHA( 7,1,18)= 0.14285714285714D+00
      ALPHA( 8,1,18)= 0.12500000000000D+00
      ALPHA( 9,1,18)= 0.11111111111111D+00
      ALPHA(10,1,18)= 0.10000000000000D+00
      ALPHA(11,1,18)= 0.90909090909091D-01
      ALPHA(12,1,18)= 0.83333333333333D-01
      ALPHA(13,1,18)= 0.76923076923077D-01
      ALPHA(14,1,18)= 0.71428571428571D-01
      ALPHA(15,1,18)= 0.66666666666667D-01
      ALPHA(16,1,18)= 0.62500000000000D-01
      ALPHA(17,1,18)= 0.58823529411765D-01
      ALPHA(18,1,18)= 0.55555555555556D-01
C l= 1 n=18 ; Coef  :
      COEF (   1,18)= -3.4951080781963D+00
C l= 2 n=18 ; Alpha :
      ALPHA( 1,2,18)=  3.4951080781963D+00
      ALPHA( 2,2,18)=  1.2475540390982D+00
      ALPHA( 3,2,18)= 0.66503602606544D+00
      ALPHA( 4,2,18)= 0.41544368621575D+00
      ALPHA( 5,2,18)= 0.28235494897260D+00
      ALPHA( 6,2,18)= 0.20196245747716D+00
      ALPHA( 7,2,18)= 0.14930115402804D+00
      ALPHA( 8,2,18)= 0.11278136691740D+00
      ALPHA( 9,2,18)= 0.86361215037686D-01
      ALPHA(10,2,18)= 0.66613982422806D-01
      ALPHA(11,2,18)= 0.51467256748005D-01
      ALPHA(12,2,18)= 0.39602561109914D-01
      ALPHA(13,2,18)= 0.30145953845049D-01
      ALPHA(14,2,18)= 0.22498165933040D-01
      ALPHA(15,2,18)= 0.16236383442266D-01
      ALPHA(16,2,18)= 0.11054942810458D-01
      ALPHA(17,2,18)= 0.67281814686659D-02
      ALPHA(18,2,18)= 0.30864197530864D-02
C l= 2 n=18 ; Coef  :
      COEF (   2,18)= -6.9033368195418D+00
C l= 3 n=18 ; Alpha :
      ALPHA( 1,3,18)=  6.9033368195418D+00
      ALPHA( 2,3,18)=  1.7041143706728D+00
      ALPHA( 3,3,18)= 0.72022490074912D+00
      ALPHA( 4,3,18)= 0.37390966904548D+00
      ALPHA( 5,3,18)= 0.21603899799324D+00
      ALPHA( 6,3,18)= 0.13297334016560D+00
      ALPHA( 7,3,18)= 0.85125369073774D-01
      ALPHA( 8,3,18)= 0.55822053686046D-01
      ALPHA( 9,3,18)= 0.37088340285664D-01
      ALPHA(10,3,18)= 0.24743384753329D-01
      ALPHA(11,3,18)= 0.16438169555499D-01
      ALPHA(12,3,18)= 0.10779384030207D-01
      ALPHA(13,3,18)= 0.69038497886588D-02
      ALPHA(14,3,18)= 0.42574352433940D-02
      ALPHA(15,3,18)= 0.24737284982984D-02
      ALPHA(16,3,18)= 0.13043465020131D-02
      ALPHA(17,3,18)= 0.57732948363249D-03
      ALPHA(18,3,18)= 0.17146776406036D-03
C l= 3 n=18 ; Coef  :
      COEF (   3,18)= -10.296282956833D+00
C l= 4 n=18 ; Alpha :
      ALPHA( 1,4,18)=  10.296282956833D+00
      ALPHA( 2,4,18)=  1.6964730686454D+00
      ALPHA( 3,4,18)= 0.56294392220600D+00
      ALPHA( 4,4,18)= 0.24215171646722D+00
      ALPHA( 5,4,18)= 0.11893943936468D+00
      ALPHA( 6,4,18)= 0.63109699805029D-01
      ALPHA( 7,4,18)= 0.35097836952082D-01
      ALPHA( 8,4,18)= 0.20069936198850D-01
      ALPHA( 9,4,18)= 0.11637492878306D-01
      ALPHA(10,4,18)= 0.67649095619091D-02
      ALPHA(11,4,18)= 0.39005191696147D-02
      ALPHA(12,4,18)= 0.22056284425220D-02
      ALPHA(13,4,18)= 0.12067813292352D-02
      ALPHA(14,4,18)= 0.62745053509988D-03
      ALPHA(15,4,18)= 0.30179148320029D-03
      ALPHA(16,4,18)= 0.12832148435662D-03
      ALPHA(17,4,18)= 0.44046896923109D-04
      ALPHA(18,4,18)= 0.95259868922420D-05
C l= 4 n=18 ; Coef  :
      COEF (   4,18)= -13.061895044240D+00
C l= 0 n=19 ; Alpha :
      ALPHA( 1,0,19)=  0.0000000000000D+00
      ALPHA( 2,0,19)=  0.0000000000000D+00
      ALPHA( 3,0,19)=  0.0000000000000D+00
      ALPHA( 4,0,19)=  0.0000000000000D+00
      ALPHA( 5,0,19)=  0.0000000000000D+00
      ALPHA( 6,0,19)=  0.0000000000000D+00
      ALPHA( 7,0,19)=  0.0000000000000D+00
      ALPHA( 8,0,19)=  0.0000000000000D+00
      ALPHA( 9,0,19)=  0.0000000000000D+00
      ALPHA(10,0,19)=  0.0000000000000D+00
      ALPHA(11,0,19)=  0.0000000000000D+00
      ALPHA(12,0,19)=  0.0000000000000D+00
      ALPHA(13,0,19)=  0.0000000000000D+00
      ALPHA(14,0,19)=  0.0000000000000D+00
      ALPHA(15,0,19)=  0.0000000000000D+00
      ALPHA(16,0,19)=  0.0000000000000D+00
      ALPHA(17,0,19)=  0.0000000000000D+00
      ALPHA(18,0,19)=  0.0000000000000D+00
      ALPHA(19,0,19)=  1.0000000000000D+00
C l= 0 n=19 ; Coef  :
      COEF (   0,19)= -1.0000000000000D+00
C l= 1 n=19 ; Alpha :
      ALPHA( 1,1,19)=  1.0000000000000D+00
      ALPHA( 2,1,19)= 0.50000000000000D+00
      ALPHA( 3,1,19)= 0.33333333333333D+00
      ALPHA( 4,1,19)= 0.25000000000000D+00
      ALPHA( 5,1,19)= 0.20000000000000D+00
      ALPHA( 6,1,19)= 0.16666666666667D+00
      ALPHA( 7,1,19)= 0.14285714285714D+00
      ALPHA( 8,1,19)= 0.12500000000000D+00
      ALPHA( 9,1,19)= 0.11111111111111D+00
      ALPHA(10,1,19)= 0.10000000000000D+00
      ALPHA(11,1,19)= 0.90909090909091D-01
      ALPHA(12,1,19)= 0.83333333333333D-01
      ALPHA(13,1,19)= 0.76923076923077D-01
      ALPHA(14,1,19)= 0.71428571428571D-01
      ALPHA(15,1,19)= 0.66666666666667D-01
      ALPHA(16,1,19)= 0.62500000000000D-01
      ALPHA(17,1,19)= 0.58823529411765D-01
      ALPHA(18,1,19)= 0.55555555555556D-01
      ALPHA(19,1,19)= 0.52631578947368D-01
C l= 1 n=19 ; Coef  :
      COEF (   1,19)= -3.5477396571437D+00
C l= 2 n=19 ; Alpha :
      ALPHA( 1,2,19)=  3.5477396571437D+00
      ALPHA( 2,2,19)=  1.2738698285718D+00
      ALPHA( 3,2,19)= 0.68257988571456D+00
      ALPHA( 4,2,19)= 0.42860158095259D+00
      ALPHA( 5,2,19)= 0.29288126476207D+00
      ALPHA( 6,2,19)= 0.21073438730172D+00
      ALPHA( 7,2,19)= 0.15681995102053D+00
      ALPHA( 8,2,19)= 0.11936031428582D+00
      ALPHA( 9,2,19)= 0.92209168254060D-01
      ALPHA(10,2,19)= 0.71877140317543D-01
      ALPHA(11,2,19)= 0.56251945743221D-01
      ALPHA(12,2,19)= 0.43988526022195D-01
      ALPHA(13,2,19)= 0.34194536841000D-01
      ALPHA(14,2,19)= 0.26257564429280D-01
      ALPHA(15,2,19)= 0.19745155372090D-01
      ALPHA(16,2,19)= 0.14344416494668D-01
      ALPHA(17,2,19)= 0.98241567008640D-02
      ALPHA(18,2,19)= 0.60103963612736D-02
      ALPHA(19,2,19)= 0.27700831024931D-02
C l= 2 n=19 ; Coef  :
      COEF (   2,19)= -7.0900599593915D+00
C l= 3 n=19 ; Alpha :
      ALPHA( 1,3,19)=  7.0900599593915D+00
      ALPHA( 2,3,19)=  1.7711601511239D+00
      ALPHA( 3,3,19)= 0.75615015789199D+00
      ALPHA( 4,3,19)= 0.39646764699035D+00
      ALPHA( 5,3,19)= 0.23145380140177D+00
      ALPHA( 6,3,19)= 0.14406462370779D+00
      ALPHA( 7,3,19)= 0.93379050706433D-01
      ALPHA( 8,3,19)= 0.62104175490563D-01
      ALPHA( 9,3,19)= 0.41941454404299D-01
      ALPHA(10,3,19)= 0.28526392138463D-01
      ALPHA(11,3,19)= 0.19398798278826D-01
      ALPHA(12,3,19)= 0.13094569610322D-01
      ALPHA(13,3,19)= 0.87035622539746D-02
      ALPHA(14,3,19)= 0.56394123186193D-02
      ALPHA(15,3,19)= 0.35129472020926D-02
      ALPHA(16,3,19)= 0.20593157912062D-02
      ALPHA(17,3,19)= 0.10943903626253D-02
      ALPHA(18,3,19)= 0.48780441465370D-03
      ALPHA(19,3,19)= 0.14579384749964D-03
C l= 3 n=19 ; Coef  :
      COEF (   3,19)= -10.669444007327D+00
C l= 4 n=19 ; Alpha :
      ALPHA( 1,4,19)=  10.669444007327D+00
      ALPHA( 2,4,19)=  1.7896920239677D+00
      ALPHA( 3,4,19)= 0.60274129893716D+00
      ALPHA( 4,4,19)= 0.26301843472987D+00
      ALPHA( 5,4,19)= 0.13112121838583D+00
      ALPHA( 6,4,19)= 0.70692048421228D-01
      ALPHA( 7,4,19)= 0.40012523831368D-01
      ALPHA( 8,4,19)= 0.23338577014143D-01
      ALPHA( 9,4,19)= 0.13844937846953D-01
      ALPHA(10,4,19)= 0.82662986218282D-02
      ALPHA(11,4,19)= 0.49215085527108D-02
      ALPHA(12,4,19)= 0.28948163167494D-02
      ALPHA(13,4,19)= 0.16648635531286D-02
      ALPHA(14,4,19)= 0.92426170976405D-03
      ALPHA(15,4,19)= 0.48668344120516D-03
      ALPHA(16,4,19)= 0.23670652599905D-03
      ALPHA(17,4,19)= 0.10164638969286D-03
      ALPHA(18,4,19)= 0.35199903452963D-04
      ALPHA(19,4,19)= 0.76733603947177D-05
C l= 4 n=19 ; Coef  :
      COEF (   4,19)= -13.623444728836D+00
C l= 0 n=20 ; Alpha :
      ALPHA( 1,0,20)=  0.0000000000000D+00
      ALPHA( 2,0,20)=  0.0000000000000D+00
      ALPHA( 3,0,20)=  0.0000000000000D+00
      ALPHA( 4,0,20)=  0.0000000000000D+00
      ALPHA( 5,0,20)=  0.0000000000000D+00
      ALPHA( 6,0,20)=  0.0000000000000D+00
      ALPHA( 7,0,20)=  0.0000000000000D+00
      ALPHA( 8,0,20)=  0.0000000000000D+00
      ALPHA( 9,0,20)=  0.0000000000000D+00
      ALPHA(10,0,20)=  0.0000000000000D+00
      ALPHA(11,0,20)=  0.0000000000000D+00
      ALPHA(12,0,20)=  0.0000000000000D+00
      ALPHA(13,0,20)=  0.0000000000000D+00
      ALPHA(14,0,20)=  0.0000000000000D+00
      ALPHA(15,0,20)=  0.0000000000000D+00
      ALPHA(16,0,20)=  0.0000000000000D+00
      ALPHA(17,0,20)=  0.0000000000000D+00
      ALPHA(18,0,20)=  0.0000000000000D+00
      ALPHA(19,0,20)=  0.0000000000000D+00
      ALPHA(20,0,20)=  1.0000000000000D+00
C l= 0 n=20 ; Coef  :
      COEF (   0,20)= -1.0000000000000D+00
C l= 1 n=20 ; Alpha :
      ALPHA( 1,1,20)=  1.0000000000000D+00
      ALPHA( 2,1,20)= 0.50000000000000D+00
      ALPHA( 3,1,20)= 0.33333333333333D+00
      ALPHA( 4,1,20)= 0.25000000000000D+00
      ALPHA( 5,1,20)= 0.20000000000000D+00
      ALPHA( 6,1,20)= 0.16666666666667D+00
      ALPHA( 7,1,20)= 0.14285714285714D+00
      ALPHA( 8,1,20)= 0.12500000000000D+00
      ALPHA( 9,1,20)= 0.11111111111111D+00
      ALPHA(10,1,20)= 0.10000000000000D+00
      ALPHA(11,1,20)= 0.90909090909091D-01
      ALPHA(12,1,20)= 0.83333333333333D-01
      ALPHA(13,1,20)= 0.76923076923077D-01
      ALPHA(14,1,20)= 0.71428571428571D-01
      ALPHA(15,1,20)= 0.66666666666667D-01
      ALPHA(16,1,20)= 0.62500000000000D-01
      ALPHA(17,1,20)= 0.58823529411765D-01
      ALPHA(18,1,20)= 0.55555555555556D-01
      ALPHA(19,1,20)= 0.52631578947368D-01
      ALPHA(20,1,20)= 0.50000000000000D-01
C l= 1 n=20 ; Coef  :
      COEF (   1,20)= -3.5977396571437D+00
C l= 2 n=20 ; Alpha :
      ALPHA( 1,2,20)=  3.5977396571437D+00
      ALPHA( 2,2,20)=  1.2988698285718D+00
      ALPHA( 3,2,20)= 0.69924655238123D+00
      ALPHA( 4,2,20)= 0.44110158095259D+00
      ALPHA( 5,2,20)= 0.30288126476207D+00
      ALPHA( 6,2,20)= 0.21906772063506D+00
      ALPHA( 7,2,20)= 0.16396280816338D+00
      ALPHA( 8,2,20)= 0.12561031428582D+00
      ALPHA( 9,2,20)= 0.97764723809615D-01
      ALPHA(10,2,20)= 0.76877140317543D-01
      ALPHA(11,2,20)= 0.60797400288675D-01
      ALPHA(12,2,20)= 0.48155192688861D-01
      ALPHA(13,2,20)= 0.38040690687154D-01
      ALPHA(14,2,20)= 0.29828993000709D-01
      ALPHA(15,2,20)= 0.23078488705424D-01
      ALPHA(16,2,20)= 0.17469416494668D-01
      ALPHA(17,2,20)= 0.12765333171452D-01
      ALPHA(18,2,20)= 0.87881741390513D-02
      ALPHA(19,2,20)= 0.54016620498615D-02
      ALPHA(20,2,20)= 0.25000000000000D-02
C l= 2 n=20 ; Coef  :
      COEF (   2,20)= -7.2699469422487D+00
C l= 3 n=20 ; Alpha :
      ALPHA( 1,3,20)=  7.2699469422487D+00
      ALPHA( 2,3,20)=  1.8361036425525D+00
      ALPHA( 3,3,20)= 0.79111248551105D+00
      ALPHA( 4,3,20)= 0.41852272603798D+00
      ALPHA( 5,3,20)= 0.24659786463987D+00
      ALPHA( 6,3,20)= 0.15501800973955D+00
      ALPHA( 7,3,20)= 0.10157719111460D+00
      ALPHA( 8,3,20)= 0.68384691204854D-01
      ALPHA( 9,3,20)= 0.46829690594779D-01
      ALPHA(10,3,20)= 0.32370249154340D-01
      ALPHA(11,3,20)= 0.22438668293260D-01
      ALPHA(12,3,20)= 0.15502329244765D-01
      ALPHA(13,3,20)= 0.10605596788332D-01
      ALPHA(14,3,20)= 0.71308619686547D-02
      ALPHA(15,3,20)= 0.46668716373638D-02
      ALPHA(16,3,20)= 0.29327866159396D-02
      ALPHA(17,3,20)= 0.17326570211979D-02
      ALPHA(18,3,20)= 0.92721312160627D-03
      ALPHA(19,3,20)= 0.41587694999271D-03
      ALPHA(20,3,20)= 0.12500000000000D-03
C l= 3 n=20 ; Coef  :
      COEF (   3,20)= -11.032941354439D+00
C l= 4 n=20 ; Alpha :
      ALPHA( 1,4,20)=  11.032941354439D+00
      ALPHA( 2,4,20)=  1.8814972060953D+00
      ALPHA( 3,4,20)= 0.64229692321271D+00
      ALPHA( 4,4,20)= 0.28394457103177D+00
      ALPHA( 5,4,20)= 0.14345111161782D+00
      ALPHA( 6,4,20)= 0.78442948908206D-01
      ALPHA( 7,4,20)= 0.45091383387098D-01
      ALPHA( 8,4,20)= 0.26757811574386D-01
      ALPHA( 9,4,20)= 0.16186422376692D-01
      ALPHA(10,4,20)= 0.98848110795452D-02
      ALPHA(11,4,20)= 0.60434419673738D-02
      ALPHA(12,4,20)= 0.36699327789877D-02
      ALPHA(13,4,20)= 0.21951433925452D-02
      ALPHA(14,4,20)= 0.12808048081968D-02
      ALPHA(15,4,20)= 0.72002702307335D-03
      ALPHA(16,4,20)= 0.38334585679603D-03
      ALPHA(17,4,20)= 0.18827924075276D-03
      ALPHA(18,4,20)= 0.81560559533277D-04
      ALPHA(19,4,20)= 0.28467207894353D-04
      ALPHA(20,4,20)= 0.62500000000000D-05
C l= 4 n=20 ; Coef  :
      COEF (   4,20)= -14.175091796558D+00
C l= 0 n=21 ; Alpha :
      ALPHA( 1,0,21)=  0.0000000000000D+00
      ALPHA( 2,0,21)=  0.0000000000000D+00
      ALPHA( 3,0,21)=  0.0000000000000D+00
      ALPHA( 4,0,21)=  0.0000000000000D+00
      ALPHA( 5,0,21)=  0.0000000000000D+00
      ALPHA( 6,0,21)=  0.0000000000000D+00
      ALPHA( 7,0,21)=  0.0000000000000D+00
      ALPHA( 8,0,21)=  0.0000000000000D+00
      ALPHA( 9,0,21)=  0.0000000000000D+00
      ALPHA(10,0,21)=  0.0000000000000D+00
      ALPHA(11,0,21)=  0.0000000000000D+00
      ALPHA(12,0,21)=  0.0000000000000D+00
      ALPHA(13,0,21)=  0.0000000000000D+00
      ALPHA(14,0,21)=  0.0000000000000D+00
      ALPHA(15,0,21)=  0.0000000000000D+00
      ALPHA(16,0,21)=  0.0000000000000D+00
      ALPHA(17,0,21)=  0.0000000000000D+00
      ALPHA(18,0,21)=  0.0000000000000D+00
      ALPHA(19,0,21)=  0.0000000000000D+00
      ALPHA(20,0,21)=  0.0000000000000D+00
      ALPHA(21,0,21)=  1.0000000000000D+00
C l= 0 n=21 ; Coef  :
      COEF (   0,21)= -1.0000000000000D+00
C l= 1 n=21 ; Alpha :
      ALPHA( 1,1,21)=  1.0000000000000D+00
      ALPHA( 2,1,21)= 0.50000000000000D+00
      ALPHA( 3,1,21)= 0.33333333333333D+00
      ALPHA( 4,1,21)= 0.25000000000000D+00
      ALPHA( 5,1,21)= 0.20000000000000D+00
      ALPHA( 6,1,21)= 0.16666666666667D+00
      ALPHA( 7,1,21)= 0.14285714285714D+00
      ALPHA( 8,1,21)= 0.12500000000000D+00
      ALPHA( 9,1,21)= 0.11111111111111D+00
      ALPHA(10,1,21)= 0.10000000000000D+00
      ALPHA(11,1,21)= 0.90909090909091D-01
      ALPHA(12,1,21)= 0.83333333333333D-01
      ALPHA(13,1,21)= 0.76923076923077D-01
      ALPHA(14,1,21)= 0.71428571428571D-01
      ALPHA(15,1,21)= 0.66666666666667D-01
      ALPHA(16,1,21)= 0.62500000000000D-01
      ALPHA(17,1,21)= 0.58823529411765D-01
      ALPHA(18,1,21)= 0.55555555555556D-01
      ALPHA(19,1,21)= 0.52631578947368D-01
      ALPHA(20,1,21)= 0.50000000000000D-01
      ALPHA(21,1,21)= 0.47619047619048D-01
C l= 1 n=21 ; Coef  :
      COEF (   1,21)= -3.6453587047627D+00
C l= 2 n=21 ; Alpha :
      ALPHA( 1,2,21)=  3.6453587047627D+00
      ALPHA( 2,2,21)=  1.3226793523814D+00
      ALPHA( 3,2,21)= 0.71511956825424D+00
      ALPHA( 4,2,21)= 0.45300634285735D+00
      ALPHA( 5,2,21)= 0.31240507428588D+00
      ALPHA( 6,2,21)= 0.22700422857157D+00
      ALPHA( 7,2,21)= 0.17076552925182D+00
      ALPHA( 8,2,21)= 0.13156269523820D+00
      ALPHA( 9,2,21)= 0.10305572910062D+00
      ALPHA(10,2,21)= 0.81639045079448D-01
      ALPHA(11,2,21)= 0.65126404617680D-01
      ALPHA(12,2,21)= 0.52123446657115D-01
      ALPHA(13,2,21)= 0.41703694350158D-01
      ALPHA(14,2,21)= 0.33230353544927D-01
      ALPHA(15,2,21)= 0.26253091880027D-01
      ALPHA(16,2,21)= 0.20445606970859D-01
      ALPHA(17,2,21)= 0.15566453619632D-01
      ALPHA(18,2,21)= 0.11433676784554D-01
      ALPHA(19,2,21)= 0.79079277140219D-02
      ALPHA(20,2,21)= 0.48809523809524D-02
      ALPHA(21,2,21)= 0.22675736961451D-02
C l= 2 n=21 ; Coef  :
      COEF (   2,21)= -7.4435354519993D+00
C l= 3 n=21 ; Alpha :
      ALPHA( 1,3,21)=  7.4435354519993D+00
      ALPHA( 2,3,21)=  1.8990883736183D+00
      ALPHA( 3,3,21)= 0.82516579828506D+00
      ALPHA( 4,3,21)= 0.44009445665024D+00
      ALPHA( 5,3,21)= 0.26147429674872D+00
      ALPHA( 6,3,21)= 0.16582773490962D+00
      ALPHA( 7,3,21)= 0.10970888298374D+00
      ALPHA( 8,3,21)= 0.74649581454292D-01
      ALPHA( 9,3,21)= 0.51737106266238D-01
      ALPHA(10,3,21)= 0.36257822729552D-01
      ALPHA(11,3,21)= 0.25539925656006D-01
      ALPHA(12,3,21)= 0.17984398133199D-01
      ALPHA(13,3,21)= 0.12591486995483D-01
      ALPHA(14,3,21)= 0.87132597565084D-02
      ALPHA(15,3,21)= 0.59170188697460D-02
      ALPHA(16,3,21)= 0.39063869478852D-02
      ALPHA(17,3,21)= 0.24739167173709D-02
      ALPHA(18,3,21)= 0.14716739208707D-02
      ALPHA(19,3,21)= 0.79244493637471D-03
      ALPHA(20,3,21)= 0.35742630385488D-03
      ALPHA(21,3,21)= 0.10797969981643D-03
C l= 3 n=21 ; Coef  :
      COEF (   3,21)= -11.387395423582D+00
C l= 4 n=21 ; Alpha :
      ALPHA( 1,4,21)=  11.387395423582D+00
      ALPHA( 2,4,21)=  1.9719299857914D+00
      ALPHA( 3,4,21)= 0.68159053265486D+00
      ALPHA( 4,4,21)= 0.30490144991988D+00
      ALPHA( 5,4,21)= 0.15590226860585D+00
      ALPHA( 6,4,21)= 0.86339507713426D-01
      ALPHA( 7,4,21)= 0.50315615910133D-01
      ALPHA( 8,4,21)= 0.30312553548400D-01
      ALPHA( 9,4,21)= 0.18650094103656D-01
      ALPHA(10,4,21)= 0.11611374066667D-01
      ALPHA(11,4,21)= 0.72596289033741D-02
      ALPHA(12,4,21)= 0.45263326900924D-02
      ALPHA(13,4,21)= 0.27947380113777D-02
      ALPHA(14,4,21)= 0.16957219394591D-02
      ALPHA(15,4,21)= 0.10017898263946D-02
      ALPHA(16,4,21)= 0.56936428288580D-03
      ALPHA(17,4,21)= 0.30608479872280D-03
      ALPHA(18,4,21)= 0.15164027005093D-03
      ALPHA(19,4,21)= 0.66202681055053D-04
      ALPHA(20,4,21)= 0.23270300183565D-04
      ALPHA(21,4,21)= 0.51418904674493D-05
C l= 4 n=21 ; Coef  :
      COEF (   4,21)= -14.717348721491D+00
C l= 0 n=22 ; Alpha :
      ALPHA( 1,0,22)=  0.0000000000000D+00
      ALPHA( 2,0,22)=  0.0000000000000D+00
      ALPHA( 3,0,22)=  0.0000000000000D+00
      ALPHA( 4,0,22)=  0.0000000000000D+00
      ALPHA( 5,0,22)=  0.0000000000000D+00
      ALPHA( 6,0,22)=  0.0000000000000D+00
      ALPHA( 7,0,22)=  0.0000000000000D+00
      ALPHA( 8,0,22)=  0.0000000000000D+00
      ALPHA( 9,0,22)=  0.0000000000000D+00
      ALPHA(10,0,22)=  0.0000000000000D+00
      ALPHA(11,0,22)=  0.0000000000000D+00
      ALPHA(12,0,22)=  0.0000000000000D+00
      ALPHA(13,0,22)=  0.0000000000000D+00
      ALPHA(14,0,22)=  0.0000000000000D+00
      ALPHA(15,0,22)=  0.0000000000000D+00
      ALPHA(16,0,22)=  0.0000000000000D+00
      ALPHA(17,0,22)=  0.0000000000000D+00
      ALPHA(18,0,22)=  0.0000000000000D+00
      ALPHA(19,0,22)=  0.0000000000000D+00
      ALPHA(20,0,22)=  0.0000000000000D+00
      ALPHA(21,0,22)=  0.0000000000000D+00
      ALPHA(22,0,22)=  1.0000000000000D+00
C l= 0 n=22 ; Coef  :
      COEF (   0,22)= -1.0000000000000D+00
C l= 1 n=22 ; Alpha :
      ALPHA( 1,1,22)=  1.0000000000000D+00
      ALPHA( 2,1,22)= 0.50000000000000D+00
      ALPHA( 3,1,22)= 0.33333333333333D+00
      ALPHA( 4,1,22)= 0.25000000000000D+00
      ALPHA( 5,1,22)= 0.20000000000000D+00
      ALPHA( 6,1,22)= 0.16666666666667D+00
      ALPHA( 7,1,22)= 0.14285714285714D+00
      ALPHA( 8,1,22)= 0.12500000000000D+00
      ALPHA( 9,1,22)= 0.11111111111111D+00
      ALPHA(10,1,22)= 0.10000000000000D+00
      ALPHA(11,1,22)= 0.90909090909091D-01
      ALPHA(12,1,22)= 0.83333333333333D-01
      ALPHA(13,1,22)= 0.76923076923077D-01
      ALPHA(14,1,22)= 0.71428571428571D-01
      ALPHA(15,1,22)= 0.66666666666667D-01
      ALPHA(16,1,22)= 0.62500000000000D-01
      ALPHA(17,1,22)= 0.58823529411765D-01
      ALPHA(18,1,22)= 0.55555555555556D-01
      ALPHA(19,1,22)= 0.52631578947368D-01
      ALPHA(20,1,22)= 0.50000000000000D-01
      ALPHA(21,1,22)= 0.47619047619048D-01
      ALPHA(22,1,22)= 0.45454545454545D-01
C l= 1 n=22 ; Coef  :
      COEF (   1,22)= -3.6908132502173D+00
C l= 2 n=22 ; Alpha :
      ALPHA( 1,2,22)=  3.6908132502173D+00
      ALPHA( 2,2,22)=  1.3454066251086D+00
      ALPHA( 3,2,22)= 0.73027108340576D+00
      ALPHA( 4,2,22)= 0.46436997922099D+00
      ALPHA( 5,2,22)= 0.32149598337679D+00
      ALPHA( 6,2,22)= 0.23457998614732D+00
      ALPHA( 7,2,22)= 0.17725903574532D+00
      ALPHA( 8,2,22)= 0.13724451342002D+00
      ALPHA( 9,2,22)= 0.10810623415113D+00
      ALPHA(10,2,22)= 0.86184499624902D-01
      ALPHA(11,2,22)= 0.69258636022638D-01
      ALPHA(12,2,22)= 0.55911325444994D-01
      ALPHA(13,2,22)= 0.45200197846661D-01
      ALPHA(14,2,22)= 0.36477106791680D-01
      ALPHA(15,2,22)= 0.29283394910330D-01
      ALPHA(16,2,22)= 0.23286516061768D-01
      ALPHA(17,2,22)= 0.18240250411075D-01
      ALPHA(18,2,22)= 0.13958929309807D-01
      ALPHA(19,2,22)= 0.10300272211630D-01
      ALPHA(20,2,22)= 0.71536796536797D-02
      ALPHA(21,2,22)= 0.44320758606473D-02
      ALPHA(22,2,22)= 0.20661157024793D-02
C l= 2 n=22 ; Coef  :
      COEF (   2,22)= -7.6112996906455D+00
C l= 3 n=22 ; Alpha :
      ALPHA( 1,3,22)=  7.6112996906455D+00
      ALPHA( 2,3,22)=  1.9602432202141D+00
      ALPHA( 3,3,22)= 0.85835993843987D+00
      ALPHA( 4,3,22)= 0.46120218297846D+00
      ALPHA( 5,3,22)= 0.27608775053857D+00
      ALPHA( 6,3,22)= 0.17649046155268D+00
      ALPHA( 7,3,22)= 0.11776611188125D+00
      ALPHA( 8,3,22)= 0.80887968427929D-01
      ALPHA( 9,3,22)= 0.56651026000380D-01
      ALPHA(10,3,22)= 0.40175299985229D-01
      ALPHA(11,3,22)= 0.28688045475217D-01
      ALPHA(12,3,22)= 0.20525822017063D-01
      ALPHA(13,3,22)= 0.14646041443058D-01
      ALPHA(14,3,22)= 0.10371310065221D-01
      ALPHA(15,3,22)= 0.72480822747610D-02
      ALPHA(16,3,22)= 0.49648649506928D-02
      ALPHA(17,3,22)= 0.33030190087834D-02
      ALPHA(18,3,22)= 0.21061707076801D-02
      ALPHA(19,3,22)= 0.12606391278124D-02
      ALPHA(20,3,22)= 0.68259356084031D-03
      ALPHA(21,3,22)= 0.30943769348222D-03
      ALPHA(22,3,22)= 0.93914350112697D-04
C l= 3 n=22 ; Coef  :
      COEF (   3,22)= -11.733363591339D+00
C l= 4 n=22 ; Alpha :
      ALPHA( 1,4,22)=  11.733363591339D+00
      ALPHA( 2,4,22)=  2.0610319503466D+00
      ALPHA( 3,4,22)= 0.72060689349303D+00
      ALPHA( 4,4,22)= 0.32586518550981D+00
      ALPHA( 5,4,22)= 0.16845171181215D+00
      ALPHA( 6,4,22)= 0.94361801420366D-01
      ALPHA( 7,4,22)= 0.55668620995645D-01
      ALPHA( 8,4,22)= 0.33989279386033D-01
      ALPHA( 9,4,22)= 0.21225140740037D-01
      ALPHA(10,4,22)= 0.13437524065995D-01
      ALPHA(11,4,22)= 0.85636309704295D-02
      ALPHA(12,4,22)= 0.54593245999589D-02
      ALPHA(13,4,22)= 0.34604671678803D-02
      ALPHA(14,4,22)= 0.21671451242419D-02
      ALPHA(15,4,22)= 0.13312481116110D-02
      ALPHA(16,4,22)= 0.79503996246275D-03
      ALPHA(17,4,22)= 0.45622202639477D-03
      ALPHA(18,4,22)= 0.24737530221821D-03
      ALPHA(19,4,22)= 0.12350445959198D-03
      ALPHA(20,4,22)= 0.54297280221762D-04
      ALPHA(21,4,22)= 0.19207240171187D-04
      ALPHA(22,4,22)= 0.42688340960317D-05
C l= 4 n=22 ; Coef  :
      COEF (   4,22)= -15.250683430188D+00
C l= 0 n=23 ; Alpha :
      ALPHA( 1,0,23)=  0.0000000000000D+00
      ALPHA( 2,0,23)=  0.0000000000000D+00
      ALPHA( 3,0,23)=  0.0000000000000D+00
      ALPHA( 4,0,23)=  0.0000000000000D+00
      ALPHA( 5,0,23)=  0.0000000000000D+00
      ALPHA( 6,0,23)=  0.0000000000000D+00
      ALPHA( 7,0,23)=  0.0000000000000D+00
      ALPHA( 8,0,23)=  0.0000000000000D+00
      ALPHA( 9,0,23)=  0.0000000000000D+00
      ALPHA(10,0,23)=  0.0000000000000D+00
      ALPHA(11,0,23)=  0.0000000000000D+00
      ALPHA(12,0,23)=  0.0000000000000D+00
      ALPHA(13,0,23)=  0.0000000000000D+00
      ALPHA(14,0,23)=  0.0000000000000D+00
      ALPHA(15,0,23)=  0.0000000000000D+00
      ALPHA(16,0,23)=  0.0000000000000D+00
      ALPHA(17,0,23)=  0.0000000000000D+00
      ALPHA(18,0,23)=  0.0000000000000D+00
      ALPHA(19,0,23)=  0.0000000000000D+00
      ALPHA(20,0,23)=  0.0000000000000D+00
      ALPHA(21,0,23)=  0.0000000000000D+00
      ALPHA(22,0,23)=  0.0000000000000D+00
      ALPHA(23,0,23)=  1.0000000000000D+00
C l= 0 n=23 ; Coef  :
      COEF (   0,23)= -1.0000000000000D+00
C l= 1 n=23 ; Alpha :
      ALPHA( 1,1,23)=  1.0000000000000D+00
      ALPHA( 2,1,23)= 0.50000000000000D+00
      ALPHA( 3,1,23)= 0.33333333333333D+00
      ALPHA( 4,1,23)= 0.25000000000000D+00
      ALPHA( 5,1,23)= 0.20000000000000D+00
      ALPHA( 6,1,23)= 0.16666666666667D+00
      ALPHA( 7,1,23)= 0.14285714285714D+00
      ALPHA( 8,1,23)= 0.12500000000000D+00
      ALPHA( 9,1,23)= 0.11111111111111D+00
      ALPHA(10,1,23)= 0.10000000000000D+00
      ALPHA(11,1,23)= 0.90909090909091D-01
      ALPHA(12,1,23)= 0.83333333333333D-01
      ALPHA(13,1,23)= 0.76923076923077D-01
      ALPHA(14,1,23)= 0.71428571428571D-01
      ALPHA(15,1,23)= 0.66666666666667D-01
      ALPHA(16,1,23)= 0.62500000000000D-01
      ALPHA(17,1,23)= 0.58823529411765D-01
      ALPHA(18,1,23)= 0.55555555555556D-01
      ALPHA(19,1,23)= 0.52631578947368D-01
      ALPHA(20,1,23)= 0.50000000000000D-01
      ALPHA(21,1,23)= 0.47619047619048D-01
      ALPHA(22,1,23)= 0.45454545454545D-01
      ALPHA(23,1,23)= 0.43478260869565D-01
C l= 1 n=23 ; Coef  :
      COEF (   1,23)= -3.7342915110868D+00
C l= 2 n=23 ; Alpha :
      ALPHA( 1,2,23)=  3.7342915110868D+00
      ALPHA( 2,2,23)=  1.3671457555434D+00
      ALPHA( 3,2,23)= 0.74476383702895D+00
      ALPHA( 4,2,23)= 0.47523954443838D+00
      ALPHA( 5,2,23)= 0.33019163555070D+00
      ALPHA( 6,2,23)= 0.24182636295892D+00
      ALPHA( 7,2,23)= 0.18347021586955D+00
      ALPHA( 8,2,23)= 0.14267929602871D+00
      ALPHA( 9,2,23)= 0.11293715202552D+00
      ALPHA(10,2,23)= 0.90532325711859D-01
      ALPHA(11,2,23)= 0.73211205192599D-01
      ALPHA(12,2,23)= 0.59534513850791D-01
      ALPHA(13,2,23)= 0.48544679452012D-01
      ALPHA(14,2,23)= 0.39582696853792D-01
      ALPHA(15,2,23)= 0.32181945634968D-01
      ALPHA(16,2,23)= 0.26003907366115D-01
      ALPHA(17,2,23)= 0.20797795168109D-01
      ALPHA(18,2,23)= 0.16374388247005D-01
      ALPHA(19,2,23)= 0.12588601731080D-01
      ALPHA(20,2,23)= 0.93275926971579D-02
      ALPHA(21,2,23)= 0.65024692353885D-02
      ALPHA(22,2,23)= 0.40424002874596D-02
      ALPHA(23,2,23)= 0.18903591682420D-02
C l= 2 n=23 ; Coef  :
      COEF (   2,23)= -7.7736601911276D+00
C l= 3 n=23 ; Alpha :
      ALPHA( 1,3,23)=  7.7736601911276D+00
      ALPHA( 2,3,23)=  2.0196843400204D+00
      ALPHA( 3,3,23)= 0.89074097483243D+00
      ALPHA( 4,3,23)= 0.48186477186709D+00
      ALPHA( 5,3,23)= 0.29044390860600D+00
      ALPHA( 6,3,23)= 0.18700465124655D+00
      ALPHA( 7,3,23)= 0.12574307778862D+00
      ALPHA( 8,3,23)= 0.87091416081351D-01
      ALPHA( 9,3,23)= 0.61561336958011D-01
      ALPHA(10,3,23)= 0.44111488059658D-01
      ALPHA(11,3,23)= 0.31871141353156D-01
      ALPHA(12,3,23)= 0.23114279141010D-01
      ALPHA(13,3,23)= 0.16756679680102D-01
      ALPHA(14,3,23)= 0.12092296884951D-01
      ALPHA(15,3,23)= 0.86472973023683D-02
      ALPHA(16,3,23)= 0.60954696187848D-02
      ALPHA(17,3,23)= 0.42072709726142D-02
      ALPHA(18,3,23)= 0.28181006314629D-02
      ALPHA(19,3,23)= 0.18079696378594D-02
      ALPHA(20,3,23)= 0.10881410694124D-02
      ALPHA(21,3,23)= 0.59215374719476D-03
      ALPHA(22,3,23)= 0.26967088435007D-03
      ALPHA(23,3,23)= 0.82189529053999D-04
C l= 3 n=23 ; Coef  :
      COEF (   3,23)= -12.071348817040D+00
C l= 4 n=23 ; Alpha :
      ALPHA( 1,4,23)=  12.071348817040D+00
      ALPHA( 2,4,23)=  2.1488443129562D+00
      ALPHA( 3,4,23)= 0.75933476196401D+00
      ALPHA( 4,4,23)= 0.34681582776490D+00
      ALPHA( 5,4,23)= 0.18107970783850D+00
      ALPHA( 6,4,23)= 0.10249243843108D+00
      ALPHA( 7,4,23)= 0.61135711334281D-01
      ALPHA( 8,4,23)= 0.37775862693918D-01
      ALPHA( 9,4,23)= 0.23901720607777D-01
      ALPHA(10,4,23)= 0.15355414851198D-01
      ALPHA(11,4,23)= 0.99493327683928D-02
      ALPHA(12,4,23)= 0.64642932582637D-02
      ALPHA(13,4,23)= 0.41890184583196D-02
      ALPHA(14,4,23)= 0.26928971627180D-02
      ALPHA(15,4,23)= 0.17072175595401D-02
      ALPHA(16,4,23)= 0.10600603806708D-02
      ALPHA(17,4,23)= 0.63914685129104D-03
      ALPHA(18,4,23)= 0.36990141662964D-03
      ALPHA(19,4,23)= 0.20211183515108D-03
      ALPHA(20,4,23)= 0.10160776150056D-03
      ALPHA(21,4,23)= 0.44953055266611D-04
      ALPHA(22,4,23)= 0.15993655154730D-04
      ALPHA(23,4,23)= 0.35734577849565D-05
C l= 4 n=23 ; Coef  :
      COEF (   4,23)= -15.775524683102D+00
C l= 0 n=24 ; Alpha :
      ALPHA( 1,0,24)=  0.0000000000000D+00
      ALPHA( 2,0,24)=  0.0000000000000D+00
      ALPHA( 3,0,24)=  0.0000000000000D+00
      ALPHA( 4,0,24)=  0.0000000000000D+00
      ALPHA( 5,0,24)=  0.0000000000000D+00
      ALPHA( 6,0,24)=  0.0000000000000D+00
      ALPHA( 7,0,24)=  0.0000000000000D+00
      ALPHA( 8,0,24)=  0.0000000000000D+00
      ALPHA( 9,0,24)=  0.0000000000000D+00
      ALPHA(10,0,24)=  0.0000000000000D+00
      ALPHA(11,0,24)=  0.0000000000000D+00
      ALPHA(12,0,24)=  0.0000000000000D+00
      ALPHA(13,0,24)=  0.0000000000000D+00
      ALPHA(14,0,24)=  0.0000000000000D+00
      ALPHA(15,0,24)=  0.0000000000000D+00
      ALPHA(16,0,24)=  0.0000000000000D+00
      ALPHA(17,0,24)=  0.0000000000000D+00
      ALPHA(18,0,24)=  0.0000000000000D+00
      ALPHA(19,0,24)=  0.0000000000000D+00
      ALPHA(20,0,24)=  0.0000000000000D+00
      ALPHA(21,0,24)=  0.0000000000000D+00
      ALPHA(22,0,24)=  0.0000000000000D+00
      ALPHA(23,0,24)=  0.0000000000000D+00
      ALPHA(24,0,24)=  1.0000000000000D+00
C l= 0 n=24 ; Coef  :
      COEF (   0,24)= -1.0000000000000D+00
C l= 1 n=24 ; Alpha :
      ALPHA( 1,1,24)=  1.0000000000000D+00
      ALPHA( 2,1,24)= 0.50000000000000D+00
      ALPHA( 3,1,24)= 0.33333333333333D+00
      ALPHA( 4,1,24)= 0.25000000000000D+00
      ALPHA( 5,1,24)= 0.20000000000000D+00
      ALPHA( 6,1,24)= 0.16666666666667D+00
      ALPHA( 7,1,24)= 0.14285714285714D+00
      ALPHA( 8,1,24)= 0.12500000000000D+00
      ALPHA( 9,1,24)= 0.11111111111111D+00
      ALPHA(10,1,24)= 0.10000000000000D+00
      ALPHA(11,1,24)= 0.90909090909091D-01
      ALPHA(12,1,24)= 0.83333333333333D-01
      ALPHA(13,1,24)= 0.76923076923077D-01
      ALPHA(14,1,24)= 0.71428571428571D-01
      ALPHA(15,1,24)= 0.66666666666667D-01
      ALPHA(16,1,24)= 0.62500000000000D-01
      ALPHA(17,1,24)= 0.58823529411765D-01
      ALPHA(18,1,24)= 0.55555555555556D-01
      ALPHA(19,1,24)= 0.52631578947368D-01
      ALPHA(20,1,24)= 0.50000000000000D-01
      ALPHA(21,1,24)= 0.47619047619048D-01
      ALPHA(22,1,24)= 0.45454545454545D-01
      ALPHA(23,1,24)= 0.43478260869565D-01
      ALPHA(24,1,24)= 0.41666666666667D-01
C l= 1 n=24 ; Coef  :
      COEF (   1,24)= -3.7759581777535D+00
C l= 2 n=24 ; Alpha :
      ALPHA( 1,2,24)=  3.7759581777535D+00
      ALPHA( 2,2,24)=  1.3879790888768D+00
      ALPHA( 3,2,24)= 0.75865272591784D+00
      ALPHA( 4,2,24)= 0.48565621110504D+00
      ALPHA( 5,2,24)= 0.33852496888403D+00
      ALPHA( 6,2,24)= 0.24877080740336D+00
      ALPHA( 7,2,24)= 0.18942259682193D+00
      ALPHA( 8,2,24)= 0.14788762936205D+00
      ALPHA( 9,2,24)= 0.11756678165515D+00
      ALPHA(10,2,24)= 0.94698992378525D-01
      ALPHA(11,2,24)= 0.76999083980478D-01
      ALPHA(12,2,24)= 0.63006736073013D-01
      ALPHA(13,2,24)= 0.51749807657141D-01
      ALPHA(14,2,24)= 0.42558887329982D-01
      ALPHA(15,2,24)= 0.34959723412745D-01
      ALPHA(16,2,24)= 0.28608074032782D-01
      ALPHA(17,2,24)= 0.23248775560266D-01
      ALPHA(18,2,24)= 0.18689203061819D-01
      ALPHA(19,2,24)= 0.14781584187221D-01
      ALPHA(20,2,24)= 0.11410926030491D-01
      ALPHA(21,2,24)= 0.84865962195155D-02
      ALPHA(22,2,24)= 0.59363396813990D-02
      ALPHA(23,2,24)= 0.37019533711405D-02
      ALPHA(24,2,24)= 0.17361111111111D-02
C l= 2 n=24 ; Coef  :
      COEF (   2,24)= -7.9309917818673D+00
C l= 3 n=24 ; Alpha :
      ALPHA( 1,3,24)=  7.9309917818673D+00
      ALPHA( 2,3,24)=  2.0775168020569D+00
      ALPHA( 3,3,24)= 0.92235150507901D+00
      ALPHA( 4,3,24)= 0.50210044732980D+00
      ALPHA( 5,3,24)= 0.30454911564283D+00
      ALPHA( 6,3,24)= 0.19737010155502D+00
      ALPHA( 7,3,24)= 0.13363568598954D+00
      ALPHA( 8,3,24)= 0.93253400638103D-01
      ALPHA( 9,3,24)= 0.66459952860309D-01
      ALPHA(10,3,24)= 0.48057279408763D-01
      ALPHA(11,3,24)= 0.35079436519009D-01
      ALPHA(12,3,24)= 0.25739559810719D-01
      ALPHA(13,3,24)= 0.18912921665816D-01
      ALPHA(14,3,24)= 0.13865583857034D-01
      ALPHA(15,3,24)= 0.10103952444566D-01
      ALPHA(16,3,24)= 0.72874727034841D-02
      ALPHA(17,3,24)= 0.51759699542919D-02
      ALPHA(18,3,24)= 0.35968174257054D-02
      ALPHA(19,3,24)= 0.24238689789936D-02
      ALPHA(20,3,24)= 0.15635963206829D-02
      ALPHA(21,3,24)= 0.94576192300791D-03
      ALPHA(22,3,24)= 0.51701837107503D-03
      ALPHA(23,3,24)= 0.23643758618485D-03
      ALPHA(24,3,24)= 0.72337962962963D-04
C l= 3 n=24 ; Coef  :
      COEF (   3,24)= -12.401806807951D+00
C l= 4 n=24 ; Alpha :
      ALPHA( 1,4,24)=  12.401806807951D+00
      ALPHA( 2,4,24)=  2.2354075130419D+00
      ALPHA( 3,4,24)= 0.79776607467564D+00
      ALPHA( 4,4,24)= 0.36773667973697D+00
      ALPHA( 5,4,24)= 0.19376925432362D+00
      ALPHA( 6,4,24)= 0.11071619266254D+00
      ALPHA( 7,4,24)= 0.66703864917178D-01
      ALPHA( 8,4,24)= 0.41661421053839D-01
      ALPHA( 9,4,24)= 0.26670885310289D-01
      ALPHA(10,4,24)= 0.17357801493230D-01
      ALPHA(11,4,24)= 0.11410975956685D-01
      ALPHA(12,4,24)= 0.75367749170436D-02
      ALPHA(13,4,24)= 0.49770568610619D-02
      ALPHA(14,4,24)= 0.32706298234277D-02
      ALPHA(15,4,24)= 0.21282155780636D-02
      ALPHA(16,4,24)= 0.13637050766493D-02
      ALPHA(17,4,24)= 0.85481226605321D-03
      ALPHA(18,4,24)= 0.51976880936737D-03
      ALPHA(19,4,24)= 0.30310637594248D-03
      ALPHA(20,4,24)= 0.16675760819568D-03
      ALPHA(21,4,24)= 0.84359802058607D-04
      ALPHA(22,4,24)= 0.37536087282857D-04
      ALPHA(23,4,24)= 0.13425023875992D-04
      ALPHA(24,4,24)= 0.30140817901235D-05
C l= 4 n=24 ; Coef  :
      COEF (   4,24)= -16.292266633434D+00
C l= 0 n=25 ; Alpha :
      ALPHA( 1,0,25)=  0.0000000000000D+00
      ALPHA( 2,0,25)=  0.0000000000000D+00
      ALPHA( 3,0,25)=  0.0000000000000D+00
      ALPHA( 4,0,25)=  0.0000000000000D+00
      ALPHA( 5,0,25)=  0.0000000000000D+00
      ALPHA( 6,0,25)=  0.0000000000000D+00
      ALPHA( 7,0,25)=  0.0000000000000D+00
      ALPHA( 8,0,25)=  0.0000000000000D+00
      ALPHA( 9,0,25)=  0.0000000000000D+00
      ALPHA(10,0,25)=  0.0000000000000D+00
      ALPHA(11,0,25)=  0.0000000000000D+00
      ALPHA(12,0,25)=  0.0000000000000D+00
      ALPHA(13,0,25)=  0.0000000000000D+00
      ALPHA(14,0,25)=  0.0000000000000D+00
      ALPHA(15,0,25)=  0.0000000000000D+00
      ALPHA(16,0,25)=  0.0000000000000D+00
      ALPHA(17,0,25)=  0.0000000000000D+00
      ALPHA(18,0,25)=  0.0000000000000D+00
      ALPHA(19,0,25)=  0.0000000000000D+00
      ALPHA(20,0,25)=  0.0000000000000D+00
      ALPHA(21,0,25)=  0.0000000000000D+00
      ALPHA(22,0,25)=  0.0000000000000D+00
      ALPHA(23,0,25)=  0.0000000000000D+00
      ALPHA(24,0,25)=  0.0000000000000D+00
      ALPHA(25,0,25)=  1.0000000000000D+00
C l= 0 n=25 ; Coef  :
      COEF (   0,25)= -1.0000000000000D+00
C l= 1 n=25 ; Alpha :
      ALPHA( 1,1,25)=  1.0000000000000D+00
      ALPHA( 2,1,25)= 0.50000000000000D+00
      ALPHA( 3,1,25)= 0.33333333333333D+00
      ALPHA( 4,1,25)= 0.25000000000000D+00
      ALPHA( 5,1,25)= 0.20000000000000D+00
      ALPHA( 6,1,25)= 0.16666666666667D+00
      ALPHA( 7,1,25)= 0.14285714285714D+00
      ALPHA( 8,1,25)= 0.12500000000000D+00
      ALPHA( 9,1,25)= 0.11111111111111D+00
      ALPHA(10,1,25)= 0.10000000000000D+00
      ALPHA(11,1,25)= 0.90909090909091D-01
      ALPHA(12,1,25)= 0.83333333333333D-01
      ALPHA(13,1,25)= 0.76923076923077D-01
      ALPHA(14,1,25)= 0.71428571428571D-01
      ALPHA(15,1,25)= 0.66666666666667D-01
      ALPHA(16,1,25)= 0.62500000000000D-01
      ALPHA(17,1,25)= 0.58823529411765D-01
      ALPHA(18,1,25)= 0.55555555555556D-01
      ALPHA(19,1,25)= 0.52631578947368D-01
      ALPHA(20,1,25)= 0.50000000000000D-01
      ALPHA(21,1,25)= 0.47619047619048D-01
      ALPHA(22,1,25)= 0.45454545454545D-01
      ALPHA(23,1,25)= 0.43478260869565D-01
      ALPHA(24,1,25)= 0.41666666666667D-01
      ALPHA(25,1,25)= 0.40000000000000D-01
C l= 1 n=25 ; Coef  :
      COEF (   1,25)= -3.8159581777535D+00
C l= 2 n=25 ; Alpha :
      ALPHA( 1,2,25)=  3.8159581777535D+00
      ALPHA( 2,2,25)=  1.4079790888768D+00
      ALPHA( 3,2,25)= 0.77198605925117D+00
      ALPHA( 4,2,25)= 0.49565621110504D+00
      ALPHA( 5,2,25)= 0.34652496888403D+00
      ALPHA( 6,2,25)= 0.25543747407003D+00
      ALPHA( 7,2,25)= 0.19513688253622D+00
      ALPHA( 8,2,25)= 0.15288762936205D+00
      ALPHA( 9,2,25)= 0.12201122609960D+00
      ALPHA(10,2,25)= 0.98698992378525D-01
      ALPHA(11,2,25)= 0.80635447616841D-01
      ALPHA(12,2,25)= 0.66340069406347D-01
      ALPHA(13,2,25)= 0.54826730734064D-01
      ALPHA(14,2,25)= 0.45416030187125D-01
      ALPHA(15,2,25)= 0.37626390079412D-01
      ALPHA(16,2,25)= 0.31108074032782D-01
      ALPHA(17,2,25)= 0.25601716736736D-01
      ALPHA(18,2,25)= 0.20911425284042D-01
      ALPHA(19,2,25)= 0.16886847345115D-01
      ALPHA(20,2,25)= 0.13410926030491D-01
      ALPHA(21,2,25)= 0.10391358124277D-01
      ALPHA(22,2,25)= 0.77545214995808D-02
      ALPHA(23,2,25)= 0.54410838059231D-02
      ALPHA(24,2,25)= 0.34027777777778D-02
      ALPHA(25,2,25)= 0.16000000000000D-02
C l= 2 n=25 ; Coef  :
      COEF (   2,25)= -8.0836301089774D+00
C l= 3 n=25 ; Alpha :
      ALPHA( 1,3,25)=  8.0836301089774D+00
      ALPHA( 2,3,25)=  2.1338359656120D+00
      ALPHA( 3,3,25)= 0.95323094744906D+00
      ALPHA( 4,3,25)= 0.52192669577400D+00
      ALPHA( 5,3,25)= 0.31841011439819D+00
      ALPHA( 6,3,25)= 0.20758760051782D+00
      ALPHA( 7,3,25)= 0.14144116129099D+00
      ALPHA( 8,3,25)= 0.99368905812585D-01
      ALPHA( 9,3,25)= 0.71340401904293D-01
      ALPHA(10,3,25)= 0.52005239103904D-01
      ALPHA(11,3,25)= 0.38304854423683D-01
      ALPHA(12,3,25)= 0.28393162586973D-01
      ALPHA(13,3,25)= 0.21105990895179D-01
      ALPHA(14,3,25)= 0.15682225064519D-01
      ALPHA(15,3,25)= 0.11609008047743D-01
      ALPHA(16,3,25)= 0.85317956647953D-02
      ALPHA(17,3,25)= 0.62000386237614D-02
      ALPHA(18,3,25)= 0.44332744370671D-02
      ALPHA(19,3,25)= 0.30993428727982D-02
      ALPHA(20,3,25)= 0.21000333619025D-02
      ALPHA(21,3,25)= 0.13614162479790D-02
      ALPHA(22,3,25)= 0.82719923105826D-03
      ALPHA(23,3,25)= 0.45408093842178D-03
      ALPHA(24,3,25)= 0.20844907407407D-03
      ALPHA(25,3,25)= 0.64000000000000D-04
C l= 3 n=25 ; Coef  :
      COEF (   3,25)= -12.725152012310D+00
C l= 4 n=25 ; Alpha :
      ALPHA( 1,4,25)=  12.725152012310D+00
      ALPHA( 2,4,25)=  2.3207609516664D+00
      ALPHA( 3,4,25)= 0.83589531257360D+00
      ALPHA( 4,4,25)= 0.38861374756793D+00
      ALPHA( 5,4,25)= 0.20650565889955D+00
      ALPHA( 6,4,25)= 0.11901969668326D+00
      ALPHA( 7,4,25)= 0.72361511368817D-01
      ALPHA( 8,4,25)= 0.45636177286342D-01
      ALPHA( 9,4,25)= 0.29524501386461D-01
      ALPHA(10,4,25)= 0.19438011057386D-01
      ALPHA(11,4,25)= 0.12943170133632D-01
      ALPHA(12,4,25)= 0.86725014205226D-02
      ALPHA(13,4,25)= 0.58212964968691D-02
      ALPHA(14,4,25)= 0.38979188260085D-02
      ALPHA(15,4,25)= 0.25925758999733D-02
      ALPHA(16,4,25)= 0.17049769032411D-02
      ALPHA(17,4,25)= 0.11028138110037D-02
      ALPHA(18,4,25)= 0.69709978685005D-03
      ALPHA(19,4,25)= 0.42708009085441D-03
      ALPHA(20,4,25)= 0.25075894267178D-03
      ALPHA(21,4,25)= 0.13881645197777D-03
      ALPHA(22,4,25)= 0.70624056525187D-04
      ALPHA(23,4,25)= 0.31588261412863D-04
      ALPHA(24,4,25)= 0.11352044753086D-04
      ALPHA(25,4,25)= 0.25600000000000D-05
C l= 4 n=25 ; Coef  :
      COEF (   4,25)= -16.801272713926D+00
C l= 0 n=26 ; Alpha :
      ALPHA( 1,0,26)=  0.0000000000000D+00
      ALPHA( 2,0,26)=  0.0000000000000D+00
      ALPHA( 3,0,26)=  0.0000000000000D+00
      ALPHA( 4,0,26)=  0.0000000000000D+00
      ALPHA( 5,0,26)=  0.0000000000000D+00
      ALPHA( 6,0,26)=  0.0000000000000D+00
      ALPHA( 7,0,26)=  0.0000000000000D+00
      ALPHA( 8,0,26)=  0.0000000000000D+00
      ALPHA( 9,0,26)=  0.0000000000000D+00
      ALPHA(10,0,26)=  0.0000000000000D+00
      ALPHA(11,0,26)=  0.0000000000000D+00
      ALPHA(12,0,26)=  0.0000000000000D+00
      ALPHA(13,0,26)=  0.0000000000000D+00
      ALPHA(14,0,26)=  0.0000000000000D+00
      ALPHA(15,0,26)=  0.0000000000000D+00
      ALPHA(16,0,26)=  0.0000000000000D+00
      ALPHA(17,0,26)=  0.0000000000000D+00
      ALPHA(18,0,26)=  0.0000000000000D+00
      ALPHA(19,0,26)=  0.0000000000000D+00
      ALPHA(20,0,26)=  0.0000000000000D+00
      ALPHA(21,0,26)=  0.0000000000000D+00
      ALPHA(22,0,26)=  0.0000000000000D+00
      ALPHA(23,0,26)=  0.0000000000000D+00
      ALPHA(24,0,26)=  0.0000000000000D+00
      ALPHA(25,0,26)=  0.0000000000000D+00
      ALPHA(26,0,26)=  1.0000000000000D+00
C l= 0 n=26 ; Coef  :
      COEF (   0,26)= -1.0000000000000D+00
C l= 1 n=26 ; Alpha :
      ALPHA( 1,1,26)=  1.0000000000000D+00
      ALPHA( 2,1,26)= 0.50000000000000D+00
      ALPHA( 3,1,26)= 0.33333333333333D+00
      ALPHA( 4,1,26)= 0.25000000000000D+00
      ALPHA( 5,1,26)= 0.20000000000000D+00
      ALPHA( 6,1,26)= 0.16666666666667D+00
      ALPHA( 7,1,26)= 0.14285714285714D+00
      ALPHA( 8,1,26)= 0.12500000000000D+00
      ALPHA( 9,1,26)= 0.11111111111111D+00
      ALPHA(10,1,26)= 0.10000000000000D+00
      ALPHA(11,1,26)= 0.90909090909091D-01
      ALPHA(12,1,26)= 0.83333333333333D-01
      ALPHA(13,1,26)= 0.76923076923077D-01
      ALPHA(14,1,26)= 0.71428571428571D-01
      ALPHA(15,1,26)= 0.66666666666667D-01
      ALPHA(16,1,26)= 0.62500000000000D-01
      ALPHA(17,1,26)= 0.58823529411765D-01
      ALPHA(18,1,26)= 0.55555555555556D-01
      ALPHA(19,1,26)= 0.52631578947368D-01
      ALPHA(20,1,26)= 0.50000000000000D-01
      ALPHA(21,1,26)= 0.47619047619048D-01
      ALPHA(22,1,26)= 0.45454545454545D-01
      ALPHA(23,1,26)= 0.43478260869565D-01
      ALPHA(24,1,26)= 0.41666666666667D-01
      ALPHA(25,1,26)= 0.40000000000000D-01
      ALPHA(26,1,26)= 0.38461538461538D-01
C l= 1 n=26 ; Coef  :
      COEF (   1,26)= -3.8544197162150D+00
C l= 2 n=26 ; Alpha :
      ALPHA( 1,2,26)=  3.8544197162150D+00
      ALPHA( 2,2,26)=  1.4272098581075D+00
      ALPHA( 3,2,26)= 0.78480657207168D+00
      ALPHA( 4,2,26)= 0.50527159572043D+00
      ALPHA( 5,2,26)= 0.35421727657634D+00
      ALPHA( 6,2,26)= 0.26184773048029D+00
      ALPHA( 7,2,26)= 0.20063138803072D+00
      ALPHA( 8,2,26)= 0.15769532166974D+00
      ALPHA( 9,2,26)= 0.12628473037310D+00
      ALPHA(10,2,26)= 0.10254514622468D+00
      ALPHA(11,2,26)= 0.84131951113345D-01
      ALPHA(12,2,26)= 0.69545197611475D-01
      ALPHA(13,2,26)= 0.57785310615721D-01
      ALPHA(14,2,26)= 0.48163282934378D-01
      ALPHA(15,2,26)= 0.40190492643515D-01
      ALPHA(16,2,26)= 0.33511920186628D-01
      ALPHA(17,2,26)= 0.27864160175650D-01
      ALPHA(18,2,26)= 0.23048177420794D-01
      ALPHA(19,2,26)= 0.18911138843091D-01
      ALPHA(20,2,26)= 0.15334002953568D-01
      ALPHA(21,2,26)= 0.12222859955779D-01
      ALPHA(22,2,26)= 0.95027732478325D-02
      ALPHA(23,2,26)= 0.71133246085987D-02
      ALPHA(24,2,26)= 0.50053418803419D-02
      ALPHA(25,2,26)= 0.31384615384615D-02
      ALPHA(26,2,26)= 0.14792899408284D-02
C l= 2 n=26 ; Coef  :
      COEF (   2,26)= -8.2318770211395D+00
C l= 3 n=26 ; Alpha :
      ALPHA( 1,3,26)=  8.2318770211395D+00
      ALPHA( 2,3,26)=  2.1887286524623D+00
      ALPHA( 3,3,26)= 0.98341581560566D+00
      ALPHA( 4,3,26)= 0.54136021868633D+00
      ALPHA( 5,3,26)= 0.33203385580497D+00
      ALPHA( 6,3,26)= 0.21765866707475D+00
      ALPHA( 7,3,26)= 0.14915775313832D+00
      ALPHA( 8,3,26)= 0.10543411049219D+00
      ALPHA( 9,3,26)= 0.76197506918643D-01
      ALPHA(10,3,26)= 0.55949283189469D-01
      ALPHA(11,3,26)= 0.41540698697273D-01
      ALPHA(12,3,26)= 0.31067977879722D-01
      ALPHA(13,3,26)= 0.23328502841937D-01
      ALPHA(14,3,26)= 0.17534659023533D-01
      ALPHA(15,3,26)= 0.13154796226339D-01
      ALPHA(16,3,26)= 0.98207156719734D-02
      ALPHA(17,3,26)= 0.72717370920556D-02
      ALPHA(18,3,26)= 0.53197427994053D-02
      ALPHA(19,3,26)= 0.38266943667632D-02
      ALPHA(20,3,26)= 0.26898027062705D-02
      ALPHA(21,3,26)= 0.18315262462782D-02
      ALPHA(22,3,26)= 0.11926905098210D-02
      ALPHA(23,3,26)= 0.72767034644481D-03
      ALPHA(24,3,26)= 0.40096222331799D-03
      ALPHA(25,3,26)= 0.18471005917160D-03
      ALPHA(26,3,26)= 0.56895766954939D-04
C l= 3 n=26 ; Coef  :
      COEF (   3,26)= -13.041762666969D+00
C l= 4 n=26 ; Alpha :
      ALPHA( 1,4,26)=  13.041762666969D+00
      ALPHA( 2,4,26)=  2.4049428229149D+00
      ALPHA( 3,4,26)= 0.87371899778920D+00
      ALPHA( 4,4,26)= 0.40943529444048D+00
      ALPHA( 5,4,26)= 0.21927619181512D+00
      ALPHA( 6,4,26)= 0.12739118387844D+00
      ALPHA( 7,4,26)= 0.78098348027983D-01
      ALPHA( 8,4,26)= 0.49691335382195D-01
      ALPHA( 9,4,26)= 0.32455174729486D-01
      ALPHA(10,4,26)= 0.21589906564673D-01
      ALPHA(11,4,26)= 0.14540889314297D-01
      ALPHA(12,4,26)= 0.98674236466657D-02
      ALPHA(13,4,26)= 0.67185466061744D-02
      ALPHA(14,4,26)= 0.45723287884521D-02
      ALPHA(15,4,26)= 0.30985296009864D-02
      ALPHA(16,4,26)= 0.20826967367785D-02
      ALPHA(17,4,26)= 0.13824960068520D-02
      ALPHA(18,4,26)= 0.90170527913487D-03
      ALPHA(19,4,26)= 0.57426064342223D-03
      ALPHA(20,4,26)= 0.35421289291296D-03
      ALPHA(21,4,26)= 0.20925976914231D-03
      ALPHA(22,4,26)= 0.11649676844138D-03
      ALPHA(23,4,26)= 0.59575582429971D-04
      ALPHA(24,4,26)= 0.26773668726855D-04
      ALPHA(25,4,26)= 0.96642330450614D-05
      ALPHA(26,4,26)= 0.21882987290361D-05
C l= 4 n=26 ; Coef  :
      COEF (   4,26)= -17.302878970348D+00
C l= 0 n=27 ; Alpha :
      ALPHA( 1,0,27)=  0.0000000000000D+00
      ALPHA( 2,0,27)=  0.0000000000000D+00
      ALPHA( 3,0,27)=  0.0000000000000D+00
      ALPHA( 4,0,27)=  0.0000000000000D+00
      ALPHA( 5,0,27)=  0.0000000000000D+00
      ALPHA( 6,0,27)=  0.0000000000000D+00
      ALPHA( 7,0,27)=  0.0000000000000D+00
      ALPHA( 8,0,27)=  0.0000000000000D+00
      ALPHA( 9,0,27)=  0.0000000000000D+00
      ALPHA(10,0,27)=  0.0000000000000D+00
      ALPHA(11,0,27)=  0.0000000000000D+00
      ALPHA(12,0,27)=  0.0000000000000D+00
      ALPHA(13,0,27)=  0.0000000000000D+00
      ALPHA(14,0,27)=  0.0000000000000D+00
      ALPHA(15,0,27)=  0.0000000000000D+00
      ALPHA(16,0,27)=  0.0000000000000D+00
      ALPHA(17,0,27)=  0.0000000000000D+00
      ALPHA(18,0,27)=  0.0000000000000D+00
      ALPHA(19,0,27)=  0.0000000000000D+00
      ALPHA(20,0,27)=  0.0000000000000D+00
      ALPHA(21,0,27)=  0.0000000000000D+00
      ALPHA(22,0,27)=  0.0000000000000D+00
      ALPHA(23,0,27)=  0.0000000000000D+00
      ALPHA(24,0,27)=  0.0000000000000D+00
      ALPHA(25,0,27)=  0.0000000000000D+00
      ALPHA(26,0,27)=  0.0000000000000D+00
      ALPHA(27,0,27)=  1.0000000000000D+00
C l= 0 n=27 ; Coef  :
      COEF (   0,27)= -1.0000000000000D+00
C l= 1 n=27 ; Alpha :
      ALPHA( 1,1,27)=  1.0000000000000D+00
      ALPHA( 2,1,27)= 0.50000000000000D+00
      ALPHA( 3,1,27)= 0.33333333333333D+00
      ALPHA( 4,1,27)= 0.25000000000000D+00
      ALPHA( 5,1,27)= 0.20000000000000D+00
      ALPHA( 6,1,27)= 0.16666666666667D+00
      ALPHA( 7,1,27)= 0.14285714285714D+00
      ALPHA( 8,1,27)= 0.12500000000000D+00
      ALPHA( 9,1,27)= 0.11111111111111D+00
      ALPHA(10,1,27)= 0.10000000000000D+00
      ALPHA(11,1,27)= 0.90909090909091D-01
      ALPHA(12,1,27)= 0.83333333333333D-01
      ALPHA(13,1,27)= 0.76923076923077D-01
      ALPHA(14,1,27)= 0.71428571428571D-01
      ALPHA(15,1,27)= 0.66666666666667D-01
      ALPHA(16,1,27)= 0.62500000000000D-01
      ALPHA(17,1,27)= 0.58823529411765D-01
      ALPHA(18,1,27)= 0.55555555555556D-01
      ALPHA(19,1,27)= 0.52631578947368D-01
      ALPHA(20,1,27)= 0.50000000000000D-01
      ALPHA(21,1,27)= 0.47619047619048D-01
      ALPHA(22,1,27)= 0.45454545454545D-01
      ALPHA(23,1,27)= 0.43478260869565D-01
      ALPHA(24,1,27)= 0.41666666666667D-01
      ALPHA(25,1,27)= 0.40000000000000D-01
      ALPHA(26,1,27)= 0.38461538461538D-01
      ALPHA(27,1,27)= 0.37037037037037D-01
C l= 1 n=27 ; Coef  :
      COEF (   1,27)= -3.8914567532521D+00
C l= 2 n=27 ; Alpha :
      ALPHA( 1,2,27)=  3.8914567532521D+00
      ALPHA( 2,2,27)=  1.4457283766260D+00
      ALPHA( 3,2,27)= 0.79715225108403D+00
      ALPHA( 4,2,27)= 0.51453085497969D+00
      ALPHA( 5,2,27)= 0.36162468398375D+00
      ALPHA( 6,2,27)= 0.26802056998646D+00
      ALPHA( 7,2,27)= 0.20592239332173D+00
      ALPHA( 8,2,27)= 0.16232495129937D+00
      ALPHA( 9,2,27)= 0.13039995671055D+00
      ALPHA(10,2,27)= 0.10624884992838D+00
      ALPHA(11,2,27)= 0.87498954480348D-01
      ALPHA(12,2,27)= 0.72631617364561D-01
      ALPHA(13,2,27)= 0.60634313464723D-01
      ALPHA(14,2,27)= 0.50808785579881D-01
      ALPHA(15,2,27)= 0.42659628445984D-01
      ALPHA(16,2,27)= 0.35826735001443D-01
      ALPHA(17,2,27)= 0.30042809413123D-01
      ALPHA(18,2,27)= 0.25105790589518D-01
      ALPHA(19,2,27)= 0.20860456581883D-01
      ALPHA(20,2,27)= 0.17185854805420D-01
      ALPHA(21,2,27)= 0.13986528386114D-01
      ALPHA(22,2,27)= 0.11186274931334D-01
      ALPHA(23,2,27)= 0.87236305667308D-02
      ALPHA(24,2,27)= 0.65485517568851D-02
      ALPHA(25,2,27)= 0.46199430199430D-02
      ALPHA(26,2,27)= 0.29037913653298D-02
      ALPHA(27,2,27)= 0.13717421124829D-02
C l= 2 n=27 ; Coef  :
      COEF (   2,27)= -8.3760050490378D+00
C l= 3 n=27 ; Alpha :
      ALPHA( 1,3,27)=  8.3760050490378D+00
      ALPHA( 2,3,27)=  2.2422741478928D+00
      ALPHA( 3,3,27)=  1.0129399730532D+00
      ALPHA( 4,3,27)= 0.56041691701891D+00
      ALPHA( 5,3,27)= 0.34542736261919D+00
      ALPHA( 6,3,27)= 0.22758535485203D+00
      ALPHA( 7,3,27)= 0.15678450844653D+00
      ALPHA( 8,3,27)= 0.11144614572550D+00
      ALPHA( 9,3,27)= 0.81027134944959D-01
      ALPHA(10,3,27)= 0.59884425779409D-01
      ALPHA(11,3,27)= 0.44781400715064D-01
      ALPHA(12,3,27)= 0.33758037782113D-01
      ALPHA(13,3,27)= 0.25574218155446D-01
      ALPHA(14,3,27)= 0.19416465896862D-01
      ALPHA(15,3,27)= 0.14734782465079D-01
      ALPHA(16,3,27)= 0.11147631783138D-01
      ALPHA(17,3,27)= 0.83844337369861D-02
      ALPHA(18,3,27)= 0.62495868953134D-02
      ALPHA(19,3,27)= 0.45993038697959D-02
      ALPHA(20,3,27)= 0.33263158472120D-02
      ALPHA(21,3,27)= 0.23495458161343D-02
      ALPHA(22,3,27)= 0.16069969887594D-02
      ALPHA(23,3,27)= 0.10507677748422D-02
      ALPHA(24,3,27)= 0.64350117727670D-03
      ALPHA(25,3,27)= 0.35581905991023D-03
      ALPHA(26,3,27)= 0.16444359530049D-03
      ALPHA(27,3,27)= 0.50805263425291D-04
C l= 3 n=27 ; Coef  :
      COEF (   3,27)= -13.351985076193D+00
C l= 4 n=27 ; Alpha :
      ALPHA( 1,4,27)=  13.351985076193D+00
      ALPHA( 2,4,27)=  2.4879900135776D+00
      ALPHA( 3,4,27)= 0.91123529308747D+00
      ALPHA( 4,4,27)= 0.43019147655230D+00
      ALPHA( 5,4,27)= 0.23206979783806D+00
      ALPHA( 6,4,27)= 0.13582027109518D+00
      ALPHA( 7,4,27)= 0.83905181674151D-01
      ALPHA( 8,4,27)= 0.53818970409066D-01
      ALPHA( 9,4,27)= 0.35456179727447D-01
      ALPHA(10,4,27)= 0.23807848260207D-01
      ALPHA(11,4,27)= 0.16199459711151D-01
      ALPHA(12,4,27)= 0.11117721342300D-01
      ALPHA(13,4,27)= 0.76657398711909D-02
      ALPHA(14,4,27)= 0.52914571550025D-02
      ALPHA(15,4,27)= 0.36442622848782D-02
      ALPHA(16,4,27)= 0.24955719880059D-02
      ALPHA(17,4,27)= 0.16930305897033D-02
      ALPHA(18,4,27)= 0.11331714604428D-02
      ALPHA(19,4,27)= 0.74460523119245D-03
      ALPHA(20,4,27)= 0.47740977614303D-03
      ALPHA(21,4,27)= 0.29627998455469D-03
      ALPHA(22,4,27)= 0.17601517543247D-03
      ALPHA(23,4,27)= 0.98492907424128D-04
      ALPHA(24,4,27)= 0.50607045663029D-04
      ALPHA(25,4,27)= 0.22842716745440D-04
      ALPHA(26,4,27)= 0.82788022586838D-05
      ALPHA(27,4,27)= 0.18816764231589D-05
C l= 4 n=27 ; Coef  :
      COEF (   4,27)= -17.797396936133D+00
C l= 0 n=28 ; Alpha :
      ALPHA( 1,0,28)=  0.0000000000000D+00
      ALPHA( 2,0,28)=  0.0000000000000D+00
      ALPHA( 3,0,28)=  0.0000000000000D+00
      ALPHA( 4,0,28)=  0.0000000000000D+00
      ALPHA( 5,0,28)=  0.0000000000000D+00
      ALPHA( 6,0,28)=  0.0000000000000D+00
      ALPHA( 7,0,28)=  0.0000000000000D+00
      ALPHA( 8,0,28)=  0.0000000000000D+00
      ALPHA( 9,0,28)=  0.0000000000000D+00
      ALPHA(10,0,28)=  0.0000000000000D+00
      ALPHA(11,0,28)=  0.0000000000000D+00
      ALPHA(12,0,28)=  0.0000000000000D+00
      ALPHA(13,0,28)=  0.0000000000000D+00
      ALPHA(14,0,28)=  0.0000000000000D+00
      ALPHA(15,0,28)=  0.0000000000000D+00
      ALPHA(16,0,28)=  0.0000000000000D+00
      ALPHA(17,0,28)=  0.0000000000000D+00
      ALPHA(18,0,28)=  0.0000000000000D+00
      ALPHA(19,0,28)=  0.0000000000000D+00
      ALPHA(20,0,28)=  0.0000000000000D+00
      ALPHA(21,0,28)=  0.0000000000000D+00
      ALPHA(22,0,28)=  0.0000000000000D+00
      ALPHA(23,0,28)=  0.0000000000000D+00
      ALPHA(24,0,28)=  0.0000000000000D+00
      ALPHA(25,0,28)=  0.0000000000000D+00
      ALPHA(26,0,28)=  0.0000000000000D+00
      ALPHA(27,0,28)=  0.0000000000000D+00
      ALPHA(28,0,28)=  1.0000000000000D+00
C l= 0 n=28 ; Coef  :
      COEF (   0,28)= -1.0000000000000D+00
C l= 1 n=28 ; Alpha :
      ALPHA( 1,1,28)=  1.0000000000000D+00
      ALPHA( 2,1,28)= 0.50000000000000D+00
      ALPHA( 3,1,28)= 0.33333333333333D+00
      ALPHA( 4,1,28)= 0.25000000000000D+00
      ALPHA( 5,1,28)= 0.20000000000000D+00
      ALPHA( 6,1,28)= 0.16666666666667D+00
      ALPHA( 7,1,28)= 0.14285714285714D+00
      ALPHA( 8,1,28)= 0.12500000000000D+00
      ALPHA( 9,1,28)= 0.11111111111111D+00
      ALPHA(10,1,28)= 0.10000000000000D+00
      ALPHA(11,1,28)= 0.90909090909091D-01
      ALPHA(12,1,28)= 0.83333333333333D-01
      ALPHA(13,1,28)= 0.76923076923077D-01
      ALPHA(14,1,28)= 0.71428571428571D-01
      ALPHA(15,1,28)= 0.66666666666667D-01
      ALPHA(16,1,28)= 0.62500000000000D-01
      ALPHA(17,1,28)= 0.58823529411765D-01
      ALPHA(18,1,28)= 0.55555555555556D-01
      ALPHA(19,1,28)= 0.52631578947368D-01
      ALPHA(20,1,28)= 0.50000000000000D-01
      ALPHA(21,1,28)= 0.47619047619048D-01
      ALPHA(22,1,28)= 0.45454545454545D-01
      ALPHA(23,1,28)= 0.43478260869565D-01
      ALPHA(24,1,28)= 0.41666666666667D-01
      ALPHA(25,1,28)= 0.40000000000000D-01
      ALPHA(26,1,28)= 0.38461538461538D-01
      ALPHA(27,1,28)= 0.37037037037037D-01
      ALPHA(28,1,28)= 0.35714285714286D-01
C l= 1 n=28 ; Coef  :
      COEF (   1,28)= -3.9271710389664D+00
C l= 2 n=28 ; Alpha :
      ALPHA( 1,2,28)=  3.9271710389664D+00
      ALPHA( 2,2,28)=  1.4635855194832D+00
      ALPHA( 3,2,28)= 0.80905701298879D+00
      ALPHA( 4,2,28)= 0.52345942640826D+00
      ALPHA( 5,2,28)= 0.36876754112661D+00
      ALPHA( 6,2,28)= 0.27397295093884D+00
      ALPHA( 7,2,28)= 0.21102443413805D+00
      ALPHA( 8,2,28)= 0.16678923701365D+00
      ALPHA( 9,2,28)= 0.13436821067880D+00
      ALPHA(10,2,28)= 0.10982027849981D+00
      ALPHA(11,2,28)= 0.90745707727101D-01
      ALPHA(12,2,28)= 0.75607807840752D-01
      ALPHA(13,2,28)= 0.63381566211976D-01
      ALPHA(14,2,28)= 0.53359805988044D-01
      ALPHA(15,2,28)= 0.45040580826936D-01
      ALPHA(16,2,28)= 0.38058877858586D-01
      ALPHA(17,2,28)= 0.32143649749257D-01
      ALPHA(18,2,28)= 0.27089917573645D-01
      ALPHA(19,2,28)= 0.22740155830003D-01
      ALPHA(20,2,28)= 0.18971569091134D-01
      ALPHA(21,2,28)= 0.15687208658223D-01
      ALPHA(22,2,28)= 0.12809651554711D-01
      ALPHA(23,2,28)= 0.10276425597787D-01
      ALPHA(24,2,28)= 0.80366469949803D-02
      ALPHA(25,2,28)= 0.60485144485144D-02
      ALPHA(26,2,28)= 0.42774177389562D-02
      ALPHA(27,2,28)= 0.26944934352342D-02
      ALPHA(28,2,28)= 0.12755102040816D-02
C l= 2 n=28 ; Coef  :
      COEF (   2,28)= -8.5162611575723D+00
C l= 3 n=28 ; Alpha :
      ALPHA( 1,3,28)=  8.5162611575723D+00
      ALPHA( 2,3,28)=  2.2945450593030D+00
      ALPHA( 3,3,28)=  1.0418348663742D+00
      ALPHA( 4,3,28)= 0.57911189653349D+00
      ALPHA( 5,3,28)= 0.35859763194514D+00
      ALPHA( 6,3,28)= 0.23737010309985D+00
      ALPHA( 7,3,28)= 0.16432109538003D+00
      ALPHA( 8,3,28)= 0.11740290419027D+00
      ALPHA( 9,3,28)= 0.85825999612060D-01
      ALPHA(10,3,28)= 0.63806578582973D-01
      ALPHA(11,3,28)= 0.48022318848175D-01
      ALPHA(12,3,28)= 0.36458316633568D-01
      ALPHA(13,3,28)= 0.27837845520159D-01
      ALPHA(14,3,28)= 0.21322173253578D-01
      ALPHA(15,3,28)= 0.16343374637470D-01
      ALPHA(16,3,28)= 0.12506877420945D-01
      ALPHA(17,3,28)= 0.95324212280310D-02
      ALPHA(18,3,28)= 0.72170839515150D-02
      ALPHA(19,3,28)= 0.54114522922960D-02
      ALPHA(20,3,28)= 0.40038718861811D-02
      ALPHA(21,3,28)= 0.29098032682137D-02
      ALPHA(22,3,28)= 0.20644845442847D-02
      ALPHA(23,3,28)= 0.14177829747632D-02
      ALPHA(24,3,28)= 0.93052428424028D-03
      ALPHA(25,3,28)= 0.57183743307146D-03
      ALPHA(26,3,28)= 0.31720851454892D-03
      ALPHA(27,3,28)= 0.14703717182651D-03
      ALPHA(28,3,28)= 0.45553935860058D-04
C l= 3 n=28 ; Coef  :
      COEF (   3,28)= -13.656137260392D+00
C l= 4 n=28 ; Alpha :
      ALPHA( 1,4,28)=  13.656137260392D+00
      ALPHA( 2,4,28)=  2.5699380514099D+00
      ALPHA( 3,4,28)= 0.94844368117226D+00
      ALPHA( 4,4,28)= 0.45087404428563D+00
      ALPHA( 5,4,28)= 0.24487685612181D+00
      ALPHA( 6,4,28)= 0.14429777477732D+00
      ALPHA( 7,4,28)= 0.89773792223438D-01
      ALPHA( 8,4,28)= 0.58011931273004D-01
      ALPHA( 9,4,28)= 0.38521393999307D-01
      ALPHA(10,4,28)= 0.26086654638170D-01
      ALPHA(11,4,28)= 0.17914542527157D-01
      ALPHA(12,4,28)= 0.12419804079213D-01
      ALPHA(13,4,28)= 0.86599486397680D-02
      ALPHA(14,4,28)= 0.60529633426303D-02
      ALPHA(15,4,28)= 0.42279542362164D-02
      ALPHA(16,4,28)= 0.29422461816110D-02
      ALPHA(17,4,28)= 0.20334742049901D-02
      ALPHA(18,4,28)= 0.13909244587112D-02
      ALPHA(19,4,28)= 0.93787138448874D-03
      ALPHA(20,4,28)= 0.62040520064950D-03
      ALPHA(21,4,28)= 0.40020152984804D-03
      ALPHA(22,4,28)= 0.24974676629978D-03
      ALPHA(23,4,28)= 0.14912801366567D-03
      ALPHA(24,4,28)= 0.83840055814468D-04
      ALPHA(25,4,28)= 0.43265482212278D-04
      ALPHA(26,4,28)= 0.19607677778288D-04
      ALPHA(27,4,28)= 0.71330039883915D-05
      ALPHA(28,4,28)= 0.16269262807164D-05
C l= 4 n=28 ; Coef  :
      COEF (   4,28)= -18.285116124004D+00
C l= 0 n=29 ; Alpha :
      ALPHA( 1,0,29)=  0.0000000000000D+00
      ALPHA( 2,0,29)=  0.0000000000000D+00
      ALPHA( 3,0,29)=  0.0000000000000D+00
      ALPHA( 4,0,29)=  0.0000000000000D+00
      ALPHA( 5,0,29)=  0.0000000000000D+00
      ALPHA( 6,0,29)=  0.0000000000000D+00
      ALPHA( 7,0,29)=  0.0000000000000D+00
      ALPHA( 8,0,29)=  0.0000000000000D+00
      ALPHA( 9,0,29)=  0.0000000000000D+00
      ALPHA(10,0,29)=  0.0000000000000D+00
      ALPHA(11,0,29)=  0.0000000000000D+00
      ALPHA(12,0,29)=  0.0000000000000D+00
      ALPHA(13,0,29)=  0.0000000000000D+00
      ALPHA(14,0,29)=  0.0000000000000D+00
      ALPHA(15,0,29)=  0.0000000000000D+00
      ALPHA(16,0,29)=  0.0000000000000D+00
      ALPHA(17,0,29)=  0.0000000000000D+00
      ALPHA(18,0,29)=  0.0000000000000D+00
      ALPHA(19,0,29)=  0.0000000000000D+00
      ALPHA(20,0,29)=  0.0000000000000D+00
      ALPHA(21,0,29)=  0.0000000000000D+00
      ALPHA(22,0,29)=  0.0000000000000D+00
      ALPHA(23,0,29)=  0.0000000000000D+00
      ALPHA(24,0,29)=  0.0000000000000D+00
      ALPHA(25,0,29)=  0.0000000000000D+00
      ALPHA(26,0,29)=  0.0000000000000D+00
      ALPHA(27,0,29)=  0.0000000000000D+00
      ALPHA(28,0,29)=  0.0000000000000D+00
      ALPHA(29,0,29)=  1.0000000000000D+00
C l= 0 n=29 ; Coef  :
      COEF (   0,29)= -1.0000000000000D+00
C l= 1 n=29 ; Alpha :
      ALPHA( 1,1,29)=  1.0000000000000D+00
      ALPHA( 2,1,29)= 0.50000000000000D+00
      ALPHA( 3,1,29)= 0.33333333333333D+00
      ALPHA( 4,1,29)= 0.25000000000000D+00
      ALPHA( 5,1,29)= 0.20000000000000D+00
      ALPHA( 6,1,29)= 0.16666666666667D+00
      ALPHA( 7,1,29)= 0.14285714285714D+00
      ALPHA( 8,1,29)= 0.12500000000000D+00
      ALPHA( 9,1,29)= 0.11111111111111D+00
      ALPHA(10,1,29)= 0.10000000000000D+00
      ALPHA(11,1,29)= 0.90909090909091D-01
      ALPHA(12,1,29)= 0.83333333333333D-01
      ALPHA(13,1,29)= 0.76923076923077D-01
      ALPHA(14,1,29)= 0.71428571428571D-01
      ALPHA(15,1,29)= 0.66666666666667D-01
      ALPHA(16,1,29)= 0.62500000000000D-01
      ALPHA(17,1,29)= 0.58823529411765D-01
      ALPHA(18,1,29)= 0.55555555555556D-01
      ALPHA(19,1,29)= 0.52631578947368D-01
      ALPHA(20,1,29)= 0.50000000000000D-01
      ALPHA(21,1,29)= 0.47619047619048D-01
      ALPHA(22,1,29)= 0.45454545454545D-01
      ALPHA(23,1,29)= 0.43478260869565D-01
      ALPHA(24,1,29)= 0.41666666666667D-01
      ALPHA(25,1,29)= 0.40000000000000D-01
      ALPHA(26,1,29)= 0.38461538461538D-01
      ALPHA(27,1,29)= 0.37037037037037D-01
      ALPHA(28,1,29)= 0.35714285714286D-01
      ALPHA(29,1,29)= 0.34482758620690D-01
C l= 1 n=29 ; Coef  :
      COEF (   1,29)= -3.9616537975871D+00
C l= 2 n=29 ; Alpha :
      ALPHA( 1,2,29)=  3.9616537975871D+00
      ALPHA( 2,2,29)=  1.4808268987935D+00
      ALPHA( 3,2,29)= 0.82055126586235D+00
      ALPHA( 4,2,29)= 0.53208011606343D+00
      ALPHA( 5,2,29)= 0.37566409285074D+00
      ALPHA( 6,2,29)= 0.27972007737562D+00
      ALPHA( 7,2,29)= 0.21595054251244D+00
      ALPHA( 8,2,29)= 0.17109958184124D+00
      ALPHA( 9,2,29)= 0.13819962830332D+00
      ALPHA(10,2,29)= 0.11326855436188D+00
      ALPHA(11,2,29)= 0.93880503965346D-01
      ALPHA(12,2,29)= 0.78481371059143D-01
      ALPHA(13,2,29)= 0.66034086105875D-01
      ALPHA(14,2,29)= 0.55822860175236D-01
      ALPHA(15,2,29)= 0.47339431401649D-01
      ALPHA(16,2,29)= 0.40214050272379D-01
      ALPHA(17,2,29)= 0.34172047315180D-01
      ALPHA(18,2,29)= 0.29005626385906D-01
      ALPHA(19,2,29)= 0.24555037862671D-01
      ALPHA(20,2,29)= 0.20695707022169D-01
      ALPHA(21,2,29)= 0.17329244783018D-01
      ALPHA(22,2,29)= 0.14377049673833D-01
      ALPHA(23,2,29)= 0.11775675972599D-01
      ALPHA(24,2,29)= 0.94734286041757D-02
      ALPHA(25,2,29)= 0.74278247933420D-02
      ALPHA(26,2,29)= 0.56036776859058D-02
      ALPHA(27,2,29)= 0.39716326434079D-02
      ALPHA(28,2,29)= 0.25070372976777D-02
      ALPHA(29,2,29)= 0.11890606420927D-02
C l= 2 n=29 ; Coef  :
      COEF (   2,29)= -8.6528699092132D+00
C l= 3 n=29 ; Alpha :
      ALPHA( 1,3,29)=  8.6528699092132D+00
      ALPHA( 2,3,29)=  2.3456080558131D+00
      ALPHA( 3,3,29)=  1.0701297376109D+00
      ALPHA( 4,3,29)= 0.59745948674257D+00
      ALPHA( 5,3,29)= 0.37155156618137D+00
      ALPHA( 6,3,29)= 0.24701562300935D+00
      ALPHA( 7,3,29)= 0.17176766581150D+00
      ALPHA( 8,3,29)= 0.12330288977101D+00
      ALPHA( 9,3,29)= 0.90591504036312D-01
      ALPHA(10,3,29)= 0.67712390802349D-01
      ALPHA(11,3,29)= 0.51259577605600D-01
      ALPHA(12,3,29)= 0.39164570808022D-01
      ALPHA(13,3,29)= 0.30114882972086D-01
      ALPHA(14,3,29)= 0.23247099466517D-01
      ALPHA(15,3,29)= 0.17975768823734D-01
      ALPHA(16,3,29)= 0.13893568809647D-01
      ALPHA(17,3,29)= 0.10710767687175D-01
      ALPHA(18,3,29)= 0.82172779648221D-02
      ALPHA(19,3,29)= 0.62581777358364D-02
      ALPHA(20,3,29)= 0.47175169559110D-02
      ALPHA(21,3,29)= 0.35073634331453D-02
      ALPHA(22,3,29)= 0.25602448778652D-02
      ALPHA(23,3,29)= 0.18238407669218D-02
      ALPHA(24,3,29)= 0.12571942361084D-02
      ALPHA(25,3,29)= 0.82796932249705D-03
      ALPHA(26,3,29)= 0.51043877958016D-03
      ALPHA(27,3,29)= 0.28399002159920D-03
      ALPHA(28,3,29)= 0.13200349784894D-03
      ALPHA(29,3,29)= 0.41002091106646D-04
C l= 3 n=29 ; Coef  :
      COEF (   3,29)= -13.954512084848D+00
C l= 4 n=29 ; Alpha :
      ALPHA( 1,4,29)=  13.954512084848D+00
      ALPHA( 2,4,29)=  2.6508210878172D+00
      ALPHA( 3,4,29)= 0.98534470660712D+00
      ALPHA( 4,4,29)= 0.47147609555262D+00
      ALPHA( 5,4,29)= 0.25768897909358D+00
      ALPHA( 6,4,29)= 0.15281555488109D+00
      ALPHA( 7,4,29)= 0.95696815182455D-01
      ALPHA( 8,4,29)= 0.62263755058211D-01
      ALPHA( 9,4,29)= 0.41645238966076D-01
      ALPHA(10,4,29)= 0.28421564665837D-01
      ALPHA(11,4,29)= 0.19682114168729D-01
      ALPHA(12,4,29)= 0.13770306520869D-01
      ALPHA(13,4,29)= 0.96983928801847D-02
      ALPHA(14,4,29)= 0.68545874621654D-02
      ALPHA(15,4,29)= 0.48478083335866D-02
      ALPHA(16,4,29)= 0.34213347612540D-02
      ALPHA(17,4,29)= 0.24028110217893D-02
      ALPHA(18,4,29)= 0.16742788712912D-02
      ALPHA(19,4,29)= 0.11536706167590D-02
      ALPHA(20,4,29)= 0.78307819912919D-03
      ALPHA(21,4,29)= 0.52114509650822D-03
      ALPHA(22,4,29)= 0.33803107243306D-03
      ALPHA(23,4,29)= 0.21201907459401D-03
      ALPHA(24,4,29)= 0.12719158119752D-03
      ALPHA(25,4,29)= 0.71816148505280D-04
      ALPHA(26,4,29)= 0.37209015005190D-04
      ALPHA(27,4,29)= 0.16925763353881D-04
      ALPHA(28,4,29)= 0.61787710341282D-05
      ALPHA(29,4,29)= 0.14138652105740D-05
C l= 4 n=29 ; Coef  :
      COEF (   4,29)= -18.766306195895D+00
C l= 0 n=30 ; Alpha :
      ALPHA( 1,0,30)=  0.0000000000000D+00
      ALPHA( 2,0,30)=  0.0000000000000D+00
      ALPHA( 3,0,30)=  0.0000000000000D+00
      ALPHA( 4,0,30)=  0.0000000000000D+00
      ALPHA( 5,0,30)=  0.0000000000000D+00
      ALPHA( 6,0,30)=  0.0000000000000D+00
      ALPHA( 7,0,30)=  0.0000000000000D+00
      ALPHA( 8,0,30)=  0.0000000000000D+00
      ALPHA( 9,0,30)=  0.0000000000000D+00
      ALPHA(10,0,30)=  0.0000000000000D+00
      ALPHA(11,0,30)=  0.0000000000000D+00
      ALPHA(12,0,30)=  0.0000000000000D+00
      ALPHA(13,0,30)=  0.0000000000000D+00
      ALPHA(14,0,30)=  0.0000000000000D+00
      ALPHA(15,0,30)=  0.0000000000000D+00
      ALPHA(16,0,30)=  0.0000000000000D+00
      ALPHA(17,0,30)=  0.0000000000000D+00
      ALPHA(18,0,30)=  0.0000000000000D+00
      ALPHA(19,0,30)=  0.0000000000000D+00
      ALPHA(20,0,30)=  0.0000000000000D+00
      ALPHA(21,0,30)=  0.0000000000000D+00
      ALPHA(22,0,30)=  0.0000000000000D+00
      ALPHA(23,0,30)=  0.0000000000000D+00
      ALPHA(24,0,30)=  0.0000000000000D+00
      ALPHA(25,0,30)=  0.0000000000000D+00
      ALPHA(26,0,30)=  0.0000000000000D+00
      ALPHA(27,0,30)=  0.0000000000000D+00
      ALPHA(28,0,30)=  0.0000000000000D+00
      ALPHA(29,0,30)=  0.0000000000000D+00
      ALPHA(30,0,30)=  1.0000000000000D+00
C l= 0 n=30 ; Coef  :
      COEF (   0,30)= -1.0000000000000D+00
C l= 1 n=30 ; Alpha :
      ALPHA( 1,1,30)=  1.0000000000000D+00
      ALPHA( 2,1,30)= 0.50000000000000D+00
      ALPHA( 3,1,30)= 0.33333333333333D+00
      ALPHA( 4,1,30)= 0.25000000000000D+00
      ALPHA( 5,1,30)= 0.20000000000000D+00
      ALPHA( 6,1,30)= 0.16666666666667D+00
      ALPHA( 7,1,30)= 0.14285714285714D+00
      ALPHA( 8,1,30)= 0.12500000000000D+00
      ALPHA( 9,1,30)= 0.11111111111111D+00
      ALPHA(10,1,30)= 0.10000000000000D+00
      ALPHA(11,1,30)= 0.90909090909091D-01
      ALPHA(12,1,30)= 0.83333333333333D-01
      ALPHA(13,1,30)= 0.76923076923077D-01
      ALPHA(14,1,30)= 0.71428571428571D-01
      ALPHA(15,1,30)= 0.66666666666667D-01
      ALPHA(16,1,30)= 0.62500000000000D-01
      ALPHA(17,1,30)= 0.58823529411765D-01
      ALPHA(18,1,30)= 0.55555555555556D-01
      ALPHA(19,1,30)= 0.52631578947368D-01
      ALPHA(20,1,30)= 0.50000000000000D-01
      ALPHA(21,1,30)= 0.47619047619048D-01
      ALPHA(22,1,30)= 0.45454545454545D-01
      ALPHA(23,1,30)= 0.43478260869565D-01
      ALPHA(24,1,30)= 0.41666666666667D-01
      ALPHA(25,1,30)= 0.40000000000000D-01
      ALPHA(26,1,30)= 0.38461538461538D-01
      ALPHA(27,1,30)= 0.37037037037037D-01
      ALPHA(28,1,30)= 0.35714285714286D-01
      ALPHA(29,1,30)= 0.34482758620690D-01
      ALPHA(30,1,30)= 0.33333333333333D-01
C l= 1 n=30 ; Coef  :
      COEF (   1,30)= -3.9949871309204D+00
C l= 2 n=30 ; Alpha :
      ALPHA( 1,2,30)=  3.9949871309204D+00
      ALPHA( 2,2,30)=  1.4974935654602D+00
      ALPHA( 3,2,30)= 0.83166237697346D+00
      ALPHA( 4,2,30)= 0.54041344939676D+00
      ALPHA( 5,2,30)= 0.38233075951741D+00
      ALPHA( 6,2,30)= 0.28527563293118D+00
      ALPHA( 7,2,30)= 0.22071244727434D+00
      ALPHA( 8,2,30)= 0.17526624850791D+00
      ALPHA( 9,2,30)= 0.14190333200703D+00
      ALPHA(10,2,30)= 0.11660188769521D+00
      ALPHA(11,2,30)= 0.96910806995649D-01
      ALPHA(12,2,30)= 0.81259148836921D-01
      ALPHA(13,2,30)= 0.68598188669978D-01
      ALPHA(14,2,30)= 0.58203812556188D-01
      ALPHA(15,2,30)= 0.49561653623871D-01
      ALPHA(16,2,30)= 0.42297383605712D-01
      ALPHA(17,2,30)= 0.36132831628906D-01
      ALPHA(18,2,30)= 0.30857478237757D-01
      ALPHA(19,2,30)= 0.26309423827583D-01
      ALPHA(20,2,30)= 0.22362373688835D-01
      ALPHA(21,2,30)= 0.18916546370319D-01
      ALPHA(22,2,30)= 0.15892201188985D-01
      ALPHA(23,2,30)= 0.13224951334918D-01
      ALPHA(24,2,30)= 0.10862317493065D-01
      ALPHA(25,2,30)= 0.87611581266754D-02
      ALPHA(26,2,30)= 0.68857289679571D-02
      ALPHA(27,2,30)= 0.52062005446424D-02
      ALPHA(28,2,30)= 0.36975134881539D-02
      ALPHA(29,2,30)= 0.23384859294491D-02
      ALPHA(30,2,30)= 0.11111111111111D-02
C l= 2 n=30 ; Coef  :
      COEF (   2,30)= -8.7860361469106D+00
C l= 3 n=30 ; Alpha :
      ALPHA( 1,3,30)=  8.7860361469106D+00
      ALPHA( 2,3,30)=  2.3955245079951D+00
      ALPHA( 3,3,30)=  1.0978518168433D+00
      ALPHA( 4,3,30)= 0.61547326838913D+00
      ALPHA( 5,3,30)= 0.38429592483195D+00
      ALPHA( 6,3,30)= 0.25652481077372D+00
      ALPHA( 7,3,30)= 0.17912474738731D+00
      ALPHA( 8,3,30)= 0.12914509805460D+00
      ALPHA( 9,3,30)= 0.95321615103213D-01
      ALPHA(10,3,30)= 0.71599120392189D-01
      ALPHA(11,3,30)= 0.54489937838789D-01
      ALPHA(12,3,30)= 0.41873209102586D-01
      ALPHA(13,3,30)= 0.32401489261085D-01
      ALPHA(14,3,30)= 0.25187226551724D-01
      ALPHA(15,3,30)= 0.19627823944529D-01
      ALPHA(16,3,30)= 0.15303481596504D-01
      ALPHA(17,3,30)= 0.11915195408139D-01
      ALPHA(18,3,30)= 0.92458605727473D-02
      ALPHA(19,3,30)= 0.71351585300892D-02
      ALPHA(20,3,30)= 0.54629294122056D-02
      ALPHA(21,3,30)= 0.41379149788227D-02
      ALPHA(22,3,30)= 0.30899849174980D-02
      ALPHA(23,3,30)= 0.22646724780857D-02
      ALPHA(24,3,30)= 0.16192714858772D-02
      ALPHA(25,3,30)= 0.11200079267196D-02
      ALPHA(26,3,30)= 0.73996307851206D-03
      ALPHA(27,3,30)= 0.45753003975394D-03
      ALPHA(28,3,30)= 0.25525394745407D-03
      ALPHA(29,3,30)= 0.11895162208828D-03
      ALPHA(30,3,30)= 0.37037037037037D-04
C l= 3 n=30 ; Coef  :
      COEF (   3,30)= -14.247379956411D+00
C l= 4 n=30 ; Alpha :
      ALPHA( 1,4,30)=  14.247379956411D+00
      ALPHA( 2,4,30)=  2.7306719047504D+00
      ALPHA( 3,4,30)=  1.0219397671686D+00
      ALPHA( 4,4,30)= 0.49199187116559D+00
      ALPHA( 5,4,30)= 0.27049884325465D+00
      ALPHA( 6,4,30)= 0.16136638190688D+00
      ALPHA( 7,4,30)= 0.10166764009537D+00
      ALPHA( 8,4,30)= 0.66568591660031D-01
      ALPHA( 9,4,30)= 0.44822626136183D-01
      ALPHA(10,4,30)= 0.30808202012244D-01
      ALPHA(11,4,30)= 0.21498445430022D-01
      ALPHA(12,4,30)= 0.15166080157621D-01
      ALPHA(13,4,30)= 0.10778442522221D-01
      ALPHA(14,4,30)= 0.76941616805562D-02
      ALPHA(15,4,30)= 0.55020691317375D-02
      ALPHA(16,4,30)= 0.39314508144709D-02
      ALPHA(17,4,30)= 0.27999842020605D-02
      ALPHA(18,4,30)= 0.19824742237161D-02
      ALPHA(19,4,30)= 0.13915092344286D-02
      ALPHA(20,4,30)= 0.96517584620271D-03
      ALPHA(21,4,30)= 0.65907559580231D-03
      ALPHA(22,4,30)= 0.44103056968300D-03
      ALPHA(23,4,30)= 0.28750815719687D-03
      ALPHA(24,4,30)= 0.18116729739342D-03
      ALPHA(25,4,30)= 0.10914974606260D-03
      ALPHA(26,4,30)= 0.61874450955592D-04
      ALPHA(27,4,30)= 0.32176764679012D-04
      ALPHA(28,4,30)= 0.14687235949264D-04
      ALPHA(29,4,30)= 0.53789192801834D-05
      ALPHA(30,4,30)= 0.12345679012346D-05
C l= 4 n=30 ; Coef  :
      COEF (   4,30)= -19.241218861109D+00
C l= 0 n=31 ; Alpha :
      ALPHA( 1,0,31)=  0.0000000000000D+00
      ALPHA( 2,0,31)=  0.0000000000000D+00
      ALPHA( 3,0,31)=  0.0000000000000D+00
      ALPHA( 4,0,31)=  0.0000000000000D+00
      ALPHA( 5,0,31)=  0.0000000000000D+00
      ALPHA( 6,0,31)=  0.0000000000000D+00
      ALPHA( 7,0,31)=  0.0000000000000D+00
      ALPHA( 8,0,31)=  0.0000000000000D+00
      ALPHA( 9,0,31)=  0.0000000000000D+00
      ALPHA(10,0,31)=  0.0000000000000D+00
      ALPHA(11,0,31)=  0.0000000000000D+00
      ALPHA(12,0,31)=  0.0000000000000D+00
      ALPHA(13,0,31)=  0.0000000000000D+00
      ALPHA(14,0,31)=  0.0000000000000D+00
      ALPHA(15,0,31)=  0.0000000000000D+00
      ALPHA(16,0,31)=  0.0000000000000D+00
      ALPHA(17,0,31)=  0.0000000000000D+00
      ALPHA(18,0,31)=  0.0000000000000D+00
      ALPHA(19,0,31)=  0.0000000000000D+00
      ALPHA(20,0,31)=  0.0000000000000D+00
      ALPHA(21,0,31)=  0.0000000000000D+00
      ALPHA(22,0,31)=  0.0000000000000D+00
      ALPHA(23,0,31)=  0.0000000000000D+00
      ALPHA(24,0,31)=  0.0000000000000D+00
      ALPHA(25,0,31)=  0.0000000000000D+00
      ALPHA(26,0,31)=  0.0000000000000D+00
      ALPHA(27,0,31)=  0.0000000000000D+00
      ALPHA(28,0,31)=  0.0000000000000D+00
      ALPHA(29,0,31)=  0.0000000000000D+00
      ALPHA(30,0,31)=  0.0000000000000D+00
      ALPHA(31,0,31)=  1.0000000000000D+00
C l= 0 n=31 ; Coef  :
      COEF (   0,31)= -1.0000000000000D+00
C l= 1 n=31 ; Alpha :
      ALPHA( 1,1,31)=  1.0000000000000D+00
      ALPHA( 2,1,31)= 0.50000000000000D+00
      ALPHA( 3,1,31)= 0.33333333333333D+00
      ALPHA( 4,1,31)= 0.25000000000000D+00
      ALPHA( 5,1,31)= 0.20000000000000D+00
      ALPHA( 6,1,31)= 0.16666666666667D+00
      ALPHA( 7,1,31)= 0.14285714285714D+00
      ALPHA( 8,1,31)= 0.12500000000000D+00
      ALPHA( 9,1,31)= 0.11111111111111D+00
      ALPHA(10,1,31)= 0.10000000000000D+00
      ALPHA(11,1,31)= 0.90909090909091D-01
      ALPHA(12,1,31)= 0.83333333333333D-01
      ALPHA(13,1,31)= 0.76923076923077D-01
      ALPHA(14,1,31)= 0.71428571428571D-01
      ALPHA(15,1,31)= 0.66666666666667D-01
      ALPHA(16,1,31)= 0.62500000000000D-01
      ALPHA(17,1,31)= 0.58823529411765D-01
      ALPHA(18,1,31)= 0.55555555555556D-01
      ALPHA(19,1,31)= 0.52631578947368D-01
      ALPHA(20,1,31)= 0.50000000000000D-01
      ALPHA(21,1,31)= 0.47619047619048D-01
      ALPHA(22,1,31)= 0.45454545454545D-01
      ALPHA(23,1,31)= 0.43478260869565D-01
      ALPHA(24,1,31)= 0.41666666666667D-01
      ALPHA(25,1,31)= 0.40000000000000D-01
      ALPHA(26,1,31)= 0.38461538461538D-01
      ALPHA(27,1,31)= 0.37037037037037D-01
      ALPHA(28,1,31)= 0.35714285714286D-01
      ALPHA(29,1,31)= 0.34482758620690D-01
      ALPHA(30,1,31)= 0.33333333333333D-01
      ALPHA(31,1,31)= 0.32258064516129D-01
C l= 1 n=31 ; Coef  :
      COEF (   1,31)= -4.0272451954365D+00
C l= 2 n=31 ; Alpha :
      ALPHA( 1,2,31)=  4.0272451954365D+00
      ALPHA( 2,2,31)=  1.5136225977183D+00
      ALPHA( 3,2,31)= 0.84241506514551D+00
      ALPHA( 4,2,31)= 0.54847796552580D+00
      ALPHA( 5,2,31)= 0.38878237242064D+00
      ALPHA( 6,2,31)= 0.29065197701720D+00
      ALPHA( 7,2,31)= 0.22532074220522D+00
      ALPHA( 8,2,31)= 0.17929850657242D+00
      ALPHA( 9,2,31)= 0.14548756139771D+00
      ALPHA(10,2,31)= 0.11982769414683D+00
      ALPHA(11,2,31)= 0.99843358315297D-01
      ALPHA(12,2,31)= 0.83947320879931D-01
      ALPHA(13,2,31)= 0.71079578248142D-01
      ALPHA(14,2,31)= 0.60507960021626D-01
      ALPHA(15,2,31)= 0.51712191258280D-01
      ALPHA(16,2,31)= 0.44313512637970D-01
      ALPHA(17,2,31)= 0.38030364835737D-01
      ALPHA(18,2,31)= 0.32649592933098D-01
      ALPHA(19,2,31)= 0.28007216696853D-01
      ALPHA(20,2,31)= 0.23975276914642D-01
      ALPHA(21,2,31)= 0.20452644680611D-01
      ALPHA(22,2,31)= 0.17358476848809D-01
      ALPHA(23,2,31)= 0.14627475879098D-01
      ALPHA(24,2,31)= 0.12206403514570D-01
      ALPHA(25,2,31)= 0.10051480707321D-01
      ALPHA(26,2,31)= 0.81264237570390D-02
      ALPHA(27,2,31)= 0.64009436748694D-02
      ALPHA(28,2,31)= 0.48495872208728D-02
      ALPHA(29,2,31)= 0.34508329817294D-02
      ALPHA(30,2,31)= 0.21863799283154D-02
      ALPHA(31,2,31)= 0.10405827263267D-02
C l= 2 n=31 ; Coef  :
      COEF (   2,31)= -8.9159472822472D+00
C l= 3 n=31 ; Alpha :
      ALPHA( 1,3,31)=  8.9159472822472D+00
      ALPHA( 2,3,31)=  2.4443510434054D+00
      ALPHA( 3,3,31)=  1.1250264963641D+00
      ALPHA( 4,3,31)= 0.63316610598674D+00
      ALPHA( 5,3,31)= 0.39683729168423D+00
      ALPHA( 6,3,31)= 0.26590068100008D+00
      ALPHA( 7,3,31)= 0.18639315842619D+00
      ALPHA( 8,3,31)= 0.13492892084726D+00
      ALPHA( 9,3,31)= 0.10001476224507D+00
      ALPHA(10,3,31)= 0.75464529880796D-01
      ALPHA(11,3,31)= 0.57710691332831D-01
      ALPHA(12,3,31)= 0.44581187195487D-01
      ALPHA(13,3,31)= 0.34694378881993D-01
      ALPHA(14,3,31)= 0.27139096229840D-01
      ALPHA(15,3,31)= 0.21295959146409D-01
      ALPHA(16,3,31)= 0.16732949746116D-01
      ALPHA(17,3,31)= 0.13141981370582D-01
      ALPHA(18,3,31)= 0.10299073248009D-01
      ALPHA(19,3,31)= 0.80386171332135D-02
      ALPHA(20,3,31)= 0.62363254417101D-02
      ALPHA(21,3,31)= 0.47976777104553D-02
      ALPHA(22,3,31)= 0.36499357835886D-02
      ALPHA(23,3,31)= 0.27365265387018D-02
      ALPHA(24,3,31)= 0.20130264379601D-02
      ALPHA(25,3,31)= 0.14442492398589D-02
      ALPHA(26,3,31)= 0.10021057803520D-02
      ALPHA(27,3,31)= 0.66401209378199D-03
      ALPHA(28,3,31)= 0.41169224490158D-03
      ALPHA(29,3,31)= 0.23026881504729D-03
      ALPHA(30,3,31)= 0.10756542182141D-03
      ALPHA(31,3,31)= 0.33567184720218D-04
C l= 3 n=31 ; Coef  :
      COEF (   3,31)= -14.534991159064D+00
C l= 4 n=31 ; Alpha :
      ALPHA( 1,4,31)=  14.534991159064D+00
      ALPHA( 2,4,31)=  2.8095219384086D+00
      ALPHA( 3,4,31)=  1.0582309444706D+00
      ALPHA( 4,4,31)= 0.51241658426194D+00
      ALPHA( 5,4,31)= 0.28330004621220D+00
      ALPHA( 6,4,31)= 0.16994382322946D+00
      ALPHA( 7,4,31)= 0.10768032262524D+00
      ALPHA( 8,4,31)= 0.70921137493814D-01
      ALPHA( 9,4,31)= 0.48048908789250D-01
      ALPHA(10,4,31)= 0.33242541685818D-01
      ALPHA(11,4,31)= 0.23360080634307D-01
      ALPHA(12,4,31)= 0.16604182970379D-01
      ALPHA(13,4,31)= 0.11897616034543D-01
      ALPHA(14,4,31)= 0.85696163976478D-02
      ALPHA(15,4,31)= 0.61890355558153D-02
      ALPHA(16,4,31)= 0.44712233869262D-02
      ALPHA(17,4,31)= 0.32239190849825D-02
      ALPHA(18,4,31)= 0.23147023930067D-02
      ALPHA(19,4,31)= 0.16508194645323D-02
      ALPHA(20,4,31)= 0.11663476346450D-02
      ALPHA(21,4,31)= 0.81383939291377D-03
      ALPHA(22,4,31)= 0.55877043366973D-03
      ALPHA(23,4,31)= 0.37578320683241D-03
      ALPHA(24,4,31)= 0.24610363410182D-03
      ALPHA(25,4,31)= 0.15573843121934D-03
      ALPHA(26,4,31)= 0.94200443870174D-04
      ALPHA(27,4,31)= 0.53596509639722D-04
      ALPHA(28,4,31)= 0.27967630946089D-04
      ALPHA(29,4,31)= 0.12806945572032D-04
      ALPHA(30,4,31)= 0.47044202180541D-05
      ALPHA(31,4,31)= 0.10828124103296D-05
C l= 4 n=31 ; Coef  :
      COEF (   4,31)= -19.710089543660D+00
C l= 0 n=32 ; Alpha :
      ALPHA( 1,0,32)=  0.0000000000000D+00
      ALPHA( 2,0,32)=  0.0000000000000D+00
      ALPHA( 3,0,32)=  0.0000000000000D+00
      ALPHA( 4,0,32)=  0.0000000000000D+00
      ALPHA( 5,0,32)=  0.0000000000000D+00
      ALPHA( 6,0,32)=  0.0000000000000D+00
      ALPHA( 7,0,32)=  0.0000000000000D+00
      ALPHA( 8,0,32)=  0.0000000000000D+00
      ALPHA( 9,0,32)=  0.0000000000000D+00
      ALPHA(10,0,32)=  0.0000000000000D+00
      ALPHA(11,0,32)=  0.0000000000000D+00
      ALPHA(12,0,32)=  0.0000000000000D+00
      ALPHA(13,0,32)=  0.0000000000000D+00
      ALPHA(14,0,32)=  0.0000000000000D+00
      ALPHA(15,0,32)=  0.0000000000000D+00
      ALPHA(16,0,32)=  0.0000000000000D+00
      ALPHA(17,0,32)=  0.0000000000000D+00
      ALPHA(18,0,32)=  0.0000000000000D+00
      ALPHA(19,0,32)=  0.0000000000000D+00
      ALPHA(20,0,32)=  0.0000000000000D+00
      ALPHA(21,0,32)=  0.0000000000000D+00
      ALPHA(22,0,32)=  0.0000000000000D+00
      ALPHA(23,0,32)=  0.0000000000000D+00
      ALPHA(24,0,32)=  0.0000000000000D+00
      ALPHA(25,0,32)=  0.0000000000000D+00
      ALPHA(26,0,32)=  0.0000000000000D+00
      ALPHA(27,0,32)=  0.0000000000000D+00
      ALPHA(28,0,32)=  0.0000000000000D+00
      ALPHA(29,0,32)=  0.0000000000000D+00
      ALPHA(30,0,32)=  0.0000000000000D+00
      ALPHA(31,0,32)=  0.0000000000000D+00
      ALPHA(32,0,32)=  1.0000000000000D+00
C l= 0 n=32 ; Coef  :
      COEF (   0,32)= -1.0000000000000D+00
C l= 1 n=32 ; Alpha :
      ALPHA( 1,1,32)=  1.0000000000000D+00
      ALPHA( 2,1,32)= 0.50000000000000D+00
      ALPHA( 3,1,32)= 0.33333333333333D+00
      ALPHA( 4,1,32)= 0.25000000000000D+00
      ALPHA( 5,1,32)= 0.20000000000000D+00
      ALPHA( 6,1,32)= 0.16666666666667D+00
      ALPHA( 7,1,32)= 0.14285714285714D+00
      ALPHA( 8,1,32)= 0.12500000000000D+00
      ALPHA( 9,1,32)= 0.11111111111111D+00
      ALPHA(10,1,32)= 0.10000000000000D+00
      ALPHA(11,1,32)= 0.90909090909091D-01
      ALPHA(12,1,32)= 0.83333333333333D-01
      ALPHA(13,1,32)= 0.76923076923077D-01
      ALPHA(14,1,32)= 0.71428571428571D-01
      ALPHA(15,1,32)= 0.66666666666667D-01
      ALPHA(16,1,32)= 0.62500000000000D-01
      ALPHA(17,1,32)= 0.58823529411765D-01
      ALPHA(18,1,32)= 0.55555555555556D-01
      ALPHA(19,1,32)= 0.52631578947368D-01
      ALPHA(20,1,32)= 0.50000000000000D-01
      ALPHA(21,1,32)= 0.47619047619048D-01
      ALPHA(22,1,32)= 0.45454545454545D-01
      ALPHA(23,1,32)= 0.43478260869565D-01
      ALPHA(24,1,32)= 0.41666666666667D-01
      ALPHA(25,1,32)= 0.40000000000000D-01
      ALPHA(26,1,32)= 0.38461538461538D-01
      ALPHA(27,1,32)= 0.37037037037037D-01
      ALPHA(28,1,32)= 0.35714285714286D-01
      ALPHA(29,1,32)= 0.34482758620690D-01
      ALPHA(30,1,32)= 0.33333333333333D-01
      ALPHA(31,1,32)= 0.32258064516129D-01
      ALPHA(32,1,32)= 0.31250000000000D-01
C l= 1 n=32 ; Coef  :
      COEF (   1,32)= -4.0584951954365D+00
C l= 2 n=32 ; Alpha :
      ALPHA( 1,2,32)=  4.0584951954365D+00
      ALPHA( 2,2,32)=  1.5292475977183D+00
      ALPHA( 3,2,32)= 0.85283173181217D+00
      ALPHA( 4,2,32)= 0.55629046552580D+00
      ALPHA( 5,2,32)= 0.39503237242064D+00
      ALPHA( 6,2,32)= 0.29586031035053D+00
      ALPHA( 7,2,32)= 0.22978502791950D+00
      ALPHA( 8,2,32)= 0.18320475657242D+00
      ALPHA( 9,2,32)= 0.14895978361993D+00
      ALPHA(10,2,32)= 0.12295269414683D+00
      ALPHA(11,2,32)= 0.10268426740621D+00
      ALPHA(12,2,32)= 0.86551487546598D-01
      ALPHA(13,2,32)= 0.73483424401988D-01
      ALPHA(14,2,32)= 0.62740102878769D-01
      ALPHA(15,2,32)= 0.53795524591613D-01
      ALPHA(16,2,32)= 0.46266637637970D-01
      ALPHA(17,2,32)= 0.39868600129855D-01
      ALPHA(18,2,32)= 0.34385704044209D-01
      ALPHA(19,2,32)= 0.29651953538958D-01
      ALPHA(20,2,32)= 0.25537776914642D-01
      ALPHA(21,2,32)= 0.21940739918707D-01
      ALPHA(22,2,32)= 0.18778931394263D-01
      ALPHA(23,2,32)= 0.15986171531272D-01
      ALPHA(24,2,32)= 0.13508486847903D-01
      ALPHA(25,2,32)= 0.11301480707321D-01
      ALPHA(26,2,32)= 0.93283468339620D-02
      ALPHA(27,2,32)= 0.75583510822768D-02
      ALPHA(28,2,32)= 0.59656586494442D-02
      ALPHA(29,2,32)= 0.45284191886259D-02
      ALPHA(30,2,32)= 0.32280465949821D-02
      ALPHA(31,2,32)= 0.20486472424558D-02
      ALPHA(32,2,32)= 0.97656250000000D-03
C l= 2 n=32 ; Coef  :
      COEF (   2,32)= -9.0427752571046D+00
C l= 3 n=32 ; Alpha :
      ALPHA( 1,3,32)=  9.0427752571046D+00
      ALPHA( 2,3,32)=  2.4921400308341D+00
      ALPHA( 3,3,32)=  1.1516774879833D+00
      ALPHA( 4,3,32)= 0.65055018303442D+00
      ALPHA( 5,3,32)= 0.40918205332237D+00
      ALPHA( 6,3,32)= 0.27514631569854D+00
      ALPHA( 7,3,32)= 0.19357394054867D+00
      ALPHA( 8,3,32)= 0.14065406949015D+00
      ALPHA( 9,3,32)= 0.10466975548320D+00
      ALPHA(10,3,32)= 0.79306801572885D-01
      ALPHA(11,3,32)= 0.60919574689275D-01
      ALPHA(12,3,32)= 0.47285921181318D-01
      ALPHA(13,3,32)= 0.36990735894555D-01
      ALPHA(14,3,32)= 0.29099724444802D-01
      ALPHA(15,3,32)= 0.22977069289897D-01
      ALPHA(16,3,32)= 0.18178782172303D-01
      ALPHA(17,3,32)= 0.14387875124640D-01
      ALPHA(18,3,32)= 0.11373626499390D-01
      ALPHA(19,3,32)= 0.89652406813059D-02
      ALPHA(20,3,32)= 0.70343809702927D-02
      ALPHA(21,3,32)= 0.54833258329149D-02
      ALPHA(22,3,32)= 0.42367773896593D-02
      ALPHA(23,3,32)= 0.32360943990540D-02
      ALPHA(24,3,32)= 0.24351666519571D-02
      ALPHA(25,3,32)= 0.17974205119627D-02
      ALPHA(26,3,32)= 0.12936166189133D-02
      ALPHA(27,3,32)= 0.90021056510314D-03
      ALPHA(28,3,32)= 0.59811907769671D-03
      ALPHA(29,3,32)= 0.37178191469185D-03
      ALPHA(30,3,32)= 0.20844187791460D-03
      ALPHA(31,3,32)= 0.97587411046960D-04
      ALPHA(32,3,32)= 0.30517578125000D-04
C l= 3 n=32 ; Coef  :
      COEF (   3,32)= -14.817577885849D+00
C l= 4 n=32 ; Alpha :
      ALPHA( 1,4,32)=  14.817577885849D+00
      ALPHA( 2,4,32)=  2.8874013143722D+00
      ALPHA( 3,4,32)=  1.0942208659701D+00
      ALPHA( 4,4,32)= 0.53274627748176D+00
      ALPHA( 5,4,32)= 0.29608698537853D+00
      ALPHA( 6,4,32)= 0.17854214559504D+00
      ALPHA( 7,4,32)= 0.11372950826739D+00
      ALPHA( 8,4,32)= 0.75316577165381D-01
      ALPHA( 9,4,32)= 0.51319838648100D-01
      ALPHA(10,4,32)= 0.35720879234970D-01
      ALPHA(11,4,32)= 0.25263817343347D-01
      ALPHA(12,4,32)= 0.18081868007295D-01
      ALPHA(13,4,32)= 0.13053576531248D-01
      ALPHA(14,4,32)= 0.94789827865479D-02
      ALPHA(15,4,32)= 0.69070689711245D-02
      ALPHA(16,4,32)= 0.50393103298107D-02
      ALPHA(17,4,32)= 0.36735401826275D-02
      ALPHA(18,4,32)= 0.26701282211127D-02
      ALPHA(19,4,32)= 0.19309832358231D-02
      ALPHA(20,4,32)= 0.13861720399666D-02
      ALPHA(21,4,32)= 0.98519332519236D-03
      ALPHA(22,4,32)= 0.69116972709658D-03
      ALPHA(23,4,32)= 0.47691115680284D-03
      ALPHA(24,4,32)= 0.32220259197548D-03
      ALPHA(25,4,32)= 0.21190782221817D-03
      ALPHA(26,4,32)= 0.13462596321122D-03
      ALPHA(27,4,32)= 0.81728089799195D-04
      ALPHA(28,4,32)= 0.46658852124112D-04
      ALPHA(29,4,32)= 0.24425130406152D-04
      ALPHA(30,4,32)= 0.11218228902885D-04
      ALPHA(31,4,32)= 0.41324190055471D-05
      ALPHA(32,4,32)= 0.95367431640625D-06
C l= 4 n=32 ; Coef  :
      COEF (   4,32)= -20.173138852592D+00
C l= 0 n=33 ; Alpha :
      ALPHA( 1,0,33)=  0.0000000000000D+00
      ALPHA( 2,0,33)=  0.0000000000000D+00
      ALPHA( 3,0,33)=  0.0000000000000D+00
      ALPHA( 4,0,33)=  0.0000000000000D+00
      ALPHA( 5,0,33)=  0.0000000000000D+00
      ALPHA( 6,0,33)=  0.0000000000000D+00
      ALPHA( 7,0,33)=  0.0000000000000D+00
      ALPHA( 8,0,33)=  0.0000000000000D+00
      ALPHA( 9,0,33)=  0.0000000000000D+00
      ALPHA(10,0,33)=  0.0000000000000D+00
      ALPHA(11,0,33)=  0.0000000000000D+00
      ALPHA(12,0,33)=  0.0000000000000D+00
      ALPHA(13,0,33)=  0.0000000000000D+00
      ALPHA(14,0,33)=  0.0000000000000D+00
      ALPHA(15,0,33)=  0.0000000000000D+00
      ALPHA(16,0,33)=  0.0000000000000D+00
      ALPHA(17,0,33)=  0.0000000000000D+00
      ALPHA(18,0,33)=  0.0000000000000D+00
      ALPHA(19,0,33)=  0.0000000000000D+00
      ALPHA(20,0,33)=  0.0000000000000D+00
      ALPHA(21,0,33)=  0.0000000000000D+00
      ALPHA(22,0,33)=  0.0000000000000D+00
      ALPHA(23,0,33)=  0.0000000000000D+00
      ALPHA(24,0,33)=  0.0000000000000D+00
      ALPHA(25,0,33)=  0.0000000000000D+00
      ALPHA(26,0,33)=  0.0000000000000D+00
      ALPHA(27,0,33)=  0.0000000000000D+00
      ALPHA(28,0,33)=  0.0000000000000D+00
      ALPHA(29,0,33)=  0.0000000000000D+00
      ALPHA(30,0,33)=  0.0000000000000D+00
      ALPHA(31,0,33)=  0.0000000000000D+00
      ALPHA(32,0,33)=  0.0000000000000D+00
      ALPHA(33,0,33)=  1.0000000000000D+00
C l= 0 n=33 ; Coef  :
      COEF (   0,33)= -1.0000000000000D+00
C l= 1 n=33 ; Alpha :
      ALPHA( 1,1,33)=  1.0000000000000D+00
      ALPHA( 2,1,33)= 0.50000000000000D+00
      ALPHA( 3,1,33)= 0.33333333333333D+00
      ALPHA( 4,1,33)= 0.25000000000000D+00
      ALPHA( 5,1,33)= 0.20000000000000D+00
      ALPHA( 6,1,33)= 0.16666666666667D+00
      ALPHA( 7,1,33)= 0.14285714285714D+00
      ALPHA( 8,1,33)= 0.12500000000000D+00
      ALPHA( 9,1,33)= 0.11111111111111D+00
      ALPHA(10,1,33)= 0.10000000000000D+00
      ALPHA(11,1,33)= 0.90909090909091D-01
      ALPHA(12,1,33)= 0.83333333333333D-01
      ALPHA(13,1,33)= 0.76923076923077D-01
      ALPHA(14,1,33)= 0.71428571428571D-01
      ALPHA(15,1,33)= 0.66666666666667D-01
      ALPHA(16,1,33)= 0.62500000000000D-01
      ALPHA(17,1,33)= 0.58823529411765D-01
      ALPHA(18,1,33)= 0.55555555555556D-01
      ALPHA(19,1,33)= 0.52631578947368D-01
      ALPHA(20,1,33)= 0.50000000000000D-01
      ALPHA(21,1,33)= 0.47619047619048D-01
      ALPHA(22,1,33)= 0.45454545454545D-01
      ALPHA(23,1,33)= 0.43478260869565D-01
      ALPHA(24,1,33)= 0.41666666666667D-01
      ALPHA(25,1,33)= 0.40000000000000D-01
      ALPHA(26,1,33)= 0.38461538461538D-01
      ALPHA(27,1,33)= 0.37037037037037D-01
      ALPHA(28,1,33)= 0.35714285714286D-01
      ALPHA(29,1,33)= 0.34482758620690D-01
      ALPHA(30,1,33)= 0.33333333333333D-01
      ALPHA(31,1,33)= 0.32258064516129D-01
      ALPHA(32,1,33)= 0.31250000000000D-01
      ALPHA(33,1,33)= 0.30303030303030D-01
C l= 1 n=33 ; Coef  :
      COEF (   1,33)= -4.0887982257396D+00
C l= 2 n=33 ; Alpha :
      ALPHA( 1,2,33)=  4.0887982257396D+00
      ALPHA( 2,2,33)=  1.5443991128698D+00
      ALPHA( 3,2,33)= 0.86293274191318D+00
      ALPHA( 4,2,33)= 0.56386622310155D+00
      ALPHA( 5,2,33)= 0.40109297848124D+00
      ALPHA( 6,2,33)= 0.30091081540104D+00
      ALPHA( 7,2,33)= 0.23411403224851D+00
      ALPHA( 8,2,33)= 0.18699263536030D+00
      ALPHA( 9,2,33)= 0.15232678698693D+00
      ALPHA(10,2,33)= 0.12598299717713D+00
      ALPHA(11,2,33)= 0.10543908834285D+00
      ALPHA(12,2,33)= 0.89076740071850D-01
      ALPHA(13,2,33)= 0.75814426732990D-01
      ALPHA(14,2,33)= 0.64904605043271D-01
      ALPHA(15,2,33)= 0.55815726611815D-01
      ALPHA(16,2,33)= 0.48160577031910D-01
      ALPHA(17,2,33)= 0.41651131324150D-01
      ALPHA(18,2,33)= 0.36069205727711D-01
      ALPHA(19,2,33)= 0.31246849870697D-01
      ALPHA(20,2,33)= 0.27052928429793D-01
      ALPHA(21,2,33)= 0.23383741361708D-01
      ALPHA(22,2,33)= 0.20156341862583D-01
      ALPHA(23,2,33)= 0.17303694587925D-01
      ALPHA(24,2,33)= 0.14771113110530D-01
      ALPHA(25,2,33)= 0.12513601919442D-01
      ALPHA(26,2,33)= 0.10493847999463D-01
      ALPHA(27,2,33)= 0.86806855379446D-02
      ALPHA(28,2,33)= 0.70479097316953D-02
      ALPHA(29,2,33)= 0.55733512680408D-02
      ALPHA(30,2,33)= 0.42381476050831D-02
      ALPHA(31,2,33)= 0.30261643490051D-02
      ALPHA(32,2,33)= 0.19235321969697D-02
      ALPHA(33,2,33)= 0.91827364554637D-03
C l= 2 n=33 ; Coef  :
      COEF (   2,33)= -9.1666782336422D+00
C l= 3 n=33 ; Alpha :
      ALPHA( 1,3,33)=  9.1666782336422D+00
      ALPHA( 2,3,33)=  2.5389400039513D+00
      ALPHA( 3,3,33)=  1.1778269650110D+00
      ALPHA( 4,3,33)= 0.66763703827992D+00
      ALPHA( 5,3,33)= 0.42133638600362D+00
      ALPHA( 6,3,33)= 0.28426482525615D+00
      ALPHA( 7,3,33)= 0.20066830516226D+00
      ALPHA( 8,3,33)= 0.14632051298592D+00
      ALPHA( 9,3,33)= 0.10928571872523D+00
      ALPHA(10,3,33)= 0.83124468154010D-01
      ALPHA(11,3,33)= 0.64114698578452D-01
      ALPHA(12,3,33)= 0.49985216335010D-01
      ALPHA(13,3,33)= 0.39288142765252D-01
      ALPHA(14,3,33)= 0.31066530658234D-01
      ALPHA(15,3,33)= 0.24668454944801D-01
      ALPHA(16,3,33)= 0.19638193597512D-01
      ALPHA(17,3,33)= 0.15650030619311D-01
      ALPHA(18,3,33)= 0.12466632733563D-01
      ALPHA(19,3,33)= 0.99121149198119D-02
      ALPHA(20,3,33)= 0.78541666802864D-02
      ALPHA(21,3,33)= 0.61919240559969D-02
      ALPHA(22,3,33)= 0.48475756279194D-02
      ALPHA(23,3,33)= 0.37604487805063D-02
      ALPHA(24,3,33)= 0.28827761401550D-02
      ALPHA(25,3,33)= 0.21766205701276D-02
      ALPHA(26,3,33)= 0.16116120128365D-02
      ALPHA(27,3,33)= 0.11632616420106D-02
      ALPHA(28,3,33)= 0.81169209986930D-03
      ALPHA(29,3,33)= 0.54067134705673D-03
      ALPHA(30,3,33)= 0.33687059322014D-03
      ALPHA(31,3,33)= 0.18928936101681D-03
      ALPHA(32,3,33)= 0.88806432578627D-04
      ALPHA(33,3,33)= 0.27826474107466D-04
C l= 3 n=33 ; Coef  :
      COEF (   3,33)= -15.095356014141D+00
C l= 4 n=33 ; Alpha :
      ALPHA( 1,4,33)=  15.095356014141D+00
      ALPHA( 2,4,33)=  2.9643388902495D+00
      ALPHA( 3,4,33)=  1.1299125921826D+00
      ALPHA( 4,4,33)= 0.55297770288418D+00
      ALPHA( 5,4,33)= 0.30885475465136D+00
      ALPHA( 6,4,33)= 0.18715623120887D+00
      ALPHA( 7,4,33)= 0.11981036599958D+00
      ALPHA( 8,4,33)= 0.79750532104348D-01
      ALPHA( 9,4,33)= 0.54631527094319D-01
      ALPHA(10,4,33)= 0.38239802512364D-01
      ALPHA(11,4,33)= 0.27206686997240D-01
      ALPHA(12,4,33)= 0.19596571532599D-01
      ALPHA(13,4,33)= 0.14244126312013D-01
      ALPHA(14,4,33)= 0.10420392806494D-01
      ALPHA(15,4,33)= 0.76545979088458D-02
      ALPHA(16,4,33)= 0.56344071054929D-02
      ALPHA(17,4,33)= 0.41477835347279D-02
      ALPHA(18,4,33)= 0.30479049706146D-02
      ALPHA(19,4,33)= 0.22313503546052D-02
      ALPHA(20,4,33)= 0.16241770908844D-02
      ALPHA(21,4,33)= 0.11728273874953D-02
      ALPHA(22,4,33)= 0.83806595824565D-03
      ALPHA(23,4,33)= 0.59086415015152D-03
      ALPHA(24,4,33)= 0.40955944470744D-03
      ALPHA(25,4,33)= 0.27786602131295D-03
      ALPHA(26,4,33)= 0.18346269087293D-03
      ALPHA(27,4,33)= 0.11697844258739D-03
      ALPHA(28,4,33)= 0.71255582423181D-04
      ALPHA(29,4,33)= 0.40809110619992D-04
      ALPHA(30,4,33)= 0.21426428697435D-04
      ALPHA(31,4,33)= 0.98684602484808D-05
      ALPHA(32,4,33)= 0.36447783339404D-05
      ALPHA(33,4,33)= 0.84322648810503D-06
C l= 4 n=33 ; Coef  :
      COEF (   4,33)= -20.630573883324D+00
C l= 0 n=34 ; Alpha :
      ALPHA( 1,0,34)=  0.0000000000000D+00
      ALPHA( 2,0,34)=  0.0000000000000D+00
      ALPHA( 3,0,34)=  0.0000000000000D+00
      ALPHA( 4,0,34)=  0.0000000000000D+00
      ALPHA( 5,0,34)=  0.0000000000000D+00
      ALPHA( 6,0,34)=  0.0000000000000D+00
      ALPHA( 7,0,34)=  0.0000000000000D+00
      ALPHA( 8,0,34)=  0.0000000000000D+00
      ALPHA( 9,0,34)=  0.0000000000000D+00
      ALPHA(10,0,34)=  0.0000000000000D+00
      ALPHA(11,0,34)=  0.0000000000000D+00
      ALPHA(12,0,34)=  0.0000000000000D+00
      ALPHA(13,0,34)=  0.0000000000000D+00
      ALPHA(14,0,34)=  0.0000000000000D+00
      ALPHA(15,0,34)=  0.0000000000000D+00
      ALPHA(16,0,34)=  0.0000000000000D+00
      ALPHA(17,0,34)=  0.0000000000000D+00
      ALPHA(18,0,34)=  0.0000000000000D+00
      ALPHA(19,0,34)=  0.0000000000000D+00
      ALPHA(20,0,34)=  0.0000000000000D+00
      ALPHA(21,0,34)=  0.0000000000000D+00
      ALPHA(22,0,34)=  0.0000000000000D+00
      ALPHA(23,0,34)=  0.0000000000000D+00
      ALPHA(24,0,34)=  0.0000000000000D+00
      ALPHA(25,0,34)=  0.0000000000000D+00
      ALPHA(26,0,34)=  0.0000000000000D+00
      ALPHA(27,0,34)=  0.0000000000000D+00
      ALPHA(28,0,34)=  0.0000000000000D+00
      ALPHA(29,0,34)=  0.0000000000000D+00
      ALPHA(30,0,34)=  0.0000000000000D+00
      ALPHA(31,0,34)=  0.0000000000000D+00
      ALPHA(32,0,34)=  0.0000000000000D+00
      ALPHA(33,0,34)=  0.0000000000000D+00
      ALPHA(34,0,34)=  1.0000000000000D+00
C l= 0 n=34 ; Coef  :
      COEF (   0,34)= -1.0000000000000D+00
C l= 1 n=34 ; Alpha :
      ALPHA( 1,1,34)=  1.0000000000000D+00
      ALPHA( 2,1,34)= 0.50000000000000D+00
      ALPHA( 3,1,34)= 0.33333333333333D+00
      ALPHA( 4,1,34)= 0.25000000000000D+00
      ALPHA( 5,1,34)= 0.20000000000000D+00
      ALPHA( 6,1,34)= 0.16666666666667D+00
      ALPHA( 7,1,34)= 0.14285714285714D+00
      ALPHA( 8,1,34)= 0.12500000000000D+00
      ALPHA( 9,1,34)= 0.11111111111111D+00
      ALPHA(10,1,34)= 0.10000000000000D+00
      ALPHA(11,1,34)= 0.90909090909091D-01
      ALPHA(12,1,34)= 0.83333333333333D-01
      ALPHA(13,1,34)= 0.76923076923077D-01
      ALPHA(14,1,34)= 0.71428571428571D-01
      ALPHA(15,1,34)= 0.66666666666667D-01
      ALPHA(16,1,34)= 0.62500000000000D-01
      ALPHA(17,1,34)= 0.58823529411765D-01
      ALPHA(18,1,34)= 0.55555555555556D-01
      ALPHA(19,1,34)= 0.52631578947368D-01
      ALPHA(20,1,34)= 0.50000000000000D-01
      ALPHA(21,1,34)= 0.47619047619048D-01
      ALPHA(22,1,34)= 0.45454545454545D-01
      ALPHA(23,1,34)= 0.43478260869565D-01
      ALPHA(24,1,34)= 0.41666666666667D-01
      ALPHA(25,1,34)= 0.40000000000000D-01
      ALPHA(26,1,34)= 0.38461538461538D-01
      ALPHA(27,1,34)= 0.37037037037037D-01
      ALPHA(28,1,34)= 0.35714285714286D-01
      ALPHA(29,1,34)= 0.34482758620690D-01
      ALPHA(30,1,34)= 0.33333333333333D-01
      ALPHA(31,1,34)= 0.32258064516129D-01
      ALPHA(32,1,34)= 0.31250000000000D-01
      ALPHA(33,1,34)= 0.30303030303030D-01
      ALPHA(34,1,34)= 0.29411764705882D-01
C l= 1 n=34 ; Coef  :
      COEF (   1,34)= -4.1182099904454D+00
C l= 2 n=34 ; Alpha :
      ALPHA( 1,2,34)=  4.1182099904454D+00
      ALPHA( 2,2,34)=  1.5591049952227D+00
      ALPHA( 3,2,34)= 0.87273666348181D+00
      ALPHA( 4,2,34)= 0.57121916427802D+00
      ALPHA( 5,2,34)= 0.40697533142242D+00
      ALPHA( 6,2,34)= 0.30581277618535D+00
      ALPHA( 7,2,34)= 0.23831571292078D+00
      ALPHA( 8,2,34)= 0.19066910594854D+00
      ALPHA( 9,2,34)= 0.15559476084314D+00
      ALPHA(10,2,34)= 0.12892417364772D+00
      ALPHA(11,2,34)= 0.10811288513429D+00
      ALPHA(12,2,34)= 0.91527720464007D-01
      ALPHA(13,2,34)= 0.78076870171904D-01
      ALPHA(14,2,34)= 0.67005445379406D-01
      ALPHA(15,2,34)= 0.57776510925540D-01
      ALPHA(16,2,34)= 0.49998812326027D-01
      ALPHA(17,2,34)= 0.43381235130379D-01
      ALPHA(18,2,34)= 0.37703192655815D-01
      ALPHA(19,2,34)= 0.32794837486796D-01
      ALPHA(20,2,34)= 0.28523516665088D-01
      ALPHA(21,2,34)= 0.24784301585798D-01
      ALPHA(22,2,34)= 0.21493240258305D-01
      ALPHA(23,2,34)= 0.18582466966442D-01
      ALPHA(24,2,34)= 0.15996603306608D-01
      ALPHA(25,2,34)= 0.13690072507677D-01
      ALPHA(26,2,34)= 0.11625069718920D-01
      ALPHA(27,2,34)= 0.97700101566810D-02
      ALPHA(28,2,34)= 0.80983298997625D-02
      ALPHA(29,2,34)= 0.65875500510022D-02
      ALPHA(30,2,34)= 0.52185397619458D-02
      ALPHA(31,2,34)= 0.39749309524207D-02
      ALPHA(32,2,34)= 0.28426498440285D-02
      ALPHA(33,2,34)= 0.18095392426943D-02
      ALPHA(34,2,34)= 0.86505190311419D-03
C l= 2 n=34 ; Coef  :
      COEF (   2,34)= -9.2878020568906D+00
C l= 3 n=34 ; Alpha :
      ALPHA( 1,3,34)=  9.2878020568906D+00
      ALPHA( 2,3,34)=  2.5847960332226D+00
      ALPHA( 3,3,34)=  1.2034956904075D+00
      ALPHA( 4,3,34)= 0.68443760193515D+00
      ALPHA( 5,3,34)= 0.43330624869252D+00
      ALPHA( 6,3,34)= 0.29325931867336D+00
      ALPHA( 7,3,34)= 0.20767759083640D+00
      ALPHA( 8,3,34)= 0.15192842786676D+00
      ALPHA( 9,3,34)= 0.11386203522061D+00
      ALPHA(10,3,34)= 0.86916355614237D-01
      ALPHA(11,3,34)= 0.67294489317695D-01
      ALPHA(12,3,34)= 0.52677208113363D-01
      ALPHA(13,3,34)= 0.41584521299720D-01
      ALPHA(14,3,34)= 0.33037279051746D-01
      ALPHA(15,3,34)= 0.26367764089670D-01
      ALPHA(16,3,34)= 0.21108746901219D-01
      ALPHA(17,3,34)= 0.16925949299616D-01
      ALPHA(18,3,34)= 0.13575550164617D-01
      ALPHA(19,3,34)= 0.10876668963541D-01
      ALPHA(20,3,34)= 0.86930936410243D-02
      ALPHA(21,3,34)= 0.69208741026380D-02
      ALPHA(22,3,34)= 0.54797297531637D-02
      ALPHA(23,3,34)= 0.43069919265781D-02
      ALPHA(24,3,34)= 0.33532644727023D-02
      ALPHA(25,3,34)= 0.25792697615299D-02
      ALPHA(26,3,34)= 0.19535258280988D-02
      ALPHA(27,3,34)= 0.14506148819129D-02
      ALPHA(28,3,34)= 0.10498782733917D-02
      ALPHA(29,3,34)= 0.73442281914503D-03
      ALPHA(30,3,34)= 0.49035705680679D-03
      ALPHA(31,3,34)= 0.30619909491154D-03
      ALPHA(32,3,34)= 0.17241378093241D-03
      ALPHA(33,3,34)= 0.81048216539652D-04
      ALPHA(34,3,34)= 0.25442703032770D-04
C l= 3 n=34 ; Coef  :
      COEF (   3,34)= -15.368526662873D+00
C l= 4 n=34 ; Alpha :
      ALPHA( 1,4,34)=  15.368526662873D+00
      ALPHA( 2,4,34)=  3.0403623029913D+00
      ALPHA( 3,4,34)=  1.1653095242534D+00
      ALPHA( 4,4,34)= 0.57310822058816D+00
      ALPHA( 5,4,34)= 0.32159905608350D+00
      ALPHA( 6,4,34)= 0.19578150528749D+00
      ALPHA( 7,4,34)= 0.12591853043594D+00
      ALPHA( 8,4,34)= 0.84219015276900D-01
      ALPHA( 9,4,34)= 0.57980410483160D-01
      ALPHA(10,4,34)= 0.40796165912783D-01
      ALPHA(11,4,34)= 0.29185936683054D-01
      ALPHA(12,4,34)= 0.21145901182992D-01
      ALPHA(13,4,34)= 0.15467200467887D-01
      ALPHA(14,4,34)= 0.11392077484487D-01
      ALPHA(15,4,34)= 0.84301203820714D-02
      ALPHA(16,4,34)= 0.62552526025875D-02
      ALPHA(17,4,34)= 0.46456055729519D-02
      ALPHA(18,4,34)= 0.34471858578092D-02
      ALPHA(19,4,34)= 0.25512523829447D-02
      ALPHA(20,4,34)= 0.18798563156204D-02
      ALPHA(21,4,34)= 0.13763825081611D-02
      ALPHA(22,4,34)= 0.99923448039753D-03
      ALPHA(23,4,34)= 0.71754038328617D-03
      ALPHA(24,4,34)= 0.50818487037516D-03
      ALPHA(25,4,34)= 0.35372689665206D-03
      ALPHA(26,4,34)= 0.24091933287583D-03
      ALPHA(27,4,34)= 0.15964358617307D-03
      ALPHA(28,4,34)= 0.10213435517000D-03
      ALPHA(29,4,34)= 0.62409781771317D-04
      ALPHA(30,4,34)= 0.35848695074105D-04
      ALPHA(31,4,34)= 0.18874315981173D-04
      ALPHA(32,4,34)= 0.87157718907759D-05
      ALPHA(33,4,34)= 0.32269975628007D-05
      ALPHA(34,4,34)= 0.74831479508148D-06
C l= 4 n=34 ; Coef  :
      COEF (   4,34)= -21.082589373408D+00
C l= 0 n=35 ; Alpha :
      ALPHA( 1,0,35)=  0.0000000000000D+00
      ALPHA( 2,0,35)=  0.0000000000000D+00
      ALPHA( 3,0,35)=  0.0000000000000D+00
      ALPHA( 4,0,35)=  0.0000000000000D+00
      ALPHA( 5,0,35)=  0.0000000000000D+00
      ALPHA( 6,0,35)=  0.0000000000000D+00
      ALPHA( 7,0,35)=  0.0000000000000D+00
      ALPHA( 8,0,35)=  0.0000000000000D+00
      ALPHA( 9,0,35)=  0.0000000000000D+00
      ALPHA(10,0,35)=  0.0000000000000D+00
      ALPHA(11,0,35)=  0.0000000000000D+00
      ALPHA(12,0,35)=  0.0000000000000D+00
      ALPHA(13,0,35)=  0.0000000000000D+00
      ALPHA(14,0,35)=  0.0000000000000D+00
      ALPHA(15,0,35)=  0.0000000000000D+00
      ALPHA(16,0,35)=  0.0000000000000D+00
      ALPHA(17,0,35)=  0.0000000000000D+00
      ALPHA(18,0,35)=  0.0000000000000D+00
      ALPHA(19,0,35)=  0.0000000000000D+00
      ALPHA(20,0,35)=  0.0000000000000D+00
      ALPHA(21,0,35)=  0.0000000000000D+00
      ALPHA(22,0,35)=  0.0000000000000D+00
      ALPHA(23,0,35)=  0.0000000000000D+00
      ALPHA(24,0,35)=  0.0000000000000D+00
      ALPHA(25,0,35)=  0.0000000000000D+00
      ALPHA(26,0,35)=  0.0000000000000D+00
      ALPHA(27,0,35)=  0.0000000000000D+00
      ALPHA(28,0,35)=  0.0000000000000D+00
      ALPHA(29,0,35)=  0.0000000000000D+00
      ALPHA(30,0,35)=  0.0000000000000D+00
      ALPHA(31,0,35)=  0.0000000000000D+00
      ALPHA(32,0,35)=  0.0000000000000D+00
      ALPHA(33,0,35)=  0.0000000000000D+00
      ALPHA(34,0,35)=  0.0000000000000D+00
      ALPHA(35,0,35)=  1.0000000000000D+00
C l= 0 n=35 ; Coef  :
      COEF (   0,35)= -1.0000000000000D+00
C l= 1 n=35 ; Alpha :
      ALPHA( 1,1,35)=  1.0000000000000D+00
      ALPHA( 2,1,35)= 0.50000000000000D+00
      ALPHA( 3,1,35)= 0.33333333333333D+00
      ALPHA( 4,1,35)= 0.25000000000000D+00
      ALPHA( 5,1,35)= 0.20000000000000D+00
      ALPHA( 6,1,35)= 0.16666666666667D+00
      ALPHA( 7,1,35)= 0.14285714285714D+00
      ALPHA( 8,1,35)= 0.12500000000000D+00
      ALPHA( 9,1,35)= 0.11111111111111D+00
      ALPHA(10,1,35)= 0.10000000000000D+00
      ALPHA(11,1,35)= 0.90909090909091D-01
      ALPHA(12,1,35)= 0.83333333333333D-01
      ALPHA(13,1,35)= 0.76923076923077D-01
      ALPHA(14,1,35)= 0.71428571428571D-01
      ALPHA(15,1,35)= 0.66666666666667D-01
      ALPHA(16,1,35)= 0.62500000000000D-01
      ALPHA(17,1,35)= 0.58823529411765D-01
      ALPHA(18,1,35)= 0.55555555555556D-01
      ALPHA(19,1,35)= 0.52631578947368D-01
      ALPHA(20,1,35)= 0.50000000000000D-01
      ALPHA(21,1,35)= 0.47619047619048D-01
      ALPHA(22,1,35)= 0.45454545454545D-01
      ALPHA(23,1,35)= 0.43478260869565D-01
      ALPHA(24,1,35)= 0.41666666666667D-01
      ALPHA(25,1,35)= 0.40000000000000D-01
      ALPHA(26,1,35)= 0.38461538461538D-01
      ALPHA(27,1,35)= 0.37037037037037D-01
      ALPHA(28,1,35)= 0.35714285714286D-01
      ALPHA(29,1,35)= 0.34482758620690D-01
      ALPHA(30,1,35)= 0.33333333333333D-01
      ALPHA(31,1,35)= 0.32258064516129D-01
      ALPHA(32,1,35)= 0.31250000000000D-01
      ALPHA(33,1,35)= 0.30303030303030D-01
      ALPHA(34,1,35)= 0.29411764705882D-01
      ALPHA(35,1,35)= 0.28571428571429D-01
C l= 1 n=35 ; Coef  :
      COEF (   1,35)= -4.1467814190169D+00
C l= 2 n=35 ; Alpha :
      ALPHA( 1,2,35)=  4.1467814190169D+00
      ALPHA( 2,2,35)=  1.5733907095084D+00
      ALPHA( 3,2,35)= 0.88226047300562D+00
      ALPHA( 4,2,35)= 0.57836202142088D+00
      ALPHA( 5,2,35)= 0.41268961713671D+00
      ALPHA( 6,2,35)= 0.31057468094725D+00
      ALPHA( 7,2,35)= 0.24239734557384D+00
      ALPHA( 8,2,35)= 0.19424053451996D+00
      ALPHA( 9,2,35)= 0.15876936401775D+00
      ALPHA(10,2,35)= 0.13178131650486D+00
      ALPHA(11,2,35)= 0.11071028773169D+00
      ALPHA(12,2,35)= 0.93908672844960D-01
      ALPHA(13,2,35)= 0.80274672369706D-01
      ALPHA(14,2,35)= 0.69046261705936D-01
      ALPHA(15,2,35)= 0.59681272830302D-01
      ALPHA(16,2,35)= 0.51784526611742D-01
      ALPHA(17,2,35)= 0.45061907399286D-01
      ALPHA(18,2,35)= 0.39290494243117D-01
      ALPHA(19,2,35)= 0.34298596885292D-01
      ALPHA(20,2,35)= 0.29952088093659D-01
      ALPHA(21,2,35)= 0.26144845803485D-01
      ALPHA(22,2,35)= 0.22791941557006D-01
      ALPHA(23,2,35)= 0.19824702991286D-01
      ALPHA(24,2,35)= 0.17187079497084D-01
      ALPHA(25,2,35)= 0.14832929650534D-01
      ALPHA(26,2,35)= 0.12723970817821D-01
      ALPHA(27,2,35)= 0.10828211214882D-01
      ALPHA(28,2,35)= 0.91187380630278D-02
      ALPHA(29,2,35)= 0.75727717258791D-02
      ALPHA(30,2,35)= 0.61709207143268D-02
      ALPHA(31,2,35)= 0.48965899385958D-02
      ALPHA(32,2,35)= 0.37355069868857D-02
      ALPHA(33,2,35)= 0.26753401084952D-02
      ALPHA(34,2,35)= 0.17053880375680D-02
      ALPHA(35,2,35)= 0.81632653061224D-03
C l= 2 n=35 ; Coef  :
      COEF (   2,35)= -9.4062815260053D+00
C l= 3 n=35 ; Alpha :
      ALPHA( 1,3,35)=  9.4062815260053D+00
      ALPHA( 2,3,35)=  2.6297500534942D+00
      ALPHA( 3,3,35)=  1.2287031324934D+00
      ALPHA( 4,3,35)= 0.70096223111861D+00
      ALPHA( 5,3,35)= 0.44509738061071D+00
      ALPHA( 6,3,35)= 0.30213288098614D+00
      ALPHA( 7,3,35)= 0.21460322928137D+00
      ALPHA( 8,3,35)= 0.15747815742447D+00
      ALPHA( 9,3,35)= 0.11839830276398D+00
      ALPHA(10,3,35)= 0.90681536085804D-01
      ALPHA(11,3,35)= 0.70457640395744D-01
      ALPHA(12,3,35)= 0.55360313051791D-01
      ALPHA(13,3,35)= 0.43878083367425D-01
      ALPHA(14,3,35)= 0.35010029386202D-01
      ALPHA(15,3,35)= 0.28072943313393D-01
      ALPHA(16,3,35)= 0.22588304804412D-01
      ALPHA(17,3,35)= 0.18213432368167D-01
      ALPHA(18,3,35)= 0.14698135714420D-01
      ALPHA(19,3,35)= 0.11856628874549D-01
      ALPHA(20,3,35)= 0.95488675865574D-02
      ALPHA(21,3,35)= 0.76678696970233D-02
      ALPHA(22,3,35)= 0.61309280833639D-02
      ALPHA(23,3,35)= 0.48734120120434D-02
      ALPHA(24,3,35)= 0.38443238869047D-02
      ALPHA(25,3,35)= 0.30030677515451D-02
      ALPHA(26,3,35)= 0.23170678514652D-02
      ALPHA(27,3,35)= 0.17599923451953D-02
      ALPHA(28,3,35)= 0.13104136466211D-02
      ALPHA(29,3,35)= 0.95078772559872D-03
      ALPHA(30,3,35)= 0.66666907721612D-03
      ALPHA(31,3,35)= 0.44610166458571D-03
      ALPHA(32,3,35)= 0.27914255198628D-03
      ALPHA(33,3,35)= 0.15748650535380D-03
      ALPHA(34,3,35)= 0.74168075534712D-04
      ALPHA(35,3,35)= 0.23323615160350D-04
C l= 3 n=35 ; Coef  :
      COEF (   3,35)= -15.637277563616D+00
C l= 4 n=35 ; Alpha :
      ALPHA( 1,4,35)=  15.637277563616D+00
      ALPHA( 2,4,35)=  3.1154980188055D+00
      ALPHA( 3,4,35)=  1.2004153280389D+00
      ALPHA( 4,4,35)= 0.59313571290583D+00
      ALPHA( 5,4,35)= 0.33431612410095D+00
      ALPHA( 6,4,35)= 0.20441387331567D+00
      ALPHA( 7,4,35)= 0.13205005127255D+00
      ALPHA( 8,4,35)= 0.88718391203313D-01
      ALPHA( 9,4,35)= 0.61363219133560D-01
      ALPHA(10,4,35)= 0.43387066943806D-01
      ALPHA(11,4,35)= 0.31199012122932D-01
      ALPHA(12,4,35)= 0.22727624413043D-01
      ALPHA(13,4,35)= 0.16720859992671D-01
      ALPHA(14,4,35)= 0.12392364038378D-01
      ALPHA(15,4,35)= 0.92322044767397D-02
      ALPHA(16,4,35)= 0.69006327398565D-02
      ALPHA(17,4,35)= 0.51659893548995D-02
      ALPHA(18,4,35)= 0.38671325925069D-02
      ALPHA(19,4,35)= 0.28900132079318D-02
      ALPHA(20,4,35)= 0.21526811038078D-02
      ALPHA(21,4,35)= 0.15954644995046D-02
      ALPHA(22,4,35)= 0.11744038542079D-02
      ALPHA(23,4,35)= 0.85678072648741D-03
      ALPHA(24,4,35)= 0.61802269571529D-03
      ALPHA(25,4,35)= 0.43952883241049D-03
      ALPHA(26,4,35)= 0.30712127148912D-03
      ALPHA(27,4,35)= 0.20992908175008D-03
      ALPHA(28,4,35)= 0.13957474507346D-03
      ALPHA(29,4,35)= 0.89575145359851D-04
      ALPHA(30,4,35)= 0.54896382994566D-04
      ALPHA(31,4,35)= 0.31620077826479D-04
      ALPHA(32,4,35)= 0.16691273376098D-04
      ALPHA(33,4,35)= 0.77266120014807D-05
      ALPHA(34,4,35)= 0.28674026675018D-05
      ALPHA(35,4,35)= 0.66638900458142D-06
C l= 4 n=35 ; Coef  :
      COEF (   4,35)= -21.529368732369D+00
C l= 0 n=36 ; Alpha :
      ALPHA( 1,0,36)=  0.0000000000000D+00
      ALPHA( 2,0,36)=  0.0000000000000D+00
      ALPHA( 3,0,36)=  0.0000000000000D+00
      ALPHA( 4,0,36)=  0.0000000000000D+00
      ALPHA( 5,0,36)=  0.0000000000000D+00
      ALPHA( 6,0,36)=  0.0000000000000D+00
      ALPHA( 7,0,36)=  0.0000000000000D+00
      ALPHA( 8,0,36)=  0.0000000000000D+00
      ALPHA( 9,0,36)=  0.0000000000000D+00
      ALPHA(10,0,36)=  0.0000000000000D+00
      ALPHA(11,0,36)=  0.0000000000000D+00
      ALPHA(12,0,36)=  0.0000000000000D+00
      ALPHA(13,0,36)=  0.0000000000000D+00
      ALPHA(14,0,36)=  0.0000000000000D+00
      ALPHA(15,0,36)=  0.0000000000000D+00
      ALPHA(16,0,36)=  0.0000000000000D+00
      ALPHA(17,0,36)=  0.0000000000000D+00
      ALPHA(18,0,36)=  0.0000000000000D+00
      ALPHA(19,0,36)=  0.0000000000000D+00
      ALPHA(20,0,36)=  0.0000000000000D+00
      ALPHA(21,0,36)=  0.0000000000000D+00
      ALPHA(22,0,36)=  0.0000000000000D+00
      ALPHA(23,0,36)=  0.0000000000000D+00
      ALPHA(24,0,36)=  0.0000000000000D+00
      ALPHA(25,0,36)=  0.0000000000000D+00
      ALPHA(26,0,36)=  0.0000000000000D+00
      ALPHA(27,0,36)=  0.0000000000000D+00
      ALPHA(28,0,36)=  0.0000000000000D+00
      ALPHA(29,0,36)=  0.0000000000000D+00
      ALPHA(30,0,36)=  0.0000000000000D+00
      ALPHA(31,0,36)=  0.0000000000000D+00
      ALPHA(32,0,36)=  0.0000000000000D+00
      ALPHA(33,0,36)=  0.0000000000000D+00
      ALPHA(34,0,36)=  0.0000000000000D+00
      ALPHA(35,0,36)=  0.0000000000000D+00
      ALPHA(36,0,36)=  1.0000000000000D+00
C l= 0 n=36 ; Coef  :
      COEF (   0,36)= -1.0000000000000D+00
C l= 1 n=36 ; Alpha :
      ALPHA( 1,1,36)=  1.0000000000000D+00
      ALPHA( 2,1,36)= 0.50000000000000D+00
      ALPHA( 3,1,36)= 0.33333333333333D+00
      ALPHA( 4,1,36)= 0.25000000000000D+00
      ALPHA( 5,1,36)= 0.20000000000000D+00
      ALPHA( 6,1,36)= 0.16666666666667D+00
      ALPHA( 7,1,36)= 0.14285714285714D+00
      ALPHA( 8,1,36)= 0.12500000000000D+00
      ALPHA( 9,1,36)= 0.11111111111111D+00
      ALPHA(10,1,36)= 0.10000000000000D+00
      ALPHA(11,1,36)= 0.90909090909091D-01
      ALPHA(12,1,36)= 0.83333333333333D-01
      ALPHA(13,1,36)= 0.76923076923077D-01
      ALPHA(14,1,36)= 0.71428571428571D-01
      ALPHA(15,1,36)= 0.66666666666667D-01
      ALPHA(16,1,36)= 0.62500000000000D-01
      ALPHA(17,1,36)= 0.58823529411765D-01
      ALPHA(18,1,36)= 0.55555555555556D-01
      ALPHA(19,1,36)= 0.52631578947368D-01
      ALPHA(20,1,36)= 0.50000000000000D-01
      ALPHA(21,1,36)= 0.47619047619048D-01
      ALPHA(22,1,36)= 0.45454545454545D-01
      ALPHA(23,1,36)= 0.43478260869565D-01
      ALPHA(24,1,36)= 0.41666666666667D-01
      ALPHA(25,1,36)= 0.40000000000000D-01
      ALPHA(26,1,36)= 0.38461538461538D-01
      ALPHA(27,1,36)= 0.37037037037037D-01
      ALPHA(28,1,36)= 0.35714285714286D-01
      ALPHA(29,1,36)= 0.34482758620690D-01
      ALPHA(30,1,36)= 0.33333333333333D-01
      ALPHA(31,1,36)= 0.32258064516129D-01
      ALPHA(32,1,36)= 0.31250000000000D-01
      ALPHA(33,1,36)= 0.30303030303030D-01
      ALPHA(34,1,36)= 0.29411764705882D-01
      ALPHA(35,1,36)= 0.28571428571429D-01
      ALPHA(36,1,36)= 0.27777777777778D-01
C l= 1 n=36 ; Coef  :
      COEF (   1,36)= -4.1745591967946D+00
C l= 2 n=36 ; Alpha :
      ALPHA( 1,2,36)=  4.1745591967946D+00
      ALPHA( 2,2,36)=  1.5872795983973D+00
      ALPHA( 3,2,36)= 0.89151973226488D+00
      ALPHA( 4,2,36)= 0.58530646586533D+00
      ALPHA( 5,2,36)= 0.41824517269226D+00
      ALPHA( 6,2,36)= 0.31520431057688D+00
      ALPHA( 7,2,36)= 0.24636559954209D+00
      ALPHA( 8,2,36)= 0.19771275674219D+00
      ALPHA( 9,2,36)= 0.16185578377083D+00
      ALPHA(10,2,36)= 0.13455909428264D+00
      ALPHA(11,2,36)= 0.11323554025694D+00
      ALPHA(12,2,36)= 0.96223487659775D-01
      ALPHA(13,2,36)= 0.82411424506459D-01
      ALPHA(14,2,36)= 0.71030388690063D-01
      ALPHA(15,2,36)= 0.61533124682154D-01
      ALPHA(16,2,36)= 0.53520637722853D-01
      ALPHA(17,2,36)= 0.46695894327391D-01
      ALPHA(18,2,36)= 0.40833704119660D-01
      ALPHA(19,2,36)= 0.35760585189386D-01
      ALPHA(20,2,36)= 0.31340976982548D-01
      ALPHA(21,2,36)= 0.27467597126236D-01
      ALPHA(22,2,36)= 0.24054567819632D-01
      ALPHA(23,2,36)= 0.21032432459885D-01
      ALPHA(24,2,36)= 0.18344486904492D-01
      ALPHA(25,2,36)= 0.15944040761645D-01
      ALPHA(26,2,36)= 0.13792346886197D-01
      ALPHA(27,2,36)= 0.11857017799244D-01
      ALPHA(28,2,36)= 0.10110801555091D-01
      ALPHA(29,2,36)= 0.85306261320093D-02
      ALPHA(30,2,36)= 0.70968466402527D-02
      ALPHA(31,2,36)= 0.57926472862661D-02
      ALPHA(32,2,36)= 0.46035625424412D-02
      ALPHA(33,2,36)= 0.35170909502460D-02
      ALPHA(34,2,36)= 0.25223815016203D-02
      ALPHA(35,2,36)= 0.16099773242630D-02
      ALPHA(36,2,36)= 0.77160493827160D-03
C l= 2 n=36 ; Coef  :
      COEF (   2,36)= -9.5222415036941D+00
C l= 3 n=36 ; Alpha :
      ALPHA( 1,3,36)=  9.5222415036941D+00
      ALPHA( 2,3,36)=  2.6738411534497D+00
      ALPHA( 3,3,36)=  1.2534675695007D+00
      ALPHA( 4,3,36)= 0.71722074405931D+00
      ALPHA( 5,3,36)= 0.45671530207438D+00
      ALPHA( 6,3,36)= 0.31088855627994D+00
      ALPHA( 7,3,36)= 0.22144671815754D+00
      ALPHA( 8,3,36)= 0.16297017844509D+00
      ALPHA( 9,3,36)= 0.12289429675761D+00
      ALPHA(10,3,36)= 0.94419288704766D-01
      ALPHA(11,3,36)= 0.73603072069548D-01
      ALPHA(12,3,36)= 0.58033187709007D-01
      ALPHA(13,3,36)= 0.46167289603716D-01
      ALPHA(14,3,36)= 0.36983095738703D-01
      ALPHA(15,3,36)= 0.29782196776786D-01
      ALPHA(16,3,36)= 0.24074989185602D-01
      ALPHA(17,3,36)= 0.19510540543928D-01
      ALPHA(18,3,36)= 0.15832405273299D-01
      ALPHA(19,3,36)= 0.12849978463144D-01
      ALPHA(20,3,36)= 0.10419450280517D-01
      ALPHA(21,3,36)= 0.84308585060854D-02
      ALPHA(22,3,36)= 0.67991105227981D-02
      ALPHA(23,3,36)= 0.54576462470402D-02
      ALPHA(24,3,36)= 0.43538929675850D-02
      ALPHA(25,3,36)= 0.34459577727019D-02
      ALPHA(26,3,36)= 0.27001885983040D-02
      ALPHA(27,3,36)= 0.20893539507298D-02
      ALPHA(28,3,36)= 0.15912692453736D-02
      ALPHA(29,3,36)= 0.11877495625990D-02
      ALPHA(30,3,36)= 0.86380370611203D-03
      ALPHA(31,3,36)= 0.60700853364865D-03
      ALPHA(32,3,36)= 0.40701928927632D-03
      ALPHA(33,3,36)= 0.25518347619397D-03
      ALPHA(34,3,36)= 0.14423422835750D-03
      ALPHA(35,3,36)= 0.68045207500990D-04
      ALPHA(36,3,36)= 0.21433470507545D-04
C l= 3 n=36 ; Coef  :
      COEF (   3,36)= -15.901784272052D+00
C l= 4 n=36 ; Alpha :
      ALPHA( 1,4,36)=  15.901784272052D+00
      ALPHA( 2,4,36)=  3.1897713841791D+00
      ALPHA( 3,4,36)=  1.2352338716361D+00
      ALPHA( 4,4,36)= 0.61305851135193D+00
      ALPHA( 5,4,36)= 0.34700266026968D+00
      ALPHA( 6,4,36)= 0.21304966654567D+00
      ALPHA( 7,4,36)= 0.13820134899915D+00
      ALPHA( 8,4,36)= 0.93245340604566D-01
      ALPHA( 9,4,36)= 0.64776949599049D-01
      ALPHA(10,4,36)= 0.46009824963383D-01
      ALPHA(11,4,36)= 0.33243541902642D-01
      ALPHA(12,4,36)= 0.24339657404960D-01
      ALPHA(13,4,36)= 0.18003284703885D-01
      ALPHA(14,4,36)= 0.13419672253342D-01
      ALPHA(15,4,36)= 0.10059487720539D-01
      ALPHA(16,4,36)= 0.75693824394565D-02
      ALPHA(17,4,36)= 0.57079488144531D-02
      ALPHA(18,4,36)= 0.43069216278763D-02
      ALPHA(19,4,36)= 0.32469570541302D-02
      ALPHA(20,4,36)= 0.24421102782666D-02
      ALPHA(21,4,36)= 0.18296550135626D-02
      ALPHA(22,4,36)= 0.13632680353968D-02
      ALPHA(23,4,36)= 0.10083820111274D-02
      ALPHA(24,4,36)= 0.73896416703710D-03
      ALPHA(25,4,36)= 0.53524988165221D-03
      ALPHA(26,4,36)= 0.38212651033090D-03
      ALPHA(27,4,36)= 0.26796669149257D-03
      ALPHA(28,4,36)= 0.18377666855606D-03
      ALPHA(29,4,36)= 0.12256818876538D-03
      ALPHA(30,4,36)= 0.78890930386567D-04
      ALPHA(31,4,36)= 0.48481425983386D-04
      ALPHA(32,4,36)= 0.27997364744885D-04
      ALPHA(33,4,36)= 0.14815041895758D-04
      ALPHA(34,4,36)= 0.68739090107656D-05
      ALPHA(35,4,36)= 0.25565336573867D-05
      ALPHA(36,4,36)= 0.59537418076513D-06
C l= 4 n=36 ; Coef  :
      COEF (   4,36)= -21.971084962148D+00
C l= 0 n=37 ; Alpha :
      ALPHA( 1,0,37)=  0.0000000000000D+00
      ALPHA( 2,0,37)=  0.0000000000000D+00
      ALPHA( 3,0,37)=  0.0000000000000D+00
      ALPHA( 4,0,37)=  0.0000000000000D+00
      ALPHA( 5,0,37)=  0.0000000000000D+00
      ALPHA( 6,0,37)=  0.0000000000000D+00
      ALPHA( 7,0,37)=  0.0000000000000D+00
      ALPHA( 8,0,37)=  0.0000000000000D+00
      ALPHA( 9,0,37)=  0.0000000000000D+00
      ALPHA(10,0,37)=  0.0000000000000D+00
      ALPHA(11,0,37)=  0.0000000000000D+00
      ALPHA(12,0,37)=  0.0000000000000D+00
      ALPHA(13,0,37)=  0.0000000000000D+00
      ALPHA(14,0,37)=  0.0000000000000D+00
      ALPHA(15,0,37)=  0.0000000000000D+00
      ALPHA(16,0,37)=  0.0000000000000D+00
      ALPHA(17,0,37)=  0.0000000000000D+00
      ALPHA(18,0,37)=  0.0000000000000D+00
      ALPHA(19,0,37)=  0.0000000000000D+00
      ALPHA(20,0,37)=  0.0000000000000D+00
      ALPHA(21,0,37)=  0.0000000000000D+00
      ALPHA(22,0,37)=  0.0000000000000D+00
      ALPHA(23,0,37)=  0.0000000000000D+00
      ALPHA(24,0,37)=  0.0000000000000D+00
      ALPHA(25,0,37)=  0.0000000000000D+00
      ALPHA(26,0,37)=  0.0000000000000D+00
      ALPHA(27,0,37)=  0.0000000000000D+00
      ALPHA(28,0,37)=  0.0000000000000D+00
      ALPHA(29,0,37)=  0.0000000000000D+00
      ALPHA(30,0,37)=  0.0000000000000D+00
      ALPHA(31,0,37)=  0.0000000000000D+00
      ALPHA(32,0,37)=  0.0000000000000D+00
      ALPHA(33,0,37)=  0.0000000000000D+00
      ALPHA(34,0,37)=  0.0000000000000D+00
      ALPHA(35,0,37)=  0.0000000000000D+00
      ALPHA(36,0,37)=  0.0000000000000D+00
      ALPHA(37,0,37)=  1.0000000000000D+00
C l= 0 n=37 ; Coef  :
      COEF (   0,37)= -1.0000000000000D+00
C l= 1 n=37 ; Alpha :
      ALPHA( 1,1,37)=  1.0000000000000D+00
      ALPHA( 2,1,37)= 0.50000000000000D+00
      ALPHA( 3,1,37)= 0.33333333333333D+00
      ALPHA( 4,1,37)= 0.25000000000000D+00
      ALPHA( 5,1,37)= 0.20000000000000D+00
      ALPHA( 6,1,37)= 0.16666666666667D+00
      ALPHA( 7,1,37)= 0.14285714285714D+00
      ALPHA( 8,1,37)= 0.12500000000000D+00
      ALPHA( 9,1,37)= 0.11111111111111D+00
      ALPHA(10,1,37)= 0.10000000000000D+00
      ALPHA(11,1,37)= 0.90909090909091D-01
      ALPHA(12,1,37)= 0.83333333333333D-01
      ALPHA(13,1,37)= 0.76923076923077D-01
      ALPHA(14,1,37)= 0.71428571428571D-01
      ALPHA(15,1,37)= 0.66666666666667D-01
      ALPHA(16,1,37)= 0.62500000000000D-01
      ALPHA(17,1,37)= 0.58823529411765D-01
      ALPHA(18,1,37)= 0.55555555555556D-01
      ALPHA(19,1,37)= 0.52631578947368D-01
      ALPHA(20,1,37)= 0.50000000000000D-01
      ALPHA(21,1,37)= 0.47619047619048D-01
      ALPHA(22,1,37)= 0.45454545454545D-01
      ALPHA(23,1,37)= 0.43478260869565D-01
      ALPHA(24,1,37)= 0.41666666666667D-01
      ALPHA(25,1,37)= 0.40000000000000D-01
      ALPHA(26,1,37)= 0.38461538461538D-01
      ALPHA(27,1,37)= 0.37037037037037D-01
      ALPHA(28,1,37)= 0.35714285714286D-01
      ALPHA(29,1,37)= 0.34482758620690D-01
      ALPHA(30,1,37)= 0.33333333333333D-01
      ALPHA(31,1,37)= 0.32258064516129D-01
      ALPHA(32,1,37)= 0.31250000000000D-01
      ALPHA(33,1,37)= 0.30303030303030D-01
      ALPHA(34,1,37)= 0.29411764705882D-01
      ALPHA(35,1,37)= 0.28571428571429D-01
      ALPHA(36,1,37)= 0.27777777777778D-01
      ALPHA(37,1,37)= 0.27027027027027D-01
C l= 1 n=37 ; Coef  :
      COEF (   1,37)= -4.2015862238217D+00
C l= 2 n=37 ; Alpha :
      ALPHA( 1,2,37)=  4.2015862238217D+00
      ALPHA( 2,2,37)=  1.6007931119108D+00
      ALPHA( 3,2,37)= 0.90052874127389D+00
      ALPHA( 4,2,37)= 0.59206322262208D+00
      ALPHA( 5,2,37)= 0.42365057809767D+00
      ALPHA( 6,2,37)= 0.31970881508139D+00
      ALPHA( 7,2,37)= 0.25022660340310D+00
      ALPHA( 8,2,37)= 0.20109113512057D+00
      ALPHA( 9,2,37)= 0.16485878677384D+00
      ALPHA(10,2,37)= 0.13726179698534D+00
      ALPHA(11,2,37)= 0.11569254271395D+00
      ALPHA(12,2,37)= 0.98475739912027D-01
      ALPHA(13,2,37)= 0.84490426585461D-01
      ALPHA(14,2,37)= 0.72960890620565D-01
      ALPHA(15,2,37)= 0.63334926483956D-01
      ALPHA(16,2,37)= 0.55209826912042D-01
      ALPHA(17,2,37)= 0.48285719446628D-01
      ALPHA(18,2,37)= 0.42335205621162D-01
      ALPHA(19,2,37)= 0.37183060296071D-01
      ALPHA(20,2,37)= 0.32692328333899D-01
      ALPHA(21,2,37)= 0.28754598413237D-01
      ALPHA(22,2,37)= 0.25283069048133D-01
      ALPHA(23,2,37)= 0.22207520591495D-01
      ALPHA(24,2,37)= 0.19470613030618D-01
      ALPHA(25,2,37)= 0.17025121842726D-01
      ALPHA(26,2,37)= 0.14831847925698D-01
      ALPHA(27,2,37)= 0.12858018800245D-01
      ALPHA(28,2,37)= 0.11076052520342D-01
      ALPHA(29,2,37)= 0.94625925812172D-02
      ALPHA(30,2,37)= 0.79977475411536D-02
      ALPHA(31,2,37)= 0.66644868677831D-02
      ALPHA(32,2,37)= 0.54481571370358D-02
      ALPHA(33,2,37)= 0.43360917692468D-02
      ALPHA(34,2,37)= 0.33172940612387D-02
      ALPHA(35,2,37)= 0.23821780964638D-02
      ALPHA(36,2,37)= 0.15223556890224D-02
      ALPHA(37,2,37)= 0.73046018991965D-03
C l= 2 n=37 ; Coef  :
      COEF (   2,37)= -9.6357978881217D+00
C l= 3 n=37 ; Alpha :
      ALPHA( 1,3,37)=  9.6357978881217D+00
      ALPHA( 2,3,37)=  2.7171058321500D+00
      ALPHA( 3,3,37)=  1.2778061841297D+00
      ALPHA( 4,3,37)= 0.73322245277883D+00
      ALPHA( 5,3,37)= 0.46816531769865D+00
      ALPHA( 6,3,37)= 0.31952933506593D+00
      ALPHA( 7,3,37)= 0.22820959933060D+00
      ALPHA( 8,3,37)= 0.16840507398888D+00
      ALPHA( 9,3,37)= 0.12734993964339D+00
      ALPHA(10,3,37)= 0.98129067001668D-01
      ALPHA(11,3,37)= 0.76729897548303D-01
      ALPHA(12,3,37)= 0.60694694193116D-01
      ALPHA(13,3,37)= 0.48450814646566D-01
      ALPHA(14,3,37)= 0.38955011701421D-01
      ALPHA(15,3,37)= 0.31493951546622D-01
      ALPHA(16,3,37)= 0.25567146669711D-01
      ALPHA(17,3,37)= 0.20815559988432D-01
      ALPHA(18,3,37)= 0.16976600019817D-01
      ALPHA(19,3,37)= 0.13854926038713D-01
      ALPHA(20,3,37)= 0.11303026721974D-01
      ALPHA(21,3,37)= 0.92080098145513D-02
      ALPHA(22,3,37)= 0.74824367132882D-02
      ALPHA(23,3,37)= 0.60578495062698D-02
      ALPHA(24,3,37)= 0.48801257521963D-02
      ALPHA(25,3,37)= 0.39060962008837D-02
      ALPHA(26,3,37)= 0.31010493530526D-02
      ALPHA(27,3,37)= 0.24368679723581D-02
      ALPHA(28,3,37)= 0.18906220161937D-02
      ALPHA(29,3,37)= 0.14434953080373D-02
      ALPHA(30,3,37)= 0.10799590450621D-02
      ALPHA(31,3,37)= 0.78712980034549D-03
      ALPHA(32,3,37)= 0.55426677946647D-03
      ALPHA(33,3,37)= 0.37237514563307D-03
      ALPHA(34,3,37)= 0.23389082460719D-03
      ALPHA(35,3,37)= 0.13242839929731D-03
      ALPHA(36,3,37)= 0.62578218859500D-04
      ALPHA(37,3,37)= 0.19742167295126D-04
C l= 3 n=37 ; Coef  :
      COEF (   3,37)= -16.162211242001D+00
C l= 4 n=37 ; Alpha :
      ALPHA( 1,4,37)=  16.162211242001D+00
      ALPHA( 2,4,37)=  3.2632066769399D+00
      ALPHA( 3,4,37)=  1.2697691739099D+00
      ALPHA( 4,4,37)= 0.63287533440000D+00
      ALPHA( 5,4,37)= 0.35965577696424D+00
      ALPHA( 6,4,37)= 0.22168559452042D+00
      ALPHA( 7,4,37)= 0.14436917600809D+00
      ALPHA( 8,4,37)= 0.97796829090752D-01
      ALPHA( 9,4,37)= 0.68218839859681D-01
      ALPHA(10,4,37)= 0.48661961909374D-01
      ALPHA(11,4,37)= 0.35317322917461D-01
      ALPHA(12,4,37)= 0.25980054545314D-01
      ALPHA(13,4,37)= 0.19312766180820D-01
      ALPHA(14,4,37)= 0.14472510407435D-01
      ALPHA(15,4,37)= 0.10910675600178D-01
      ALPHA(16,4,37)= 0.82603864035028D-02
      ALPHA(17,4,37)= 0.62705315168431D-02
      ALPHA(18,4,37)= 0.47657486554390D-02
      ALPHA(19,4,37)= 0.36214145146360D-02
      ALPHA(20,4,37)= 0.27475974869686D-02
      ALPHA(21,4,37)= 0.20785201436856D-02
      ALPHA(22,4,37)= 0.15654960546748D-02
      ALPHA(23,4,37)= 0.11721076734590D-02
      ALPHA(24,4,37)= 0.87085945763700D-03
      ALPHA(25,4,37)= 0.64082004924367D-03
      ALPHA(26,4,37)= 0.46593865500800D-03
      ALPHA(27,4,37)= 0.33382798804279D-03
      ALPHA(28,4,37)= 0.23487456088562D-03
      ALPHA(29,4,37)= 0.16158157546909D-03
      ALPHA(30,4,37)= 0.10807901268554D-03
      ALPHA(31,4,37)= 0.69755204371102D-04
      ALPHA(32,4,37)= 0.42977547973709D-04
      ALPHA(33,4,37)= 0.24879235020976D-04
      ALPHA(34,4,37)= 0.13195282648798D-04
      ALPHA(35,4,37)= 0.61356795843410D-05
      ALPHA(36,4,37)= 0.22866773931840D-05
      ALPHA(37,4,37)= 0.53357208905745D-06
C l= 4 n=37 ; Coef  :
      COEF (   4,37)= -22.407901482202D+00
C l= 0 n=38 ; Alpha :
      ALPHA( 1,0,38)=  0.0000000000000D+00
      ALPHA( 2,0,38)=  0.0000000000000D+00
      ALPHA( 3,0,38)=  0.0000000000000D+00
      ALPHA( 4,0,38)=  0.0000000000000D+00
      ALPHA( 5,0,38)=  0.0000000000000D+00
      ALPHA( 6,0,38)=  0.0000000000000D+00
      ALPHA( 7,0,38)=  0.0000000000000D+00
      ALPHA( 8,0,38)=  0.0000000000000D+00
      ALPHA( 9,0,38)=  0.0000000000000D+00
      ALPHA(10,0,38)=  0.0000000000000D+00
      ALPHA(11,0,38)=  0.0000000000000D+00
      ALPHA(12,0,38)=  0.0000000000000D+00
      ALPHA(13,0,38)=  0.0000000000000D+00
      ALPHA(14,0,38)=  0.0000000000000D+00
      ALPHA(15,0,38)=  0.0000000000000D+00
      ALPHA(16,0,38)=  0.0000000000000D+00
      ALPHA(17,0,38)=  0.0000000000000D+00
      ALPHA(18,0,38)=  0.0000000000000D+00
      ALPHA(19,0,38)=  0.0000000000000D+00
      ALPHA(20,0,38)=  0.0000000000000D+00
      ALPHA(21,0,38)=  0.0000000000000D+00
      ALPHA(22,0,38)=  0.0000000000000D+00
      ALPHA(23,0,38)=  0.0000000000000D+00
      ALPHA(24,0,38)=  0.0000000000000D+00
      ALPHA(25,0,38)=  0.0000000000000D+00
      ALPHA(26,0,38)=  0.0000000000000D+00
      ALPHA(27,0,38)=  0.0000000000000D+00
      ALPHA(28,0,38)=  0.0000000000000D+00
      ALPHA(29,0,38)=  0.0000000000000D+00
      ALPHA(30,0,38)=  0.0000000000000D+00
      ALPHA(31,0,38)=  0.0000000000000D+00
      ALPHA(32,0,38)=  0.0000000000000D+00
      ALPHA(33,0,38)=  0.0000000000000D+00
      ALPHA(34,0,38)=  0.0000000000000D+00
      ALPHA(35,0,38)=  0.0000000000000D+00
      ALPHA(36,0,38)=  0.0000000000000D+00
      ALPHA(37,0,38)=  0.0000000000000D+00
      ALPHA(38,0,38)=  1.0000000000000D+00
C l= 0 n=38 ; Coef  :
      COEF (   0,38)= -1.0000000000000D+00
C l= 1 n=38 ; Alpha :
      ALPHA( 1,1,38)=  1.0000000000000D+00
      ALPHA( 2,1,38)= 0.50000000000000D+00
      ALPHA( 3,1,38)= 0.33333333333333D+00
      ALPHA( 4,1,38)= 0.25000000000000D+00
      ALPHA( 5,1,38)= 0.20000000000000D+00
      ALPHA( 6,1,38)= 0.16666666666667D+00
      ALPHA( 7,1,38)= 0.14285714285714D+00
      ALPHA( 8,1,38)= 0.12500000000000D+00
      ALPHA( 9,1,38)= 0.11111111111111D+00
      ALPHA(10,1,38)= 0.10000000000000D+00
      ALPHA(11,1,38)= 0.90909090909091D-01
      ALPHA(12,1,38)= 0.83333333333333D-01
      ALPHA(13,1,38)= 0.76923076923077D-01
      ALPHA(14,1,38)= 0.71428571428571D-01
      ALPHA(15,1,38)= 0.66666666666667D-01
      ALPHA(16,1,38)= 0.62500000000000D-01
      ALPHA(17,1,38)= 0.58823529411765D-01
      ALPHA(18,1,38)= 0.55555555555556D-01
      ALPHA(19,1,38)= 0.52631578947368D-01
      ALPHA(20,1,38)= 0.50000000000000D-01
      ALPHA(21,1,38)= 0.47619047619048D-01
      ALPHA(22,1,38)= 0.45454545454545D-01
      ALPHA(23,1,38)= 0.43478260869565D-01
      ALPHA(24,1,38)= 0.41666666666667D-01
      ALPHA(25,1,38)= 0.40000000000000D-01
      ALPHA(26,1,38)= 0.38461538461538D-01
      ALPHA(27,1,38)= 0.37037037037037D-01
      ALPHA(28,1,38)= 0.35714285714286D-01
      ALPHA(29,1,38)= 0.34482758620690D-01
      ALPHA(30,1,38)= 0.33333333333333D-01
      ALPHA(31,1,38)= 0.32258064516129D-01
      ALPHA(32,1,38)= 0.31250000000000D-01
      ALPHA(33,1,38)= 0.30303030303030D-01
      ALPHA(34,1,38)= 0.29411764705882D-01
      ALPHA(35,1,38)= 0.28571428571429D-01
      ALPHA(36,1,38)= 0.27777777777778D-01
      ALPHA(37,1,38)= 0.27027027027027D-01
      ALPHA(38,1,38)= 0.26315789473684D-01
C l= 1 n=38 ; Coef  :
      COEF (   1,38)= -4.2279020132954D+00
C l= 2 n=38 ; Alpha :
      ALPHA( 1,2,38)=  4.2279020132954D+00
      ALPHA( 2,2,38)=  1.6139510066477D+00
      ALPHA( 3,2,38)= 0.90930067109845D+00
      ALPHA( 4,2,38)= 0.59864216999050D+00
      ALPHA( 5,2,38)= 0.42891373599240D+00
      ALPHA( 6,2,38)= 0.32409477999367D+00
      ALPHA( 7,2,38)= 0.25398600189934D+00
      ALPHA( 8,2,38)= 0.20438060880478D+00
      ALPHA( 9,2,38)= 0.16778276338202D+00
      ALPHA(10,2,38)= 0.13989337593271D+00
      ALPHA(11,2,38)= 0.11808488721155D+00
      ALPHA(12,2,38)= 0.10066872236817D+00
      ALPHA(13,2,38)= 0.86514718083436D-01
      ALPHA(14,2,38)= 0.74840589868685D-01
      ALPHA(15,2,38)= 0.65089312448868D-01
      ALPHA(16,2,38)= 0.56854563754147D-01
      ALPHA(17,2,38)= 0.49833707062727D-01
      ALPHA(18,2,38)= 0.43797193925255D-01
      ALPHA(19,2,38)= 0.38568101847318D-01
      ALPHA(20,2,38)= 0.34008117807583D-01
      ALPHA(21,2,38)= 0.30007731245318D-01
      ALPHA(22,2,38)= 0.26479241296937D-01
      ALPHA(23,2,38)= 0.23351685351221D-01
      ALPHA(24,2,38)= 0.20567104258688D-01
      ALPHA(25,2,38)= 0.18077753421674D-01
      ALPHA(26,2,38)= 0.15843993674686D-01
      ALPHA(27,2,38)= 0.13832677669641D-01
      ALPHA(28,2,38)= 0.12015902144402D-01
      ALPHA(29,2,38)= 0.10370033597551D-01
      ALPHA(30,2,38)= 0.88749405236098D-02
      ALPHA(31,2,38)= 0.75133833024180D-02
      ALPHA(32,2,38)= 0.62705255580884D-02
      ALPHA(33,2,38)= 0.51335399351161D-02
      ALPHA(34,2,38)= 0.40912878692882D-02
      ALPHA(35,2,38)= 0.31340577957119D-02
      ALPHA(36,2,38)= 0.22533498410691D-02
      ALPHA(37,2,38)= 0.14416977432625D-02
      ALPHA(38,2,38)= 0.69252077562327D-03
C l= 2 n=38 ; Coef  :
      COEF (   2,38)= -9.7470584674189D+00
C l= 3 n=38 ; Alpha :
      ALPHA( 1,3,38)=  9.7470584674189D+00
      ALPHA( 2,3,38)=  2.7595782270618D+00
      ALPHA( 3,3,38)=  1.3017351491586D+00
      ALPHA( 4,3,38)= 0.74897619409437D+00
      ALPHA( 5,3,38)= 0.47945252127739D+00
      ALPHA( 6,3,38)= 0.32805814506576D+00
      ALPHA( 7,3,38)= 0.23489344148584D+00
      ALPHA( 8,3,38)= 0.17378351106269D+00
      ALPHA( 9,3,38)= 0.13176527552186D+00
      ALPHA(10,3,38)= 0.10181047163148D+00
      ALPHA(11,3,38)= 0.79837394580186D-01
      ALPHA(12,3,38)= 0.63343871097541D-01
      ALPHA(13,3,38)= 0.50727517754025D-01
      ALPHA(14,3,38)= 0.40924500908492D-01
      ALPHA(15,3,38)= 0.33206828190014D-01
      ALPHA(16,3,38)= 0.27063319400083D-01
      ALPHA(17,3,38)= 0.22126973332188D-01
      ALPHA(18,3,38)= 0.18129157754692D-01
      ALPHA(19,3,38)= 0.14869876087327D-01
      ALPHA(20,3,38)= 0.12197977190594D-01
      ALPHA(21,3,38)= 0.99976869525860D-02
      ALPHA(22,3,38)= 0.81792588526813D-02
      ALPHA(23,3,38)= 0.66723675418283D-02
      ALPHA(24,3,38)= 0.54213653379512D-02
      ALPHA(25,3,38)= 0.43818265540857D-02
      ALPHA(26,3,38)= 0.35179965550180D-02
      ALPHA(27,3,38)= 0.28008858057697D-02
      ALPHA(28,3,38)= 0.22068299673622D-02
      ALPHA(29,3,38)= 0.17163909290255D-02
      ALPHA(30,3,38)= 0.13135101114729D-02
      ALPHA(31,3,38)= 0.98485041356702D-03
      ALPHA(32,3,38)= 0.71928060994249D-03
      ALPHA(33,3,38)= 0.50746830182034D-03
      ALPHA(34,3,38)= 0.34155629485162D-03
      ALPHA(35,3,38)= 0.21490360444762D-03
      ALPHA(36,3,38)= 0.12187689888764D-03
      ALPHA(37,3,38)= 0.57681581591506D-04
      ALPHA(38,3,38)= 0.18224230937454D-04
C l= 3 n=38 ; Coef  :
      COEF (   3,38)= -16.418712780618D+00
C l= 4 n=38 ; Alpha :
      ALPHA( 1,4,38)=  16.418712780618D+00
      ALPHA( 2,4,38)=  3.3358271565994D+00
      ALPHA( 3,4,38)=  1.3040253620457D+00
      ALPHA( 4,4,38)= 0.65258523424459D+00
      ALPHA( 5,4,38)= 0.37227294857680D+00
      ALPHA( 6,4,38)= 0.23031870360110D+00
      ALPHA( 7,4,38)= 0.15055058236298D+00
      ALPHA( 8,4,38)= 0.10237007938188D+00
      ALPHA( 9,4,38)= 0.71686347110257D-01
      ALPHA(10,4,38)= 0.51341184847044D-01
      ALPHA(11,4,38)= 0.37418306985361D-01
      ALPHA(12,4,38)= 0.27646998521565D-01
      ALPHA(13,4,38)= 0.20647700858557D-01
      ALPHA(14,4,38)= 0.15549470957658D-01
      ALPHA(15,4,38)= 0.11784539499915D-01
      ALPHA(16,4,38)= 0.89725790192944D-02
      ALPHA(17,4,38)= 0.68528202887428D-02
      ALPHA(18,4,38)= 0.52428317542467D-02
      ALPHA(19,4,38)= 0.40127270432499D-02
      ALPHA(20,4,38)= 0.30685968867210D-02
      ALPHA(21,4,38)= 0.23416171687536D-02
      ALPHA(22,4,38)= 0.17807397086927D-02
      ALPHA(23,4,38)= 0.13476962929808D-02
      ALPHA(24,4,38)= 0.10135269665305D-02
      ALPHA(25,4,38)= 0.75613127435118D-03
      ALPHA(26,4,38)= 0.55851751171900D-03
      ALPHA(27,4,38)= 0.40753550924726D-03
      ALPHA(28,4,38)= 0.29294903371094D-03
      ALPHA(29,4,38)= 0.20674975781186D-03
      ALPHA(30,4,38)= 0.14264506825062D-03
      ALPHA(31,4,38)= 0.95672320517603D-04
      ALPHA(32,4,38)= 0.61905985077458D-04
      ALPHA(33,4,38)= 0.38233664016248D-04
      ALPHA(34,4,38)= 0.22183606197525D-04
      ALPHA(35,4,38)= 0.11791037596121D-04
      ALPHA(36,4,38)= 0.54939642060166D-05
      ALPHA(37,4,38)= 0.20515084467287D-05
      ALPHA(38,4,38)= 0.47958502466985D-06
C l= 4 n=38 ; Coef  :
      COEF (   4,38)= -22.839972871166D+00
C l= 0 n=39 ; Alpha :
      ALPHA( 1,0,39)=  0.0000000000000D+00
      ALPHA( 2,0,39)=  0.0000000000000D+00
      ALPHA( 3,0,39)=  0.0000000000000D+00
      ALPHA( 4,0,39)=  0.0000000000000D+00
      ALPHA( 5,0,39)=  0.0000000000000D+00
      ALPHA( 6,0,39)=  0.0000000000000D+00
      ALPHA( 7,0,39)=  0.0000000000000D+00
      ALPHA( 8,0,39)=  0.0000000000000D+00
      ALPHA( 9,0,39)=  0.0000000000000D+00
      ALPHA(10,0,39)=  0.0000000000000D+00
      ALPHA(11,0,39)=  0.0000000000000D+00
      ALPHA(12,0,39)=  0.0000000000000D+00
      ALPHA(13,0,39)=  0.0000000000000D+00
      ALPHA(14,0,39)=  0.0000000000000D+00
      ALPHA(15,0,39)=  0.0000000000000D+00
      ALPHA(16,0,39)=  0.0000000000000D+00
      ALPHA(17,0,39)=  0.0000000000000D+00
      ALPHA(18,0,39)=  0.0000000000000D+00
      ALPHA(19,0,39)=  0.0000000000000D+00
      ALPHA(20,0,39)=  0.0000000000000D+00
      ALPHA(21,0,39)=  0.0000000000000D+00
      ALPHA(22,0,39)=  0.0000000000000D+00
      ALPHA(23,0,39)=  0.0000000000000D+00
      ALPHA(24,0,39)=  0.0000000000000D+00
      ALPHA(25,0,39)=  0.0000000000000D+00
      ALPHA(26,0,39)=  0.0000000000000D+00
      ALPHA(27,0,39)=  0.0000000000000D+00
      ALPHA(28,0,39)=  0.0000000000000D+00
      ALPHA(29,0,39)=  0.0000000000000D+00
      ALPHA(30,0,39)=  0.0000000000000D+00
      ALPHA(31,0,39)=  0.0000000000000D+00
      ALPHA(32,0,39)=  0.0000000000000D+00
      ALPHA(33,0,39)=  0.0000000000000D+00
      ALPHA(34,0,39)=  0.0000000000000D+00
      ALPHA(35,0,39)=  0.0000000000000D+00
      ALPHA(36,0,39)=  0.0000000000000D+00
      ALPHA(37,0,39)=  0.0000000000000D+00
      ALPHA(38,0,39)=  0.0000000000000D+00
      ALPHA(39,0,39)=  1.0000000000000D+00
C l= 0 n=39 ; Coef  :
      COEF (   0,39)= -1.0000000000000D+00
C l= 1 n=39 ; Alpha :
      ALPHA( 1,1,39)=  1.0000000000000D+00
      ALPHA( 2,1,39)= 0.50000000000000D+00
      ALPHA( 3,1,39)= 0.33333333333333D+00
      ALPHA( 4,1,39)= 0.25000000000000D+00
      ALPHA( 5,1,39)= 0.20000000000000D+00
      ALPHA( 6,1,39)= 0.16666666666667D+00
      ALPHA( 7,1,39)= 0.14285714285714D+00
      ALPHA( 8,1,39)= 0.12500000000000D+00
      ALPHA( 9,1,39)= 0.11111111111111D+00
      ALPHA(10,1,39)= 0.10000000000000D+00
      ALPHA(11,1,39)= 0.90909090909091D-01
      ALPHA(12,1,39)= 0.83333333333333D-01
      ALPHA(13,1,39)= 0.76923076923077D-01
      ALPHA(14,1,39)= 0.71428571428571D-01
      ALPHA(15,1,39)= 0.66666666666667D-01
      ALPHA(16,1,39)= 0.62500000000000D-01
      ALPHA(17,1,39)= 0.58823529411765D-01
      ALPHA(18,1,39)= 0.55555555555556D-01
      ALPHA(19,1,39)= 0.52631578947368D-01
      ALPHA(20,1,39)= 0.50000000000000D-01
      ALPHA(21,1,39)= 0.47619047619048D-01
      ALPHA(22,1,39)= 0.45454545454545D-01
      ALPHA(23,1,39)= 0.43478260869565D-01
      ALPHA(24,1,39)= 0.41666666666667D-01
      ALPHA(25,1,39)= 0.40000000000000D-01
      ALPHA(26,1,39)= 0.38461538461538D-01
      ALPHA(27,1,39)= 0.37037037037037D-01
      ALPHA(28,1,39)= 0.35714285714286D-01
      ALPHA(29,1,39)= 0.34482758620690D-01
      ALPHA(30,1,39)= 0.33333333333333D-01
      ALPHA(31,1,39)= 0.32258064516129D-01
      ALPHA(32,1,39)= 0.31250000000000D-01
      ALPHA(33,1,39)= 0.30303030303030D-01
      ALPHA(34,1,39)= 0.29411764705882D-01
      ALPHA(35,1,39)= 0.28571428571429D-01
      ALPHA(36,1,39)= 0.27777777777778D-01
      ALPHA(37,1,39)= 0.27027027027027D-01
      ALPHA(38,1,39)= 0.26315789473684D-01
      ALPHA(39,1,39)= 0.25641025641026D-01
C l= 1 n=39 ; Coef  :
      COEF (   1,39)= -4.2535430389364D+00
C l= 2 n=39 ; Alpha :
      ALPHA( 1,2,39)=  4.2535430389364D+00
      ALPHA( 2,2,39)=  1.6267715194682D+00
      ALPHA( 3,2,39)= 0.91784767964546D+00
      ALPHA( 4,2,39)= 0.60505242640076D+00
      ALPHA( 5,2,39)= 0.43404194112061D+00
      ALPHA( 6,2,39)= 0.32836828426717D+00
      ALPHA( 7,2,39)= 0.25764900556234D+00
      ALPHA( 8,2,39)= 0.20758573700990D+00
      ALPHA( 9,2,39)= 0.17063176623103D+00
      ALPHA(10,2,39)= 0.14245747849681D+00
      ALPHA(11,2,39)= 0.12041588954256D+00
      ALPHA(12,2,39)= 0.10280547450492D+00
      ALPHA(13,2,39)= 0.88487104671208D-01
      ALPHA(14,2,39)= 0.76672091700187D-01
      ALPHA(15,2,39)= 0.66798714158270D-01
      ALPHA(16,2,39)= 0.58457127856711D-01
      ALPHA(17,2,39)= 0.51342002688670D-01
      ALPHA(18,2,39)= 0.45221695349757D-01
      ALPHA(19,2,39)= 0.39917629512635D-01
      ALPHA(20,2,39)= 0.35290169089635D-01
      ALPHA(21,2,39)= 0.31228732466319D-01
      ALPHA(22,2,39)= 0.27644742462438D-01
      ALPHA(23,2,39)= 0.24466512553004D-01
      ALPHA(24,2,39)= 0.21635480327064D-01
      ALPHA(25,2,39)= 0.19103394447315D-01
      ALPHA(26,2,39)= 0.16830186968572D-01
      ALPHA(27,2,39)= 0.14782345285975D-01
      ALPHA(28,2,39)= 0.12931653060153D-01
      ALPHA(29,2,39)= 0.11254206895518D-01
      ALPHA(30,2,39)= 0.97296413783106D-02
      ALPHA(31,2,39)= 0.83405131618060D-02
      ALPHA(32,2,39)= 0.70718076093705D-02
      ALPHA(33,2,39)= 0.59105407121168D-02
      ALPHA(34,2,39)= 0.48454356822596D-02
      ALPHA(35,2,39)= 0.38666585283127D-02
      ALPHA(36,2,39)= 0.29656005533199D-02
      ALPHA(37,2,39)= 0.21346984362632D-02
      ALPHA(38,2,39)= 0.13672846082818D-02
      ALPHA(39,2,39)= 0.65746219592373D-03
C l= 2 n=39 ; Coef  :
      COEF (   2,39)= -9.8561236735455D+00
C l= 3 n=39 ; Alpha :
      ALPHA( 1,3,39)=  9.8561236735455D+00
      ALPHA( 2,3,39)=  2.8012903173046D+00
      ALPHA( 3,3,39)=  1.3252697050470D+00
      ALPHA( 4,3,39)= 0.76449035887387D+00
      ALPHA( 5,3,39)= 0.49058180181895D+00
      ALPHA( 6,3,39)= 0.33647784466235D+00
      ALPHA( 7,3,39)= 0.24149982624385D+00
      ALPHA( 8,3,39)= 0.17910622226808D+00
      ALPHA( 9,3,39)= 0.13614044901497D+00
      ALPHA(10,3,39)= 0.10546322749037D+00
      ALPHA(11,3,39)= 0.82924981491534D-01
      ALPHA(12,3,39)= 0.65979908905360D-01
      ALPHA(13,3,39)= 0.52996417873800D-01
      ALPHA(14,3,39)= 0.42890451977728D-01
      ALPHA(15,3,39)= 0.34919615732533D-01
      ALPHA(16,3,39)= 0.28562220114358D-01
      ALPHA(17,3,39)= 0.23443434939589D-01
      ALPHA(18,3,39)= 0.19288688404686D-01
      ALPHA(19,3,39)= 0.15893405049189D-01
      ALPHA(20,3,39)= 0.13102853321098D-01
      ALPHA(21,3,39)= 0.10798423682492D-01
      ALPHA(22,3,39)= 0.88880984030002D-02
      ALPHA(23,3,39)= 0.72997140175463D-02
      ALPHA(24,3,39)= 0.59761212437734D-02
      ALPHA(25,3,39)= 0.48716571809399D-02
      ALPHA(26,3,39)= 0.39495398106224D-02
      ALPHA(27,3,39)= 0.31799203002819D-02
      ALPHA(28,3,39)= 0.25384108150584D-02
      ALPHA(29,3,39)= 0.20049603366028D-02
      ALPHA(30,3,39)= 0.15629880955322D-02
      ALPHA(31,3,39)= 0.11987097254082D-02
      ALPHA(32,3,39)= 0.90060901018276D-03
      ALPHA(33,3,39)= 0.65902062777205D-03
      ALPHA(34,3,39)= 0.46579823542238D-03
      ALPHA(35,3,39)= 0.31404869491718D-03
      ALPHA(36,3,39)= 0.19791793871635D-03
      ALPHA(37,3,39)= 0.11241743893159D-03
      ALPHA(38,3,39)= 0.53282810636989D-04
      ALPHA(39,3,39)= 0.16858005023685D-04
C l= 3 n=39 ; Coef  :
      COEF (   3,39)= -16.671433900452D+00
C l= 4 n=39 ; Alpha :
      ALPHA( 1,4,39)=  16.671433900452D+00
      ALPHA( 2,4,39)=  3.4076551134534D+00
      ALPHA( 3,4,39)=  1.3380066365341D+00
      ALPHA( 4,4,39)= 0.67218755113879D+00
      ALPHA( 5,4,39)= 0.38485196913626D+00
      ALPHA( 6,4,39)= 0.23894634064373D+00
      ALPHA( 7,4,39)= 0.15674288560000D+00
      ALPHA( 8,4,39)= 0.10696254661952D+00
      ALPHA( 9,4,39)= 0.75177127854230D-01
      ALPHA(10,4,39)= 0.54045370167310D-01
      ALPHA(11,4,39)= 0.39544588562067D-01
      ALPHA(12,4,39)= 0.29338791057600D-01
      ALPHA(13,4,39)= 0.22006583368142D-01
      ALPHA(14,4,39)= 0.16649226136574D-01
      ALPHA(15,4,39)= 0.12679914262288D-01
      ALPHA(16,4,39)= 0.97049436376113D-02
      ALPHA(17,4,39)= 0.74539340051425D-02
      ALPHA(18,4,39)= 0.57374135082130D-02
      ALPHA(19,4,39)= 0.44202502496393D-02
      ALPHA(20,4,39)= 0.34045674846979D-02
      ALPHA(21,4,39)= 0.26184998272791D-02
      ALPHA(22,4,39)= 0.20086396677440D-02
      ALPHA(23,4,39)= 0.15348684472769D-02
      ALPHA(24,4,39)= 0.11667608445759D-02
      ALPHA(25,4,39)= 0.88104556104195D-03
      ALPHA(26,4,39)= 0.65978776327342D-03
      ALPHA(27,4,39)= 0.48907192720320D-03
      ALPHA(28,4,39)= 0.35803649050731D-03
      ALPHA(29,4,39)= 0.25815899721194D-03
      ALPHA(30,4,39)= 0.18272168608478D-03
      ALPHA(31,4,39)= 0.12640846732294D-03
      ALPHA(32,4,39)= 0.84998523800093D-04
      ALPHA(33,4,39)= 0.55131628830916D-04
      ALPHA(34,4,39)= 0.34127150695534D-04
      ALPHA(35,4,39)= 0.19843568235023D-04
      ALPHA(36,4,39)= 0.10568783147461D-04
      ALPHA(37,4,39)= 0.49340068808719D-05
      ALPHA(38,4,39)= 0.18458109384388D-05
      ALPHA(39,4,39)= 0.43225653906886D-06
C l= 4 n=39 ; Coef  :
      COEF (   4,39)= -23.267445535280D+00
C l= 0 n=40 ; Alpha :
      ALPHA( 1,0,40)=  0.0000000000000D+00
      ALPHA( 2,0,40)=  0.0000000000000D+00
      ALPHA( 3,0,40)=  0.0000000000000D+00
      ALPHA( 4,0,40)=  0.0000000000000D+00
      ALPHA( 5,0,40)=  0.0000000000000D+00
      ALPHA( 6,0,40)=  0.0000000000000D+00
      ALPHA( 7,0,40)=  0.0000000000000D+00
      ALPHA( 8,0,40)=  0.0000000000000D+00
      ALPHA( 9,0,40)=  0.0000000000000D+00
      ALPHA(10,0,40)=  0.0000000000000D+00
      ALPHA(11,0,40)=  0.0000000000000D+00
      ALPHA(12,0,40)=  0.0000000000000D+00
      ALPHA(13,0,40)=  0.0000000000000D+00
      ALPHA(14,0,40)=  0.0000000000000D+00
      ALPHA(15,0,40)=  0.0000000000000D+00
      ALPHA(16,0,40)=  0.0000000000000D+00
      ALPHA(17,0,40)=  0.0000000000000D+00
      ALPHA(18,0,40)=  0.0000000000000D+00
      ALPHA(19,0,40)=  0.0000000000000D+00
      ALPHA(20,0,40)=  0.0000000000000D+00
      ALPHA(21,0,40)=  0.0000000000000D+00
      ALPHA(22,0,40)=  0.0000000000000D+00
      ALPHA(23,0,40)=  0.0000000000000D+00
      ALPHA(24,0,40)=  0.0000000000000D+00
      ALPHA(25,0,40)=  0.0000000000000D+00
      ALPHA(26,0,40)=  0.0000000000000D+00
      ALPHA(27,0,40)=  0.0000000000000D+00
      ALPHA(28,0,40)=  0.0000000000000D+00
      ALPHA(29,0,40)=  0.0000000000000D+00
      ALPHA(30,0,40)=  0.0000000000000D+00
      ALPHA(31,0,40)=  0.0000000000000D+00
      ALPHA(32,0,40)=  0.0000000000000D+00
      ALPHA(33,0,40)=  0.0000000000000D+00
      ALPHA(34,0,40)=  0.0000000000000D+00
      ALPHA(35,0,40)=  0.0000000000000D+00
      ALPHA(36,0,40)=  0.0000000000000D+00
      ALPHA(37,0,40)=  0.0000000000000D+00
      ALPHA(38,0,40)=  0.0000000000000D+00
      ALPHA(39,0,40)=  0.0000000000000D+00
      ALPHA(40,0,40)=  1.0000000000000D+00
C l= 0 n=40 ; Coef  :
      COEF (   0,40)= -1.0000000000000D+00
C l= 1 n=40 ; Alpha :
      ALPHA( 1,1,40)=  1.0000000000000D+00
      ALPHA( 2,1,40)= 0.50000000000000D+00
      ALPHA( 3,1,40)= 0.33333333333333D+00
      ALPHA( 4,1,40)= 0.25000000000000D+00
      ALPHA( 5,1,40)= 0.20000000000000D+00
      ALPHA( 6,1,40)= 0.16666666666667D+00
      ALPHA( 7,1,40)= 0.14285714285714D+00
      ALPHA( 8,1,40)= 0.12500000000000D+00
      ALPHA( 9,1,40)= 0.11111111111111D+00
      ALPHA(10,1,40)= 0.10000000000000D+00
      ALPHA(11,1,40)= 0.90909090909091D-01
      ALPHA(12,1,40)= 0.83333333333333D-01
      ALPHA(13,1,40)= 0.76923076923077D-01
      ALPHA(14,1,40)= 0.71428571428571D-01
      ALPHA(15,1,40)= 0.66666666666667D-01
      ALPHA(16,1,40)= 0.62500000000000D-01
      ALPHA(17,1,40)= 0.58823529411765D-01
      ALPHA(18,1,40)= 0.55555555555556D-01
      ALPHA(19,1,40)= 0.52631578947368D-01
      ALPHA(20,1,40)= 0.50000000000000D-01
      ALPHA(21,1,40)= 0.47619047619048D-01
      ALPHA(22,1,40)= 0.45454545454545D-01
      ALPHA(23,1,40)= 0.43478260869565D-01
      ALPHA(24,1,40)= 0.41666666666667D-01
      ALPHA(25,1,40)= 0.40000000000000D-01
      ALPHA(26,1,40)= 0.38461538461538D-01
      ALPHA(27,1,40)= 0.37037037037037D-01
      ALPHA(28,1,40)= 0.35714285714286D-01
      ALPHA(29,1,40)= 0.34482758620690D-01
      ALPHA(30,1,40)= 0.33333333333333D-01
      ALPHA(31,1,40)= 0.32258064516129D-01
      ALPHA(32,1,40)= 0.31250000000000D-01
      ALPHA(33,1,40)= 0.30303030303030D-01
      ALPHA(34,1,40)= 0.29411764705882D-01
      ALPHA(35,1,40)= 0.28571428571429D-01
      ALPHA(36,1,40)= 0.27777777777778D-01
      ALPHA(37,1,40)= 0.27027027027027D-01
      ALPHA(38,1,40)= 0.26315789473684D-01
      ALPHA(39,1,40)= 0.25641025641026D-01
      ALPHA(40,1,40)= 0.25000000000000D-01
C l= 1 n=40 ; Coef  :
      COEF (   1,40)= -4.2785430389364D+00
C l= 2 n=40 ; Alpha :
      ALPHA( 1,2,40)=  4.2785430389364D+00
      ALPHA( 2,2,40)=  1.6392715194682D+00
      ALPHA( 3,2,40)= 0.92618101297879D+00
      ALPHA( 4,2,40)= 0.61130242640076D+00
      ALPHA( 5,2,40)= 0.43904194112061D+00
      ALPHA( 6,2,40)= 0.33253495093384D+00
      ALPHA( 7,2,40)= 0.26122043413377D+00
      ALPHA( 8,2,40)= 0.21071073700990D+00
      ALPHA( 9,2,40)= 0.17340954400880D+00
      ALPHA(10,2,40)= 0.14495747849681D+00
      ALPHA(11,2,40)= 0.12268861681528D+00
      ALPHA(12,2,40)= 0.10488880783825D+00
      ALPHA(13,2,40)= 0.90410181594284D-01
      ALPHA(14,2,40)= 0.78457805985901D-01
      ALPHA(15,2,40)= 0.68465380824937D-01
      ALPHA(16,2,40)= 0.60019627856711D-01
      ALPHA(17,2,40)= 0.52812590923964D-01
      ALPHA(18,2,40)= 0.46610584238645D-01
      ALPHA(19,2,40)= 0.41233418986319D-01
      ALPHA(20,2,40)= 0.36540169089635D-01
      ALPHA(21,2,40)= 0.32419208656795D-01
      ALPHA(22,2,40)= 0.28781106098802D-01
      ALPHA(23,2,40)= 0.25553469074744D-01
      ALPHA(24,2,40)= 0.22677146993731D-01
      ALPHA(25,2,40)= 0.20103394447315D-01
      ALPHA(26,2,40)= 0.17791725430110D-01
      ALPHA(27,2,40)= 0.15708271211901D-01
      ALPHA(28,2,40)= 0.13824510203010D-01
      ALPHA(29,2,40)= 0.12116275861035D-01
      ALPHA(30,2,40)= 0.10562974711644D-01
      ALPHA(31,2,40)= 0.91469647747092D-02
      ALPHA(32,2,40)= 0.78530576093705D-02
      ALPHA(33,2,40)= 0.66681164696926D-02
      ALPHA(34,2,40)= 0.55807297999066D-02
      ALPHA(35,2,40)= 0.45809442425984D-02
      ALPHA(36,2,40)= 0.36600449977643D-02
      ALPHA(37,2,40)= 0.28103741119388D-02
      ALPHA(38,2,40)= 0.20251793451239D-02
      ALPHA(39,2,40)= 0.12984878369494D-02
      ALPHA(40,2,40)= 0.62500000000000D-03
C l= 2 n=40 ; Coef  :
      COEF (   2,40)= -9.9630872495189D+00
C l= 3 n=40 ; Alpha :
      ALPHA( 1,3,40)=  9.9630872495189D+00
      ALPHA( 2,3,40)=  2.8422721052913D+00
      ALPHA( 3,3,40)=  1.3484242303715D+00
      ALPHA( 4,3,40)= 0.77977291953389D+00
      ALPHA( 5,3,40)= 0.50155785034696D+00
      ALPHA( 6,3,40)= 0.34479121843570D+00
      ALPHA( 7,3,40)= 0.24803033709719D+00
      ALPHA( 8,3,40)= 0.18437399069332D+00
      ALPHA( 9,3,40)= 0.14047568761519D+00
      ALPHA(10,3,40)= 0.10908716445279D+00
      ALPHA(11,3,40)= 0.85992196911916D-01
      ALPHA(12,3,40)= 0.68602129101316D-01
      ALPHA(13,3,40)= 0.55256672413657D-01
      ALPHA(14,3,40)= 0.44851897127375D-01
      ALPHA(15,3,40)= 0.36631250253157D-01
      ALPHA(16,3,40)= 0.30062710810776D-01
      ALPHA(17,3,40)= 0.24763749712688D-01
      ALPHA(18,3,40)= 0.20453953010652D-01
      ALPHA(19,3,40)= 0.16924240523847D-01
      ALPHA(20,3,40)= 0.14016357548339D-01
      ALPHA(21,3,40)= 0.11608903898911D-01
      ALPHA(22,3,40)= 0.96076260554702D-02
      ALPHA(23,3,40)= 0.79385507444149D-02
      ALPHA(24,3,40)= 0.65430499186167D-02
      ALPHA(25,3,40)= 0.53742420421228D-02
      ALPHA(26,3,40)= 0.43943329463752D-02
      ALPHA(27,3,40)= 0.35726270805794D-02
      ALPHA(28,3,40)= 0.28840235701337D-02
      ALPHA(29,3,40)= 0.23078672331287D-02
      ALPHA(30,3,40)= 0.18270624633233D-02
      ALPHA(31,3,40)= 0.14273838447759D-02
      ALPHA(32,3,40)= 0.10969354504170D-02
      ALPHA(33,3,40)= 0.82572353951437D-03
      ALPHA(34,3,40)= 0.60531648042004D-03
      ALPHA(35,3,40)= 0.42857230098214D-03
      ALPHA(36,3,40)= 0.28941906366046D-03
      ALPHA(37,3,40)= 0.18267679173006D-03
      ALPHA(38,3,40)= 0.10391229426509D-03
      ALPHA(39,3,40)= 0.49320200947420D-04
      ALPHA(40,3,40)= 0.15625000000000D-04
C l= 3 n=40 ; Coef  :
      COEF (   3,40)= -16.920511081690D+00
C l= 4 n=40 ; Alpha :
      ALPHA( 1,4,40)=  16.920511081690D+00
      ALPHA( 2,4,40)=  3.4787119160856D+00
      ALPHA( 3,4,40)=  1.3717172422933D+00
      ALPHA( 4,4,40)= 0.69168187412714D+00
      ALPHA( 5,4,40)= 0.39739091539493D+00
      ALPHA( 6,4,40)= 0.24756612110462D+00
      ALPHA( 7,4,40)= 0.16294364402743D+00
      ALPHA( 8,4,40)= 0.11157189638685D+00
      ALPHA( 9,4,40)= 0.78689020044610D-01
      ALPHA(10,4,40)= 0.56772549278630D-01
      ALPHA(11,4,40)= 0.41694393484865D-01
      ALPHA(12,4,40)= 0.31053844285133D-01
      ALPHA(13,4,40)= 0.23388000178483D-01
      ALPHA(14,4,40)= 0.17770523564759D-01
      ALPHA(15,4,40)= 0.13595695518617D-01
      ALPHA(16,4,40)= 0.10456511407881D-01
      ALPHA(17,4,40)= 0.80730277479597D-02
      ALPHA(18,4,40)= 0.62487623334793D-02
      ALPHA(19,4,40)= 0.48433562627355D-02
      ALPHA(20,4,40)= 0.37549764234064D-02
      ALPHA(21,4,40)= 0.29087224247518D-02
      ALPHA(22,4,40)= 0.22488303191308D-02
      ALPHA(23,4,40)= 0.17333322158873D-02
      ALPHA(24,4,40)= 0.13303370925413D-02
      ALPHA(25,4,40)= 0.10154016120950D-02
      ALPHA(26,4,40)= 0.76964608693280D-03
      ALPHA(27,4,40)= 0.57838760421769D-03
      ALPHA(28,4,40)= 0.43013707976065D-03
      ALPHA(29,4,40)= 0.31585567804015D-03
      ALPHA(30,4,40)= 0.22839824766786D-03
      ALPHA(31,4,40)= 0.16209306344234D-03
      ALPHA(32,4,40)= 0.11242191006052D-03
      ALPHA(33,4,40)= 0.75774717318775D-04
      ALPHA(34,4,40)= 0.49260062706035D-04
      ALPHA(35,4,40)= 0.30557875759576D-04
      ALPHA(36,4,40)= 0.17804259738973D-04
      ALPHA(37,4,40)= 0.95009266741234D-05
      ALPHA(38,4,40)= 0.44436182950660D-05
      ALPHA(39,4,40)= 0.16652615627544D-05
      ALPHA(40,4,40)= 0.39062500000000D-06
C l= 4 n=40 ; Coef  :
      COEF (   4,40)= -23.690458312322D+00
C l= 0 n=41 ; Alpha :
      ALPHA( 1,0,41)=  0.0000000000000D+00
      ALPHA( 2,0,41)=  0.0000000000000D+00
      ALPHA( 3,0,41)=  0.0000000000000D+00
      ALPHA( 4,0,41)=  0.0000000000000D+00
      ALPHA( 5,0,41)=  0.0000000000000D+00
      ALPHA( 6,0,41)=  0.0000000000000D+00
      ALPHA( 7,0,41)=  0.0000000000000D+00
      ALPHA( 8,0,41)=  0.0000000000000D+00
      ALPHA( 9,0,41)=  0.0000000000000D+00
      ALPHA(10,0,41)=  0.0000000000000D+00
      ALPHA(11,0,41)=  0.0000000000000D+00
      ALPHA(12,0,41)=  0.0000000000000D+00
      ALPHA(13,0,41)=  0.0000000000000D+00
      ALPHA(14,0,41)=  0.0000000000000D+00
      ALPHA(15,0,41)=  0.0000000000000D+00
      ALPHA(16,0,41)=  0.0000000000000D+00
      ALPHA(17,0,41)=  0.0000000000000D+00
      ALPHA(18,0,41)=  0.0000000000000D+00
      ALPHA(19,0,41)=  0.0000000000000D+00
      ALPHA(20,0,41)=  0.0000000000000D+00
      ALPHA(21,0,41)=  0.0000000000000D+00
      ALPHA(22,0,41)=  0.0000000000000D+00
      ALPHA(23,0,41)=  0.0000000000000D+00
      ALPHA(24,0,41)=  0.0000000000000D+00
      ALPHA(25,0,41)=  0.0000000000000D+00
      ALPHA(26,0,41)=  0.0000000000000D+00
      ALPHA(27,0,41)=  0.0000000000000D+00
      ALPHA(28,0,41)=  0.0000000000000D+00
      ALPHA(29,0,41)=  0.0000000000000D+00
      ALPHA(30,0,41)=  0.0000000000000D+00
      ALPHA(31,0,41)=  0.0000000000000D+00
      ALPHA(32,0,41)=  0.0000000000000D+00
      ALPHA(33,0,41)=  0.0000000000000D+00
      ALPHA(34,0,41)=  0.0000000000000D+00
      ALPHA(35,0,41)=  0.0000000000000D+00
      ALPHA(36,0,41)=  0.0000000000000D+00
      ALPHA(37,0,41)=  0.0000000000000D+00
      ALPHA(38,0,41)=  0.0000000000000D+00
      ALPHA(39,0,41)=  0.0000000000000D+00
      ALPHA(40,0,41)=  0.0000000000000D+00
      ALPHA(41,0,41)=  1.0000000000000D+00
C l= 0 n=41 ; Coef  :
      COEF (   0,41)= -1.0000000000000D+00
C l= 1 n=41 ; Alpha :
      ALPHA( 1,1,41)=  1.0000000000000D+00
      ALPHA( 2,1,41)= 0.50000000000000D+00
      ALPHA( 3,1,41)= 0.33333333333333D+00
      ALPHA( 4,1,41)= 0.25000000000000D+00
      ALPHA( 5,1,41)= 0.20000000000000D+00
      ALPHA( 6,1,41)= 0.16666666666667D+00
      ALPHA( 7,1,41)= 0.14285714285714D+00
      ALPHA( 8,1,41)= 0.12500000000000D+00
      ALPHA( 9,1,41)= 0.11111111111111D+00
      ALPHA(10,1,41)= 0.10000000000000D+00
      ALPHA(11,1,41)= 0.90909090909091D-01
      ALPHA(12,1,41)= 0.83333333333333D-01
      ALPHA(13,1,41)= 0.76923076923077D-01
      ALPHA(14,1,41)= 0.71428571428571D-01
      ALPHA(15,1,41)= 0.66666666666667D-01
      ALPHA(16,1,41)= 0.62500000000000D-01
      ALPHA(17,1,41)= 0.58823529411765D-01
      ALPHA(18,1,41)= 0.55555555555556D-01
      ALPHA(19,1,41)= 0.52631578947368D-01
      ALPHA(20,1,41)= 0.50000000000000D-01
      ALPHA(21,1,41)= 0.47619047619048D-01
      ALPHA(22,1,41)= 0.45454545454545D-01
      ALPHA(23,1,41)= 0.43478260869565D-01
      ALPHA(24,1,41)= 0.41666666666667D-01
      ALPHA(25,1,41)= 0.40000000000000D-01
      ALPHA(26,1,41)= 0.38461538461538D-01
      ALPHA(27,1,41)= 0.37037037037037D-01
      ALPHA(28,1,41)= 0.35714285714286D-01
      ALPHA(29,1,41)= 0.34482758620690D-01
      ALPHA(30,1,41)= 0.33333333333333D-01
      ALPHA(31,1,41)= 0.32258064516129D-01
      ALPHA(32,1,41)= 0.31250000000000D-01
      ALPHA(33,1,41)= 0.30303030303030D-01
      ALPHA(34,1,41)= 0.29411764705882D-01
      ALPHA(35,1,41)= 0.28571428571429D-01
      ALPHA(36,1,41)= 0.27777777777778D-01
      ALPHA(37,1,41)= 0.27027027027027D-01
      ALPHA(38,1,41)= 0.26315789473684D-01
      ALPHA(39,1,41)= 0.25641025641026D-01
      ALPHA(40,1,41)= 0.25000000000000D-01
      ALPHA(41,1,41)= 0.24390243902439D-01
C l= 1 n=41 ; Coef  :
      COEF (   1,41)= -4.3029332828388D+00
C l= 2 n=41 ; Alpha :
      ALPHA( 1,2,41)=  4.3029332828388D+00
      ALPHA( 2,2,41)=  1.6514666414194D+00
      ALPHA( 3,2,41)= 0.93431109427961D+00
      ALPHA( 4,2,41)= 0.61739998737637D+00
      ALPHA( 5,2,41)= 0.44391998990110D+00
      ALPHA( 6,2,41)= 0.33659999158425D+00
      ALPHA( 7,2,41)= 0.26470475469126D+00
      ALPHA( 8,2,41)= 0.21375951749771D+00
      ALPHA( 9,2,41)= 0.17611957110907D+00
      ALPHA(10,2,41)= 0.14739650288706D+00
      ALPHA(11,2,41)= 0.12490591171551D+00
      ALPHA(12,2,41)= 0.10692132816346D+00
      ALPHA(13,2,41)= 0.92286354202164D-01
      ALPHA(14,2,41)= 0.80199966264647D-01
      ALPHA(15,2,41)= 0.70091397085099D-01
      ALPHA(16,2,41)= 0.61544018100614D-01
      ALPHA(17,2,41)= 0.54247311153519D-01
      ALPHA(18,2,41)= 0.47965597788781D-01
      ALPHA(19,2,41)= 0.42517116033816D-01
      ALPHA(20,2,41)= 0.37759681284757D-01
      ALPHA(21,2,41)= 0.33580648842625D-01
      ALPHA(22,2,41)= 0.29889753548913D-01
      ALPHA(23,2,41)= 0.26613914461806D-01
      ALPHA(24,2,41)= 0.23693407156332D-01
      ALPHA(25,2,41)= 0.21079004203412D-01
      ALPHA(26,2,41)= 0.18729811734050D-01
      ALPHA(27,2,41)= 0.16611613578658D-01
      ALPHA(28,2,41)= 0.14695590342383D-01
      ALPHA(29,2,41)= 0.12957318754222D-01
      ALPHA(30,2,41)= 0.11375982841725D-01
      ALPHA(31,2,41)= 0.99337468360782D-02
      ALPHA(32,2,41)= 0.86152527313217D-02
      ALPHA(33,2,41)= 0.74072147697665D-02
      ALPHA(34,2,41)= 0.62980899146843D-02
      ALPHA(35,2,41)= 0.52778083540966D-02
      ALPHA(36,2,41)= 0.43375517728320D-02
      ALPHA(37,2,41)= 0.34695698930858D-02
      ALPHA(38,2,41)= 0.26670278688723D-02
      ALPHA(39,2,41)= 0.19238787062427D-02
      ALPHA(40,2,41)= 0.12347560975610D-02
      ALPHA(41,2,41)= 0.59488399762046D-03
C l= 2 n=41 ; Coef  :
      COEF (   2,41)= -10.068036841783D+00
C l= 3 n=41 ; Alpha :
      ALPHA( 1,3,41)=  10.068036841783D+00
      ALPHA( 2,3,41)=  2.8825517794722D+00
      ALPHA( 3,3,41)=  1.3712123058417D+00
      ALPHA( 4,3,41)= 0.79483145581137D+00
      ALPHA( 5,3,41)= 0.51238516717382D+00
      ALPHA( 6,3,41)= 0.35300097432800D+00
      ALPHA( 7,3,41)= 0.25448655062625D+00
      ALPHA( 8,3,41)= 0.18958763746156D+00
      ALPHA( 9,3,41)= 0.14477128691053D+00
      ALPHA(10,3,41)= 0.11268220110857D+00
      ALPHA(11,3,41)= 0.89038682563513D-01
      ALPHA(12,3,41)= 0.71209966373595D-01
      ALPHA(13,3,41)= 0.57507559101514D-01
      ALPHA(14,3,41)= 0.46807993865537D-01
      ALPHA(15,3,41)= 0.38340796523525D-01
      ALPHA(16,3,41)= 0.31563784422986D-01
      ALPHA(17,3,41)= 0.26086854862774D-01
      ALPHA(18,3,41)= 0.21623845639647D-01
      ALPHA(19,3,41)= 0.17961243353940D-01
      ALPHA(20,3,41)= 0.14937325384552D-01
      ALPHA(21,3,41)= 0.12427944114585D-01
      ALPHA(22,3,41)= 0.10336644434712D-01
      ALPHA(23,3,41)= 0.85876706093370D-02
      ALPHA(24,3,41)= 0.71209378980394D-02
      ALPHA(25,3,41)= 0.58883640958645D-02
      ALPHA(26,3,41)= 0.48511576228154D-02
      ALPHA(27,3,41)= 0.39777883873759D-02
      ALPHA(28,3,41)= 0.32424526028747D-02
      ALPHA(29,3,41)= 0.26238993978658D-02
      ALPHA(30,3,41)= 0.21045254594629D-02
      ALPHA(31,3,41)= 0.16696703529730D-02
      ALPHA(32,3,41)= 0.13070635658151D-02
      ALPHA(33,3,41)= 0.10063873143867D-02
      ALPHA(34,3,41)= 0.75892842955868D-03
      ALPHA(35,3,41)= 0.55729933400889D-03
      ALPHA(36,3,41)= 0.39521300933929D-03
      ALPHA(37,3,41)= 0.26730044765898D-03
      ALPHA(38,3,41)= 0.16896175448149D-03
      ALPHA(39,3,41)= 0.96244071831388D-04
      ALPHA(40,3,41)= 0.45741002379536D-04
      ALPHA(41,3,41)= 0.14509365795621D-04
C l= 3 n=41 ; Coef  :
      COEF (   3,41)= -17.166072955880D+00
C l= 4 n=41 ; Alpha :
      ALPHA( 1,4,41)=  17.166072955880D+00
      ALPHA( 2,4,41)=  3.5490180570484D+00
      ALPHA( 3,4,41)=  1.4051614448748D+00
      ALPHA( 4,4,41)= 0.71106800719571D+00
      ALPHA( 5,4,41)= 0.40988811459430D+00
      ALPHA( 6,4,41)= 0.25617590096628D+00
      ALPHA( 7,4,41)= 0.16915063306709D+00
      ALPHA( 8,4,41)= 0.11619598510543D+00
      ALPHA( 9,4,41)= 0.82220027042428D-01
      ALPHA(10,4,41)= 0.59520895647132D-01
      ALPHA(11,4,41)= 0.43866068669341D-01
      ALPHA(12,4,41)= 0.32790672733269D-01
      ALPHA(13,4,41)= 0.24790623571203D-01
      ALPHA(14,4,41)= 0.18912181951723D-01
      ALPHA(15,4,41)= 0.14530836897239D-01
      ALPHA(16,4,41)= 0.11226359808441D-01
      ALPHA(17,4,41)= 0.87092925007103D-02
      ALPHA(18,4,41)= 0.67761732027389D-02
      ALPHA(19,4,41)= 0.52814353689292D-02
      ALPHA(20,4,41)= 0.41193014327857D-02
      ALPHA(21,4,41)= 0.32118430129125D-02
      ALPHA(22,4,41)= 0.25009435980262D-02
      ALPHA(23,4,41)= 0.19427875966028D-02
      ALPHA(24,4,41)= 0.15040185046886D-02
      ALPHA(25,4,41)= 0.11590202485795D-02
      ALPHA(26,4,41)= 0.88796700456244D-03
      ALPHA(27,4,41)= 0.67540683317808D-03
      ALPHA(28,4,41)= 0.50922128958686D-03
      ALPHA(29,4,41)= 0.37985322432956D-03
      ALPHA(30,4,41)= 0.27972813692305D-03
      ALPHA(31,4,41)= 0.20281673058802D-03
      ALPHA(32,4,41)= 0.14430150922674D-03
      ALPHA(33,4,41)= 0.10032074937699D-03
      ALPHA(34,4,41)= 0.67770512207467D-04
      ALPHA(35,4,41)= 0.44150542442720D-04
      ALPHA(36,4,41)= 0.27443601430175D-04
      ALPHA(37,4,41)= 0.16020449787757D-04
      ALPHA(38,4,41)= 0.85646366970534D-05
      ALPHA(39,4,41)= 0.40126779488858D-05
      ALPHA(40,4,41)= 0.15062592043789D-05
      ALPHA(41,4,41)= 0.35388697062490D-06
C l= 4 n=41 ; Coef  :
      COEF (   4,41)= -24.109143018563D+00
C l= 0 n=42 ; Alpha :
      ALPHA( 1,0,42)=  0.0000000000000D+00
      ALPHA( 2,0,42)=  0.0000000000000D+00
      ALPHA( 3,0,42)=  0.0000000000000D+00
      ALPHA( 4,0,42)=  0.0000000000000D+00
      ALPHA( 5,0,42)=  0.0000000000000D+00
      ALPHA( 6,0,42)=  0.0000000000000D+00
      ALPHA( 7,0,42)=  0.0000000000000D+00
      ALPHA( 8,0,42)=  0.0000000000000D+00
      ALPHA( 9,0,42)=  0.0000000000000D+00
      ALPHA(10,0,42)=  0.0000000000000D+00
      ALPHA(11,0,42)=  0.0000000000000D+00
      ALPHA(12,0,42)=  0.0000000000000D+00
      ALPHA(13,0,42)=  0.0000000000000D+00
      ALPHA(14,0,42)=  0.0000000000000D+00
      ALPHA(15,0,42)=  0.0000000000000D+00
      ALPHA(16,0,42)=  0.0000000000000D+00
      ALPHA(17,0,42)=  0.0000000000000D+00
      ALPHA(18,0,42)=  0.0000000000000D+00
      ALPHA(19,0,42)=  0.0000000000000D+00
      ALPHA(20,0,42)=  0.0000000000000D+00
      ALPHA(21,0,42)=  0.0000000000000D+00
      ALPHA(22,0,42)=  0.0000000000000D+00
      ALPHA(23,0,42)=  0.0000000000000D+00
      ALPHA(24,0,42)=  0.0000000000000D+00
      ALPHA(25,0,42)=  0.0000000000000D+00
      ALPHA(26,0,42)=  0.0000000000000D+00
      ALPHA(27,0,42)=  0.0000000000000D+00
      ALPHA(28,0,42)=  0.0000000000000D+00
      ALPHA(29,0,42)=  0.0000000000000D+00
      ALPHA(30,0,42)=  0.0000000000000D+00
      ALPHA(31,0,42)=  0.0000000000000D+00
      ALPHA(32,0,42)=  0.0000000000000D+00
      ALPHA(33,0,42)=  0.0000000000000D+00
      ALPHA(34,0,42)=  0.0000000000000D+00
      ALPHA(35,0,42)=  0.0000000000000D+00
      ALPHA(36,0,42)=  0.0000000000000D+00
      ALPHA(37,0,42)=  0.0000000000000D+00
      ALPHA(38,0,42)=  0.0000000000000D+00
      ALPHA(39,0,42)=  0.0000000000000D+00
      ALPHA(40,0,42)=  0.0000000000000D+00
      ALPHA(41,0,42)=  0.0000000000000D+00
      ALPHA(42,0,42)=  1.0000000000000D+00
C l= 0 n=42 ; Coef  :
      COEF (   0,42)= -1.0000000000000D+00
C l= 1 n=42 ; Alpha :
      ALPHA( 1,1,42)=  1.0000000000000D+00
      ALPHA( 2,1,42)= 0.50000000000000D+00
      ALPHA( 3,1,42)= 0.33333333333333D+00
      ALPHA( 4,1,42)= 0.25000000000000D+00
      ALPHA( 5,1,42)= 0.20000000000000D+00
      ALPHA( 6,1,42)= 0.16666666666667D+00
      ALPHA( 7,1,42)= 0.14285714285714D+00
      ALPHA( 8,1,42)= 0.12500000000000D+00
      ALPHA( 9,1,42)= 0.11111111111111D+00
      ALPHA(10,1,42)= 0.10000000000000D+00
      ALPHA(11,1,42)= 0.90909090909091D-01
      ALPHA(12,1,42)= 0.83333333333333D-01
      ALPHA(13,1,42)= 0.76923076923077D-01
      ALPHA(14,1,42)= 0.71428571428571D-01
      ALPHA(15,1,42)= 0.66666666666667D-01
      ALPHA(16,1,42)= 0.62500000000000D-01
      ALPHA(17,1,42)= 0.58823529411765D-01
      ALPHA(18,1,42)= 0.55555555555556D-01
      ALPHA(19,1,42)= 0.52631578947368D-01
      ALPHA(20,1,42)= 0.50000000000000D-01
      ALPHA(21,1,42)= 0.47619047619048D-01
      ALPHA(22,1,42)= 0.45454545454545D-01
      ALPHA(23,1,42)= 0.43478260869565D-01
      ALPHA(24,1,42)= 0.41666666666667D-01
      ALPHA(25,1,42)= 0.40000000000000D-01
      ALPHA(26,1,42)= 0.38461538461538D-01
      ALPHA(27,1,42)= 0.37037037037037D-01
      ALPHA(28,1,42)= 0.35714285714286D-01
      ALPHA(29,1,42)= 0.34482758620690D-01
      ALPHA(30,1,42)= 0.33333333333333D-01
      ALPHA(31,1,42)= 0.32258064516129D-01
      ALPHA(32,1,42)= 0.31250000000000D-01
      ALPHA(33,1,42)= 0.30303030303030D-01
      ALPHA(34,1,42)= 0.29411764705882D-01
      ALPHA(35,1,42)= 0.28571428571429D-01
      ALPHA(36,1,42)= 0.27777777777778D-01
      ALPHA(37,1,42)= 0.27027027027027D-01
      ALPHA(38,1,42)= 0.26315789473684D-01
      ALPHA(39,1,42)= 0.25641025641026D-01
      ALPHA(40,1,42)= 0.25000000000000D-01
      ALPHA(41,1,42)= 0.24390243902439D-01
      ALPHA(42,1,42)= 0.23809523809524D-01
C l= 1 n=42 ; Coef  :
      COEF (   1,42)= -4.3267428066483D+00
C l= 2 n=42 ; Alpha :
      ALPHA( 1,2,42)=  4.3267428066483D+00
      ALPHA( 2,2,42)=  1.6633714033242D+00
      ALPHA( 3,2,42)= 0.94224760221611D+00
      ALPHA( 4,2,42)= 0.62335236832875D+00
      ALPHA( 5,2,42)= 0.44868189466300D+00
      ALPHA( 6,2,42)= 0.34056824555250D+00
      ALPHA( 7,2,42)= 0.26810611523548D+00
      ALPHA( 8,2,42)= 0.21673570797390D+00
      ALPHA( 9,2,42)= 0.17876507375458D+00
      ALPHA(10,2,42)= 0.14977745526801D+00
      ALPHA(11,2,42)= 0.12707041388001D+00
      ALPHA(12,2,42)= 0.10890545514758D+00
      ALPHA(13,2,42)= 0.94117856033666D-01
      ALPHA(14,2,42)= 0.81900646536756D-01
      ALPHA(15,2,42)= 0.71678698672401D-01
      ALPHA(16,2,42)= 0.63032113338709D-01
      ALPHA(17,2,42)= 0.55647871377609D-01
      ALPHA(18,2,42)= 0.49288349111532D-01
      ALPHA(19,2,42)= 0.43770248865896D-01
      ALPHA(20,2,42)= 0.38950157475233D-01
      ALPHA(21,2,42)= 0.34714435690698D-01
      ALPHA(22,2,42)= 0.30972004631164D-01
      ALPHA(23,2,42)= 0.27649111149177D-01
      ALPHA(24,2,42)= 0.24685470648396D-01
      ALPHA(25,2,42)= 0.22031385155793D-01
      ALPHA(26,2,42)= 0.19645562649801D-01
      ALPHA(27,2,42)= 0.17493447793826D-01
      ALPHA(28,2,42)= 0.15545930478438D-01
      ALPHA(29,2,42)= 0.13778336816620D-01
      ALPHA(30,2,42)= 0.12169633635376D-01
      ALPHA(31,2,42)= 0.10701795991224D-01
      ALPHA(32,2,42)= 0.93593003503693D-02
      ALPHA(33,2,42)= 0.81287154912672D-02
      ALPHA(34,2,42)= 0.69983700267291D-02
      ALPHA(35,2,42)= 0.59580804629402D-02
      ALPHA(36,2,42)= 0.49989274342077D-02
      ALPHA(37,2,42)= 0.41130705365865D-02
      ALPHA(38,2,42)= 0.32935942849124D-02
      ALPHA(39,2,42)= 0.25343793167433D-02
      ALPHA(40,2,42)= 0.18299941927991D-02
      ALPHA(41,2,42)= 0.11756040905357D-02
      ALPHA(42,2,42)= 0.56689342403628D-03
C l= 2 n=42 ; Coef  :
      COEF (   2,42)= -10.171054527656D+00
C l= 3 n=42 ; Alpha :
      ALPHA( 1,3,42)=  10.171054527656D+00
      ALPHA( 2,3,42)=  2.9221558605038D+00
      ALPHA( 3,3,42)=  1.3936467725611D+00
      ALPHA( 4,3,42)= 0.80967317886681D+00
      ALPHA( 5,3,42)= 0.52306806942770D+00
      ALPHA( 6,3,42)= 0.36110974207925D+00
      ALPHA( 7,3,42)= 0.26087002956043D+00
      ALPHA( 8,3,42)= 0.19474801146094D+00
      ALPHA( 9,3,42)= 0.14902759819040D+00
      ALPHA(10,3,42)= 0.11624833099590D+00
      ALPHA(11,3,42)= 0.92064168608276D-01
      ALPHA(12,3,42)= 0.73802953400919D-01
      ALPHA(13,3,42)= 0.59748460435649D-01
      ALPHA(14,3,42)= 0.48758009259270D-01
      ALPHA(15,3,42)= 0.40047432206201D-01
      ALPHA(16,3,42)= 0.33064549026289D-01
      ALPHA(17,3,42)= 0.27411804181289D-01
      ALPHA(18,3,42)= 0.22797377761350D-01
      ALPHA(19,3,42)= 0.19003392136461D-01
      ALPHA(20,3,42)= 0.15864710086344D-01
      ALPHA(21,3,42)= 0.13254478297697D-01
      ALPHA(22,3,42)= 0.11074073116406D-01
      ALPHA(23,3,42)= 0.92459827795555D-02
      ALPHA(24,3,42)= 0.77086871991917D-02
      ALPHA(25,3,42)= 0.64129208852882D-02
      ALPHA(26,3,42)= 0.53189091144774D-02
      ALPHA(27,3,42)= 0.43942990491337D-02
      ALPHA(28,3,42)= 0.36125938047423D-02
      ALPHA(29,3,42)= 0.29519550363568D-02
      ALPHA(30,3,42)= 0.23942786412576D-02
      ALPHA(31,3,42)= 0.19244750194307D-02
      ALPHA(32,3,42)= 0.15299040503477D-02
      ALPHA(33,3,42)= 0.11999281594169D-02
      ALPHA(34,3,42)= 0.92555628733795D-03
      ALPHA(35,3,42)= 0.69915839265032D-03
      ALPHA(36,3,42)= 0.51423509110614D-03
      ALPHA(37,3,42)= 0.36523069853009D-03
      ALPHA(38,3,42)= 0.24738066602702D-03
      ALPHA(39,3,42)= 0.15658643651575D-03
      ALPHA(40,3,42)= 0.89312292684276D-04
      ALPHA(41,3,42)= 0.42499939379804D-04
      ALPHA(42,3,42)= 0.13497462477054D-04
C l= 3 n=42 ; Coef  :
      COEF (   3,42)= -17.408240920824D+00
C l= 4 n=42 ; Alpha :
      ALPHA( 1,4,42)=  17.408240920824D+00
      ALPHA( 2,4,42)=  3.6185931965842D+00
      ALPHA( 3,4,42)=  1.4383435108882D+00
      ALPHA( 4,4,42)= 0.73034594002587D+00
      ALPHA( 5,4,42)= 0.42234211624734D+00
      ALPHA( 6,4,42)= 0.26477375196816D+00
      ALPHA( 7,4,42)= 0.17536182424710D+00
      ALPHA( 8,4,42)= 0.12083284252116D+00
      ALPHA( 9,4,42)= 0.85768303189818D-01
      ALPHA(10,4,42)= 0.62288713051796D-01
      ALPHA(11,4,42)= 0.46058072683823D-01
      ALPHA(12,4,42)= 0.34547885909482D-01
      ALPHA(13,4,42)= 0.26213205962528D-01
      ALPHA(14,4,42)= 0.20073086934087D-01
      ALPHA(15,4,42)= 0.15484347187863D-01
      ALPHA(16,4,42)= 0.12013610975734D-01
      ALPHA(17,4,42)= 0.93619545050267D-02
      ALPHA(18,4,42)= 0.73189679113425D-02
      ALPHA(19,4,42)= 0.57338970864640D-02
      ALPHA(20,4,42)= 0.44970326253177D-02
      ALPHA(21,4,42)= 0.35274258295243D-02
      ALPHA(22,4,42)= 0.27646120055597D-02
      ALPHA(23,4,42)= 0.21629300437351D-02
      ALPHA(24,4,42)= 0.16875586760980D-02
      ALPHA(25,4,42)= 0.13117088410864D-02
      ALPHA(26,4,42)= 0.10146076977643D-02
      ALPHA(27,4,42)= 0.78003300101459D-03
      ALPHA(28,4,42)= 0.59523542779501D-03
      ALPHA(29,4,42)= 0.45013786805235D-03
      ALPHA(30,4,42)= 0.33673477123871D-03
      ALPHA(31,4,42)= 0.24863756438399D-03
      ALPHA(32,4,42)= 0.18072779613978D-03
      ALPHA(33,4,42)= 0.12889046745834D-03
      ALPHA(34,4,42)= 0.89807566667894D-04
      ALPHA(35,4,42)= 0.60797170839156D-04
      ALPHA(36,4,42)= 0.39687294075559D-04
      ALPHA(37,4,42)= 0.24716418800378D-04
      ALPHA(38,4,42)= 0.14454652554840D-04
      ALPHA(39,4,42)= 0.77409264373560D-05
      ALPHA(40,4,42)= 0.36327423635283D-05
      ALPHA(41,4,42)= 0.13657902891917D-05
      ALPHA(42,4,42)= 0.32136815421558D-06
C l= 4 n=42 ; Coef  :
      COEF (   4,42)= -24.523624945250D+00
C l= 0 n=43 ; Alpha :
      ALPHA( 1,0,43)=  0.0000000000000D+00
      ALPHA( 2,0,43)=  0.0000000000000D+00
      ALPHA( 3,0,43)=  0.0000000000000D+00
      ALPHA( 4,0,43)=  0.0000000000000D+00
      ALPHA( 5,0,43)=  0.0000000000000D+00
      ALPHA( 6,0,43)=  0.0000000000000D+00
      ALPHA( 7,0,43)=  0.0000000000000D+00
      ALPHA( 8,0,43)=  0.0000000000000D+00
      ALPHA( 9,0,43)=  0.0000000000000D+00
      ALPHA(10,0,43)=  0.0000000000000D+00
      ALPHA(11,0,43)=  0.0000000000000D+00
      ALPHA(12,0,43)=  0.0000000000000D+00
      ALPHA(13,0,43)=  0.0000000000000D+00
      ALPHA(14,0,43)=  0.0000000000000D+00
      ALPHA(15,0,43)=  0.0000000000000D+00
      ALPHA(16,0,43)=  0.0000000000000D+00
      ALPHA(17,0,43)=  0.0000000000000D+00
      ALPHA(18,0,43)=  0.0000000000000D+00
      ALPHA(19,0,43)=  0.0000000000000D+00
      ALPHA(20,0,43)=  0.0000000000000D+00
      ALPHA(21,0,43)=  0.0000000000000D+00
      ALPHA(22,0,43)=  0.0000000000000D+00
      ALPHA(23,0,43)=  0.0000000000000D+00
      ALPHA(24,0,43)=  0.0000000000000D+00
      ALPHA(25,0,43)=  0.0000000000000D+00
      ALPHA(26,0,43)=  0.0000000000000D+00
      ALPHA(27,0,43)=  0.0000000000000D+00
      ALPHA(28,0,43)=  0.0000000000000D+00
      ALPHA(29,0,43)=  0.0000000000000D+00
      ALPHA(30,0,43)=  0.0000000000000D+00
      ALPHA(31,0,43)=  0.0000000000000D+00
      ALPHA(32,0,43)=  0.0000000000000D+00
      ALPHA(33,0,43)=  0.0000000000000D+00
      ALPHA(34,0,43)=  0.0000000000000D+00
      ALPHA(35,0,43)=  0.0000000000000D+00
      ALPHA(36,0,43)=  0.0000000000000D+00
      ALPHA(37,0,43)=  0.0000000000000D+00
      ALPHA(38,0,43)=  0.0000000000000D+00
      ALPHA(39,0,43)=  0.0000000000000D+00
      ALPHA(40,0,43)=  0.0000000000000D+00
      ALPHA(41,0,43)=  0.0000000000000D+00
      ALPHA(42,0,43)=  0.0000000000000D+00
      ALPHA(43,0,43)=  1.0000000000000D+00
C l= 0 n=43 ; Coef  :
      COEF (   0,43)= -1.0000000000000D+00
C l= 1 n=43 ; Alpha :
      ALPHA( 1,1,43)=  1.0000000000000D+00
      ALPHA( 2,1,43)= 0.50000000000000D+00
      ALPHA( 3,1,43)= 0.33333333333333D+00
      ALPHA( 4,1,43)= 0.25000000000000D+00
      ALPHA( 5,1,43)= 0.20000000000000D+00
      ALPHA( 6,1,43)= 0.16666666666667D+00
      ALPHA( 7,1,43)= 0.14285714285714D+00
      ALPHA( 8,1,43)= 0.12500000000000D+00
      ALPHA( 9,1,43)= 0.11111111111111D+00
      ALPHA(10,1,43)= 0.10000000000000D+00
      ALPHA(11,1,43)= 0.90909090909091D-01
      ALPHA(12,1,43)= 0.83333333333333D-01
      ALPHA(13,1,43)= 0.76923076923077D-01
      ALPHA(14,1,43)= 0.71428571428571D-01
      ALPHA(15,1,43)= 0.66666666666667D-01
      ALPHA(16,1,43)= 0.62500000000000D-01
      ALPHA(17,1,43)= 0.58823529411765D-01
      ALPHA(18,1,43)= 0.55555555555556D-01
      ALPHA(19,1,43)= 0.52631578947368D-01
      ALPHA(20,1,43)= 0.50000000000000D-01
      ALPHA(21,1,43)= 0.47619047619048D-01
      ALPHA(22,1,43)= 0.45454545454545D-01
      ALPHA(23,1,43)= 0.43478260869565D-01
      ALPHA(24,1,43)= 0.41666666666667D-01
      ALPHA(25,1,43)= 0.40000000000000D-01
      ALPHA(26,1,43)= 0.38461538461538D-01
      ALPHA(27,1,43)= 0.37037037037037D-01
      ALPHA(28,1,43)= 0.35714285714286D-01
      ALPHA(29,1,43)= 0.34482758620690D-01
      ALPHA(30,1,43)= 0.33333333333333D-01
      ALPHA(31,1,43)= 0.32258064516129D-01
      ALPHA(32,1,43)= 0.31250000000000D-01
      ALPHA(33,1,43)= 0.30303030303030D-01
      ALPHA(34,1,43)= 0.29411764705882D-01
      ALPHA(35,1,43)= 0.28571428571429D-01
      ALPHA(36,1,43)= 0.27777777777778D-01
      ALPHA(37,1,43)= 0.27027027027027D-01
      ALPHA(38,1,43)= 0.26315789473684D-01
      ALPHA(39,1,43)= 0.25641025641026D-01
      ALPHA(40,1,43)= 0.25000000000000D-01
      ALPHA(41,1,43)= 0.24390243902439D-01
      ALPHA(42,1,43)= 0.23809523809524D-01
      ALPHA(43,1,43)= 0.23255813953488D-01
C l= 1 n=43 ; Coef  :
      COEF (   1,43)= -4.3499986206018D+00
C l= 2 n=43 ; Alpha :
      ALPHA( 1,2,43)=  4.3499986206018D+00
      ALPHA( 2,2,43)=  1.6749993103009D+00
      ALPHA( 3,2,43)= 0.94999954020061D+00
      ALPHA( 4,2,43)= 0.62916632181712D+00
      ALPHA( 5,2,43)= 0.45333305745370D+00
      ALPHA( 6,2,43)= 0.34444421454475D+00
      ALPHA( 7,2,43)= 0.27142837437169D+00
      ALPHA( 8,2,43)= 0.21964268471809D+00
      ALPHA( 9,2,43)= 0.18134905308274D+00
      ALPHA(10,2,43)= 0.15210303666336D+00
      ALPHA(11,2,43)= 0.12918457878487D+00
      ALPHA(12,2,43)= 0.11084343964371D+00
      ALPHA(13,2,43)= 0.95906764799319D-01
      ALPHA(14,2,43)= 0.83561776104862D-01
      ALPHA(15,2,43)= 0.73229086269300D-01
      ALPHA(16,2,43)= 0.64485601710802D-01
      ALPHA(17,2,43)= 0.57015860433696D-01
      ALPHA(18,2,43)= 0.50580338775615D-01
      ALPHA(19,2,43)= 0.44994239073974D-01
      ALPHA(20,2,43)= 0.40112948172907D-01
      ALPHA(21,2,43)= 0.35821855402769D-01
      ALPHA(22,2,43)= 0.32029087083595D-01
      ALPHA(23,2,43)= 0.28660233494981D-01
      ALPHA(24,2,43)= 0.25654462896458D-01
      ALPHA(25,2,43)= 0.22961617713933D-01
      ALPHA(26,2,43)= 0.20540017032628D-01
      ALPHA(27,2,43)= 0.18354774236547D-01
      ALPHA(28,2,43)= 0.16376495262491D-01
      ALPHA(29,2,43)= 0.14580261435705D-01
      ALPHA(30,2,43)= 0.12944827433826D-01
      ALPHA(31,2,43)= 0.11451983538111D-01
      ALPHA(32,2,43)= 0.10086044536416D-01
      ALPHA(33,2,43)= 0.88334371262214D-02
      ALPHA(34,2,43)= 0.76823645547728D-02
      ALPHA(35,2,43)= 0.66225322901827D-02
      ALPHA(36,2,43)= 0.56449222662491D-02
      ALPHA(37,2,43)= 0.47416060488429D-02
      ALPHA(38,2,43)= 0.39055893889516D-02
      ALPHA(39,2,43)= 0.31306822386276D-02
      ALPHA(40,2,43)= 0.24113895416363D-02
      ALPHA(41,2,43)= 0.17428190650110D-02
      ALPHA(42,2,43)= 0.11206032800717D-02
      ALPHA(43,2,43)= 0.54083288263926D-03
C l= 2 n=43 ; Coef  :
      COEF (   2,43)= -10.272217286275D+00
C l= 3 n=43 ; Alpha :
      ALPHA( 1,3,43)=  10.272217286275D+00
      ALPHA( 2,3,43)=  2.9611093328363D+00
      ALPHA( 3,3,43)=  1.4157397851239D+00
      ALPHA( 4,3,43)= 0.82430495379279D+00
      ALPHA( 5,3,43)= 0.53361069867081D+00
      ALPHA( 6,3,43)= 0.36912007265006D+00
      ALPHA( 7,3,43)= 0.26718231733651D+00
      ALPHA( 8,3,43)= 0.19985598087299D+00
      ALPHA( 9,3,43)= 0.15324501802954D+00
      ALPHA(10,3,43)= 0.11978561091831D+00
      ALPHA(11,3,43)= 0.95068461138156D-01
      ALPHA(12,3,43)= 0.76380707811237D-01
      ALPHA(13,3,43)= 0.61978850314703D-01
      ALPHA(14,3,43)= 0.50701306377987D-01
      ALPHA(15,3,43)= 0.41750434212464D-01
      ALPHA(16,3,43)= 0.34564214182354D-01
      ALPHA(17,3,43)= 0.28737754423933D-01
      ALPHA(18,3,43)= 0.23973664709620D-01
      ALPHA(19,3,43)= 0.20049769789345D-01
      ALPHA(20,3,43)= 0.16797569346179D-01
      ALPHA(21,3,43)= 0.14087544702413D-01
      ALPHA(22,3,43)= 0.11818935606723D-01
      ALPHA(23,3,43)= 0.99124998375783D-02
      ALPHA(24,3,43)= 0.83053026153884D-02
      ALPHA(25,3,43)= 0.69469119949145D-02
      ALPHA(26,3,43)= 0.57965839291896D-02
      ALPHA(27,3,43)= 0.48211542639371D-02
      ALPHA(28,3,43)= 0.39934425317770D-02
      ALPHA(29,3,43)= 0.32910308836988D-02
      ALPHA(30,3,43)= 0.26953211397186D-02
      ALPHA(31,3,43)= 0.21908002179914D-02
      ALPHA(32,3,43)= 0.17644632256132D-02
      ALPHA(33,3,43)= 0.14053569297941D-02
      ALPHA(34,3,43)= 0.11042159281466D-02
      ALPHA(35,3,43)= 0.85317077149178D-03
      ALPHA(36,3,43)= 0.64551235311193D-03
      ALPHA(37,3,43)= 0.47550060664271D-03
      ALPHA(38,3,43)= 0.33820832623520D-03
      ALPHA(39,3,43)= 0.22939300020477D-03
      ALPHA(40,3,43)= 0.14539111923396D-03
      ALPHA(41,3,43)= 0.83030615310292D-04
      ALPHA(42,3,43)= 0.39558003874071D-04
      ALPHA(43,3,43)= 0.12577508898588D-04
C l= 3 n=43 ; Coef  :
      COEF (   3,43)= -17.647129694924D+00
C l= 4 n=43 ; Alpha :
      ALPHA( 1,4,43)=  17.647129694924D+00
      ALPHA( 2,4,43)=  3.6874562043246D+00
      ALPHA( 3,4,43)=  1.4712676919376D+00
      ALPHA( 4,4,43)= 0.74951582267222D+00
      ALPHA( 5,4,43)= 0.43475166737921D+00
      ALPHA( 6,4,43)= 0.27335793970421D+00
      ALPHA( 7,4,43)= 0.18157536651074D+00
      ALPHA( 8,4,43)= 0.12548065602984D+00
      ALPHA( 9,4,43)= 0.89332140818412D-01
      ALPHA(10,4,43)= 0.65074424933617D-01
      ALPHA(11,4,43)= 0.48268967128897D-01
      ALPHA(12,4,43)= 0.36324181439976D-01
      ALPHA(13,4,43)= 0.27654574574498D-01
      ALPHA(14,4,43)= 0.21252187082412D-01
      ALPHA(15,4,43)= 0.16455287518385D-01
      ALPHA(16,4,43)= 0.12817429910207D-01
      ALPHA(17,4,43)= 0.10030274375351D-01
      ALPHA(18,4,43)= 0.78764949976128D-02
      ALPHA(19,4,43)= 0.62001708024952D-02
      ALPHA(20,4,43)= 0.48876737729032D-02
      ALPHA(21,4,43)= 0.38550431481851D-02
      ALPHA(22,4,43)= 0.30394709731579D-02
      ALPHA(23,4,43)= 0.23934532957718D-02
      ALPHA(24,4,43)= 0.18807052485489D-02
      ALPHA(25,4,43)= 0.14732649339914D-02
      ALPHA(26,4,43)= 0.11494119751873D-02
      ALPHA(27,4,43)= 0.89215286761778D-03
      ALPHA(28,4,43)= 0.68810618434796D-03
      ALPHA(29,4,43)= 0.52667346999883D-03
      ALPHA(30,4,43)= 0.39941665820891D-03
      ALPHA(31,4,43)= 0.29958640666286D-03
      ALPHA(32,4,43)= 0.22176182464241D-03
      ALPHA(33,4,43)= 0.16157318675588D-03
      ALPHA(34,4,43)= 0.11548700685735D-03
      ALPHA(35,4,43)= 0.80638351571523D-04
      ALPHA(36,4,43)= 0.54699209264209D-04
      ALPHA(37,4,43)= 0.35774572443232D-04
      ALPHA(38,4,43)= 0.22319962467286D-04
      ALPHA(39,4,43)= 0.13075647372351D-04
      ALPHA(40,4,43)= 0.70139311829227D-05
      ALPHA(41,4,43)= 0.32967348312915D-05
      ALPHA(42,4,43)= 0.12413217326823D-05
      ALPHA(43,4,43)= 0.29250020694390D-06
C l= 4 n=43 ; Coef  :
      COEF (   4,43)= -24.934023310248D+00
C l= 0 n=44 ; Alpha :
      ALPHA( 1,0,44)=  0.0000000000000D+00
      ALPHA( 2,0,44)=  0.0000000000000D+00
      ALPHA( 3,0,44)=  0.0000000000000D+00
      ALPHA( 4,0,44)=  0.0000000000000D+00
      ALPHA( 5,0,44)=  0.0000000000000D+00
      ALPHA( 6,0,44)=  0.0000000000000D+00
      ALPHA( 7,0,44)=  0.0000000000000D+00
      ALPHA( 8,0,44)=  0.0000000000000D+00
      ALPHA( 9,0,44)=  0.0000000000000D+00
      ALPHA(10,0,44)=  0.0000000000000D+00
      ALPHA(11,0,44)=  0.0000000000000D+00
      ALPHA(12,0,44)=  0.0000000000000D+00
      ALPHA(13,0,44)=  0.0000000000000D+00
      ALPHA(14,0,44)=  0.0000000000000D+00
      ALPHA(15,0,44)=  0.0000000000000D+00
      ALPHA(16,0,44)=  0.0000000000000D+00
      ALPHA(17,0,44)=  0.0000000000000D+00
      ALPHA(18,0,44)=  0.0000000000000D+00
      ALPHA(19,0,44)=  0.0000000000000D+00
      ALPHA(20,0,44)=  0.0000000000000D+00
      ALPHA(21,0,44)=  0.0000000000000D+00
      ALPHA(22,0,44)=  0.0000000000000D+00
      ALPHA(23,0,44)=  0.0000000000000D+00
      ALPHA(24,0,44)=  0.0000000000000D+00
      ALPHA(25,0,44)=  0.0000000000000D+00
      ALPHA(26,0,44)=  0.0000000000000D+00
      ALPHA(27,0,44)=  0.0000000000000D+00
      ALPHA(28,0,44)=  0.0000000000000D+00
      ALPHA(29,0,44)=  0.0000000000000D+00
      ALPHA(30,0,44)=  0.0000000000000D+00
      ALPHA(31,0,44)=  0.0000000000000D+00
      ALPHA(32,0,44)=  0.0000000000000D+00
      ALPHA(33,0,44)=  0.0000000000000D+00
      ALPHA(34,0,44)=  0.0000000000000D+00
      ALPHA(35,0,44)=  0.0000000000000D+00
      ALPHA(36,0,44)=  0.0000000000000D+00
      ALPHA(37,0,44)=  0.0000000000000D+00
      ALPHA(38,0,44)=  0.0000000000000D+00
      ALPHA(39,0,44)=  0.0000000000000D+00
      ALPHA(40,0,44)=  0.0000000000000D+00
      ALPHA(41,0,44)=  0.0000000000000D+00
      ALPHA(42,0,44)=  0.0000000000000D+00
      ALPHA(43,0,44)=  0.0000000000000D+00
      ALPHA(44,0,44)=  1.0000000000000D+00
C l= 0 n=44 ; Coef  :
      COEF (   0,44)= -1.0000000000000D+00
C l= 1 n=44 ; Alpha :
      ALPHA( 1,1,44)=  1.0000000000000D+00
      ALPHA( 2,1,44)= 0.50000000000000D+00
      ALPHA( 3,1,44)= 0.33333333333333D+00
      ALPHA( 4,1,44)= 0.25000000000000D+00
      ALPHA( 5,1,44)= 0.20000000000000D+00
      ALPHA( 6,1,44)= 0.16666666666667D+00
      ALPHA( 7,1,44)= 0.14285714285714D+00
      ALPHA( 8,1,44)= 0.12500000000000D+00
      ALPHA( 9,1,44)= 0.11111111111111D+00
      ALPHA(10,1,44)= 0.10000000000000D+00
      ALPHA(11,1,44)= 0.90909090909091D-01
      ALPHA(12,1,44)= 0.83333333333333D-01
      ALPHA(13,1,44)= 0.76923076923077D-01
      ALPHA(14,1,44)= 0.71428571428571D-01
      ALPHA(15,1,44)= 0.66666666666667D-01
      ALPHA(16,1,44)= 0.62500000000000D-01
      ALPHA(17,1,44)= 0.58823529411765D-01
      ALPHA(18,1,44)= 0.55555555555556D-01
      ALPHA(19,1,44)= 0.52631578947368D-01
      ALPHA(20,1,44)= 0.50000000000000D-01
      ALPHA(21,1,44)= 0.47619047619048D-01
      ALPHA(22,1,44)= 0.45454545454545D-01
      ALPHA(23,1,44)= 0.43478260869565D-01
      ALPHA(24,1,44)= 0.41666666666667D-01
      ALPHA(25,1,44)= 0.40000000000000D-01
      ALPHA(26,1,44)= 0.38461538461538D-01
      ALPHA(27,1,44)= 0.37037037037037D-01
      ALPHA(28,1,44)= 0.35714285714286D-01
      ALPHA(29,1,44)= 0.34482758620690D-01
      ALPHA(30,1,44)= 0.33333333333333D-01
      ALPHA(31,1,44)= 0.32258064516129D-01
      ALPHA(32,1,44)= 0.31250000000000D-01
      ALPHA(33,1,44)= 0.30303030303030D-01
      ALPHA(34,1,44)= 0.29411764705882D-01
      ALPHA(35,1,44)= 0.28571428571429D-01
      ALPHA(36,1,44)= 0.27777777777778D-01
      ALPHA(37,1,44)= 0.27027027027027D-01
      ALPHA(38,1,44)= 0.26315789473684D-01
      ALPHA(39,1,44)= 0.25641025641026D-01
      ALPHA(40,1,44)= 0.25000000000000D-01
      ALPHA(41,1,44)= 0.24390243902439D-01
      ALPHA(42,1,44)= 0.23809523809524D-01
      ALPHA(43,1,44)= 0.23255813953488D-01
      ALPHA(44,1,44)= 0.22727272727273D-01
C l= 1 n=44 ; Coef  :
      COEF (   1,44)= -4.3727258933291D+00
C l= 2 n=44 ; Alpha :
      ALPHA( 1,2,44)=  4.3727258933291D+00
      ALPHA( 2,2,44)=  1.6863629466645D+00
      ALPHA( 3,2,44)= 0.95757529777637D+00
      ALPHA( 4,2,44)= 0.63484813999894D+00
      ALPHA( 5,2,44)= 0.45787851199915D+00
      ALPHA( 6,2,44)= 0.34823209333263D+00
      ALPHA( 7,2,44)= 0.27467512761844D+00
      ALPHA( 8,2,44)= 0.22248359380899D+00
      ALPHA( 9,2,44)= 0.18387430560800D+00
      ALPHA(10,2,44)= 0.15437576393608D+00
      ALPHA(11,2,44)= 0.13125069448735D+00
      ALPHA(12,2,44)= 0.11273737903765D+00
      ALPHA(13,2,44)= 0.97655016547571D-01
      ALPHA(14,2,44)= 0.85185152728239D-01
      ALPHA(15,2,44)= 0.74744237784452D-01
      ALPHA(16,2,44)= 0.65906056256257D-01
      ALPHA(17,2,44)= 0.58352758829418D-01
      ALPHA(18,2,44)= 0.51842965038241D-01
      ALPHA(19,2,44)= 0.46190411322778D-01
      ALPHA(20,2,44)= 0.41249311809271D-01
      ALPHA(21,2,44)= 0.36904106485020D-01
      ALPHA(22,2,44)= 0.33062144934835D-01
      ALPHA(23,2,44)= 0.29648375787471D-01
      ALPHA(24,2,44)= 0.26601432593427D-01
      ALPHA(25,2,44)= 0.23870708623024D-01
      ALPHA(26,2,44)= 0.21414142906754D-01
      ALPHA(27,2,44)= 0.19196525078298D-01
      ALPHA(28,2,44)= 0.17188183574179D-01
      ALPHA(29,2,44)= 0.15363960495267D-01
      ALPHA(30,2,44)= 0.13702403191401D-01
      ALPHA(31,2,44)= 0.12185121368023D-01
      ALPHA(32,2,44)= 0.10796271809143D-01
      ALPHA(33,2,44)= 0.95221423603812D-02
      ALPHA(34,2,44)= 0.83508137526338D-02
      ALPHA(35,2,44)= 0.72718829395333D-02
      ALPHA(36,2,44)= 0.62762353975622D-02
      ALPHA(37,2,44)= 0.53558566630935D-02
      ALPHA(38,2,44)= 0.45036755133535D-02
      ALPHA(39,2,44)= 0.37134328213782D-02
      ALPHA(40,2,44)= 0.29795713598181D-02
      ALPHA(41,2,44)= 0.22971427900664D-02
      ALPHA(42,2,44)= 0.16617288211973D-02
      ALPHA(43,2,44)= 0.10693741088549D-02
      ALPHA(44,2,44)= 0.51652892561983D-03
C l= 2 n=44 ; Coef  :
      COEF (   2,44)= -10.371597420214D+00
C l= 3 n=44 ; Alpha :
      ALPHA( 1,3,44)=  10.371597420214D+00
      ALPHA( 2,3,44)=  2.9994357634424D+00
      ALPHA( 3,3,44)=  1.4375028600734D+00
      ALPHA( 4,3,44)= 0.83873332061095D+00
      ALPHA( 5,3,44)= 0.54401702848897D+00
      ALPHA( 6,3,44)= 0.37703443840762D+00
      ALPHA( 7,3,44)= 0.27342493387330D+00
      ALPHA( 8,3,44)= 0.20491242618683D+00
      ALPHA( 9,3,44)= 0.15742397952063D+00
      ALPHA(10,3,44)= 0.12329415100776D+00
      ALPHA(11,3,44)= 0.98051431467414D-01
      ALPHA(12,3,44)= 0.78942920971184D-01
      ALPHA(13,3,44)= 0.64198282508966D-01
      ALPHA(14,3,44)= 0.52637332576356D-01
      ALPHA(15,3,44)= 0.43449166889383D-01
      ALPHA(16,3,44)= 0.36062079097269D-01
      ALPHA(17,3,44)= 0.30063953488238D-01
      ALPHA(18,3,44)= 0.25151913915035D-01
      ALPHA(19,3,44)= 0.21099551864862D-01
      ALPHA(20,3,44)= 0.17735053705480D-01
      ALPHA(21,3,44)= 0.14926274395254D-01
      ALPHA(22,3,44)= 0.12570347991605D-01
      ALPHA(23,3,44)= 0.10586326560021D-01
      ALPHA(24,3,44)= 0.89098806288754D-02
      ALPHA(25,3,44)= 0.74894280999832D-02
      ALPHA(26,3,44)= 0.62832689952522D-02
      ALPHA(27,3,44)= 0.52574389248076D-02
      ALPHA(28,3,44)= 0.43840830675538D-02
      ALPHA(29,3,44)= 0.36402118040457D-02
      ALPHA(30,3,44)= 0.30067393940687D-02
      ALPHA(31,3,44)= 0.24677347945374D-02
      ALPHA(32,3,44)= 0.20098330394574D-02
      ALPHA(33,3,44)= 0.16217692561664D-02
      ALPHA(34,3,44)= 0.12940071497974D-02
      ALPHA(35,3,44)= 0.10184408382994D-02
      ALPHA(36,3,44)= 0.78815406669289D-03
      ALPHA(37,3,44)= 0.59722462171302D-03
      ALPHA(38,3,44)= 0.44056458790232D-03
      ALPHA(39,3,44)= 0.31378920069063D-03
      ALPHA(40,3,44)= 0.21310865013891D-03
      ALPHA(41,3,44)= 0.13523840599362D-03
      ALPHA(42,3,44)= 0.77324567992191D-04
      ALPHA(43,3,44)= 0.36881465918017D-04
      ALPHA(44,3,44)= 0.11739293764087D-04
C l= 3 n=44 ; Coef  :
      COEF (   3,44)= -17.882847818110D+00
C l= 4 n=44 ; Alpha :
      ALPHA( 1,4,44)=  17.882847818110D+00
      ALPHA( 2,4,44)=  3.7556251989483D+00
      ALPHA( 3,4,44)=  1.5039382114847D+00
      ALPHA( 4,4,44)= 0.76857794359519D+00
      ALPHA( 5,4,44)= 0.44711569075396D+00
      ALPHA( 6,4,44)= 0.28192690421348D+00
      ALPHA( 7,4,44)= 0.18778956955332D+00
      ALPHA( 8,4,44)= 0.13013775662499D+00
      ALPHA( 9,4,44)= 0.92909958534790D-01
      ALPHA(10,4,44)= 0.67876564729248D-01
      ALPHA(11,4,44)= 0.50497408753156D-01
      ALPHA(12,4,44)= 0.38118338734775D-01
      ALPHA(13,4,44)= 0.29113626449702D-01
      ALPHA(14,4,44)= 0.22448490095511D-01
      ALPHA(15,4,44)= 0.17442768584053D-01
      ALPHA(16,4,44)= 0.13637022616963D-01
      ALPHA(17,4,44)= 0.10713546045538D-01
      ALPHA(18,4,44)= 0.84481294047726D-02
      ALPHA(19,4,44)= 0.66797060721512D-02
      ALPHA(20,4,44)= 0.52907431753005D-02
      ALPHA(21,4,44)= 0.41942766571681D-02
      ALPHA(22,4,44)= 0.33251607002398D-02
      ALPHA(23,4,44)= 0.26340516266813D-02
      ALPHA(24,4,44)= 0.20832025355688D-02
      ALPHA(25,4,44)= 0.16434792089910D-02
      ALPHA(26,4,44)= 0.12922135432612D-02
      ALPHA(27,4,44)= 0.10116401159089D-02
      ALPHA(28,4,44)= 0.78774443588328D-03
      ALPHA(29,4,44)= 0.60940555645441D-03
      ALPHA(30,4,44)= 0.46775164443774D-03
      ALPHA(31,4,44)= 0.35567128835689D-03
      ALPHA(32,4,44)= 0.26743984826644D-03
      ALPHA(33,4,44)= 0.19843157894148D-03
      ALPHA(34,4,44)= 0.14489626026184D-03
      ALPHA(35,4,44)= 0.10378473426014D-03
      ALPHA(36,4,44)= 0.72611801689047D-04
      ALPHA(37,4,44)= 0.49347859300346D-04
      ALPHA(38,4,44)= 0.32332794010521D-04
      ALPHA(39,4,44)= 0.20207220115320D-04
      ALPHA(40,4,44)= 0.11857309595171D-04
      ALPHA(41,4,44)= 0.63703349675101D-05
      ALPHA(42,4,44)= 0.29986982779594D-05
      ALPHA(43,4,44)= 0.11307153414443D-05
      ALPHA(44,4,44)= 0.26680213100198D-06
C l= 4 n=44 ; Coef  :
      COEF (   4,44)= -25.340451669750D+00
C l= 0 n=45 ; Alpha :
      ALPHA( 1,0,45)=  0.0000000000000D+00
      ALPHA( 2,0,45)=  0.0000000000000D+00
      ALPHA( 3,0,45)=  0.0000000000000D+00
      ALPHA( 4,0,45)=  0.0000000000000D+00
      ALPHA( 5,0,45)=  0.0000000000000D+00
      ALPHA( 6,0,45)=  0.0000000000000D+00
      ALPHA( 7,0,45)=  0.0000000000000D+00
      ALPHA( 8,0,45)=  0.0000000000000D+00
      ALPHA( 9,0,45)=  0.0000000000000D+00
      ALPHA(10,0,45)=  0.0000000000000D+00
      ALPHA(11,0,45)=  0.0000000000000D+00
      ALPHA(12,0,45)=  0.0000000000000D+00
      ALPHA(13,0,45)=  0.0000000000000D+00
      ALPHA(14,0,45)=  0.0000000000000D+00
      ALPHA(15,0,45)=  0.0000000000000D+00
      ALPHA(16,0,45)=  0.0000000000000D+00
      ALPHA(17,0,45)=  0.0000000000000D+00
      ALPHA(18,0,45)=  0.0000000000000D+00
      ALPHA(19,0,45)=  0.0000000000000D+00
      ALPHA(20,0,45)=  0.0000000000000D+00
      ALPHA(21,0,45)=  0.0000000000000D+00
      ALPHA(22,0,45)=  0.0000000000000D+00
      ALPHA(23,0,45)=  0.0000000000000D+00
      ALPHA(24,0,45)=  0.0000000000000D+00
      ALPHA(25,0,45)=  0.0000000000000D+00
      ALPHA(26,0,45)=  0.0000000000000D+00
      ALPHA(27,0,45)=  0.0000000000000D+00
      ALPHA(28,0,45)=  0.0000000000000D+00
      ALPHA(29,0,45)=  0.0000000000000D+00
      ALPHA(30,0,45)=  0.0000000000000D+00
      ALPHA(31,0,45)=  0.0000000000000D+00
      ALPHA(32,0,45)=  0.0000000000000D+00
      ALPHA(33,0,45)=  0.0000000000000D+00
      ALPHA(34,0,45)=  0.0000000000000D+00
      ALPHA(35,0,45)=  0.0000000000000D+00
      ALPHA(36,0,45)=  0.0000000000000D+00
      ALPHA(37,0,45)=  0.0000000000000D+00
      ALPHA(38,0,45)=  0.0000000000000D+00
      ALPHA(39,0,45)=  0.0000000000000D+00
      ALPHA(40,0,45)=  0.0000000000000D+00
      ALPHA(41,0,45)=  0.0000000000000D+00
      ALPHA(42,0,45)=  0.0000000000000D+00
      ALPHA(43,0,45)=  0.0000000000000D+00
      ALPHA(44,0,45)=  0.0000000000000D+00
      ALPHA(45,0,45)=  1.0000000000000D+00
C l= 0 n=45 ; Coef  :
      COEF (   0,45)= -1.0000000000000D+00
C l= 1 n=45 ; Alpha :
      ALPHA( 1,1,45)=  1.0000000000000D+00
      ALPHA( 2,1,45)= 0.50000000000000D+00
      ALPHA( 3,1,45)= 0.33333333333333D+00
      ALPHA( 4,1,45)= 0.25000000000000D+00
      ALPHA( 5,1,45)= 0.20000000000000D+00
      ALPHA( 6,1,45)= 0.16666666666667D+00
      ALPHA( 7,1,45)= 0.14285714285714D+00
      ALPHA( 8,1,45)= 0.12500000000000D+00
      ALPHA( 9,1,45)= 0.11111111111111D+00
      ALPHA(10,1,45)= 0.10000000000000D+00
      ALPHA(11,1,45)= 0.90909090909091D-01
      ALPHA(12,1,45)= 0.83333333333333D-01
      ALPHA(13,1,45)= 0.76923076923077D-01
      ALPHA(14,1,45)= 0.71428571428571D-01
      ALPHA(15,1,45)= 0.66666666666667D-01
      ALPHA(16,1,45)= 0.62500000000000D-01
      ALPHA(17,1,45)= 0.58823529411765D-01
      ALPHA(18,1,45)= 0.55555555555556D-01
      ALPHA(19,1,45)= 0.52631578947368D-01
      ALPHA(20,1,45)= 0.50000000000000D-01
      ALPHA(21,1,45)= 0.47619047619048D-01
      ALPHA(22,1,45)= 0.45454545454545D-01
      ALPHA(23,1,45)= 0.43478260869565D-01
      ALPHA(24,1,45)= 0.41666666666667D-01
      ALPHA(25,1,45)= 0.40000000000000D-01
      ALPHA(26,1,45)= 0.38461538461538D-01
      ALPHA(27,1,45)= 0.37037037037037D-01
      ALPHA(28,1,45)= 0.35714285714286D-01
      ALPHA(29,1,45)= 0.34482758620690D-01
      ALPHA(30,1,45)= 0.33333333333333D-01
      ALPHA(31,1,45)= 0.32258064516129D-01
      ALPHA(32,1,45)= 0.31250000000000D-01
      ALPHA(33,1,45)= 0.30303030303030D-01
      ALPHA(34,1,45)= 0.29411764705882D-01
      ALPHA(35,1,45)= 0.28571428571429D-01
      ALPHA(36,1,45)= 0.27777777777778D-01
      ALPHA(37,1,45)= 0.27027027027027D-01
      ALPHA(38,1,45)= 0.26315789473684D-01
      ALPHA(39,1,45)= 0.25641025641026D-01
      ALPHA(40,1,45)= 0.25000000000000D-01
      ALPHA(41,1,45)= 0.24390243902439D-01
      ALPHA(42,1,45)= 0.23809523809524D-01
      ALPHA(43,1,45)= 0.23255813953488D-01
      ALPHA(44,1,45)= 0.22727272727273D-01
      ALPHA(45,1,45)= 0.22222222222222D-01
C l= 1 n=45 ; Coef  :
      COEF (   1,45)= -4.3949481155513D+00
C l= 2 n=45 ; Alpha :
      ALPHA( 1,2,45)=  4.3949481155513D+00
      ALPHA( 2,2,45)=  1.6974740577757D+00
      ALPHA( 3,2,45)= 0.96498270518377D+00
      ALPHA( 4,2,45)= 0.64040369555450D+00
      ALPHA( 5,2,45)= 0.46232295644360D+00
      ALPHA( 6,2,45)= 0.35193579703633D+00
      ALPHA( 7,2,45)= 0.27784973079305D+00
      ALPHA( 8,2,45)= 0.22526137158677D+00
      ALPHA( 9,2,45)= 0.18634344141046D+00
      ALPHA(10,2,45)= 0.15659798615831D+00
      ALPHA(11,2,45)= 0.13327089650755D+00
      ALPHA(12,2,45)= 0.11458923088950D+00
      ALPHA(13,2,45)= 0.99364418256973D-01
      ALPHA(14,2,45)= 0.86772454315541D-01
      ALPHA(15,2,45)= 0.76225719265933D-01
      ALPHA(16,2,45)= 0.67294945145146D-01
      ALPHA(17,2,45)= 0.59659948371902D-01
      ALPHA(18,2,45)= 0.53077532939476D-01
      ALPHA(19,2,45)= 0.47360001966053D-01
      ALPHA(20,2,45)= 0.42360422920382D-01
      ALPHA(21,2,45)= 0.37962307543221D-01
      ALPHA(22,2,45)= 0.34072245944936D-01
      ALPHA(23,2,45)= 0.30614559362350D-01
      ALPHA(24,2,45)= 0.27527358519353D-01
      ALPHA(25,2,45)= 0.24759597511913D-01
      ALPHA(26,2,45)= 0.22268843761454D-01
      ALPHA(27,2,45)= 0.20019570345788D-01
      ALPHA(28,2,45)= 0.17981834367830D-01
      ALPHA(29,2,45)= 0.16130244020171D-01
      ALPHA(30,2,45)= 0.14443143932142D-01
      ALPHA(31,2,45)= 0.12901967246159D-01
      ALPHA(32,2,45)= 0.11490716253588D-01
      ALPHA(33,2,45)= 0.10195543033782D-01
      ALPHA(34,2,45)= 0.90044085238756D-02
      ALPHA(35,2,45)= 0.79068035744540D-02
      ALPHA(36,2,45)= 0.68935193481795D-02
      ALPHA(37,2,45)= 0.59564572636941D-02
      ALPHA(38,2,45)= 0.50884708349909D-02
      ALPHA(39,2,45)= 0.42832333911788D-02
      ALPHA(40,2,45)= 0.35351269153737D-02
      ALPHA(41,2,45)= 0.28391482101206D-02
      ALPHA(42,2,45)= 0.21908293502978D-02
      ALPHA(43,2,45)= 0.15861699744880D-02
      ALPHA(44,2,45)= 0.10215794306703D-02
      ALPHA(45,2,45)= 0.49382716049383D-03
C l= 2 n=45 ; Coef  :
      COEF (   2,45)= -10.469262933893D+00
C l= 3 n=45 ; Alpha :
      ALPHA( 1,3,45)=  10.469262933893D+00
      ALPHA( 2,3,45)=  3.0371574091707D+00
      ALPHA( 3,3,45)=  1.4589469201886D+00
      ALPHA( 4,3,45)= 0.85296451384549D+00
      ALPHA( 5,3,45)= 0.55429087196550D+00
      ALPHA( 6,3,45)= 0.38485523389731D+00
      ALPHA( 7,3,45)= 0.27959937233536D+00
      ALPHA( 8,3,45)= 0.20991823444431D+00
      ALPHA( 9,3,45)= 0.16156494488530D+00
      ALPHA(10,3,45)= 0.12677410625573D+00
      ALPHA(11,3,45)= 0.10101300694536D+00
      ALPHA(12,3,45)= 0.81489348324284D-01
      ALPHA(13,3,45)= 0.66406380692454D-01
      ALPHA(14,3,45)= 0.54565609338924D-01
      ALPHA(15,3,45)= 0.45143071761960D-01
      ALPHA(16,3,45)= 0.37557522322716D-01
      ALPHA(17,3,45)= 0.31389730118725D-01
      ALPHA(18,3,45)= 0.26331414647023D-01
      ALPHA(19,3,45)= 0.22151996352997D-01
      ALPHA(20,3,45)= 0.18676396437044D-01
      ALPHA(21,3,45)= 0.15769881229548D-01
      ALPHA(22,3,45)= 0.13327509012604D-01
      ALPHA(23,3,45)= 0.11266650101406D-01
      ALPHA(24,3,45)= 0.95215997070832D-02
      ALPHA(25,3,45)= 0.80396413780257D-02
      ALPHA(26,3,45)= 0.67781321899512D-02
      ALPHA(27,3,45)= 0.57023182658251D-02
      ALPHA(28,3,45)= 0.47836793868389D-02
      ALPHA(29,3,45)= 0.39986616711606D-02
      ALPHA(30,3,45)= 0.33276981481163D-02
      ALPHA(31,3,45)= 0.27544451777853D-02
      ALPHA(32,3,45)= 0.22651822895371D-02
      ALPHA(33,3,45)= 0.18483368791394D-02
      ALPHA(34,3,45)= 0.14941051169946D-02
      ALPHA(35,3,45)= 0.11941475843983D-02
      ALPHA(36,3,45)= 0.94134338554132D-03
      ALPHA(37,3,45)= 0.72959033868400D-03
      ALPHA(38,3,45)= 0.55364171756879D-03
      ALPHA(39,3,45)= 0.40897216493905D-03
      ALPHA(40,3,45)= 0.29166702603611D-03
      ALPHA(41,3,45)= 0.19833058844075D-03
      ALPHA(42,3,45)= 0.12600966466547D-03
      ALPHA(43,3,45)= 0.72129687573306D-04
      ALPHA(44,3,45)= 0.34441058890095D-04
      ALPHA(45,3,45)= 0.10973936899863D-04
C l= 3 n=45 ; Coef  :
      COEF (   3,45)= -18.115498105530D+00
C l= 4 n=45 ; Alpha :
      ALPHA( 1,4,45)=  18.115498105530D+00
      ALPHA( 2,4,45)=  3.8231175858187D+00
      ALPHA( 3,4,45)=  1.5363592541556D+00
      ALPHA( 4,4,45)= 0.78753271056954D+00
      ALPHA( 5,4,45)= 0.45943326568653D+00
      ALPHA( 6,4,45)= 0.29047924274453D+00
      ALPHA( 7,4,45)= 0.19400288893855D+00
      ALPHA( 8,4,45)= 0.13480260627931D+00
      ALPHA( 9,4,45)= 0.96500290643352D-01
      ALPHA(10,4,45)= 0.70693767090487D-01
      ALPHA(11,4,45)= 0.52742142240831D-01
      ALPHA(12,4,45)= 0.39929213141982D-01
      ALPHA(13,4,45)= 0.30589323798423D-01
      ALPHA(14,4,45)= 0.23661059191932D-01
      ALPHA(15,4,45)= 0.18445947956541D-01
      ALPHA(16,4,45)= 0.14471634224135D-01
      ALPHA(17,4,45)= 0.11411095603732D-01
      ALPHA(18,4,45)= 0.90332719524843D-02
      ALPHA(19,4,45)= 0.71719726577733D-02
      ALPHA(20,4,45)= 0.57057742072348D-02
      ALPHA(21,4,45)= 0.45447184622692D-02
      ALPHA(22,4,45)= 0.36213275671866D-02
      ALPHA(23,4,45)= 0.28844216289348D-02
      ALPHA(24,4,45)= 0.22947936401706D-02
      ALPHA(25,4,45)= 0.18221379062805D-02
      ALPHA(26,4,45)= 0.14428387030379D-02
      ALPHA(27,4,45)= 0.11383582995939D-02
      ALPHA(28,4,45)= 0.89404842225747D-03
      ALPHA(29,4,45)= 0.69826470470243D-03
      ALPHA(30,4,45)= 0.54170049217366D-03
      ALPHA(31,4,45)= 0.41688118119656D-03
      ALPHA(32,4,45)= 0.31777723247838D-03
      ALPHA(33,4,45)= 0.23950573181124D-03
      ALPHA(34,4,45)= 0.17809859619505D-03
      ALPHA(35,4,45)= 0.13032134724677D-03
      ALPHA(36,4,45)= 0.93530543589965D-04
      ALPHA(37,4,45)= 0.65560977937768D-04
      ALPHA(38,4,45)= 0.44635943289827D-04
      ALPHA(39,4,45)= 0.29295490447298D-04
      ALPHA(40,4,45)= 0.18338799062640D-04
      ALPHA(41,4,45)= 0.10777681377304D-04
      ALPHA(42,4,45)= 0.57989130483033D-05
      ALPHA(43,4,45)= 0.27335972875178D-05
      ALPHA(44,4,45)= 0.10321589952263D-05
      ALPHA(45,4,45)= 0.24386526444140D-06
C l= 4 n=45 ; Coef  :
      COEF (   4,45)= -25.743018294318D+00
C l= 0 n=46 ; Alpha :
      ALPHA( 1,0,46)=  0.0000000000000D+00
      ALPHA( 2,0,46)=  0.0000000000000D+00
      ALPHA( 3,0,46)=  0.0000000000000D+00
      ALPHA( 4,0,46)=  0.0000000000000D+00
      ALPHA( 5,0,46)=  0.0000000000000D+00
      ALPHA( 6,0,46)=  0.0000000000000D+00
      ALPHA( 7,0,46)=  0.0000000000000D+00
      ALPHA( 8,0,46)=  0.0000000000000D+00
      ALPHA( 9,0,46)=  0.0000000000000D+00
      ALPHA(10,0,46)=  0.0000000000000D+00
      ALPHA(11,0,46)=  0.0000000000000D+00
      ALPHA(12,0,46)=  0.0000000000000D+00
      ALPHA(13,0,46)=  0.0000000000000D+00
      ALPHA(14,0,46)=  0.0000000000000D+00
      ALPHA(15,0,46)=  0.0000000000000D+00
      ALPHA(16,0,46)=  0.0000000000000D+00
      ALPHA(17,0,46)=  0.0000000000000D+00
      ALPHA(18,0,46)=  0.0000000000000D+00
      ALPHA(19,0,46)=  0.0000000000000D+00
      ALPHA(20,0,46)=  0.0000000000000D+00
      ALPHA(21,0,46)=  0.0000000000000D+00
      ALPHA(22,0,46)=  0.0000000000000D+00
      ALPHA(23,0,46)=  0.0000000000000D+00
      ALPHA(24,0,46)=  0.0000000000000D+00
      ALPHA(25,0,46)=  0.0000000000000D+00
      ALPHA(26,0,46)=  0.0000000000000D+00
      ALPHA(27,0,46)=  0.0000000000000D+00
      ALPHA(28,0,46)=  0.0000000000000D+00
      ALPHA(29,0,46)=  0.0000000000000D+00
      ALPHA(30,0,46)=  0.0000000000000D+00
      ALPHA(31,0,46)=  0.0000000000000D+00
      ALPHA(32,0,46)=  0.0000000000000D+00
      ALPHA(33,0,46)=  0.0000000000000D+00
      ALPHA(34,0,46)=  0.0000000000000D+00
      ALPHA(35,0,46)=  0.0000000000000D+00
      ALPHA(36,0,46)=  0.0000000000000D+00
      ALPHA(37,0,46)=  0.0000000000000D+00
      ALPHA(38,0,46)=  0.0000000000000D+00
      ALPHA(39,0,46)=  0.0000000000000D+00
      ALPHA(40,0,46)=  0.0000000000000D+00
      ALPHA(41,0,46)=  0.0000000000000D+00
      ALPHA(42,0,46)=  0.0000000000000D+00
      ALPHA(43,0,46)=  0.0000000000000D+00
      ALPHA(44,0,46)=  0.0000000000000D+00
      ALPHA(45,0,46)=  0.0000000000000D+00
      ALPHA(46,0,46)=  1.0000000000000D+00
C l= 0 n=46 ; Coef  :
      COEF (   0,46)= -1.0000000000000D+00
C l= 1 n=46 ; Alpha :
      ALPHA( 1,1,46)=  1.0000000000000D+00
      ALPHA( 2,1,46)= 0.50000000000000D+00
      ALPHA( 3,1,46)= 0.33333333333333D+00
      ALPHA( 4,1,46)= 0.25000000000000D+00
      ALPHA( 5,1,46)= 0.20000000000000D+00
      ALPHA( 6,1,46)= 0.16666666666667D+00
      ALPHA( 7,1,46)= 0.14285714285714D+00
      ALPHA( 8,1,46)= 0.12500000000000D+00
      ALPHA( 9,1,46)= 0.11111111111111D+00
      ALPHA(10,1,46)= 0.10000000000000D+00
      ALPHA(11,1,46)= 0.90909090909091D-01
      ALPHA(12,1,46)= 0.83333333333333D-01
      ALPHA(13,1,46)= 0.76923076923077D-01
      ALPHA(14,1,46)= 0.71428571428571D-01
      ALPHA(15,1,46)= 0.66666666666667D-01
      ALPHA(16,1,46)= 0.62500000000000D-01
      ALPHA(17,1,46)= 0.58823529411765D-01
      ALPHA(18,1,46)= 0.55555555555556D-01
      ALPHA(19,1,46)= 0.52631578947368D-01
      ALPHA(20,1,46)= 0.50000000000000D-01
      ALPHA(21,1,46)= 0.47619047619048D-01
      ALPHA(22,1,46)= 0.45454545454545D-01
      ALPHA(23,1,46)= 0.43478260869565D-01
      ALPHA(24,1,46)= 0.41666666666667D-01
      ALPHA(25,1,46)= 0.40000000000000D-01
      ALPHA(26,1,46)= 0.38461538461538D-01
      ALPHA(27,1,46)= 0.37037037037037D-01
      ALPHA(28,1,46)= 0.35714285714286D-01
      ALPHA(29,1,46)= 0.34482758620690D-01
      ALPHA(30,1,46)= 0.33333333333333D-01
      ALPHA(31,1,46)= 0.32258064516129D-01
      ALPHA(32,1,46)= 0.31250000000000D-01
      ALPHA(33,1,46)= 0.30303030303030D-01
      ALPHA(34,1,46)= 0.29411764705882D-01
      ALPHA(35,1,46)= 0.28571428571429D-01
      ALPHA(36,1,46)= 0.27777777777778D-01
      ALPHA(37,1,46)= 0.27027027027027D-01
      ALPHA(38,1,46)= 0.26315789473684D-01
      ALPHA(39,1,46)= 0.25641025641026D-01
      ALPHA(40,1,46)= 0.25000000000000D-01
      ALPHA(41,1,46)= 0.24390243902439D-01
      ALPHA(42,1,46)= 0.23809523809524D-01
      ALPHA(43,1,46)= 0.23255813953488D-01
      ALPHA(44,1,46)= 0.22727272727273D-01
      ALPHA(45,1,46)= 0.22222222222222D-01
      ALPHA(46,1,46)= 0.21739130434783D-01
C l= 1 n=46 ; Coef  :
      COEF (   1,46)= -4.4166872459861D+00
C l= 2 n=46 ; Alpha :
      ALPHA( 1,2,46)=  4.4166872459861D+00
      ALPHA( 2,2,46)=  1.7083436229931D+00
      ALPHA( 3,2,46)= 0.97222908199537D+00
      ALPHA( 4,2,46)= 0.64583847816319D+00
      ALPHA( 5,2,46)= 0.46667078253055D+00
      ALPHA( 6,2,46)= 0.35555898544213D+00
      ALPHA( 7,2,46)= 0.28095532085516D+00
      ALPHA( 8,2,46)= 0.22797876289112D+00
      ALPHA( 9,2,46)= 0.18875890034766D+00
      ALPHA(10,2,46)= 0.15877189920179D+00
      ALPHA(11,2,46)= 0.13524718109253D+00
      ALPHA(12,2,46)= 0.11640082509240D+00
      ALPHA(13,2,46)= 0.10103665905965D+00
      ALPHA(14,2,46)= 0.88325249346596D-01
      ALPHA(15,2,46)= 0.77674994628252D-01
      ALPHA(16,2,46)= 0.68653640797319D-01
      ALPHA(17,2,46)= 0.60938720750418D-01
      ALPHA(18,2,46)= 0.54285262408075D-01
      ALPHA(19,2,46)= 0.48504166725778D-01
      ALPHA(20,2,46)= 0.43447379442121D-01
      ALPHA(21,2,46)= 0.38997504230592D-01
      ALPHA(22,2,46)= 0.35060388237426D-01
      ALPHA(23,2,46)= 0.31559738946471D-01
      ALPHA(24,2,46)= 0.28433155620803D-01
      ALPHA(25,2,46)= 0.25629162729304D-01
      ALPHA(26,2,46)= 0.23104964162792D-01
      ALPHA(27,2,46)= 0.20824723324854D-01
      ALPHA(28,2,46)= 0.18758231883358D-01
      ALPHA(29,2,46)= 0.16879869207577D-01
      ALPHA(30,2,46)= 0.15167781613302D-01
      ALPHA(31,2,46)= 0.13603229518249D-01
      ALPHA(32,2,46)= 0.12170064079675D-01
      ALPHA(33,2,46)= 0.10854304562109D-01
      ALPHA(34,2,46)= 0.96437947131340D-02
      ALPHA(35,2,46)= 0.85279215868763D-02
      ALPHA(36,2,46)= 0.74973840824790D-02
      ALPHA(37,2,46)= 0.65440013294991D-02
      ALPHA(38,2,46)= 0.56605532148536D-02
      ALPHA(39,2,46)= 0.48406469920706D-02
      ALPHA(40,2,46)= 0.40786051762432D-02
      ALPHA(41,2,46)= 0.33693709036519D-02
      ALPHA(42,2,46)= 0.27084276939831D-02
      ALPHA(43,2,46)= 0.20917311473899D-02
      ALPHA(44,2,46)= 0.15156505769154D-02
      ALPHA(45,2,46)= 0.97691894793344D-03
      ALPHA(46,2,46)= 0.47258979206049D-03
C l= 2 n=46 ; Coef  :
      COEF (   2,46)= -10.565277874023D+00
C l= 3 n=46 ; Alpha :
      ALPHA( 1,3,46)=  10.565277874023D+00
      ALPHA( 2,3,46)=  3.0742953140184D+00
      ALPHA( 3,3,46)=  1.4800823350146D+00
      ALPHA( 4,3,46)= 0.86700448076208D+00
      ALPHA( 5,3,46)= 0.56443588897703D+00
      ALPHA( 6,3,46)= 0.39258477705910D+00
      ALPHA( 7,3,46)= 0.28570709670178D+00
      ALPHA( 8,3,46)= 0.21487429450716D+00
      ALPHA( 9,3,46)= 0.16566839924069D+00
      ALPHA(10,3,46)= 0.13022566928185D+00
      ALPHA(11,3,46)= 0.10395316305607D+00
      ALPHA(12,3,46)= 0.84019801043684D-01
      ALPHA(13,3,46)= 0.68602829802447D-01
      ALPHA(14,3,46)= 0.56485723455154D-01
      ALPHA(15,3,46)= 0.46831658601704D-01
      ALPHA(16,3,46)= 0.39049992774832D-01
      ALPHA(17,3,46)= 0.32714484917647D-01
      ALPHA(18,3,46)= 0.27511529047199D-01
      ALPHA(19,3,46)= 0.23206434760079D-01
      ALPHA(20,3,46)= 0.19620904685786D-01
      ALPHA(21,3,46)= 0.16617653060648D-01
      ALPHA(22,3,46)= 0.14089691365591D-01
      ALPHA(23,3,46)= 0.11952731382851D-01
      ALPHA(24,3,46)= 0.10139711785796D-01
      ALPHA(25,3,46)= 0.85967970895324D-02
      ALPHA(26,3,46)= 0.72804140195771D-02
      ALPHA(27,3,46)= 0.61550296424523D-02
      ALPHA(28,3,46)= 0.51914670364771D-02
      ALPHA(29,3,46)= 0.43656153495862D-02
      ALPHA(30,3,46)= 0.36574325310141D-02
      ALPHA(31,3,46)= 0.30501675586168D-02
      ALPHA(32,3,46)= 0.25297488999648D-02
      ALPHA(33,3,46)= 0.20843000217939D-02
      ALPHA(34,3,46)= 0.17037528281497D-02
      ALPHA(35,3,46)= 0.13795371841130D-02
      ALPHA(36,3,46)= 0.11043299960300D-02
      ALPHA(37,3,46)= 0.87185123715137D-03
      ALPHA(38,3,46)= 0.67669722223952D-03
      ALPHA(39,3,46)= 0.51420362128841D-03
      ALPHA(40,3,46)= 0.38033235595444D-03
      ALPHA(41,3,46)= 0.27157778199840D-03
      ALPHA(42,3,46)= 0.18488852757815D-03
      ALPHA(43,3,46)= 0.11760210382091D-03
      ALPHA(44,3,46)= 0.67389984475212D-04
      ALPHA(45,3,46)= 0.32211305333198D-04
      ALPHA(46,3,46)= 0.10273691131750D-04
C l= 3 n=46 ; Coef  :
      COEF (   3,46)= -18.345178059313D+00
C l= 4 n=46 ; Alpha :
      ALPHA( 1,4,46)=  18.345178059313D+00
      ALPHA( 2,4,46)=  3.8899500926452D+00
      ALPHA( 3,4,46)=  1.5685349570907D+00
      ALPHA( 4,4,46)= 0.80638063406436D+00
      ALPHA( 5,4,46)= 0.47170361109907D+00
      ALPHA( 6,4,46)= 0.29901369441972D+00
      ALPHA( 7,4,46)= 0.20021391277989D+00
      ALPHA( 8,4,46)= 0.13947378659468D+00
      ALPHA( 9,4,46)= 0.10010177758337D+00
      ALPHA(10,4,46)= 0.73524759900962D-01
      ALPHA(11,4,46)= 0.55001993611615D-01
      ALPHA(12,4,46)= 0.41755730555975D-01
      ALPHA(13,4,46)= 0.32080689663693D-01
      ALPHA(14,4,46)= 0.24889009701826D-01
      ALPHA(15,4,46)= 0.19464027491361D-01
      ALPHA(16,4,46)= 0.15320547110544D-01
      ALPHA(17,4,46)= 0.12122280058463D-01
      ALPHA(18,4,46)= 0.96313486709016D-02
      ALPHA(19,4,46)= 0.76764603699490D-02
      ALPHA(20,4,46)= 0.61323156134476D-02
      ALPHA(21,4,46)= 0.49059717896745D-02
      ALPHA(22,4,46)= 0.39276252055690D-02
      ALPHA(23,4,46)= 0.31442636155185D-02
      ALPHA(24,4,46)= 0.25152221572531D-02
      ALPHA(25,4,46)= 0.20090247995312D-02
      ALPHA(26,4,46)= 0.16011085730287D-02
      ALPHA(27,4,46)= 0.12721632918211D-02
      ALPHA(28,4,46)= 0.10069064013113D-02
      ALPHA(29,4,46)= 0.79316938621517D-03
      ALPHA(30,4,46)= 0.62120989502179D-03
      ALPHA(31,4,46)= 0.48318917160128D-03
      ALPHA(32,4,46)= 0.37277177378196D-03
      ALPHA(33,4,46)= 0.28481660185024D-03
      ALPHA(34,4,46)= 0.21513670115483D-03
      ALPHA(35,4,46)= 0.16031128603184D-03
      ALPHA(36,4,46)= 0.11753771741670D-03
      ALPHA(37,4,46)= 0.84514265701929D-04
      ALPHA(38,4,46)= 0.59346752468947D-04
      ALPHA(39,4,46)= 0.40473830040525D-04
      ALPHA(40,4,46)= 0.26606893757301D-04
      ALPHA(41,4,46)= 0.16681546203357D-04
      ALPHA(42,4,46)= 0.98182288652196D-05
      ALPHA(43,4,46)= 0.52901647618854D-05
      ALPHA(44,4,46)= 0.24971586577309D-05
      ALPHA(45,4,46)= 0.94411103255441D-06
      ALPHA(46,4,46)= 0.22334111155978D-06
C l= 4 n=46 ; Coef  :
      COEF (   4,46)= -26.141826512998D+00
C l= 0 n=47 ; Alpha :
      ALPHA( 1,0,47)=  0.0000000000000D+00
      ALPHA( 2,0,47)=  0.0000000000000D+00
      ALPHA( 3,0,47)=  0.0000000000000D+00
      ALPHA( 4,0,47)=  0.0000000000000D+00
      ALPHA( 5,0,47)=  0.0000000000000D+00
      ALPHA( 6,0,47)=  0.0000000000000D+00
      ALPHA( 7,0,47)=  0.0000000000000D+00
      ALPHA( 8,0,47)=  0.0000000000000D+00
      ALPHA( 9,0,47)=  0.0000000000000D+00
      ALPHA(10,0,47)=  0.0000000000000D+00
      ALPHA(11,0,47)=  0.0000000000000D+00
      ALPHA(12,0,47)=  0.0000000000000D+00
      ALPHA(13,0,47)=  0.0000000000000D+00
      ALPHA(14,0,47)=  0.0000000000000D+00
      ALPHA(15,0,47)=  0.0000000000000D+00
      ALPHA(16,0,47)=  0.0000000000000D+00
      ALPHA(17,0,47)=  0.0000000000000D+00
      ALPHA(18,0,47)=  0.0000000000000D+00
      ALPHA(19,0,47)=  0.0000000000000D+00
      ALPHA(20,0,47)=  0.0000000000000D+00
      ALPHA(21,0,47)=  0.0000000000000D+00
      ALPHA(22,0,47)=  0.0000000000000D+00
      ALPHA(23,0,47)=  0.0000000000000D+00
      ALPHA(24,0,47)=  0.0000000000000D+00
      ALPHA(25,0,47)=  0.0000000000000D+00
      ALPHA(26,0,47)=  0.0000000000000D+00
      ALPHA(27,0,47)=  0.0000000000000D+00
      ALPHA(28,0,47)=  0.0000000000000D+00
      ALPHA(29,0,47)=  0.0000000000000D+00
      ALPHA(30,0,47)=  0.0000000000000D+00
      ALPHA(31,0,47)=  0.0000000000000D+00
      ALPHA(32,0,47)=  0.0000000000000D+00
      ALPHA(33,0,47)=  0.0000000000000D+00
      ALPHA(34,0,47)=  0.0000000000000D+00
      ALPHA(35,0,47)=  0.0000000000000D+00
      ALPHA(36,0,47)=  0.0000000000000D+00
      ALPHA(37,0,47)=  0.0000000000000D+00
      ALPHA(38,0,47)=  0.0000000000000D+00
      ALPHA(39,0,47)=  0.0000000000000D+00
      ALPHA(40,0,47)=  0.0000000000000D+00
      ALPHA(41,0,47)=  0.0000000000000D+00
      ALPHA(42,0,47)=  0.0000000000000D+00
      ALPHA(43,0,47)=  0.0000000000000D+00
      ALPHA(44,0,47)=  0.0000000000000D+00
      ALPHA(45,0,47)=  0.0000000000000D+00
      ALPHA(46,0,47)=  0.0000000000000D+00
      ALPHA(47,0,47)=  1.0000000000000D+00
C l= 0 n=47 ; Coef  :
      COEF (   0,47)= -1.0000000000000D+00
C l= 1 n=47 ; Alpha :
      ALPHA( 1,1,47)=  1.0000000000000D+00
      ALPHA( 2,1,47)= 0.50000000000000D+00
      ALPHA( 3,1,47)= 0.33333333333333D+00
      ALPHA( 4,1,47)= 0.25000000000000D+00
      ALPHA( 5,1,47)= 0.20000000000000D+00
      ALPHA( 6,1,47)= 0.16666666666667D+00
      ALPHA( 7,1,47)= 0.14285714285714D+00
      ALPHA( 8,1,47)= 0.12500000000000D+00
      ALPHA( 9,1,47)= 0.11111111111111D+00
      ALPHA(10,1,47)= 0.10000000000000D+00
      ALPHA(11,1,47)= 0.90909090909091D-01
      ALPHA(12,1,47)= 0.83333333333333D-01
      ALPHA(13,1,47)= 0.76923076923077D-01
      ALPHA(14,1,47)= 0.71428571428571D-01
      ALPHA(15,1,47)= 0.66666666666667D-01
      ALPHA(16,1,47)= 0.62500000000000D-01
      ALPHA(17,1,47)= 0.58823529411765D-01
      ALPHA(18,1,47)= 0.55555555555556D-01
      ALPHA(19,1,47)= 0.52631578947368D-01
      ALPHA(20,1,47)= 0.50000000000000D-01
      ALPHA(21,1,47)= 0.47619047619048D-01
      ALPHA(22,1,47)= 0.45454545454545D-01
      ALPHA(23,1,47)= 0.43478260869565D-01
      ALPHA(24,1,47)= 0.41666666666667D-01
      ALPHA(25,1,47)= 0.40000000000000D-01
      ALPHA(26,1,47)= 0.38461538461538D-01
      ALPHA(27,1,47)= 0.37037037037037D-01
      ALPHA(28,1,47)= 0.35714285714286D-01
      ALPHA(29,1,47)= 0.34482758620690D-01
      ALPHA(30,1,47)= 0.33333333333333D-01
      ALPHA(31,1,47)= 0.32258064516129D-01
      ALPHA(32,1,47)= 0.31250000000000D-01
      ALPHA(33,1,47)= 0.30303030303030D-01
      ALPHA(34,1,47)= 0.29411764705882D-01
      ALPHA(35,1,47)= 0.28571428571429D-01
      ALPHA(36,1,47)= 0.27777777777778D-01
      ALPHA(37,1,47)= 0.27027027027027D-01
      ALPHA(38,1,47)= 0.26315789473684D-01
      ALPHA(39,1,47)= 0.25641025641026D-01
      ALPHA(40,1,47)= 0.25000000000000D-01
      ALPHA(41,1,47)= 0.24390243902439D-01
      ALPHA(42,1,47)= 0.23809523809524D-01
      ALPHA(43,1,47)= 0.23255813953488D-01
      ALPHA(44,1,47)= 0.22727272727273D-01
      ALPHA(45,1,47)= 0.22222222222222D-01
      ALPHA(46,1,47)= 0.21739130434783D-01
      ALPHA(47,1,47)= 0.21276595744681D-01
C l= 1 n=47 ; Coef  :
      COEF (   1,47)= -4.4379638417308D+00
C l= 2 n=47 ; Alpha :
      ALPHA( 1,2,47)=  4.4379638417308D+00
      ALPHA( 2,2,47)=  1.7189819208654D+00
      ALPHA( 3,2,47)= 0.97932128057693D+00
      ALPHA( 4,2,47)= 0.65115762709936D+00
      ALPHA( 5,2,47)= 0.47092610167949D+00
      ALPHA( 6,2,47)= 0.35910508473291D+00
      ALPHA( 7,2,47)= 0.28399483453297D+00
      ALPHA( 8,2,47)= 0.23063833735921D+00
      ALPHA( 9,2,47)= 0.19112296654152D+00
      ALPHA(10,2,47)= 0.16089955877625D+00
      ALPHA(11,2,47)= 0.13718141706932D+00
      ALPHA(12,2,47)= 0.11817387473779D+00
      ALPHA(13,2,47)= 0.10267332027078D+00
      ALPHA(14,2,47)= 0.89845006185502D-01
      ALPHA(15,2,47)= 0.79093434344564D-01
      ALPHA(16,2,47)= 0.69983428031362D-01
      ALPHA(17,2,47)= 0.62190285205988D-01
      ALPHA(18,2,47)= 0.55467295505002D-01
      ALPHA(19,2,47)= 0.49623987554446D-01
      ALPHA(20,2,47)= 0.44511209229355D-01
      ALPHA(21,2,47)= 0.40010675456529D-01
      ALPHA(22,2,47)= 0.36027506225821D-01
      ALPHA(23,2,47)= 0.32484808326674D-01
      ALPHA(24,2,47)= 0.29319680443498D-01
      ALPHA(25,2,47)= 0.26480226559091D-01
      ALPHA(26,2,47)= 0.23923294768357D-01
      ALPHA(27,2,47)= 0.21612745389472D-01
      ALPHA(28,2,47)= 0.19518110302811D-01
      ALPHA(29,2,47)= 0.17613544922911D-01
      ALPHA(30,2,47)= 0.15877001471458D-01
      ALPHA(31,2,47)= 0.14289571316464D-01
      ALPHA(32,2,47)= 0.12834957696696D-01
      ALPHA(33,2,47)= 0.11499049887705D-01
      ALPHA(34,2,47)= 0.10269576940919D-01
      ALPHA(35,2,47)= 0.91358243224387D-02
      ALPHA(36,2,47)= 0.80884006309423D-02
      ALPHA(37,2,47)= 0.71190444577337D-02
      ALPHA(38,2,47)= 0.62204636291874D-02
      ALPHA(39,2,47)= 0.53862007291137D-02
      ALPHA(40,2,47)= 0.46105200698602D-02
      ALPHA(41,2,47)= 0.38883122632783D-02
      ALPHA(42,2,47)= 0.32150133069517D-02
      ALPHA(43,2,47)= 0.25865356995918D-02
      ALPHA(44,2,47)= 0.19992095711127D-02
      ALPHA(45,2,47)= 0.14497321867041D-02
      ALPHA(46,2,47)= 0.93512448216225D-03
      ALPHA(47,2,47)= 0.45269352648257D-03
C l= 2 n=47 ; Coef  :
      COEF (   2,47)= -10.659702636613D+00
C l= 3 n=47 ; Alpha :
      ALPHA( 1,3,47)=  10.659702636613D+00
      ALPHA( 2,3,47)=  3.1108693974410D+00
      ALPHA( 3,3,47)=  1.5009189580056D+00
      ALPHA( 4,3,47)= 0.88085889835994D+00
      ALPHA( 5,3,47)= 0.57445559326808D+00
      ALPHA( 6,3,47)= 0.40022531077682D+00
      ALPHA( 7,3,47)= 0.29174953998972D+00
      ALPHA( 8,3,47)= 0.21978149317438D+00
      ALPHA( 9,3,47)= 0.16973484533732D+00
      ALPHA(10,3,47)= 0.13364906414943D+00
      ALPHA(11,3,47)= 0.10687191661073D+00
      ALPHA(12,3,47)= 0.86534138804062D-01
      ALPHA(13,3,47)= 0.70787368531612D-01
      ALPHA(14,3,47)= 0.58397319331442D-01
      ALPHA(15,3,47)= 0.48514497630312D-01
      ALPHA(16,3,47)= 0.40539001881882D-01
      ALPHA(17,3,47)= 0.34037682475221D-01
      ALPHA(18,3,47)= 0.28691684270709D-01
      ALPHA(19,3,47)= 0.24262264282514D-01
      ALPHA(20,3,47)= 0.20567951690666D-01
      ALPHA(21,3,47)= 0.17468944027808D-01
      ALPHA(22,3,47)= 0.14856234051247D-01
      ALPHA(23,3,47)= 0.12643897517462D-01
      ALPHA(24,3,47)= 0.10763534773956D-01
      ALPHA(25,3,47)= 0.91602061652577D-02
      ALPHA(26,3,47)= 0.77894202912443D-02
      ALPHA(27,3,47)= 0.66148752890368D-02
      ALPHA(28,3,47)= 0.56067459790901D-02
      ALPHA(29,3,47)= 0.47403716245418D-02
      ALPHA(30,3,47)= 0.39952410729600D-02
      ALPHA(31,3,47)= 0.33542009908820D-02
      ALPHA(32,3,47)= 0.28028331062775D-02
      ALPHA(33,3,47)= 0.23289606577025D-02
      ALPHA(34,3,47)= 0.19222544651905D-02
      ALPHA(35,3,47)= 0.15739164250160D-02
      ALPHA(36,3,47)= 0.12764236264756D-02
      ALPHA(37,3,47)= 0.10233202681670D-02
      ALPHA(38,3,47)= 0.80904751222223D-03
      ALPHA(39,3,47)= 0.62880363680147D-03
      ALPHA(40,3,47)= 0.47842852765359D-03
      ALPHA(41,3,47)= 0.35430783015325D-03
      ALPHA(42,3,47)= 0.25329306602393D-03
      ALPHA(43,3,47)= 0.17263477828031D-03
      ALPHA(44,3,47)= 0.10992635832867D-03
      ALPHA(45,3,47)= 0.63056671007754D-04
      ALPHA(46,3,47)= 0.30169956709670D-04
      ALPHA(47,3,47)= 0.96317771592036D-05
C l= 3 n=47 ; Coef  :
      COEF (   3,47)= -18.571980243071D+00
C l= 4 n=47 ; Alpha :
      ALPHA( 1,4,47)=  18.571980243071D+00
      ALPHA( 2,4,47)=  3.9561388032291D+00
      ALPHA( 3,4,47)=  1.6004694030057D+00
      ALPHA( 4,4,47)= 0.82512231275287D+00
      ALPHA( 5,4,47)= 0.48392607053031D+00
      ALPHA( 6,4,47)= 0.30752912656391D+00
      ALPHA( 7,4,47)= 0.20642134980095D+00
      ALPHA( 8,4,47)= 0.14414998857712D+00
      ALPHA( 9,4,47)= 0.10371315727140D+00
      ALPHA(10,4,47)= 0.76368357010524D-01
      ALPHA(11,4,47)= 0.57275864177801D-01
      ALPHA(12,4,47)= 0.43596882445423D-01
      ALPHA(13,4,47)= 0.33586803887770D-01
      ALPHA(14,4,47)= 0.26131505857814D-01
      ALPHA(15,4,47)= 0.20496250845197D-01
      ALPHA(16,4,47)= 0.16183079065478D-01
      ALPHA(17,4,47)= 0.12846486068574D-01
      ALPHA(18,4,47)= 0.10241810038364D-01
      ALPHA(19,4,47)= 0.81926787589386D-02
      ALPHA(20,4,47)= 0.65699316068660D-02
      ALPHA(21,4,47)= 0.52776514498407D-02
      ALPHA(22,4,47)= 0.42437152917657D-02
      ALPHA(23,4,47)= 0.34132827116347D-02
      ALPHA(24,4,47)= 0.27442335354224D-02
      ALPHA(25,4,47)= 0.22039228030473D-02
      ALPHA(26,4,47)= 0.17668409196509D-02
      ALPHA(27,4,47)= 0.14129053192474D-02
      ALPHA(28,4,47)= 0.11261988689515D-02
      ALPHA(29,4,47)= 0.89402835695010D-03
      ALPHA(30,4,47)= 0.70621502423371D-03
      ALPHA(31,4,47)= 0.55455515013068D-03
      ALPHA(32,4,47)= 0.43240652072404D-03
      ALPHA(33,4,47)= 0.33436895626944D-03
      ALPHA(34,4,47)= 0.25603573232909D-03
      ALPHA(35,4,47)= 0.19379886954282D-03
      ALPHA(36,4,47)= 0.14469566691618D-03
      ALPHA(37,4,47)= 0.10628703736506D-03
      ALPHA(38,4,47)= 0.76560529324739D-04
      ALPHA(39,4,47)= 0.53852630823535D-04
      ALPHA(40,4,47)= 0.36786224132910D-04
      ALPHA(41,4,47)= 0.24220010674702D-04
      ALPHA(42,4,47)= 0.15207443035942D-04
      ALPHA(43,4,47)= 0.89632451508282D-05
      ALPHA(44,4,47)= 0.48360173455750D-05
      ALPHA(45,4,47)= 0.22857423305917D-05
      ALPHA(46,4,47)= 0.86525508410595D-06
      ALPHA(47,4,47)= 0.20493142891923D-06
C l= 4 n=47 ; Coef  :
      COEF (   4,47)= -26.536975028808D+00
C l= 0 n=48 ; Alpha :
      ALPHA( 1,0,48)=  0.0000000000000D+00
      ALPHA( 2,0,48)=  0.0000000000000D+00
      ALPHA( 3,0,48)=  0.0000000000000D+00
      ALPHA( 4,0,48)=  0.0000000000000D+00
      ALPHA( 5,0,48)=  0.0000000000000D+00
      ALPHA( 6,0,48)=  0.0000000000000D+00
      ALPHA( 7,0,48)=  0.0000000000000D+00
      ALPHA( 8,0,48)=  0.0000000000000D+00
      ALPHA( 9,0,48)=  0.0000000000000D+00
      ALPHA(10,0,48)=  0.0000000000000D+00
      ALPHA(11,0,48)=  0.0000000000000D+00
      ALPHA(12,0,48)=  0.0000000000000D+00
      ALPHA(13,0,48)=  0.0000000000000D+00
      ALPHA(14,0,48)=  0.0000000000000D+00
      ALPHA(15,0,48)=  0.0000000000000D+00
      ALPHA(16,0,48)=  0.0000000000000D+00
      ALPHA(17,0,48)=  0.0000000000000D+00
      ALPHA(18,0,48)=  0.0000000000000D+00
      ALPHA(19,0,48)=  0.0000000000000D+00
      ALPHA(20,0,48)=  0.0000000000000D+00
      ALPHA(21,0,48)=  0.0000000000000D+00
      ALPHA(22,0,48)=  0.0000000000000D+00
      ALPHA(23,0,48)=  0.0000000000000D+00
      ALPHA(24,0,48)=  0.0000000000000D+00
      ALPHA(25,0,48)=  0.0000000000000D+00
      ALPHA(26,0,48)=  0.0000000000000D+00
      ALPHA(27,0,48)=  0.0000000000000D+00
      ALPHA(28,0,48)=  0.0000000000000D+00
      ALPHA(29,0,48)=  0.0000000000000D+00
      ALPHA(30,0,48)=  0.0000000000000D+00
      ALPHA(31,0,48)=  0.0000000000000D+00
      ALPHA(32,0,48)=  0.0000000000000D+00
      ALPHA(33,0,48)=  0.0000000000000D+00
      ALPHA(34,0,48)=  0.0000000000000D+00
      ALPHA(35,0,48)=  0.0000000000000D+00
      ALPHA(36,0,48)=  0.0000000000000D+00
      ALPHA(37,0,48)=  0.0000000000000D+00
      ALPHA(38,0,48)=  0.0000000000000D+00
      ALPHA(39,0,48)=  0.0000000000000D+00
      ALPHA(40,0,48)=  0.0000000000000D+00
      ALPHA(41,0,48)=  0.0000000000000D+00
      ALPHA(42,0,48)=  0.0000000000000D+00
      ALPHA(43,0,48)=  0.0000000000000D+00
      ALPHA(44,0,48)=  0.0000000000000D+00
      ALPHA(45,0,48)=  0.0000000000000D+00
      ALPHA(46,0,48)=  0.0000000000000D+00
      ALPHA(47,0,48)=  0.0000000000000D+00
      ALPHA(48,0,48)=  1.0000000000000D+00
C l= 0 n=48 ; Coef  :
      COEF (   0,48)= -1.0000000000000D+00
C l= 1 n=48 ; Alpha :
      ALPHA( 1,1,48)=  1.0000000000000D+00
      ALPHA( 2,1,48)= 0.50000000000000D+00
      ALPHA( 3,1,48)= 0.33333333333333D+00
      ALPHA( 4,1,48)= 0.25000000000000D+00
      ALPHA( 5,1,48)= 0.20000000000000D+00
      ALPHA( 6,1,48)= 0.16666666666667D+00
      ALPHA( 7,1,48)= 0.14285714285714D+00
      ALPHA( 8,1,48)= 0.12500000000000D+00
      ALPHA( 9,1,48)= 0.11111111111111D+00
      ALPHA(10,1,48)= 0.10000000000000D+00
      ALPHA(11,1,48)= 0.90909090909091D-01
      ALPHA(12,1,48)= 0.83333333333333D-01
      ALPHA(13,1,48)= 0.76923076923077D-01
      ALPHA(14,1,48)= 0.71428571428571D-01
      ALPHA(15,1,48)= 0.66666666666667D-01
      ALPHA(16,1,48)= 0.62500000000000D-01
      ALPHA(17,1,48)= 0.58823529411765D-01
      ALPHA(18,1,48)= 0.55555555555556D-01
      ALPHA(19,1,48)= 0.52631578947368D-01
      ALPHA(20,1,48)= 0.50000000000000D-01
      ALPHA(21,1,48)= 0.47619047619048D-01
      ALPHA(22,1,48)= 0.45454545454545D-01
      ALPHA(23,1,48)= 0.43478260869565D-01
      ALPHA(24,1,48)= 0.41666666666667D-01
      ALPHA(25,1,48)= 0.40000000000000D-01
      ALPHA(26,1,48)= 0.38461538461538D-01
      ALPHA(27,1,48)= 0.37037037037037D-01
      ALPHA(28,1,48)= 0.35714285714286D-01
      ALPHA(29,1,48)= 0.34482758620690D-01
      ALPHA(30,1,48)= 0.33333333333333D-01
      ALPHA(31,1,48)= 0.32258064516129D-01
      ALPHA(32,1,48)= 0.31250000000000D-01
      ALPHA(33,1,48)= 0.30303030303030D-01
      ALPHA(34,1,48)= 0.29411764705882D-01
      ALPHA(35,1,48)= 0.28571428571429D-01
      ALPHA(36,1,48)= 0.27777777777778D-01
      ALPHA(37,1,48)= 0.27027027027027D-01
      ALPHA(38,1,48)= 0.26315789473684D-01
      ALPHA(39,1,48)= 0.25641025641026D-01
      ALPHA(40,1,48)= 0.25000000000000D-01
      ALPHA(41,1,48)= 0.24390243902439D-01
      ALPHA(42,1,48)= 0.23809523809524D-01
      ALPHA(43,1,48)= 0.23255813953488D-01
      ALPHA(44,1,48)= 0.22727272727273D-01
      ALPHA(45,1,48)= 0.22222222222222D-01
      ALPHA(46,1,48)= 0.21739130434783D-01
      ALPHA(47,1,48)= 0.21276595744681D-01
      ALPHA(48,1,48)= 0.20833333333333D-01
C l= 1 n=48 ; Coef  :
      COEF (   1,48)= -4.4587971750641D+00
C l= 2 n=48 ; Alpha :
      ALPHA( 1,2,48)=  4.4587971750641D+00
      ALPHA( 2,2,48)=  1.7293985875321D+00
      ALPHA( 3,2,48)= 0.98626572502137D+00
      ALPHA( 4,2,48)= 0.65636596043270D+00
      ALPHA( 5,2,48)= 0.47509276834616D+00
      ALPHA( 6,2,48)= 0.36257730695513D+00
      ALPHA( 7,2,48)= 0.28697102500916D+00
      ALPHA( 8,2,48)= 0.23324250402587D+00
      ALPHA( 9,2,48)= 0.19343778135633D+00
      ALPHA(10,2,48)= 0.16298289210959D+00
      ALPHA(11,2,48)= 0.13907535646326D+00
      ALPHA(12,2,48)= 0.11990998584890D+00
      ALPHA(13,2,48)= 0.10427588437334D+00
      ALPHA(14,2,48)= 0.91333101423597D-01
      ALPHA(15,2,48)= 0.80482323233453D-01
      ALPHA(16,2,48)= 0.71285511364695D-01
      ALPHA(17,2,48)= 0.63415775402066D-01
      ALPHA(18,2,48)= 0.56624702912409D-01
      ALPHA(19,2,48)= 0.50720478782516D-01
      ALPHA(20,2,48)= 0.45552875896022D-01
      ALPHA(21,2,48)= 0.41002738948592D-01
      ALPHA(22,2,48)= 0.36974475922790D-01
      ALPHA(23,2,48)= 0.33390605428124D-01
      ALPHA(24,2,48)= 0.30187735999053D-01
      ALPHA(25,2,48)= 0.27313559892424D-01
      ALPHA(26,2,48)= 0.24724576819639D-01
      ALPHA(27,2,48)= 0.22384350327743D-01
      ALPHA(28,2,48)= 0.20262157921858D-01
      ALPHA(29,2,48)= 0.18331935727509D-01
      ALPHA(30,2,48)= 0.16571445915902D-01
      ALPHA(31,2,48)= 0.14961614327217D-01
      ALPHA(32,2,48)= 0.13485999363362D-01
      ALPHA(33,2,48)= 0.12130363019018D-01
      ALPHA(34,2,48)= 0.10882322038958D-01
      ALPHA(35,2,48)= 0.97310624176767D-02
      ALPHA(36,2,48)= 0.86671043346460D-02
      ALPHA(37,2,48)= 0.76821075207968D-02
      ALPHA(38,2,48)= 0.67687092432224D-02
      ALPHA(39,2,48)= 0.59203887633018D-02
      ALPHA(40,2,48)= 0.51313534031936D-02
      ALPHA(41,2,48)= 0.43964423445791D-02
      ALPHA(42,2,48)= 0.37110450529834D-02
      ALPHA(43,2,48)= 0.30710318236228D-02
      ALPHA(44,2,48)= 0.24726944195975D-02
      ALPHA(45,2,48)= 0.19126951496671D-02
      ALPHA(46,2,48)= 0.13880230328869D-02
      ALPHA(47,2,48)= 0.89595593783009D-03
      ALPHA(48,2,48)= 0.43402777777778D-03
C l= 2 n=48 ; Coef  :
      COEF (   2,48)= -10.752594244427D+00
C l= 3 n=48 ; Alpha :
      ALPHA( 1,3,48)=  10.752594244427D+00
      ALPHA( 2,3,48)=  3.1468985346813D+00
      ALPHA( 3,3,48)=  1.5214661606102D+00
      ALPHA( 4,3,48)= 0.89453318920229D+00
      ALPHA( 5,3,48)= 0.58435335927529D+00
      ALPHA( 6,3,48)= 0.40777900467172D+00
      ALPHA( 7,3,48)= 0.29772810301074D+00
      ALPHA( 8,3,48)= 0.22464071200825D+00
      ALPHA( 9,3,48)= 0.17376479911557D+00
      ALPHA(10,3,48)= 0.13704454106838D+00
      ALPHA(11,3,48)= 0.10976931987038D+00
      ALPHA(12,3,48)= 0.89032263509248D-01
      ALPHA(13,3,48)= 0.72959782789390D-01
      ALPHA(14,3,48)= 0.60300092277767D-01
      ALPHA(15,3,48)= 0.50191212697676D-01
      ALPHA(16,3,48)= 0.42024116701980D-01
      ALPHA(17,3,48)= 0.35358844462764D-01
      ALPHA(18,3,48)= 0.29871365581384D-01
      ALPHA(19,3,48)= 0.25318940923816D-01
      ALPHA(20,3,48)= 0.21516969938500D-01
      ALPHA(21,3,48)= 0.18323167755903D-01
      ALPHA(22,3,48)= 0.15626535632972D-01
      ALPHA(23,3,48)= 0.13339535130547D-01
      ALPHA(24,3,48)= 0.11392445940603D-01
      ALPHA(25,3,48)= 0.97292386630165D-02
      ALPHA(26,3,48)= 0.83045156416534D-02
      ALPHA(27,3,48)= 0.70812159208648D-02
      ALPHA(28,3,48)= 0.60288742691288D-02
      ALPHA(29,3,48)= 0.51222869521982D-02
      ALPHA(30,3,48)= 0.43404795295413D-02
      ALPHA(31,3,48)= 0.36659012893657D-02
      ALPHA(32,3,48)= 0.30837914263475D-02
      ALPHA(33,3,48)= 0.25816765539321D-02
      ALPHA(34,3,48)= 0.21489695076688D-02
      ALPHA(35,3,48)= 0.17766468920509D-02
      ALPHA(36,3,48)= 0.14569883001140D-02
      ALPHA(37,3,48)= 0.11833641748502D-02
      ALPHA(38,3,48)= 0.95006228812270D-03
      ALPHA(39,3,48)= 0.75214506937026D-03
      ALPHA(40,3,48)= 0.58533172355346D-03
      ALPHA(41,3,48)= 0.44590037899865D-03
      ALPHA(42,3,48)= 0.33060650462775D-03
      ALPHA(43,3,48)= 0.23661460793912D-03
      ALPHA(44,3,48)= 0.16144082540362D-03
      ALPHA(45,3,48)= 0.10290448662582D-03
      ALPHA(46,3,48)= 0.59087103228147D-04
      ALPHA(47,3,48)= 0.28297525863997D-04
      ALPHA(48,3,48)= 0.90422453703704D-05
C l= 3 n=48 ; Coef  :
      COEF (   3,48)= -18.795992623163D+00
C l= 4 n=48 ; Alpha :
      ALPHA( 1,4,48)=  18.795992623163D+00
      ALPHA( 2,4,48)=  4.0216991893682D+00
      ALPHA( 3,4,48)=  1.6321666146851D+00
      ALPHA( 4,4,48)= 0.84375842086126D+00
      ALPHA( 5,4,48)= 0.49610009884855D+00
      ALPHA( 6,4,48)= 0.31602452249457D+00
      ALPHA( 7,4,48)= 0.21262401861367D+00
      ALPHA( 8,4,48)= 0.14883000341062D+00
      ALPHA( 9,4,48)= 0.10733325725297D+00
      ALPHA(10,4,48)= 0.79223451616115D-01
      ALPHA(11,4,48)= 0.59562725008434D-01
      ALPHA(12,4,48)= 0.45451721268532D-01
      ALPHA(13,4,48)= 0.35106799362549D-01
      ALPHA(14,4,48)= 0.27387757780268D-01
      ALPHA(15,4,48)= 0.21541901109732D-01
      ALPHA(16,4,48)= 0.17058581496769D-01
      ALPHA(17,4,48)= 0.13583128661549D-01
      ALPHA(18,4,48)= 0.10864130154642D-01
      ALPHA(19,4,48)= 0.87201566948515D-02
      ALPHA(20,4,48)= 0.70182018139181D-02
      ALPHA(21,4,48)= 0.56593841114220D-02
      ALPHA(22,4,48)= 0.45692681174527D-02
      ALPHA(23,4,48)= 0.36911896935212D-02
      ALPHA(24,4,48)= 0.29815761591850D-02
      ALPHA(25,4,48)= 0.24066152751935D-02
      ALPHA(26,4,48)= 0.19398516621854D-02
      ALPHA(27,4,48)= 0.15604306509321D-02
      ALPHA(28,4,48)= 0.12518004162251D-02
      ALPHA(29,4,48)= 0.10007426684542D-02
      ALPHA(30,4,48)= 0.79664168109915D-03
      ALPHA(31,4,48)= 0.63092809365914D-03
      ALPHA(32,4,48)= 0.49665217543961D-03
      ALPHA(33,4,48)= 0.38815388447636D-03
      ALPHA(34,4,48)= 0.30080593040553D-03
      ALPHA(35,4,48)= 0.23081234646055D-03
      ALPHA(36,4,48)= 0.17504958983523D-03
      ALPHA(37,4,48)= 0.13094045767444D-03
      ALPHA(38,4,48)= 0.96353493660629D-04
      ALPHA(39,4,48)= 0.69522319768749D-04
      ALPHA(40,4,48)= 0.48980635040273D-04
      ALPHA(41,4,48)= 0.33509601903841D-04
      ALPHA(42,4,48)= 0.22095078549020D-04
      ALPHA(43,4,48)= 0.13892716149560D-04
      ALPHA(44,4,48)= 0.81993678748172D-05
      ALPHA(45,4,48)= 0.44295858019630D-05
      ALPHA(46,4,48)= 0.20962364013590D-05
      ALPHA(47,4,48)= 0.79446321775250D-06
      ALPHA(48,4,48)= 0.18838011188272D-06
C l= 4 n=48 ; Coef  :
      COEF (   4,48)= -26.928558208458D+00
C l= 0 n=49 ; Alpha :
      ALPHA( 1,0,49)=  0.0000000000000D+00
      ALPHA( 2,0,49)=  0.0000000000000D+00
      ALPHA( 3,0,49)=  0.0000000000000D+00
      ALPHA( 4,0,49)=  0.0000000000000D+00
      ALPHA( 5,0,49)=  0.0000000000000D+00
      ALPHA( 6,0,49)=  0.0000000000000D+00
      ALPHA( 7,0,49)=  0.0000000000000D+00
      ALPHA( 8,0,49)=  0.0000000000000D+00
      ALPHA( 9,0,49)=  0.0000000000000D+00
      ALPHA(10,0,49)=  0.0000000000000D+00
      ALPHA(11,0,49)=  0.0000000000000D+00
      ALPHA(12,0,49)=  0.0000000000000D+00
      ALPHA(13,0,49)=  0.0000000000000D+00
      ALPHA(14,0,49)=  0.0000000000000D+00
      ALPHA(15,0,49)=  0.0000000000000D+00
      ALPHA(16,0,49)=  0.0000000000000D+00
      ALPHA(17,0,49)=  0.0000000000000D+00
      ALPHA(18,0,49)=  0.0000000000000D+00
      ALPHA(19,0,49)=  0.0000000000000D+00
      ALPHA(20,0,49)=  0.0000000000000D+00
      ALPHA(21,0,49)=  0.0000000000000D+00
      ALPHA(22,0,49)=  0.0000000000000D+00
      ALPHA(23,0,49)=  0.0000000000000D+00
      ALPHA(24,0,49)=  0.0000000000000D+00
      ALPHA(25,0,49)=  0.0000000000000D+00
      ALPHA(26,0,49)=  0.0000000000000D+00
      ALPHA(27,0,49)=  0.0000000000000D+00
      ALPHA(28,0,49)=  0.0000000000000D+00
      ALPHA(29,0,49)=  0.0000000000000D+00
      ALPHA(30,0,49)=  0.0000000000000D+00
      ALPHA(31,0,49)=  0.0000000000000D+00
      ALPHA(32,0,49)=  0.0000000000000D+00
      ALPHA(33,0,49)=  0.0000000000000D+00
      ALPHA(34,0,49)=  0.0000000000000D+00
      ALPHA(35,0,49)=  0.0000000000000D+00
      ALPHA(36,0,49)=  0.0000000000000D+00
      ALPHA(37,0,49)=  0.0000000000000D+00
      ALPHA(38,0,49)=  0.0000000000000D+00
      ALPHA(39,0,49)=  0.0000000000000D+00
      ALPHA(40,0,49)=  0.0000000000000D+00
      ALPHA(41,0,49)=  0.0000000000000D+00
      ALPHA(42,0,49)=  0.0000000000000D+00
      ALPHA(43,0,49)=  0.0000000000000D+00
      ALPHA(44,0,49)=  0.0000000000000D+00
      ALPHA(45,0,49)=  0.0000000000000D+00
      ALPHA(46,0,49)=  0.0000000000000D+00
      ALPHA(47,0,49)=  0.0000000000000D+00
      ALPHA(48,0,49)=  0.0000000000000D+00
      ALPHA(49,0,49)=  1.0000000000000D+00
C l= 0 n=49 ; Coef  :
      COEF (   0,49)= -1.0000000000000D+00
C l= 1 n=49 ; Alpha :
      ALPHA( 1,1,49)=  1.0000000000000D+00
      ALPHA( 2,1,49)= 0.50000000000000D+00
      ALPHA( 3,1,49)= 0.33333333333333D+00
      ALPHA( 4,1,49)= 0.25000000000000D+00
      ALPHA( 5,1,49)= 0.20000000000000D+00
      ALPHA( 6,1,49)= 0.16666666666667D+00
      ALPHA( 7,1,49)= 0.14285714285714D+00
      ALPHA( 8,1,49)= 0.12500000000000D+00
      ALPHA( 9,1,49)= 0.11111111111111D+00
      ALPHA(10,1,49)= 0.10000000000000D+00
      ALPHA(11,1,49)= 0.90909090909091D-01
      ALPHA(12,1,49)= 0.83333333333333D-01
      ALPHA(13,1,49)= 0.76923076923077D-01
      ALPHA(14,1,49)= 0.71428571428571D-01
      ALPHA(15,1,49)= 0.66666666666667D-01
      ALPHA(16,1,49)= 0.62500000000000D-01
      ALPHA(17,1,49)= 0.58823529411765D-01
      ALPHA(18,1,49)= 0.55555555555556D-01
      ALPHA(19,1,49)= 0.52631578947368D-01
      ALPHA(20,1,49)= 0.50000000000000D-01
      ALPHA(21,1,49)= 0.47619047619048D-01
      ALPHA(22,1,49)= 0.45454545454545D-01
      ALPHA(23,1,49)= 0.43478260869565D-01
      ALPHA(24,1,49)= 0.41666666666667D-01
      ALPHA(25,1,49)= 0.40000000000000D-01
      ALPHA(26,1,49)= 0.38461538461538D-01
      ALPHA(27,1,49)= 0.37037037037037D-01
      ALPHA(28,1,49)= 0.35714285714286D-01
      ALPHA(29,1,49)= 0.34482758620690D-01
      ALPHA(30,1,49)= 0.33333333333333D-01
      ALPHA(31,1,49)= 0.32258064516129D-01
      ALPHA(32,1,49)= 0.31250000000000D-01
      ALPHA(33,1,49)= 0.30303030303030D-01
      ALPHA(34,1,49)= 0.29411764705882D-01
      ALPHA(35,1,49)= 0.28571428571429D-01
      ALPHA(36,1,49)= 0.27777777777778D-01
      ALPHA(37,1,49)= 0.27027027027027D-01
      ALPHA(38,1,49)= 0.26315789473684D-01
      ALPHA(39,1,49)= 0.25641025641026D-01
      ALPHA(40,1,49)= 0.25000000000000D-01
      ALPHA(41,1,49)= 0.24390243902439D-01
      ALPHA(42,1,49)= 0.23809523809524D-01
      ALPHA(43,1,49)= 0.23255813953488D-01
      ALPHA(44,1,49)= 0.22727272727273D-01
      ALPHA(45,1,49)= 0.22222222222222D-01
      ALPHA(46,1,49)= 0.21739130434783D-01
      ALPHA(47,1,49)= 0.21276595744681D-01
      ALPHA(48,1,49)= 0.20833333333333D-01
      ALPHA(49,1,49)= 0.20408163265306D-01
C l= 1 n=49 ; Coef  :
      COEF (   1,49)= -4.4792053383294D+00
C l= 2 n=49 ; Alpha :
      ALPHA( 1,2,49)=  4.4792053383294D+00
      ALPHA( 2,2,49)=  1.7396026691647D+00
      ALPHA( 3,2,49)= 0.99306844610981D+00
      ALPHA( 4,2,49)= 0.66146800124902D+00
      ALPHA( 5,2,49)= 0.47917440099922D+00
      ALPHA( 6,2,49)= 0.36597866749935D+00
      ALPHA( 7,2,49)= 0.28988647690420D+00
      ALPHA( 8,2,49)= 0.23579352443404D+00
      ALPHA( 9,2,49)= 0.19570535505248D+00
      ALPHA(10,2,49)= 0.16502370843612D+00
      ALPHA(11,2,49)= 0.14093064403283D+00
      ALPHA(12,2,49)= 0.12161066612101D+00
      ALPHA(13,2,49)= 0.10584574308606D+00
      ALPHA(14,2,49)= 0.92790827371119D-01
      ALPHA(15,2,49)= 0.81842867451140D-01
      ALPHA(16,2,49)= 0.72561021568777D-01
      ALPHA(17,2,49)= 0.64616255594143D-01
      ALPHA(18,2,49)= 0.57758489760482D-01
      ALPHA(19,2,49)= 0.51794592638585D-01
      ALPHA(20,2,49)= 0.46573284059287D-01
      ALPHA(21,2,49)= 0.41974556246940D-01
      ALPHA(22,2,49)= 0.37902119707577D-01
      ALPHA(23,2,49)= 0.34277916874441D-01
      ALPHA(24,2,49)= 0.31038076135108D-01
      ALPHA(25,2,49)= 0.28129886423037D-01
      ALPHA(26,2,49)= 0.25509506175997D-01
      ALPHA(27,2,49)= 0.23140208226459D-01
      ALPHA(28,2,49)= 0.20991020895619D-01
      ALPHA(29,2,49)= 0.19035665495278D-01
      ALPHA(30,2,49)= 0.17251718024746D-01
      ALPHA(31,2,49)= 0.15619942174485D-01
      ALPHA(32,2,49)= 0.14123754465403D-01
      ALPHA(33,2,49)= 0.12748792208876D-01
      ALPHA(34,2,49)= 0.11482562134996D-01
      ALPHA(35,2,49)= 0.10314152796685D-01
      ALPHA(36,2,49)= 0.92339977586823D-02
      ALPHA(37,2,49)= 0.82336795009402D-02
      ALPHA(38,2,49)= 0.73057661712568D-02
      ALPHA(39,2,49)= 0.64436750008737D-02
      ALPHA(40,2,49)= 0.56415574848262D-02
      ALPHA(41,2,49)= 0.48942024242207D-02
      ALPHA(42,2,49)= 0.41969537021574D-02
      ALPHA(43,2,49)= 0.35456402716532D-02
      ALPHA(44,2,49)= 0.29365163119909D-02
      ALPHA(45,2,49)= 0.23662098888961D-02
      ALPHA(46,2,49)= 0.18316787560457D-02
      ALPHA(47,2,49)= 0.13301721775175D-02
      ALPHA(48,2,49)= 0.85919784580499D-03
      ALPHA(49,2,49)= 0.41649312786339D-03
C l= 2 n=49 ; Coef  :
      COEF (   2,49)= -10.844006598270D+00
C l= 3 n=49 ; Alpha :
      ALPHA( 1,3,49)=  10.844006598270D+00
      ALPHA( 2,3,49)=  3.1824006299704D+00
      ALPHA( 3,3,49)=  1.5417328635920D+00
      ALPHA( 4,3,49)= 0.90803253616656D+00
      ALPHA( 5,3,49)= 0.59413242868344D+00
      ALPHA( 6,3,49)= 0.41524795706966D+00
      ALPHA( 7,3,49)= 0.30364415355981D+00
      ALPHA( 8,3,49)= 0.22945282475180D+00
      ALPHA( 9,3,49)= 0.17775878595338D+00
      ALPHA(10,3,49)= 0.14041237185279D+00
      ALPHA(11,3,49)= 0.11264545546289D+00
      ALPHA(12,3,49)= 0.91514113838248D-01
      ALPHA(13,3,49)= 0.75119899995228D-01
      ALPHA(14,3,49)= 0.62193782632279D-01
      ALPHA(15,3,49)= 0.51861475298719D-01
      ALPHA(16,3,49)= 0.43504953876853D-01
      ALPHA(17,3,49)= 0.36677543556522D-01
      ALPHA(18,3,49)= 0.31050110270374D-01
      ALPHA(19,3,49)= 0.26375973426645D-01
      ALPHA(20,3,49)= 0.22467445123383D-01
      ALPHA(21,3,49)= 0.19179791352780D-01
      ALPHA(22,3,49)= 0.16400048280065D-01
      ALPHA(23,3,49)= 0.14039084454516D-01
      ALPHA(24,3,49)= 0.12025876065809D-01
      ALPHA(25,3,49)= 0.10303317977772D-01
      ALPHA(26,3,49)= 0.88251178085105D-02
      ALPHA(27,3,49)= 0.75534650683436D-02
      ALPHA(28,3,49)= 0.64572624506721D-02
      ALPHA(29,3,49)= 0.55107699214896D-02
      ALPHA(30,3,49)= 0.46925554075974D-02
      ALPHA(31,3,49)= 0.39846756194573D-02
      ALPHA(32,3,49)= 0.33720313133966D-02
      ALPHA(33,3,49)= 0.28418559867663D-02
      ALPHA(34,3,49)= 0.23833075104238D-02
      ALPHA(35,3,49)= 0.19871398062690D-02
      ALPHA(36,3,49)= 0.16454372339647D-02
      ALPHA(37,3,49)= 0.13513984503796D-02
      ALPHA(38,3,49)= 0.10991595569239D-02
      ALPHA(39,3,49)= 0.88364864081666D-03
      ALPHA(40,3,49)= 0.70046554977440D-03
      ALPHA(41,3,49)= 0.54578206112560D-03
      ALPHA(42,3,49)= 0.41625862099831D-03
      ALPHA(43,3,49)= 0.30897461348306D-03
      ALPHA(44,3,49)= 0.22136972972997D-03
      ALPHA(45,3,49)= 0.15119448435839D-03
      ALPHA(46,3,49)= 0.96468302331121D-04
      ALPHA(47,3,49)= 0.55443896833741D-04
      ALPHA(48,3,49)= 0.26576895284758D-04
      ALPHA(49,3,49)= 0.84998597523141D-05
C l= 3 n=49 ; Coef  :
      COEF (   3,49)= -19.017298880271D+00
C l= 4 n=49 ; Alpha :
      ALPHA( 1,4,49)=  19.017298880271D+00
      ALPHA( 2,4,49)=  4.0866461410003D+00
      ALPHA( 3,4,49)=  1.6636305506767D+00
      ALPHA( 4,4,49)= 0.86228969710955D+00
      ALPHA( 5,4,49)= 0.50822525045433D+00
      ALPHA( 6,4,49)= 0.32449897059804D+00
      ALPHA( 7,4,49)= 0.21882083807408D+00
      ALPHA( 8,4,49)= 0.15351271411984D+00
      ALPHA( 9,4,49)= 0.11096098757855D+00
      ALPHA(10,4,49)= 0.82089010225356D-01
      ALPHA(11,4,49)= 0.61861611854615D-01
      ALPHA(12,4,49)= 0.47319356244823D-01
      ALPHA(13,4,49)= 0.36639858546125D-01
      ALPHA(14,4,49)= 0.28657018650314D-01
      ALPHA(15,4,49)= 0.22600298564808D-01
      ALPHA(16,4,49)= 0.17946437698338D-01
      ALPHA(17,4,49)= 0.14331649958620D-01
      ALPHA(18,4,49)= 0.11497805874446D-01
      ALPHA(19,4,49)= 0.92584418668238D-02
      ALPHA(20,4,49)= 0.74767211021504D-02
      ALPHA(21,4,49)= 0.60508084247440D-02
      ALPHA(22,4,49)= 0.49039629803111D-02
      ALPHA(23,4,49)= 0.39777016211643D-02
      ALPHA(24,4,49)= 0.32270022013443D-02
      ALPHA(25,4,49)= 0.26168870706582D-02
      ALPHA(26,4,49)= 0.21199561072570D-02
      ALPHA(27,4,49)= 0.17145829992656D-02
      ALPHA(28,4,49)= 0.13835812825653D-02
      ALPHA(29,4,49)= 0.11132073607295D-02
      ALPHA(30,4,49)= 0.89240811798889D-03
      ALPHA(31,4,49)= 0.71224800426030D-03
      ALPHA(32,4,49)= 0.56546914101913D-03
      ALPHA(33,4,49)= 0.44615094543078D-03
      ALPHA(34,4,49)= 0.34944485918969D-03
      ALPHA(35,4,49)= 0.27136622005787D-03
      ALPHA(36,4,49)= 0.20862994154879D-03
      ALPHA(37,4,49)= 0.15852001788627D-03
      ALPHA(38,4,49)= 0.11878532135295D-03
      ALPHA(39,4,49)= 0.87555965499701D-04
      ALPHA(40,4,49)= 0.63275850341792D-04
      ALPHA(41,4,49)= 0.44648011314568D-04
      ALPHA(42,4,49)= 0.30590152446944D-04
      ALPHA(43,4,49)= 0.20198320506357D-04
      ALPHA(44,4,49)= 0.12717117461143D-04
      ALPHA(45,4,49)= 0.75151875235628D-05
      ALPHA(46,4,49)= 0.40649772652594D-05
      ALPHA(47,4,49)= 0.19259713164003D-05
      ALPHA(48,4,49)= 0.73076572993900D-06
      ALPHA(49,4,49)= 0.17346652555743D-06
C l= 4 n=49 ; Coef  :
      COEF (   4,49)= -27.316666348871D+00
C l= 0 n=50 ; Alpha :
      ALPHA( 1,0,50)=  0.0000000000000D+00
      ALPHA( 2,0,50)=  0.0000000000000D+00
      ALPHA( 3,0,50)=  0.0000000000000D+00
      ALPHA( 4,0,50)=  0.0000000000000D+00
      ALPHA( 5,0,50)=  0.0000000000000D+00
      ALPHA( 6,0,50)=  0.0000000000000D+00
      ALPHA( 7,0,50)=  0.0000000000000D+00
      ALPHA( 8,0,50)=  0.0000000000000D+00
      ALPHA( 9,0,50)=  0.0000000000000D+00
      ALPHA(10,0,50)=  0.0000000000000D+00
      ALPHA(11,0,50)=  0.0000000000000D+00
      ALPHA(12,0,50)=  0.0000000000000D+00
      ALPHA(13,0,50)=  0.0000000000000D+00
      ALPHA(14,0,50)=  0.0000000000000D+00
      ALPHA(15,0,50)=  0.0000000000000D+00
      ALPHA(16,0,50)=  0.0000000000000D+00
      ALPHA(17,0,50)=  0.0000000000000D+00
      ALPHA(18,0,50)=  0.0000000000000D+00
      ALPHA(19,0,50)=  0.0000000000000D+00
      ALPHA(20,0,50)=  0.0000000000000D+00
      ALPHA(21,0,50)=  0.0000000000000D+00
      ALPHA(22,0,50)=  0.0000000000000D+00
      ALPHA(23,0,50)=  0.0000000000000D+00
      ALPHA(24,0,50)=  0.0000000000000D+00
      ALPHA(25,0,50)=  0.0000000000000D+00
      ALPHA(26,0,50)=  0.0000000000000D+00
      ALPHA(27,0,50)=  0.0000000000000D+00
      ALPHA(28,0,50)=  0.0000000000000D+00
      ALPHA(29,0,50)=  0.0000000000000D+00
      ALPHA(30,0,50)=  0.0000000000000D+00
      ALPHA(31,0,50)=  0.0000000000000D+00
      ALPHA(32,0,50)=  0.0000000000000D+00
      ALPHA(33,0,50)=  0.0000000000000D+00
      ALPHA(34,0,50)=  0.0000000000000D+00
      ALPHA(35,0,50)=  0.0000000000000D+00
      ALPHA(36,0,50)=  0.0000000000000D+00
      ALPHA(37,0,50)=  0.0000000000000D+00
      ALPHA(38,0,50)=  0.0000000000000D+00
      ALPHA(39,0,50)=  0.0000000000000D+00
      ALPHA(40,0,50)=  0.0000000000000D+00
      ALPHA(41,0,50)=  0.0000000000000D+00
      ALPHA(42,0,50)=  0.0000000000000D+00
      ALPHA(43,0,50)=  0.0000000000000D+00
      ALPHA(44,0,50)=  0.0000000000000D+00
      ALPHA(45,0,50)=  0.0000000000000D+00
      ALPHA(46,0,50)=  0.0000000000000D+00
      ALPHA(47,0,50)=  0.0000000000000D+00
      ALPHA(48,0,50)=  0.0000000000000D+00
      ALPHA(49,0,50)=  0.0000000000000D+00
      ALPHA(50,0,50)=  1.0000000000000D+00
C l= 0 n=50 ; Coef  :
      COEF (   0,50)= -1.0000000000000D+00
C l= 1 n=50 ; Alpha :
      ALPHA( 1,1,50)=  1.0000000000000D+00
      ALPHA( 2,1,50)= 0.50000000000000D+00
      ALPHA( 3,1,50)= 0.33333333333333D+00
      ALPHA( 4,1,50)= 0.25000000000000D+00
      ALPHA( 5,1,50)= 0.20000000000000D+00
      ALPHA( 6,1,50)= 0.16666666666667D+00
      ALPHA( 7,1,50)= 0.14285714285714D+00
      ALPHA( 8,1,50)= 0.12500000000000D+00
      ALPHA( 9,1,50)= 0.11111111111111D+00
      ALPHA(10,1,50)= 0.10000000000000D+00
      ALPHA(11,1,50)= 0.90909090909091D-01
      ALPHA(12,1,50)= 0.83333333333333D-01
      ALPHA(13,1,50)= 0.76923076923077D-01
      ALPHA(14,1,50)= 0.71428571428571D-01
      ALPHA(15,1,50)= 0.66666666666667D-01
      ALPHA(16,1,50)= 0.62500000000000D-01
      ALPHA(17,1,50)= 0.58823529411765D-01
      ALPHA(18,1,50)= 0.55555555555556D-01
      ALPHA(19,1,50)= 0.52631578947368D-01
      ALPHA(20,1,50)= 0.50000000000000D-01
      ALPHA(21,1,50)= 0.47619047619048D-01
      ALPHA(22,1,50)= 0.45454545454545D-01
      ALPHA(23,1,50)= 0.43478260869565D-01
      ALPHA(24,1,50)= 0.41666666666667D-01
      ALPHA(25,1,50)= 0.40000000000000D-01
      ALPHA(26,1,50)= 0.38461538461538D-01
      ALPHA(27,1,50)= 0.37037037037037D-01
      ALPHA(28,1,50)= 0.35714285714286D-01
      ALPHA(29,1,50)= 0.34482758620690D-01
      ALPHA(30,1,50)= 0.33333333333333D-01
      ALPHA(31,1,50)= 0.32258064516129D-01
      ALPHA(32,1,50)= 0.31250000000000D-01
      ALPHA(33,1,50)= 0.30303030303030D-01
      ALPHA(34,1,50)= 0.29411764705882D-01
      ALPHA(35,1,50)= 0.28571428571429D-01
      ALPHA(36,1,50)= 0.27777777777778D-01
      ALPHA(37,1,50)= 0.27027027027027D-01
      ALPHA(38,1,50)= 0.26315789473684D-01
      ALPHA(39,1,50)= 0.25641025641026D-01
      ALPHA(40,1,50)= 0.25000000000000D-01
      ALPHA(41,1,50)= 0.24390243902439D-01
      ALPHA(42,1,50)= 0.23809523809524D-01
      ALPHA(43,1,50)= 0.23255813953488D-01
      ALPHA(44,1,50)= 0.22727272727273D-01
      ALPHA(45,1,50)= 0.22222222222222D-01
      ALPHA(46,1,50)= 0.21739130434783D-01
      ALPHA(47,1,50)= 0.21276595744681D-01
      ALPHA(48,1,50)= 0.20833333333333D-01
      ALPHA(49,1,50)= 0.20408163265306D-01
      ALPHA(50,1,50)= 0.20000000000000D-01
C l= 1 n=50 ; Coef  :
      COEF (   1,50)= -4.4992053383294D+00
C l= 2 n=50 ; Alpha :
      ALPHA( 1,2,50)=  4.4992053383294D+00
      ALPHA( 2,2,50)=  1.7496026691647D+00
      ALPHA( 3,2,50)= 0.99973511277648D+00
      ALPHA( 4,2,50)= 0.66646800124902D+00
      ALPHA( 5,2,50)= 0.48317440099922D+00
      ALPHA( 6,2,50)= 0.36931200083268D+00
      ALPHA( 7,2,50)= 0.29274361976135D+00
      ALPHA( 8,2,50)= 0.23829352443404D+00
      ALPHA( 9,2,50)= 0.19792757727470D+00
      ALPHA(10,2,50)= 0.16702370843612D+00
      ALPHA(11,2,50)= 0.14274882585102D+00
      ALPHA(12,2,50)= 0.12327733278767D+00
      ALPHA(13,2,50)= 0.10738420462452D+00
      ALPHA(14,2,50)= 0.94219398799691D-01
      ALPHA(15,2,50)= 0.83176200784473D-01
      ALPHA(16,2,50)= 0.73811021568777D-01
      ALPHA(17,2,50)= 0.65792726182378D-01
      ALPHA(18,2,50)= 0.58869600871593D-01
      ALPHA(19,2,50)= 0.52847224217532D-01
      ALPHA(20,2,50)= 0.47573284059287D-01
      ALPHA(21,2,50)= 0.42926937199321D-01
      ALPHA(22,2,50)= 0.38811210616668D-01
      ALPHA(23,2,50)= 0.35147482091833D-01
      ALPHA(24,2,50)= 0.31871409468441D-01
      ALPHA(25,2,50)= 0.28929886423037D-01
      ALPHA(26,2,50)= 0.26278736945228D-01
      ALPHA(27,2,50)= 0.23880948967199D-01
      ALPHA(28,2,50)= 0.21705306609905D-01
      ALPHA(29,2,50)= 0.19725320667692D-01
      ALPHA(30,2,50)= 0.17918384691412D-01
      ALPHA(31,2,50)= 0.16265103464808D-01
      ALPHA(32,2,50)= 0.14748754465403D-01
      ALPHA(33,2,50)= 0.13354852814937D-01
      ALPHA(34,2,50)= 0.12070797429114D-01
      ALPHA(35,2,50)= 0.10885581368114D-01
      ALPHA(36,2,50)= 0.97895533142379D-02
      ALPHA(37,2,50)= 0.87742200414807D-02
      ALPHA(38,2,50)= 0.78320819607305D-02
      ALPHA(39,2,50)= 0.69564955136942D-02
      ALPHA(40,2,50)= 0.61415574848262D-02
      ALPHA(41,2,50)= 0.53820073022695D-02
      ALPHA(42,2,50)= 0.46731441783479D-02
      ALPHA(43,2,50)= 0.40107565507229D-02
      ALPHA(44,2,50)= 0.33910617665363D-02
      ALPHA(45,2,50)= 0.28106543333406D-02
      ALPHA(46,2,50)= 0.22664613647414D-02
      ALPHA(47,2,50)= 0.17557040924111D-02
      ALPHA(48,2,50)= 0.12758645124717D-02
      ALPHA(49,2,50)= 0.82465639316951D-03
      ALPHA(50,2,50)= 0.40000000000000D-03
C l= 2 n=50 ; Coef  :
      COEF (   2,50)= -10.933990705037D+00
C l= 3 n=50 ; Alpha :
      ALPHA( 1,3,50)=  10.933990705037D+00
      ALPHA( 2,3,50)=  3.2173926833537D+00
      ALPHA( 3,3,50)=  1.5617275658475D+00
      ALPHA( 4,3,50)= 0.92136189619154D+00
      ALPHA( 5,3,50)= 0.60379591670343D+00
      ALPHA( 6,3,50)= 0.42263419708632D+00
      ALPHA( 7,3,50)= 0.30949902595503D+00
      ALPHA( 8,3,50)= 0.23421869524049D+00
      ALPHA( 9,3,50)= 0.18171733749887D+00
      ALPHA(10,3,50)= 0.14375284602151D+00
      ALPHA(11,3,50)= 0.11550043197991D+00
      ALPHA(12,3,50)= 0.93979660494001D-01
      ALPHA(13,3,50)= 0.77267584087719D-01
      ALPHA(14,3,50)= 0.64078170608273D-01
      ALPHA(15,3,50)= 0.53524999314409D-01
      ALPHA(16,3,50)= 0.44981174308229D-01
      ALPHA(17,3,50)= 0.37993398080170D-01
      ALPHA(18,3,50)= 0.32227502287806D-01
      ALPHA(19,3,50)= 0.27432917910995D-01
      ALPHA(20,3,50)= 0.23418910804569D-01
      ALPHA(21,3,50)= 0.20038330096766D-01
      ALPHA(22,3,50)= 0.17176272492399D-01
      ALPHA(23,3,50)= 0.14742034096352D-01
      ALPHA(24,3,50)= 0.12663304255178D-01
      ALPHA(25,3,50)= 0.10881915706233D-01
      ALPHA(26,3,50)= 0.93506925474151D-02
      ALPHA(27,3,50)= 0.80310840476876D-02
      ALPHA(28,3,50)= 0.68913685828702D-02
      ALPHA(29,3,50)= 0.59052763348434D-02
      ALPHA(30,3,50)= 0.50509231014256D-02
      ALPHA(31,3,50)= 0.43099776887534D-02
      ALPHA(32,3,50)= 0.36670064027046D-02
      ALPHA(33,3,50)= 0.31089530430650D-02
      ALPHA(34,3,50)= 0.26247234590061D-02
      ALPHA(35,3,50)= 0.22048514336313D-02
      ALPHA(36,3,50)= 0.18412283002495D-02
      ALPHA(37,3,50)= 0.15268828512093D-02
      ALPHA(38,3,50)= 0.12558011961385D-02
      ALPHA(39,3,50)= 0.10227785510905D-02
      ALPHA(40,3,50)= 0.82329669947092D-03
      ALPHA(41,3,50)= 0.65342220717099D-03
      ALPHA(42,3,50)= 0.50972150456527D-03
      ALPHA(43,3,50)= 0.38918974449752D-03
      ALPHA(44,3,50)= 0.28919096506069D-03
      ALPHA(45,3,50)= 0.20740757102520D-03
      ALPHA(46,3,50)= 0.14179752962595D-03
      ALPHA(47,3,50)= 0.90557978681963D-04
      ALPHA(48,3,50)= 0.52094185534191D-04
      ALPHA(49,3,50)= 0.24992987615704D-04
      ALPHA(50,3,50)= 0.80000000000000D-05
C l= 3 n=50 ; Coef  :
      COEF (   3,50)= -19.235978694372D+00
C l= 4 n=50 ; Alpha :
      ALPHA( 1,4,50)=  19.235978694372D+00
      ALPHA( 2,4,50)=  4.1509939946674D+00
      ALPHA( 3,4,50)=  1.6948651019937D+00
      ALPHA( 4,4,50)= 0.88071693503338D+00
      ALPHA( 5,4,50)= 0.52030116878840D+00
      ALPHA( 6,4,50)= 0.33295165453976D+00
      ALPHA( 7,4,50)= 0.22501081859318D+00
      ALPHA( 8,4,50)= 0.15819708802465D+00
      ALPHA( 9,4,50)= 0.11459533432853D+00
      ALPHA(10,4,50)= 0.84964067145786D-01
      ALPHA(11,4,50)= 0.64171620494213D-01
      ALPHA(12,4,50)= 0.49198949454703D-01
      ALPHA(13,4,50)= 0.38185210227880D-01
      ALPHA(14,4,50)= 0.29938582062480D-01
      ALPHA(15,4,50)= 0.23670798551096D-01
      ALPHA(16,4,50)= 0.18846061184502D-01
      ALPHA(17,4,50)= 0.15091517920224D-01
      ALPHA(18,4,50)= 0.12142355920202D-01
      ALPHA(19,4,50)= 0.98071002250437D-02
      ALPHA(20,4,50)= 0.79450993182418D-02
      ALPHA(21,4,50)= 0.64515750266794D-02
      ALPHA(22,4,50)= 0.52474884301591D-02
      ALPHA(23,4,50)= 0.42725423030914D-02
      ALPHA(24,4,50)= 0.34802682864479D-02
      ALPHA(25,4,50)= 0.28345253847829D-02
      ALPHA(26,4,50)= 0.23069699582053D-02
      ALPHA(27,4,50)= 0.18752046802194D-02
      ALPHA(28,4,50)= 0.15214086542227D-02
      ALPHA(29,4,50)= 0.12313128874264D-02
      ALPHA(30,4,50)= 0.99342658001741D-03
      ALPHA(31,4,50)= 0.79844755803537D-03
      ALPHA(32,4,50)= 0.63880926907322D-03
      ALPHA(33,4,50)= 0.50833000629208D-03
      ALPHA(34,4,50)= 0.40193932836981D-03
      ALPHA(35,4,50)= 0.31546324873050D-03
      ALPHA(36,4,50)= 0.24545450755378D-03
      ALPHA(37,4,50)= 0.18905767491045D-03
      ALPHA(38,4,50)= 0.14390134527572D-03
      ALPHA(39,4,50)= 0.10801153652151D-03
      ALPHA(40,4,50)= 0.79741784331210D-04
      ALPHA(41,4,50)= 0.57716455457987D-04
      ALPHA(42,4,50)= 0.40784582538250D-04
      ALPHA(43,4,50)= 0.27982115396308D-04
      ALPHA(44,4,50)= 0.18500936762357D-04
      ALPHA(45,4,50)= 0.11663338944067D-04
      ALPHA(46,4,50)= 0.69009278577784D-05
      ALPHA(47,4,50)= 0.37371308900395D-05
      ALPHA(48,4,50)= 0.17726494406228D-05
      ALPHA(49,4,50)= 0.67332627787152D-06
      ALPHA(50,4,50)= 0.16000000000000D-06
C l= 4 n=50 ; Coef  :
      COEF (   4,50)= -27.701385922759D+00
      END
